(*******************************************************************

This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)


(* author: Dan Dubin, UCSD Dept of Physics *)
(* last modified: Jan 14 2003 *)
(* this file contains functions for a primitive module debugger *)
BeginPackage["Debugger`"]

 
Begin["`Private`"]

(* set up debug notebook and find first command in module *)
beginselect[] := Module[{},
    Off[Part::"partw"];
    nb = InputNotebook[]; 
    nb1 = NotebookCreate[WindowTitle -> "debugging session", 
        WindowSize -> {420, 520}, 
        WindowMargins -> {{Automatic, 0}, {Automatic, 0}}];
    reminder;
    findmod = NotebookFind[nb, "Module[", Next, CellContents];
    If[findmod === $Failed, 
      NotebookWrite[nb1, Cell["could not find the module"]],
      
      NotebookFind[nb, "},", Next, CellContents];
      SelectionMove[nb, After, Word];
      SelectionMove[nb, After, Word];
      SelectionMove[nb, All, Expression];
      fread = First[NotebookRead[nb]];
      If[fread === "(*", NotebookFind[nb, "*)", Next, CellContents];
        SelectionMove[nb, After, Word];
        SelectionMove[nb, After, Word];,
        SelectionMove[nb, After, Character]];
      Label[beginwhile];
      fread = {1};
      ntries = 0;
      While[
        ntries < 10 &&
          
          Not[If[fread[[1]] === ";", True, parser[fread]]],
        ntries = ntries + 1;
        SelectionMove[nb, All, Expression];
        fread = First[NotebookRead[nb]];
        If[fread === "(*", NotebookFind[nb, "*)", Next, CellContents];
          SelectionMove[nb, After, Word];
          SelectionMove[nb, After, Word];
          Goto[beginwhile];];
        SelectionMove[nb, Next, Character];
        fread = NotebookRead[nb];
        SelectionMove[nb, Previous, Character];]];
        On[Part::"partw"];]

reminder := 
  NotebookWrite[nb1, 
    Cell[BoxData[ToBoxes["Remember to define all external variables"]]]]

(* write command to debugger notebook, evaluate result *)
evalselec[] := Module[{}, fread = NotebookRead[nb];
    NotebookWrite[nb1, fread];
    SelectionMove[nb1, All, Cell];
    SelectionEvaluateCreateCell[nb1];]

(* select next line, and avoid comments *)
selectnext[] := 
  Module[{}, 
  Off[Part::"partw"];
  findnext = NotebookFind[nb, ";", Next, CellContents];
    If [findnext === $Failed, 
      NotebookWrite[nb1, Cell["could not find the next line"]],
      
      SelectionMove[nb, After, Word];
      SelectionMove[nb, After, Word];
      SelectionMove[nb, All, Expression];
      fread = First[NotebookRead[nb]];
      If[fread === "(*", NotebookFind[nb, "*)", Next, CellContents];
        SelectionMove[nb, After, Word];
        SelectionMove[nb, After, Word];,
        SelectionMove[nb, After, Character]];
      Label[beginwhile];
      fread = {1};
      ntries = 0;
      While[
        ntries < 10 &&
          
          Not[If[fread[[1]] === ";", True, parser[fread]]],
        ntries = ntries + 1;
        SelectionMove[nb, All, Expression];
        fread = First[NotebookRead[nb]];
        If[fread === "(*", NotebookFind[nb, "*)", Next, CellContents];
          SelectionMove[nb, After, Word];
          SelectionMove[nb, After, Word];
          Goto[beginwhile];];
        SelectionMove[nb, Next, Character];
        fread = NotebookRead[nb];
        SelectionMove[nb, Previous, Character];]];
      On[Part::"partw"];]

parser[fs_] :=  
  If[fs[[1]][[0]] === RowBox, aa = parsep[fs]; aa || parser0[list[[length]]], 

    False]
    
parser0[fs_] :=  
  If[fs[[0]] === RowBox, a = parsep0[fs]; a || parser0[list[[length]]], 
False]
    
parsep0[fs_] := (list = fs[[1]]; length = Length[list]; 
    list[[length]] === ";")
    
parsep[fs_] := (list = fs[[1]][[1]]; length = Length[list]; 
    list[[length]] === ";")
    
evalnstep[] := Module[{}, evalselec[]; selectnext[]]

listvar[] := 
  Module[{}, NotebookWrite[nb1, "?Global`*"]; 
    SelectionMove[nb1, All, CellContents];
    SelectionEvaluateCreateCell[nb1]]
    
palettecreate[] := (nb2 = 
      NotebookCreate[ScreenRectangle->{{0,1024},{0,746}},
        WindowTitle->"controls",
        ClosingAutoSave->False,Editable->False,
        WindowToolbars->{},PageWidth->1200,
        WindowSize->{210,180},
        WindowMargins->{{Automatic,3},{-2,Automatic}},
        WindowFrame->"Palette",WindowElements->{},
        WindowFrameElements->"CloseBox",
        WindowClickSelect->False,
        ScrollingOptions->{"PagewiseScrolling"->True},
        ShowCellBracket->False,CellMargins->{{0,0},{0,0}},
        Active->True,CellOpen->True,ShowCellLabel->False,
        ShowCellTags->False,ImageMargins->{{0,0},{0,0}},
        Magnification->1,ShowSelection->False];
    
    NotebookWrite[nb2,
      Cell[BoxData[
          ButtonBox["set up",
            ButtonFunction:>Debugger`Private`beginselect[],
            ButtonEvaluator->Automatic,Active->True]],"Input"]];

    
    NotebookWrite[nb2,
      Cell[BoxData[
          ButtonBox["evaluate and step",
            ButtonFunction:>Debugger`Private`evalnstep[],
            ButtonEvaluator->Automatic,Active->True]],"Input"]];

    
    NotebookWrite[nb2,
      Cell[BoxData[
          ButtonBox["select next line",
            ButtonFunction:>Debugger`Private`selectnext[],
            ButtonEvaluator->Automatic,Active->True]],"Input"]];

    
    NotebookWrite[nb2,
      Cell[BoxData[
          ButtonBox["evaluate selection",
            ButtonFunction:>Debugger`Private`evalselec[],
            ButtonEvaluator->Automatic,Active->True]],"Input"]];

    
    NotebookWrite[nb2,
      Cell[BoxData[
          ButtonBox["list variables",
            ButtonFunction:>Debugger`Private`listvar[],
            ButtonEvaluator->Automatic,Active->True]],"Input"]];
)

End[]

EndPackage[]

Debugger`Private`palettecreate[]
