(************** Content-type: application/mathematica **************

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    232966,       9520]*)
(*NotebookOutlinePosition[    316115,      12410]*)
(*  CellTagsIndexPosition[    304922,      12013]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Index", "Subtitle",
  TextAlignment->Center],

Cell["\<\
(Items that appear only in the electronic version are indexed \
according to the section numbers in which they occur.)\
\>", "Text"],

Cell[TextData[{
  "Move directly to items beginning with the letter",
  "\n",
  StyleBox[ButtonBox["A",
    ButtonData:>"A",
    ButtonStyle->"Hyperlink"],
    FontSize->24],
  StyleBox["  ",
    FontSize->24],
  StyleBox[ButtonBox["B",
    ButtonData:>"B",
    ButtonStyle->"Hyperlink"],
    FontSize->24],
  StyleBox["  ",
    FontSize->24],
  StyleBox[ButtonBox["C",
    ButtonData:>"C",
    ButtonStyle->"Hyperlink"],
    FontSize->24],
  StyleBox["  ",
    FontSize->24],
  StyleBox[ButtonBox["D",
    ButtonData:>"D",
    ButtonStyle->"Hyperlink"],
    FontSize->24],
  StyleBox["  ",
    FontSize->24],
  StyleBox[ButtonBox["E",
    ButtonData:>"E",
    ButtonStyle->"Hyperlink"],
    FontSize->24],
  StyleBox["  ",
    FontSize->24],
  StyleBox[ButtonBox["F",
    ButtonData:>"F",
    ButtonStyle->"Hyperlink"],
    FontSize->24],
  StyleBox["  ",
    FontSize->24],
  StyleBox[ButtonBox["G",
    ButtonData:>"G",
    ButtonStyle->"Hyperlink"],
    FontSize->24],
  StyleBox["  ",
    FontSize->24],
  StyleBox[ButtonBox["H",
    ButtonData:>"H",
    ButtonStyle->"Hyperlink"],
    FontSize->24],
  StyleBox["  ",
    FontSize->24],
  StyleBox[ButtonBox["I",
    ButtonData:>"I",
    ButtonStyle->"Hyperlink"],
    FontSize->24],
  StyleBox["  ",
    FontSize->24],
  StyleBox[ButtonBox["J",
    ButtonData:>"J",
    ButtonStyle->"Hyperlink"],
    FontSize->24],
  StyleBox["  ",
    FontSize->24],
  StyleBox[ButtonBox["K",
    ButtonData:>"K",
    ButtonStyle->"Hyperlink"],
    FontSize->24],
  StyleBox["  ",
    FontSize->24],
  StyleBox[ButtonBox["L",
    ButtonData:>"L",
    ButtonStyle->"Hyperlink"],
    FontSize->24],
  StyleBox["  ",
    FontSize->24],
  StyleBox[ButtonBox["M",
    ButtonData:>"M",
    ButtonStyle->"Hyperlink"],
    FontSize->24],
  StyleBox["  ",
    FontSize->24],
  StyleBox[ButtonBox["N",
    ButtonData:>"N",
    ButtonStyle->"Hyperlink"],
    FontSize->24],
  StyleBox["  ",
    FontSize->24],
  StyleBox[ButtonBox["O",
    ButtonData:>"O",
    ButtonStyle->"Hyperlink"],
    FontSize->24],
  StyleBox["  ",
    FontSize->24],
  StyleBox[ButtonBox["P",
    ButtonData:>"P",
    ButtonStyle->"Hyperlink"],
    FontSize->24],
  StyleBox["  ",
    FontSize->24],
  StyleBox[ButtonBox["Q",
    ButtonData:>"Q",
    ButtonStyle->"Hyperlink"],
    FontSize->24],
  StyleBox["  ",
    FontSize->24],
  StyleBox[ButtonBox["R",
    ButtonData:>"R",
    ButtonStyle->"Hyperlink"],
    FontSize->24],
  StyleBox["  ",
    FontSize->24],
  StyleBox[ButtonBox["S",
    ButtonData:>"S",
    ButtonStyle->"Hyperlink"],
    FontSize->24],
  StyleBox["  ",
    FontSize->24],
  StyleBox[ButtonBox["T",
    ButtonData:>"T",
    ButtonStyle->"Hyperlink"],
    FontSize->24],
  StyleBox["  ",
    FontSize->24],
  StyleBox[ButtonBox["U",
    ButtonData:>"U",
    ButtonStyle->"Hyperlink"],
    FontSize->24],
  StyleBox["  ",
    FontSize->24],
  StyleBox[ButtonBox["V",
    ButtonData:>"V",
    ButtonStyle->"Hyperlink"],
    FontSize->24],
  StyleBox["  ",
    FontSize->24],
  StyleBox[ButtonBox["W",
    ButtonData:>"W",
    ButtonStyle->"Hyperlink"],
    FontSize->24],
  StyleBox["  ",
    FontSize->24],
  StyleBox[ButtonBox["Z",
    ButtonData:>"Z",
    ButtonStyle->"Hyperlink"],
    FontSize->24]
}], "Text"],

Cell[TextData[{
  "/;  (adding conditions to function definitions), ",
  ButtonBox["9.8.6",
    ButtonData:>{"Chapter9.nb", "i:69"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:3"],

Cell[TextData[{
  Cell[BoxData[
      \(TraditionalForm\`\[Dagger]\)]],
  " (adjoint in traditional mathematical notation), ",
  ButtonBox["272",
    ButtonData:>{"Chapter4.nb", "i:18"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:385"],

Cell[TextData[{
  "\[Rule] (arrow), ",
  ButtonBox["9.6.1",
    ButtonData:>{"Chapter9.nb", "i:133"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "(*  *) (brackets used for comments within code),  ",
  ButtonBox["216",
    ButtonData:>{"Chapter3.nb", "i:115"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:388"],

Cell[TextData[{
  "( ) (brackets used to determine order in a calculation), ",
  ButtonBox["9.2.1",
    ButtonData:>{"Chapter9.nb", "i:115"},
    ButtonStyle->"Hyperlink"],
  " "
}], "Text",
  CellTags->"ii:4"],

Cell[TextData[{
  "{ } (brackets used to define lists), ",
  ButtonBox["9.5.1",
    ButtonData:>{"Chapter9.nb", "i:26"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:7"],

Cell[TextData[{
  "[ ] (brackets used to enclose the argument of a function), ",
  ButtonBox["9.2.3",
    ButtonData:>{"Chapter9.nb", "i:18"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:5"],

Cell[TextData[{
  "[[ ]] (brackets used to extract list elements), ",
  ButtonBox["9.5.1",
    ButtonData:>{"Chapter9.nb", "i:29"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:6"],

Cell[TextData[{
  "* (complex conjugate in traditional mathematical notation), ",
  ButtonBox["9.2.5",
    ButtonData:>{"Chapter9.nb", "i:15"},
    ButtonStyle->"Hyperlink"],
  "\n\t(wildcard in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " expressions), ",
  ButtonBox["9.4.2",
    ButtonData:>{"Chapter9.nb", "i:10"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["9.7",
    ButtonData:>{"Chapter9.nb", "i:121"},
    ButtonStyle->"Hyperlink"],
  " "
}], "Text"],

Cell[TextData[{
  "? (definition of), ",
  ButtonBox["9.7",
    ButtonData:>{"Chapter9.nb", "i:122"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "\[Element] (element of), ",
  ButtonBox["33",
    ButtonData:>{"Chapter1.nb", "i:136"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:9"],

Cell[TextData[{
  " =, := and == (different forms of equality), ",
  ButtonBox["9.10.1",
    ButtonData:>{"Chapter9.nb", "i:109"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:8"],

Cell[TextData[{
  "! (factorial function), ",
  ButtonBox["9.2.3",
    ButtonData:>List[ "Chapter9.nb", "i:96"],
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  Cell[BoxData[
      \(TraditionalForm\`\(\(<\)\(\(,\)\(\ \)\(\(>\)\(\(,\)\(\ \)\(\(\
\[LessEqual]\)\(\ \)\(\(,\)\(\ \)\(\(\[GreaterEqual]\)\(\ \)\(\(,\)\(\(\
\[Equal]\)\(\(,\)\(\ \)\(\(\[NotEqual]\)\(\ \)\(\(,\)\(\ \)\(\(&&\)\(\(,\)\(\ \
\)\(||\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)\)]],
  " (logical statements), ",
  ButtonBox["9.8.6",
    ButtonData:>List[ "Chapter9.nb", "i:111"],
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:10"],

Cell[TextData[{
  "<< (reading ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " files), ",
  ButtonBox["9.6.8",
    ButtonData:>{"Chapter9.nb", "i:113"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["9.11.4",
    ButtonData:>{"Chapter9.nb", "i:130"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["167",
    ButtonData:>{"Chapter2.nb", "i:100"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  StyleBox[ButtonBox["Import",
    ButtonData:>"ii:177",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"]
}], "Text",
  CellTags->"ii:11"],

Cell[TextData[{
  "%  (referencing previous results), ",
  ButtonBox["9.4.1",
    ButtonData:>{"Chapter9.nb", "i:22"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:12"],

Cell[TextData[{
  "/.  (replacing variables),  ",
  ButtonBox["9.8.2",
    ButtonData:>{"Chapter9.nb", "i:65"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:13"],

Cell[TextData[{
  "_ (underscore), ",
  ButtonBox["9.8.3",
    ButtonData:>{"Chapter9.nb", "i:66"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:14"],

Cell[TextData[{
  StyleBox["$DisplayFunction",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["35",
    ButtonData:>{"Chapter1.nb", "i:147"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  StyleBox["$MachinePrecision",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  StyleBox["see ",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Machine precision",
    ButtonData:>"ii:215",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  StyleBox["$Path",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.11.4",
    ButtonData:>{"Chapter9.nb", "i:128"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[BoxData[""], "Input"],

Cell[TextData[{
  StyleBox["Abort",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  " ",
  StyleBox["Evaluation",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.3",
    ButtonData:>List[ "Chapter9.nb", "i:13"],
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->{"A", "ii:15"}],

Cell[TextData[{
  "Acceptance rate, ",
  ButtonBox["8.3.2",
    ButtonData:>{"Chapter8.nb", "i:86"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:16"],

Cell[TextData[{
  StyleBox["AccuracyGoal",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.11.1",
    ButtonData:>{"Chapter9.nb", "i:102"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["26",
    ButtonData:>{"Chapter1.nb", "i:111"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:17"],

Cell[TextData[{
  "Action, ",
  ButtonBox["525",
    ButtonData:>{"Chapter7.nb", "i:10"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Adiabatic invariants",
    ButtonData:>"ii:21",
    ButtonStyle->"Hyperlink"],
  ";  ",
  ButtonBox["Wave action",
    ButtonData:>"ii:360",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:18"],

Cell[TextData[{
  "Adams-Bashforth method, s",
  StyleBox["ee",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Numerical solution of ODEs",
    ButtonData:>"ii:244",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:19"],

Cell[TextData[{
  "Add-on packages, ",
  ButtonBox["9.6.8",
    ButtonData:>List[ "Chapter9.nb", "i:57"],
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:20"],

Cell[TextData[{
  "Adiabatic invariants, ",
  ButtonBox["404",
    ButtonData:>{"Chapter5.nb", "i:73"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["WKB method",
    ButtonData:>"ii:374",
    ButtonStyle->"Hyperlink"],
  "\n\tfor waves on a string, ",
  ButtonBox["432",
    ButtonData:>{"Chapter5.nb", "i:105"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:21"],

Cell[TextData[{
  "Adjoint, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  " ",
  ButtonBox["\[Dagger]",
    ButtonData:>"ii:385",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Differential operators",
    ButtonData:>"ii:85",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Orthogonality",
    ButtonData:>"ii:248",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  StyleBox["AiryAi[x]",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  " and ",
  StyleBox["AiryBi[x]",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["18",
    ButtonData:>{"Chapter1.nb", "i:133"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:22"],

Cell[TextData[{
  "Airy functions, ",
  ButtonBox["18",
    ButtonData:>{"Chapter1.nb", "i:133"},
    ButtonStyle->"Hyperlink"],
  "\n\tasymptotic form for large argument, ",
  ButtonBox["424\n",
    ButtonData:>{"Chapter5.nb", "i:109"},
    ButtonStyle->"Hyperlink"],
  "\tdifferential equation for, ",
  ButtonBox["18",
    ButtonData:>{"Chapter1.nb", "i:31"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["84",
    ButtonData:>{"Chapter1.nb", "i:106"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:23"],

Cell[TextData[{
  "Airy, George B.",
  ", ",
  ButtonBox["81",
    ButtonData:>List[ "Chapter1.nb", "i:32"],
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Aliasing, ",
  ButtonBox["150",
    ButtonData:>{"Chapter2.nb", "i:111"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Alternating direction implicit method, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Grid methods",
    ButtonData:>"ii:159",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Angular momentum, specific, ",
  ButtonBox["15",
    ButtonData:>{"Chapter1.nb", "i:39"},
    ButtonStyle->"Hyperlink"],
  "\n\ttotal, ",
  ButtonBox["58",
    ButtonData:>{"Chapter1.nb", "i:68"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:25"],

Cell[TextData[{
  "Animations, ",
  ButtonBox["9.6.7",
    ButtonData:>{"Chapter9.nb", "i:56"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:26"],

Cell[TextData[{
  " ",
  StyleBox["Append",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.5.4",
    ButtonData:>{"Chapter9.nb", "i:39"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Approximate mathematics, ",
  ButtonBox["9.2.2",
    ButtonData:>{"Chapter9.nb", "i:17"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:27"],

Cell[TextData[{
  "Arbitrary precision numbers",
  ", ",
  ButtonBox["9.2.6",
    ButtonData:>{"Chapter9.nb", "i:6"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:28"],

Cell[TextData[{
  "Area weighting, ",
  ButtonBox["7.3.4",
    ButtonData:>{"Chapter7.nb", "i:88"},
    ButtonStyle->"Hyperlink"],
  StyleBox[". See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Interpolation",
    ButtonData:>"ii:185",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["PIC method",
    ButtonData:>"ii:261",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Asymptotic expansions, ",
  ButtonBox["402",
    ButtonData:>{"Chapter5.nb", "i:140"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Average(s), ",
  StyleBox["see also ",
    FontSlant->"Italic"],
  StyleBox[ButtonBox["Mean",
    ButtonData:>"ii:221",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "\n\tfluctuation in position (mean square change in position), ",
  ButtonBox["574",
    ButtonData:>{"Chapter8.nb", "i:31"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["580",
    ButtonData:>{"Chapter8.nb", "i:17"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["581",
    ButtonData:>{"Chapter8.nb", "i:79"},
    ButtonStyle->"Hyperlink"],
  "\n\tfluctuation in density, ",
  ButtonBox["8.3.2",
    ButtonData:>{"Chapter8.nb", "i:89"},
    ButtonStyle->"Hyperlink"],
  "\n\tfluctuation in energy, ",
  ButtonBox["8.3.2",
    ButtonData:>{"Chapter8.nb", "i:90"},
    ButtonStyle->"Hyperlink"],
  "\n\tin a general random walk, ",
  ButtonBox["592",
    ButtonData:>{"Chapter8.nb", "i:44"},
    ButtonStyle->"Hyperlink"],
  "\n\tin terms of probability distribution, ",
  ButtonBox["578",
    ButtonData:>{"Chapter8.nb", "i:14"},
    ButtonStyle->"Hyperlink"],
  "\n\tlinearity of, ",
  ButtonBox["579",
    ButtonData:>{"Chapter8.nb", "i:15"},
    ButtonStyle->"Hyperlink"],
  "\n\tposition, ",
  ButtonBox["573",
    ButtonData:>{"Chapter8.nb", "i:13"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["580",
    ButtonData:>{"Chapter8.nb", "i:16"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:29"],

Cell[BoxData[""], "Input"],

Cell[TextData[{
  "Backward difference, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Derivatives, finite-differenced forms",
    ButtonData:>"ii:81",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->{"B", "ii:30"}],

Cell[TextData[{
  "Bandwidth, ",
  ButtonBox["127",
    ButtonData:>{"Chapter2.nb", "i:86"},
    ButtonStyle->"Hyperlink"],
  "\n\tand the uncertainty principle, ",
  ButtonBox["134",
    ButtonData:>{"Chapter2.nb", "i:88"},
    ButtonStyle->"Hyperlink"],
  "\n\tconnection to bit rate, ",
  ButtonBox["128",
    ButtonData:>{"Chapter2.nb", "i:87"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:31"],

Cell[TextData[{
  "Basis functions, ",
  ButtonBox["263",
    ButtonData:>{"Chapter4.nb", "i:112"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["436",
    ButtonData:>{"Chapter6.nb", "i:5"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Galerkin method",
    ButtonData:>"ii:147",
    ButtonStyle->"Hyperlink"],
  "\n\tboundary condition at origin, ",
  ButtonBox["464",
    ButtonData:>{"Chapter6.nb", "i:37"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor mixed boundary conditions, ",
  ButtonBox["451",
    ButtonData:>{"Chapter6.nb", "i:12"},
    ButtonStyle->"Hyperlink"],
  "\n\tin presence of a convex cusp, ",
  ButtonBox["448",
    ButtonData:>{"Chapter6.nb", "i:9"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:32"],

Cell[TextData[{
  "Beats, ",
  ButtonBox["83",
    ButtonData:>{"Chapter1.nb", "i:141"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Bernoulli, Jacob, ",
  ButtonBox["568",
    ButtonData:>{"Chapter8.nb", "i:1"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:33"],

Cell[TextData[{
  "Bessel\n\t beam, ",
  ButtonBox["388",
    ButtonData:>{"Chapter5.nb", "i:47"},
    ButtonStyle->"Hyperlink"],
  "\n\t Friedrich W., ",
  ButtonBox["248",
    ButtonData:>{"Chapter3.nb", "i:81"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:34"],

Cell[TextData[{
  "Bessel functions, ",
  ButtonBox["248",
    ButtonData:>{"Chapter3.nb", "i:80"},
    ButtonStyle->"Hyperlink"],
  "\n\tas cylindrical radial eigenmodes of ",
  Cell[BoxData[
      \(TraditionalForm\`\[Del]\^2\)]],
  ", ",
  ButtonBox["314",
    ButtonData:>{"Chapter4.nb", "i:68"},
    ButtonStyle->"Hyperlink"],
  "\n\tas eigenmodes of a hanging string, ",
  ButtonBox["288",
    ButtonData:>{"Chapter4.nb", "i:41"},
    ButtonStyle->"Hyperlink"],
  "\n\tas solutions of a Sturm-Liouville problem, ",
  ButtonBox["271",
    ButtonData:>{"Chapter4.nb", "i:34"},
    ButtonStyle->"Hyperlink"],
  "\n\tasymptotic form for large argument, ",
  ButtonBox["424",
    ButtonData:>{"Chapter5.nb", "i:94"},
    ButtonStyle->"Hyperlink"],
  "\n\tdifferential equation for, ",
  ButtonBox["248",
    ButtonData:>{"Chapter3.nb", "i:81"},
    ButtonStyle->"Hyperlink"],
  "\n\tform for small argument, ",
  ButtonBox["259",
    ButtonData:>{"Chapter3.nb", "i:93"},
    ButtonStyle->"Hyperlink"],
  "\n\tmodified, ",
  ButtonBox["255",
    ButtonData:>{"Chapter3.nb", "i:88"},
    ButtonStyle->"Hyperlink"],
  "\n\torthogonality relation, ",
  ButtonBox["252",
    ButtonData:>{"Chapter3.nb", "i:90"},
    ButtonStyle->"Hyperlink"],
  "\n\tspherical, ",
  ButtonBox["317",
    ButtonData:>{"Chapter4.nb", "i:69"},
    ButtonStyle->"Hyperlink"],
  "\n\tzeros of, ",
  ButtonBox["250",
    ButtonData:>{"Chapter3.nb", "i:85"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:36"],

Cell[TextData[{
  StyleBox["BesselI",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  " and ",
  StyleBox["BesselK",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["255",
    ButtonData:>{"Chapter3.nb", "i:89"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:37"],

Cell[TextData[{
  StyleBox["BesselJ",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  " and ",
  StyleBox["BesselY",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["248",
    ButtonData:>{"Chapter3.nb", "i:82"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:38"],

Cell[TextData[{
  StyleBox["BesselJZeros",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  " and ",
  StyleBox["BesselYZeros",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["250",
    ButtonData:>{"Chapter3.nb", "i:86"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:39"],

Cell[TextData[{
  "Bilinear equation, ",
  ButtonBox["304",
    ButtonData:>{"Chapter4.nb", "i:58"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:40"],

Cell[TextData[{
  "Blackbody, ",
  ButtonBox["230",
    ButtonData:>{"Chapter3.nb", "i:55"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["349",
    ButtonData:>{"Chapter4.nb", "i:95"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:41"],

Cell[TextData[{
  "Bode's rule, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Numerical integration",
    ButtonData:>"ii:181",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Bohr,\n\tNiels,  ",
  ButtonBox["350",
    ButtonData:>{"Chapter4.nb", "i:114"},
    ButtonStyle->"Hyperlink"],
  "\n\tradius,  ",
  ButtonBox["350",
    ButtonData:>{"Chapter4.nb", "i:114"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Boltzmann equation\n\tcollisionless, ",
  ButtonBox["520",
    ButtonData:>{"Chapter7.nb", "i:6"},
    ButtonStyle->"Hyperlink"],
  "\n\tequilibrium solution, ",
  ButtonBox["521",
    ButtonData:>{"Chapter7.nb", "i:9"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor self-gravitating systems, ",
  ButtonBox["7.3.1",
    ButtonData:>{"Chapter7.nb", "i:54"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:42"],

Cell[TextData[{
  "Boltzmann, Ludwig, ",
  ButtonBox["568",
    ButtonData:>{"Chapter8.nb", "i:1"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:43"],

Cell[TextData[{
  "Boole",
  StyleBox[", ",
    FontFamily->"Times",
    FontWeight->"Plain"],
  StyleBox[ButtonBox["442",
    ButtonData:>{"Chapter6.nb", "i:64"},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Times",
    FontWeight->"Plain"],
  StyleBox[", ",
    FontFamily->"Times",
    FontWeight->"Plain"],
  StyleBox[ButtonBox["6.3.3",
    ButtonData:>{"Chapter6.nb", "i:67"},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Times",
    FontWeight->"Plain"]
}], "Text",
  FontFamily->"Courier",
  FontWeight->"Bold",
  CellTags->"ii:44"],

Cell[TextData[{
  "Boundary conditions, ",
  ButtonBox["4",
    ButtonData:>{"Chapter1.nb", "i:123"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["5",
    ButtonData:>{"Chapter1.nb", "i:121"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["62",
    ButtonData:>{"Chapter1.nb", "i:120"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["64",
    ButtonData:>{"Chapter1.nb", "i:122"},
    ButtonStyle->"Hyperlink"],
  "\n\tapplying, in grid methods, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Grid methods",
    ButtonData:>"ii:159",
    ButtonStyle->"Hyperlink"],
  "\n\tcontained in the forcing function, ",
  ButtonBox["184",
    ButtonData:>{"Chapter2.nb", "i:77"},
    ButtonStyle->"Hyperlink"],
  "\n\tcontinuous vs. discontinuous, ",
  ButtonBox["312",
    ButtonData:>{"Chapter4.nb", "i:113"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Galerkin method, boundary curves",
    ButtonData:>"ii:147",
    ButtonStyle->"Hyperlink"],
  "\n\tDirichlet, ",
  ButtonBox["203",
    ButtonData:>{"Chapter3.nb", "i:10"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["209",
    ButtonData:>{"Chapter3.nb", "i:27"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["231",
    ButtonData:>{"Chapter3.nb", "i:58"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor Laplace's and Poisson's equation, ",
  ButtonBox["231",
    ButtonData:>{"Chapter3.nb", "i:57"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor Sturm Liouville problems, ",
  ButtonBox["269",
    ButtonData:>{"Chapter4.nb", "i:115"},
    ButtonStyle->"Hyperlink"],
  "\n\thomogeneous, ",
  ButtonBox["179",
    ButtonData:>{"Chapter2.nb", "i:82"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["196",
    ButtonData:>{"Chapter3.nb", "i:8"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["269",
    ButtonData:>{"Chapter4.nb", "i:115"},
    ButtonStyle->"Hyperlink"],
  "\n\tmixed, ",
  ButtonBox["209",
    ButtonData:>{"Chapter3.nb", "i:29"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["231",
    ButtonData:>{"Chapter3.nb", "i:56"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["232",
    ButtonData:>{"Chapter3.nb", "i:60"},
    ButtonStyle->"Hyperlink"],
  "\n\tmoving, ",
  ButtonBox["431",
    ButtonData:>{"Chapter5.nb", "i:104"},
    ButtonStyle->"Hyperlink"],
  "\n\tperiodic, ",
  ButtonBox["168",
    ButtonData:>{"Chapter2.nb", "i:81"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["239",
    ButtonData:>{"Chapter3.nb", "i:105"},
    ButtonStyle->"Hyperlink"],
  "\n\tstatic, ",
  ButtonBox["203",
    ButtonData:>{"Chapter3.nb", "c:11"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["210",
    ButtonData:>{"Chapter3.nb", "c:19"},
    ButtonStyle->"Hyperlink"],
  "\n\ttime-dependent, ",
  ButtonBox["278",
    ButtonData:>{"Chapter4.nb", "i:118"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["283",
    ButtonData:>{"Chapter4.nb", "i:119"},
    ButtonStyle->"Hyperlink"],
  "\n\tvon Neumann, ",
  ButtonBox["203",
    ButtonData:>{"Chapter3.nb", "i:11"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["209",
    ButtonData:>{"Chapter3.nb", "i:28"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["231",
    ButtonData:>{"Chapter3.nb", "i:59"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:45"],

Cell[TextData[{
  "Boundary value problems, ",
  ButtonBox["4",
    ButtonData:>{"Chapter1.nb", "i:12"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["62",
    ButtonData:>{"Chapter1.nb", "i:79"},
    ButtonStyle->"Hyperlink"],
  StyleBox[". See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Eigenvalue problems",
    ButtonData:>"ii:101",
    ButtonStyle->"Hyperlink"],
  "\n\texistence and uniqueness of solution, ",
  ButtonBox["63",
    ButtonData:>{"Chapter1.nb", "i:17"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["196",
    ButtonData:>{"Chapter3.nb", "i:14"},
    ButtonStyle->"Hyperlink"],
  "\n\tGreen's function approach, ",
  ButtonBox["178",
    ButtonData:>{"Chapter2.nb", "i:65"},
    ButtonStyle->"Hyperlink"],
  "\n\tmatrix inverse method for 1D problems, ",
  ButtonBox["78",
    ButtonData:>{"Chapter1.nb", "i:116"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["181",
    ButtonData:>{"Chapter2.nb", "i:69"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["184",
    ButtonData:>{"Chapter2.nb", "i:78"},
    ButtonStyle->"Hyperlink"],
  StyleBox[". See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Green's functions",
    ButtonData:>"ii:158",
    ButtonStyle->"Hyperlink"],
  "\n\tnumerical solution on a grid, ",
  ButtonBox["486",
    ButtonData:>{"Chapter6.nb", "i:29"},
    ButtonStyle->"Hyperlink"],
  "\n\tnumerical solution via Galerkin method, ",
  ButtonBox["435",
    ButtonData:>{"Chapter6.nb", "i:4"},
    ButtonStyle->"Hyperlink"],
  "\n\tparticular solution via Fourier series, ",
  ButtonBox["118",
    ButtonData:>{"Chapter2.nb", "i:33"},
    ButtonStyle->"Hyperlink"],
  "\n\tshooting method for 1D problems, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Shooting method",
    ButtonData:>"ii:308",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:46"],

Cell[TextData[{
  "Bow, ",
  ButtonBox["300",
    ButtonData:>{"Chapter4.nb", "i:50"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:47"],

Cell[TextData[{
  "Boussinesq equations, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Partial Differential Equations",
    ButtonData:>"ii:252",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Brillouin, L\[EAcute]on, ",
  ButtonBox["396",
    ButtonData:>{"Chapter5.nb", "i:128"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:48"],

Cell[TextData[{
  "Brownian motion, ",
  ButtonBox["583",
    ButtonData:>{"Chapter8.nb", "i:23"},
    ButtonStyle->"Hyperlink"],
  "\n\tin gravity, ",
  ButtonBox["603",
    ButtonData:>{"Chapter8.nb", "i:54"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:49"],

Cell[TextData[{
  "Brown, Robert, ",
  ButtonBox["583",
    ButtonData:>{"Chapter8.nb", "i:23"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:50"],

Cell[TextData[{
  "Burgers' equation,  ",
  ButtonBox["554",
    ButtonData:>{"Chapter7.nb", "i:47"},
    ButtonStyle->"Hyperlink"],
  "\n\twithout diffusion, ",
  ButtonBox["529",
    ButtonData:>{"Chapter7.nb", "i:85"},
    ButtonStyle->"Hyperlink"],
  "\t"
}], "Text",
  CellTags->"ii:51"],

Cell[BoxData[""], "Input"],

Cell[TextData[{
  "Cantilever, ",
  ButtonBox["9.10 Exercise 5",
    ButtonData:>{"Chapter9.nb", "i:112"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->{"C", "ii:52"}],

Cell[TextData[{
  "Catenary, ",
  ButtonBox["205",
    ButtonData:>{"Chapter3.nb", "i:19"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:53"],

Cell[TextData[{
  "Caustics, ",
  ButtonBox["5.3.1",
    ButtonData:>{"Chapter5.nb", "i:132"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Cell, ",
  ButtonBox["9.1",
    ButtonData:>{"Chapter9.nb", "i:4"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:54"],

Cell[TextData[{
  "Centered-difference\n\tderivative, ",
  ButtonBox["182",
    ButtonData:>{"Chapter2.nb", "i:73"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Derivatives, finite-differenced forms",
    ButtonData:>"ii:81",
    ButtonStyle->"Hyperlink"],
  ")\n\tmethod, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Numerical solution of ODEs",
    ButtonData:>"ii:244",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Grid methods",
    ButtonData:>"ii:159",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:55"],

Cell[TextData[{
  "Chaotic systems, ",
  ButtonBox["14",
    ButtonData:>{"Chapter1.nb", "i:112"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["20",
    ButtonData:>{"Chapter1.nb", "i:33"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["27",
    ButtonData:>{"Chapter1.nb", "i:26"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["517",
    ButtonData:>{"Chapter7.nb", "i:5"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Ordinary differential equations",
    ButtonData:>"ii:247",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Lyapunov exponent",
    ButtonData:>"ii:212",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:56"],

Cell[TextData[{
  "Characteristics\n\tdefinition, ",
  ButtonBox["512",
    ButtonData:>{"Chapter7.nb", "i:2"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor a nonlinear wave equation, ",
  ButtonBox["530",
    ButtonData:>{"Chapter7.nb", "i:18"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor the linear collisionless Boltzmann equation, ",
  ButtonBox["520",
    ButtonData:>{"Chapter7.nb", "i:19"},
    ButtonStyle->"Hyperlink"],
  "\n\tmethod of, ",
  ButtonBox["511",
    ButtonData:>{"Chapter7.nb", "i:1"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:57"],

Cell[TextData[{
  "Chebyshev, Pafnuty L., ",
  ButtonBox["273",
    ButtonData:>{"Chapter4.nb", "i:27"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:58"],

Cell[TextData[{
  "Circulation, ",
  ButtonBox["7.3 Exercise 5",
    ButtonData:>{"Chapter7.nb", "i:69"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:59"],

Cell[TextData[{
  "Clarke, Arthur C., ",
  ButtonBox["224",
    ButtonData:>{"Chapter3.nb", "i:45"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:60"],

Cell[TextData[{
  StyleBox["Clear",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.4.2",
    ButtonData:>{"Chapter9.nb", "i:25"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  StyleBox[ButtonBox["Remove",
    ButtonData:>"ii:378",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "; ",
  StyleBox[ButtonBox["Unset",
    ButtonData:>"ii:352",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"]
}], "Text",
  CellTags->"ii:379"],

Cell[TextData[{
  "Clearing variables, all user-defined, ",
  ButtonBox["9.4.2",
    ButtonData:>{"Chapter9.nb", "i:24"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:61"],

Cell[TextData[{
  "Comments in code, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  " ",
  ButtonBox["(*  *)",
    ButtonData:>"ii:388",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Complex arithmetic, ",
  ButtonBox["9.2.5",
    ButtonData:>{"Chapter9.nb", "i:14"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:62"],

Cell[TextData[{
  "Contexts, ",
  ButtonBox["9.4.2",
    ButtonData:>{"Chapter9.nb", "i:10"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["9.6.8",
    ButtonData:>{"Chapter9.nb", "i:113"},
    ButtonStyle->"Hyperlink"],
  ".",
  StyleBox[" See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Shadowing",
    ButtonData:>"ii:380",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:63"],

Cell[TextData[{
  "Continuity equation\n\tfor energy density, ",
  ButtonBox["208",
    ButtonData:>{"Chapter3.nb", "i:23"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["423",
    ButtonData:>{"Chapter5.nb", "i:119"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor mass density, ",
  ButtonBox["563",
    ButtonData:>{"Chapter7.nb", "i:37"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor wave action, ",
  ButtonBox["5.3.2",
    ButtonData:>{"Chapter5.nb", "i:120"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:64"],

Cell[TextData[{
  StyleBox["ContourPlot",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.6.6",
    ButtonData:>{"Chapter9.nb", "i:49"},
    ButtonStyle->"Hyperlink"],
  "\n\tadding labels to contours, ",
  ButtonBox["9.6.8\t",
    ButtonData:>{"Chapter9.nb", "i:114"},
    ButtonStyle->"Hyperlink"],
  "\n\tover arbitrary regions (using ",
  StyleBox["Boole",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "), ",
  ButtonBox["442",
    ButtonData:>{"Chapter6.nb", "i:64"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:65"],

Cell[TextData[{
  "Convergence\n\tin the mean, ",
  ButtonBox["272",
    ButtonData:>{"Chapter4.nb", "i:2"},
    ButtonStyle->"Hyperlink"],
  "\n\tnonuniform, ",
  ButtonBox["99",
    ButtonData:>{"Chapter2.nb", "i:12"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Gibbs phenomenon",
    ButtonData:>"ii:151",
    ButtonStyle->"Hyperlink"],
  "\n\tuniform, ",
  ButtonBox["98",
    ButtonData:>{"Chapter2.nb", "i:11"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:66"],

Cell[TextData[{
  "Convolution theorem, ",
  ButtonBox["132",
    ButtonData:>{"Chapter2.nb", "i:44"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:67"],

Cell[TextData[{
  "Coordinates\n\tcylindrical, ",
  ButtonBox["238",
    ButtonData:>{"Chapter3.nb", "i:75"},
    ButtonStyle->"Hyperlink"],
  "\n\trectangular, ",
  ButtonBox["233",
    ButtonData:>{"Chapter3.nb", "i:76"},
    ButtonStyle->"Hyperlink"],
  "\n\tseparable, ",
  ButtonBox["305",
    ButtonData:>{"Chapter4.nb", "i:120"},
    ButtonStyle->"Hyperlink"],
  "\t\n\tspherical, ",
  ButtonBox["240",
    ButtonData:>{"Chapter3.nb", "i:78"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:68"],

Cell[TextData[{
  "Correlation\n\tfunction, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Function(s), correlation",
    ButtonData:>"ii:144",
    ButtonStyle->"Hyperlink"],
  "\n\ttime, ",
  ButtonBox["8.3.2",
    ButtonData:>{"Chapter8.nb", "i:87"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:69"],

Cell[TextData[{
  "Coulomb, Charles, ",
  ButtonBox["301",
    ButtonData:>{"Chapter4.nb", "i:111"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:70"],

Cell[TextData[{
  "Coulomb's law, ",
  ButtonBox["59",
    ButtonData:>{"Chapter1.nb", "i:75"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Courant \n\tcondition, ",
  ButtonBox["468",
    ButtonData:>{"Chapter6.nb", "i:65"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["505",
    ButtonData:>{"Chapter6.nb", "i:66"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also ",
    FontSlant->"Italic"],
  ButtonBox["Grid methods",
    ButtonData:>"ii:159",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Von Neumann stability analysis",
    ButtonData:>"ii:357",
    ButtonStyle->"Hyperlink"],
  "\n\tRichard, ",
  ButtonBox["468",
    ButtonData:>{"Chapter6.nb", "i:65"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:71"],

Cell[TextData[{
  "Crank-Nicolson method, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Grid methods",
    ButtonData:>"ii:159",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "CTCS method, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Grid methods",
    ButtonData:>"ii:159",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Cyclotron\n\tradius, ",
  ButtonBox["22",
    ButtonData:>{"Chapter1.nb", "i:137"},
    ButtonStyle->"Hyperlink"],
  "\n\tfrequency, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Frequency, cyclotron",
    ButtonData:>"ii:141",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[BoxData[""], "Input"],

Cell[TextData[{
  StyleBox["D",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.9.1",
    ButtonData:>{"Chapter9.nb", "i:70"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->{"D", "ii:73"}],

Cell[TextData[{
  "d'Alembert, Jean, ",
  ButtonBox["203",
    ButtonData:>{"Chapter3.nb", "i:15"},
    ButtonStyle->"Hyperlink"],
  " "
}], "Text"],

Cell[TextData[{
  "Damped harmonic oscillator\n\tas a Sturm-Liouville problem, ",
  ButtonBox["270",
    ButtonData:>{"Chapter4.nb", "i:116"},
    ButtonStyle->"Hyperlink"],
  "\n\tequation, ",
  ButtonBox["70",
    ButtonData:>{"Chapter1.nb", "i:91"},
    ButtonStyle->"Hyperlink"],
  "\n\tGreen's function for, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Green's function(s)",
    ButtonData:>"ii:158",
    ButtonStyle->"Hyperlink"],
  "\n\thomogeneous solution, ",
  ButtonBox["74",
    ButtonData:>{"Chapter1.nb", "i:92"},
    ButtonStyle->"Hyperlink"],
  "\n\tresponse to sinusoial forcing, ",
  ButtonBox["79",
    ButtonData:>{"Chapter1.nb", "i:103"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:387"],

Cell[TextData[{
  "Damping rate, ",
  ButtonBox["9",
    ButtonData:>{"Chapter1.nb", "i:109"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["21",
    ButtonData:>{"Chapter1.nb", "i:110"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["70",
    ButtonData:>{"Chapter1.nb", "i:104"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:74"],

Cell[TextData[{
  "Data\n\tfitting,",
  StyleBox[" see ",
    FontSlant->"Italic"],
  StyleBox[ButtonBox["Fit",
    ButtonData:>"ii:127",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["Least-squares fit",
    ButtonData:>"ii:350",
    ButtonStyle->"Hyperlink"],
  "\n\tinterpolation, ",
  ButtonBox["9.11.3",
    ButtonData:>{"Chapter9.nb", "i:92"},
    ButtonStyle->"Hyperlink"],
  "\n\tplotting, ",
  ButtonBox["9.6.4",
    ButtonData:>{"Chapter9.nb", "i:47"},
    ButtonStyle->"Hyperlink"],
  "\n\treading from a file, ",
  ButtonBox["9.11.4",
    ButtonData:>{"Chapter9.nb", "c:82"},
    ButtonStyle->"Hyperlink"],
  "\n\twriting to a file, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  StyleBox[ButtonBox["Export",
    ButtonData:>"ii:118",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"]
}], "Text",
  CellTags->"ii:75"],

Cell[TextData[{
  "Debye length, ",
  ButtonBox["328",
    ButtonData:>{"Chapter4.nb", "i:80"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:76"],

Cell[TextData[{
  "Decibel, ",
  ButtonBox["389",
    ButtonData:>{"Chapter5.nb", "i:131"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:383"],

Cell[TextData[{
  "Decision tree, ",
  ButtonBox["575",
    ButtonData:>{"Chapter8.nb", "i:12"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:77"],

Cell[TextData[{
  StyleBox["Default3D",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.6.6",
    ButtonData:>{"Chapter9.nb", "i:55"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:78"],

Cell[TextData[{
  "Delta function\n\tDirac, ",
  ButtonBox["135",
    ButtonData:>{"Chapter2.nb", "i:46"},
    ButtonStyle->"Hyperlink"],
  "\n\tKronecker, ",
  ButtonBox["75",
    ButtonData:>{"Chapter1.nb", "i:100"},
    ButtonStyle->"Hyperlink"],
  "\n\tperiodic, ",
  ButtonBox["141",
    ButtonData:>{"Chapter2.nb", "i:48"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["169",
    ButtonData:>{"Chapter2.nb", "i:47"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:79"],

Cell[TextData[{
  "Density\n\tcurrent, ",
  ButtonBox["237",
    ButtonData:>{"Chapter3.nb", "i:77"},
    ButtonStyle->"Hyperlink"],
  "\n\tenergy, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Energy density",
    ButtonData:>"ii:109",
    ButtonStyle->"Hyperlink"],
  "\n\tmass, of various materials, ",
  ButtonBox["Front Matter Tables",
    ButtonData:>{"Frontmattertables.nb", "i:1"},
    ButtonStyle->"Hyperlink"],
  "\n\tmomentum, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Momentum density",
    ButtonData:>"ii:230",
    ButtonStyle->"Hyperlink"],
  "\n\tparticle (or number), ",
  ButtonBox["527",
    ButtonData:>{"Chapter7.nb", "i:12"},
    ButtonStyle->"Hyperlink"],
  "\n\tphase space, ",
  ButtonBox["519",
    ButtonData:>{"Chapter7.nb", "i:20"},
    ButtonStyle->"Hyperlink"],
  "\n\tprobability, ",
  ButtonBox["361",
    ButtonData:>{"Chapter5.nb", "i:12"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["582",
    ButtonData:>{"Chapter8.nb", "i:28"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Schr\[ODoubleDot]dinger's equation",
    ButtonData:>"ii:311",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:80"],

Cell[TextData[{
  "Derivative(s), ",
  ButtonBox["9.9.1",
    ButtonData:>{"Chapter9.nb", "i:70"},
    ButtonStyle->"Hyperlink"],
  "\n\tcentered-difference forms, ",
  ButtonBox["182",
    ButtonData:>{"Chapter2.nb", "i:73"},
    ButtonStyle->"Hyperlink"],
  "\n\tin ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  ", ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  StyleBox[ButtonBox["D",
    ButtonData:>"ii:73",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "\n\tfinite-differenced forms, ",
  ButtonBox["617",
    ButtonData:>{"Appendix.nb", "i:1"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["181",
    ButtonData:>{"Chapter2.nb", "i:74"},
    ButtonStyle->"Hyperlink"],
  "\n\tof a \[Delta]-function, ",
  ButtonBox["139",
    ButtonData:>{"Chapter2.nb", "i:89"},
    ButtonStyle->"Hyperlink"],
  "\n\ttotal time, ",
  ButtonBox["512",
    ButtonData:>{"Chapter7.nb", "i:3"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:81"],

Cell[TextData[{
  StyleBox["Det",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.5.2",
    ButtonData:>{"Chapter9.nb", "i:36"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:82"],

Cell[TextData[{
  "Detailed balance, ",
  ButtonBox["8.3.1",
    ButtonData:>{"Chapter8.nb", "i:66"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:83"],

Cell[TextData[{
  "Differential equations, ",
  ButtonBox["1",
    ButtonData:>{"Chapter1.nb", "i:1"},
    ButtonStyle->"Hyperlink"],
  "\n\tboundary conditions, ",
  ButtonBox["4",
    ButtonData:>{"Chapter1.nb", "i:12"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Boundary value problems",
    ButtonData:>"ii:46",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Boundary conditions",
    ButtonData:>"ii:45",
    ButtonStyle->"Hyperlink"],
  "\n\tgeneral solution, ",
  ButtonBox["2",
    ButtonData:>{"Chapter1.nb", "i:10"},
    ButtonStyle->"Hyperlink"],
  "\n\tgraphical solution, ",
  ButtonBox["5",
    ButtonData:>{"Chapter1.nb", "i:14"},
    ButtonStyle->"Hyperlink"],
  "\n\tinitial conditions, ",
  ButtonBox["2",
    ButtonData:>{"Chapter1.nb", "i:3"},
    ButtonStyle->"Hyperlink"],
  "\n\tordinary, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Ordinary differential equations",
    ButtonData:>"ii:247",
    ButtonStyle->"Hyperlink"],
  "\n\tpartial, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Partial differential equations",
    ButtonData:>"ii:252",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:84"],

Cell[TextData[{
  "Differential operators, ",
  ButtonBox["70",
    ButtonData:>{"Chapter1.nb", "i:131"},
    ButtonStyle->"Hyperlink"],
  "\n\tadjoint of, ",
  ButtonBox["272",
    ButtonData:>{"Chapter4.nb", "i:18"},
    ButtonStyle->"Hyperlink"],
  "\n\tHermitian, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Hermitian operators",
    ButtonData:>"ii:168",
    ButtonStyle->"Hyperlink"],
  "\n\tinverse of, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Green's function(s)",
    ButtonData:>"ii:158",
    ButtonStyle->"Hyperlink"],
  "\n\tlinear, ",
  ButtonBox["70",
    ButtonData:>{"Chapter1.nb", "i:130"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also ",
    FontSlant->"Italic"],
  ButtonBox["Linear ODEs",
    ButtonData:>"ii:205",
    ButtonStyle->"Hyperlink"],
  "\n\tmatrix form by finite-differencing, ",
  ButtonBox["75",
    ButtonData:>{"Chapter1.nb", "i:99"},
    ButtonStyle->"Hyperlink"],
  "\n\tmatrix form by projection onto basis functions, ",
  ButtonBox["438",
    ButtonData:>{"Chapter6.nb", "i:3"},
    ButtonStyle->"Hyperlink"],
  "\n\tnon-Hermitian, ",
  ButtonBox["272",
    ButtonData:>{"Chapter4.nb", "i:17"},
    ButtonStyle->"Hyperlink"],
  "\n\tnonlinear, ",
  ButtonBox["84",
    ButtonData:>{"Chapter1.nb", "i:132"},
    ButtonStyle->"Hyperlink"],
  "\n\tself-adjoint, ",
  ButtonBox["272",
    ButtonData:>{"Chapter4.nb", "i:19"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Hermitian operators",
    ButtonData:>"ii:168",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:85"],

Cell[TextData[{
  "Diffraction, ",
  ButtonBox["372",
    ButtonData:>{"Chapter5.nb", "i:133"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["5.3.1",
    ButtonData:>{"Chapter5.nb", "i:134"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:284"],

Cell[TextData[{
  "Diffusion\n\tcoefficient, ",
  ButtonBox["568",
    ButtonData:>{"Chapter8.nb", "i:4"},
    ButtonStyle->"Hyperlink"],
  "\n\tin random walk, ",
  ButtonBox["581",
    ButtonData:>{"Chapter8.nb", "i:18"},
    ButtonStyle->"Hyperlink"],
  "\n\tequation, ",
  ButtonBox["209",
    ButtonData:>{"Chapter3.nb", "i:114"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["568",
    ButtonData:>{"Chapter8.nb", "i:4"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Heat equation",
    ButtonData:>"ii:164",
    ButtonStyle->"Hyperlink"],
  "\n\tof velocity, ",
  ButtonBox["590",
    ButtonData:>{"Chapter8.nb", "i:40"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Langevin equation",
    ButtonData:>"ii:197",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:86"],

Cell[TextData[{
  StyleBox["DiracDelta",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["139",
    ButtonData:>{"Chapter2.nb", "i:96"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:87"],

Cell[TextData[{
  "Dirac, Paul, ",
  ButtonBox["139",
    ButtonData:>{"Chapter2.nb", "i:112"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Direction field, ",
  ButtonBox["6",
    ButtonData:>{"Chapter1.nb", "i:15"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:88"],

Cell[TextData[{
  StyleBox["Directory",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.11.4",
    ButtonData:>{"Chapter9.nb", "i:128"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["153",
    ButtonData:>{"Chapter2.nb", "i:98"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  StyleBox[ButtonBox["SetDirectory",
    ButtonData:>"ii:306",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"]
}], "Text",
  CellTags->"ii:89"],

Cell[TextData[{
  "Dirichlet\n\tboundary conditions, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Boundary conditions, Dirichlet",
    ButtonData:>"ii:45",
    ButtonStyle->"Hyperlink"],
  "\n\tJohann, ",
  ButtonBox["203",
    ButtonData:>{"Chapter3.nb", "i:10"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:90"],

Cell[TextData[{
  "Dispersion\n\tdefinition, ",
  ButtonBox["360",
    ButtonData:>{"Chapter5.nb", "i:10"},
    ButtonStyle->"Hyperlink"],
  "\n\tfunction, ",
  ButtonBox["375",
    ButtonData:>{"Chapter5.nb", "i:36"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["423",
    ButtonData:>{"Chapter5.nb", "i:119"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["5.3.1\n\t",
    ButtonData:>{"Chapter5.nb", "i:122"},
    ButtonStyle->"Hyperlink"],
  "longitudinal and transverse, ",
  ButtonBox["371",
    ButtonData:>{"Chapter5.nb", "i:24"},
    ButtonStyle->"Hyperlink"],
  "\n\tneglect of, in geometrical optics, ",
  ButtonBox["424",
    ButtonData:>{"Chapter5.nb", "i:89"},
    ButtonStyle->"Hyperlink"],
  "\n\tof a Gaussian wavepacket, in 1 dimension, ",
  ButtonBox["365",
    ButtonData:>{"Chapter5.nb", "i:15"},
    ButtonStyle->"Hyperlink"],
  "\n\tof whistler waves, ",
  ButtonBox["395",
    ButtonData:>{"Chapter5.nb", "i:58"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:91"],

Cell[TextData[{
  "Dispersion relation\n\tfor classical wave equations, ",
  ButtonBox["375",
    ButtonData:>{"Chapter5.nb", "i:36"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor deep water waves, ",
  ButtonBox["387",
    ButtonData:>{"Chapter5.nb", "i:45"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["390",
    ButtonData:>{"Chapter5.nb", "i:52"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor free quantum particle, ",
  ButtonBox["360",
    ButtonData:>{"Chapter5.nb", "i:8"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor heat equation, ",
  ButtonBox["384",
    ButtonData:>{"Chapter5.nb", "i:44"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor light ",
  ButtonBox["415",
    ButtonData:>{"Chapter5.nb", "i:129"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor sound waves, ",
  ButtonBox["563",
    ButtonData:>{"Chapter7.nb", "i:42"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor water waves including surface tension, ",
  ButtonBox["387",
    ButtonData:>{"Chapter5.nb", "i:46"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor waves on a string, ",
  ButtonBox["357",
    ButtonData:>{"Chapter5.nb", "i:3"},
    ButtonStyle->"Hyperlink"],
  "\n\tlocal, ",
  ButtonBox["5.3.1",
    ButtonData:>{"Chapter5.nb", "i:91"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Distribution\n\tbinomial, ",
  ButtonBox["575",
    ButtonData:>{"Chapter8.nb", "i:81"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["577",
    ButtonData:>{"Chapter8.nb", "i:82"},
    ButtonStyle->"Hyperlink"],
  "\n\tBoltzmann, ",
  ButtonBox["605",
    ButtonData:>{"Chapter8.nb", "i:56"},
    ButtonStyle->"Hyperlink"],
  "\n\tGaussian, ",
  ButtonBox["588",
    ButtonData:>{"Chapter8.nb", "i:33"},
    ButtonStyle->"Hyperlink"],
  "\n\tGibbs, ",
  ButtonBox["8.3.1",
    ButtonData:>{"Chapter8.nb", "i:60"},
    ButtonStyle->"Hyperlink"],
  "\n\tMaxwellian, ",
  ButtonBox["611",
    ButtonData:>{"Chapter8.nb", "i:76"},
    ButtonStyle->"Hyperlink"],
  "\n\tPoisson, ",
  ButtonBox["588",
    ButtonData:>{"Chapter8.nb", "i:34"},
    ButtonStyle->"Hyperlink"],
  "\n\tprobability, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Probability",
    ButtonData:>"ii:281",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:92"],

Cell[TextData[{
  StyleBox["Do",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["440",
    ButtonData:>{"Chapter6.nb", "i:59"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:93"],

Cell[TextData[{
  "Dominant balance, ",
  ButtonBox["398",
    ButtonData:>{"Chapter5.nb", "i:70"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["425",
    ButtonData:>{"Chapter5.nb", "i:110"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:94"],

Cell[TextData[{
  "Doppler shift, ",
  ButtonBox["382",
    ButtonData:>{"Chapter5.nb", "i:39"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:95"],

Cell[TextData[{
  "Dot product, ",
  ButtonBox["9.5.2",
    ButtonData:>{"Chapter9.nb", "i:31"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Inner product",
    ButtonData:>"ii:179",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:96"],

Cell[TextData[{
  StyleBox["DSolve",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["17",
    ButtonData:>{"Chapter1.nb", "i:30"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:97"],

Cell[BoxData[""], "Input"],

Cell[TextData[{
  StyleBox["E",
    FontWeight->"Bold"],
  "\[Times]",
  StyleBox["B ",
    FontWeight->"Bold"],
  "drift, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Velocity, ",
    ButtonData:>"ii:354",
    ButtonStyle->"Hyperlink"],
  StyleBox[ButtonBox["E",
    ButtonData:>"ii:354",
    ButtonStyle->"Hyperlink"],
    FontWeight->"Bold"],
  ButtonBox["\[Times]",
    ButtonData:>"ii:354",
    ButtonStyle->"Hyperlink"],
  StyleBox[ButtonBox["B",
    ButtonData:>"ii:354",
    ButtonStyle->"Hyperlink"],
    FontWeight->"Bold"],
  ButtonBox[" drift",
    ButtonData:>"ii:354",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->{"E", "ii:98"}],

Cell[TextData[{
  "Ear, inner, ",
  ButtonBox["108",
    ButtonData:>{"Chapter2.nb", "i:32"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Sound",
    ButtonData:>"ii:320",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Eccentricity, ",
  ButtonBox["22",
    ButtonData:>{"Chapter1.nb", "i:34"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["9.6 Exercise 3",
    ButtonData:>{"Chapter9.nb", "i:59"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:99"],

Cell[TextData[{
  "Eden model, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Random walk(s)",
    ButtonData:>"ii:285",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Eigenmodes\n\tcompressional, for elastic rod, ",
  ButtonBox["295",
    ButtonData:>{"Chapter4.nb", "i:46"},
    ButtonStyle->"Hyperlink"],
  "\n\tDirichlet, in heat equation, ",
  ButtonBox["214",
    ButtonData:>{"Chapter3.nb", "i:35"},
    ButtonStyle->"Hyperlink"],
  "\n\tDirichlet, in wave equation, ",
  ButtonBox["197",
    ButtonData:>{"Chapter3.nb", "i:12"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor electron in a periodic lattice, ",
  ButtonBox["276",
    ButtonData:>{"Chapter4.nb", "i:32"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor quantum harmonic oscillator, ",
  ButtonBox["276",
    ButtonData:>{"Chapter4.nb", "i:29"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor quantum particle in a box, ",
  ButtonBox["275",
    ButtonData:>{"Chapter4.nb", "i:33"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor quantum particle in gravity, ",
  ButtonBox["277",
    ButtonData:>{"Chapter4.nb", "i:31"},
    ButtonStyle->"Hyperlink"],
  "\n\tin a coffee cup, ",
  ButtonBox["353",
    ButtonData:>{"Chapter4.nb", "i:102"},
    ButtonStyle->"Hyperlink"],
  "\n\tin a water channel of nonuniform depth, ",
  ButtonBox["296",
    ButtonData:>{"Chapter4.nb", "i:49"},
    ButtonStyle->"Hyperlink"],
  "\n\tin a water channel of uniform depth, ",
  ButtonBox["227",
    ButtonData:>{"Chapter3.nb", "i:98"},
    ButtonStyle->"Hyperlink"],
  "\n\tmixed, for heat equation, ",
  ButtonBox["221",
    ButtonData:>{"Chapter3.nb", "i:38"},
    ButtonStyle->"Hyperlink"],
  "\n\tnumerical, ",
  ButtonBox["6.3",
    ButtonData:>{"Chapter6.nb", "i:39"},
    ButtonStyle->"Hyperlink"],
  "\n\tnumerical, via Galerkin method, ",
  ButtonBox["6.3.3",
    ButtonData:>{"Chapter6.nb", "i:41"},
    ButtonStyle->"Hyperlink"],
  "\n\tnumerical, via grid method, ",
  ButtonBox["6.3.2",
    ButtonData:>{"Chapter6.nb", "i:42"},
    ButtonStyle->"Hyperlink"],
  "\n\tnumerical, via shooting method, ",
  ButtonBox["6.3.4",
    ButtonData:>{"Chapter6.nb", "i:40"},
    ButtonStyle->"Hyperlink"],
  "\n\tof a circular drumhead, ",
  ButtonBox["334",
    ButtonData:>{"Chapter4.nb", "i:90"},
    ButtonStyle->"Hyperlink"],
  "\n\tof a quantum dot, ",
  ButtonBox["350",
    ButtonData:>{"Chapter4.nb", "i:96"},
    ButtonStyle->"Hyperlink"],
  "\n\tof a rubber ball, ",
  ButtonBox["350",
    ButtonData:>{"Chapter4.nb", "i:98"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["351",
    ButtonData:>{"Chapter4.nb", "i:99"},
    ButtonStyle->"Hyperlink"],
  "\n\tof a tidal estuary, ",
  ButtonBox["297",
    ButtonData:>{"Chapter4.nb", "i:51"},
    ButtonStyle->"Hyperlink"],
  "\n\tof ",
  Cell[BoxData[
      \(TraditionalForm\`\[Del]\^2\)]],
  ", ",
  ButtonBox["304",
    ButtonData:>{"Chapter4.nb", "i:63"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Laplacian operator",
    ButtonData:>"ii:200",
    ButtonStyle->"Hyperlink"],
  "\n\tof drumheads with arbitrary shape, ",
  ButtonBox["6.3.2",
    ButtonData:>{"Chapter6.nb", "i:47"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["6.3.3",
    ButtonData:>{"Chapter6.nb", "i:48"},
    ButtonStyle->"Hyperlink"],
  "\n\tof Hermitian operators, ",
  ButtonBox["270",
    ButtonData:>{"Chapter4.nb", "i:12"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Sturm-Liouville problems",
    ButtonData:>"ii:331",
    ButtonStyle->"Hyperlink"],
  "\n\tof the hydrogen atom, ",
  ButtonBox["350",
    ButtonData:>{"Chapter4.nb", "i:97"},
    ButtonStyle->"Hyperlink"],
  "\n\tof the ocean, ",
  ButtonBox["340",
    ButtonData:>{"Chapter4.nb", "i:92"},
    ButtonStyle->"Hyperlink"],
  "\n\tperturbed quantum, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Perturbation theory",
    ButtonData:>"ii:257",
    ButtonStyle->"Hyperlink"],
  "\n\ttransverse, for elastic rod, ",
  ButtonBox["297",
    ButtonData:>{"Chapter4.nb", "i:44"},
    ButtonStyle->"Hyperlink"],
  "\n\tvia the WKB method, ",
  ButtonBox["6.3.4",
    ButtonData:>{"Chapter6.nb", "i:43"},
    ButtonStyle->"Hyperlink"],
  "\n\tvon Neumann, for heat equation, ",
  ButtonBox["217",
    ButtonData:>{"Chapter3.nb", "i:39"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:100"],

Cell[TextData[{
  "Eigenvalue problems, ",
  StyleBox["see also ",
    FontSlant->"Italic"],
  ButtonBox["Eigenmodes",
    ButtonData:>"ii:100",
    ButtonStyle->"Hyperlink"],
  "\n\tand orthogonality of eigenmodes, ",
  ButtonBox["253",
    ButtonData:>{"Chapter3.nb", "i:107"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also ",
    FontSlant->"Italic"],
  ButtonBox["Hermitian operators",
    ButtonData:>"ii:168",
    ButtonStyle->"Hyperlink"],
  "\n\tdefinition, ",
  ButtonBox["64",
    ButtonData:>{"Chapter1.nb", "i:80"},
    ButtonStyle->"Hyperlink"],
  "\n\tin linear algebra, ",
  ButtonBox["9.5.2",
    ButtonData:>{"Chapter9.nb", "i:35"},
    ButtonStyle->"Hyperlink"],
  "\n\tnumerical solution of, ",
  ButtonBox["6.3",
    ButtonData:>{"Chapter6.nb", "i:39"},
    ButtonStyle->"Hyperlink"],
  "\n",
  ButtonBox["\t",
    ButtonData:>{"Chapter3.nb", "i:37"},
    ButtonStyle->"Hyperlink"],
  "with periodic boundary conditions, ",
  ButtonBox["239",
    ButtonData:>{"Chapter3.nb", "i:105"},
    ButtonStyle->"Hyperlink"],
  "\n\twith singular boundary conditions, ",
  ButtonBox["241",
    ButtonData:>{"Chapter3.nb", "i:69"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["248",
    ButtonData:>{"Chapter3.nb", "i:106"},
    ButtonStyle->"Hyperlink"],
  "\n"
}], "Text",
  CellTags->"ii:101"],

Cell[TextData[{
  StyleBox["Eigenvalues ",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "and ",
  StyleBox["Eigenvectors",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.5.2",
    ButtonData:>{"Chapter9.nb", "i:105"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:102"],

Cell[TextData[{
  "Eigenvalues, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Eigenmodes",
    ButtonData:>"ii:100",
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["Eigenvalue problems",
    ButtonData:>"ii:101",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:103"],

Cell[TextData[{
  "Eikonal, ",
  ButtonBox["396",
    ButtonData:>{"Chapter5.nb", "i:67"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["WKB method",
    ButtonData:>"ii:374",
    ButtonStyle->"Hyperlink"],
  "\n\tequation, ",
  ButtonBox["5.3.1",
    ButtonData:>{"Chapter5.nb", "i:121"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:104"],

Cell[TextData[{
  "Einstein\n\tAlbert, ",
  ButtonBox["20",
    ButtonData:>{"Chapter1.nb", "i:128"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["51",
    ButtonData:>{"Chapter1.nb", "i:127"},
    ButtonStyle->"Hyperlink"],
  "\n\trelation, ",
  ButtonBox["590",
    ButtonData:>{"Chapter8.nb", "i:38"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["606",
    ButtonData:>{"Chapter8.nb", "i:57"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:105"],

Cell[TextData[{
  StyleBox["EllipticF",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["540",
    ButtonData:>{"Chapter7.nb", "i:27"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:107"],

Cell[TextData[{
  StyleBox["EllipticK",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["541",
    ButtonData:>{"Chapter7.nb", "i:29"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:108"],

Cell[TextData[{
  "Energy, ",
  ButtonBox["13",
    ButtonData:>{"Chapter1.nb", "i:23"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["58",
    ButtonData:>{"Chapter1.nb", "i:78"},
    ButtonStyle->"Hyperlink"],
  "\n\tcascade, ",
  ButtonBox["548",
    ButtonData:>{"Chapter7.nb", "i:53"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Wavebreaking",
    ButtonData:>"ii:361",
    ButtonStyle->"Hyperlink"],
  "\n\tconservation, in heat equation, ",
  ButtonBox["208",
    ButtonData:>{"Chapter3.nb", "i:102"},
    ButtonStyle->"Hyperlink"],
  "\n\tconservation, in wave equation, ",
  ButtonBox["282",
    ButtonData:>{"Chapter4.nb", "i:39"},
    ButtonStyle->"Hyperlink"],
  "\n\tdensity,  ",
  ButtonBox["207",
    ButtonData:>{"Chapter3.nb", "i:22"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["373",
    ButtonData:>{"Chapter5.nb", "i:28"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["377",
    ButtonData:>{"Chapter5.nb", "i:32"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["5.3.2",
    ButtonData:>{"Chapter5.nb", "i:93"},
    ButtonStyle->"Hyperlink"],
  "\t\n\tequipartition, ",
  ButtonBox["565",
    ButtonData:>{"Chapter7.nb", "i:52"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Wavebreaking, suppression of",
    ButtonData:>"ii:361",
    ButtonStyle->"Hyperlink"],
  "\n\tflux, ",
  ButtonBox["206",
    ButtonData:>{"Chapter3.nb", "i:101"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["377",
    ButtonData:>{"Chapter5.nb", "i:116"},
    ButtonStyle->"Hyperlink"],
  "\n\tin a wavepacket, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Wavepacket",
    ButtonData:>"ii:365",
    ButtonStyle->"Hyperlink"],
  "\n\tlevels, ",
  ButtonBox["276",
    ButtonData:>{"Chapter4.nb", "i:28"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Schr\[ODoubleDot]dinger's equation",
    ButtonData:>"ii:311",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Eigenmodes",
    ButtonData:>"ii:100",
    ButtonStyle->"Hyperlink"],
  "\n\tof waves on a drumhead, ",
  ButtonBox["346",
    ButtonData:>{"Chapter4.nb", "i:94"},
    ButtonStyle->"Hyperlink"],
  "\n\tperturbed, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Perturbation theory",
    ButtonData:>"ii:257",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:109"],

Cell[TextData[{
  "Ensemble, ",
  ButtonBox["8.3.1",
    ButtonData:>{"Chapter8.nb", "i:61"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:110"],

Cell[TextData[{
  "Entropy, ",
  ButtonBox["584",
    ButtonData:>{"Chapter8.nb", "i:25"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:111"],

Cell[TextData[{
  "Equation(s)\n\t2D fluid, ",
  ButtonBox["7.3 Exercise 5",
    ButtonData:>{"Chapter7.nb", "i:65"},
    ButtonStyle->"Hyperlink"],
  "\n\talgebraic, solution of, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Solution of algebraic equations",
    ButtonData:>"ii:318",
    ButtonStyle->"Hyperlink"],
  "\n\tdifferential, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Differential equations",
    ButtonData:>"ii:84",
    ButtonStyle->"Hyperlink"],
  "\n\tNavier-Stokes, ",
  ButtonBox["562",
    ButtonData:>{"Chapter7.nb", "i:41"},
    ButtonStyle->"Hyperlink"],
  "\n\tmeaning of =, := and ==, ",
  ButtonBox["9.10.1",
    ButtonData:>{"Chapter9.nb", "i:109"},
    ButtonStyle->"Hyperlink"],
  "\n\tof state, ",
  ButtonBox["563",
    ButtonData:>{"Chapter7.nb", "i:40"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:112"],

Cell[TextData[{
  "Equilibrium\n\tchemical, for disociation of ",
  Cell[BoxData[
      \(TraditionalForm\`H\_2\)]],
  ", ",
  ButtonBox["21",
    ButtonData:>{"Chapter1.nb", "i:115"},
    ButtonStyle->"Hyperlink"],
  "\n\tconfiguration of a molecule, ",
  ButtonBox["60",
    ButtonData:>{"Chapter1.nb", "i:71"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["8.3.2",
    ButtonData:>{"Chapter8.nb", "i:72"},
    ButtonStyle->"Hyperlink"],
  "\n\tdeformation of earth, ",
  ButtonBox["332",
    ButtonData:>{"Chapter4.nb", "i:87"},
    ButtonStyle->"Hyperlink"],
  "\n\texistence of, in heat equation, ",
  ButtonBox["211",
    ButtonData:>{"Chapter3.nb", "i:31"},
    ButtonStyle->"Hyperlink"],
  "\n\tof an elastic band in gravity, ",
  ButtonBox["9.10 Exercise 4",
    ButtonData:>{"Chapter9.nb", "i:88"},
    ButtonStyle->"Hyperlink"],
  "\n\tof a horizontal rod in gravity, ",
  ButtonBox["9.10 Exercise 5",
    ButtonData:>{"Chapter9.nb", "i:89"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["295",
    ButtonData:>{"Chapter4.nb", "i:45"},
    ButtonStyle->"Hyperlink"],
  "\n\tof a stretched string, ",
  ButtonBox["191",
    ButtonData:>{"Chapter3.nb", "i:4"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["224",
    ButtonData:>{"Chapter3.nb", "i:47"},
    ButtonStyle->"Hyperlink"],
  "\n\tof a string in gravity (catenary), ",
  ButtonBox["205",
    ButtonData:>{"Chapter3.nb", "i:5"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["228",
    ButtonData:>{"Chapter3.nb", "i:96"},
    ButtonStyle->"Hyperlink"],
  "\n\tof a vertical rod in gravity, ",
  ButtonBox["9.10.1",
    ButtonData:>{"Chapter9.nb", "i:107"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["224",
    ButtonData:>{"Chapter3.nb", "i:46"},
    ButtonStyle->"Hyperlink"],
  "\n\tof pyramid in gravity, ",
  ButtonBox["9.10 Exercise 7",
    ButtonData:>{"Chapter9.nb", "i:90"},
    ButtonStyle->"Hyperlink"],
  "\n\ttemperature in heat equation, ",
  ButtonBox["211",
    ButtonData:>{"Chapter3.nb", "i:30"},
    ButtonStyle->"Hyperlink"],
  "\n\tthermal, ",
  ButtonBox["526",
    ButtonData:>{"Chapter7.nb", "i:11"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["605",
    ButtonData:>{"Chapter8.nb", "i:42"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Thermal equilibrium",
    ButtonData:>"ii:340",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:113"],

Cell[TextData[{
  "Equipartition, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Energy equipartition",
    ButtonData:>"ii:109",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Error\n\tin chaotic systems, ",
  ButtonBox["27",
    ButtonData:>{"Chapter1.nb", "i:26"},
    ButtonStyle->"Hyperlink"],
  "\n\tin numerical solution of algebraic equations, ",
  ButtonBox["9.11.1",
    ButtonData:>{"Chapter9.nb", "i:102"},
    ButtonStyle->"Hyperlink"],
  "\n\torder of, in numerical method, ",
  ButtonBox["38",
    ButtonData:>{"Chapter1.nb", "i:48"},
    ButtonStyle->"Hyperlink"],
  "\n\tstatistical, ",
  ButtonBox["8.3.2",
    ButtonData:>{"Chapter8.nb", "i:70"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Random walk",
    ButtonData:>"ii:285",
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["Correlation function",
    ButtonData:>"ii:69",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Euler\n\tequations, ",
  ButtonBox["7.3 Exercise 5",
    ButtonData:>{"Chapter7.nb", "i:84"},
    ButtonStyle->"Hyperlink"],
  "\n\tLeonhard, ",
  ButtonBox["31",
    ButtonData:>{"Chapter1.nb", "i:47"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Euler's method ",
  ButtonBox["31",
    ButtonData:>{"Chapter1.nb", "i:46"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["38",
    ButtonData:>{"Chapter1.nb", "i:125"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["75",
    ButtonData:>{"Chapter1.nb", "i:126"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["175",
    ButtonData:>{"Chapter2.nb", "i:90"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["182",
    ButtonData:>{"Chapter2.nb", "i:92"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["188",
    ButtonData:>{"Chapter2.nb", "i:91"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Numerical solution of ODEs",
    ButtonData:>"ii:244",
    ButtonStyle->"Hyperlink"],
  "\n\tfor systems of ODEs, ",
  ButtonBox["41",
    ButtonData:>{"Chapter1.nb", "i:52"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:115"],

Cell[TextData[{
  "Evanescence, ",
  ButtonBox["422",
    ButtonData:>{"Chapter5.nb", "i:138"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Turning points",
    ButtonData:>"ii:348",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Exact mathematics, ",
  ButtonBox["9.2.2",
    ButtonData:>{"Chapter9.nb", "i:16"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:116"],

Cell[TextData[{
  StyleBox["Expand",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.8.1",
    ButtonData:>{"Chapter9.nb", "i:62"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:117"],

Cell[TextData[{
  "Expected value, ",
  ButtonBox["569",
    ButtonData:>{"Chapter8.nb", "i:91"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Average(s)",
    ButtonData:>"ii:29",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Explicit methods, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Grid methods",
    ButtonData:>"ii:159",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  StyleBox["Export",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["7.3 Exercise 5",
    ButtonData:>{"Chapter7.nb", "i:67"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also ",
    FontSlant->"Italic"],
  StyleBox[ButtonBox["Import",
    ButtonData:>"ii:177",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"]
}], "Text",
  CellTags->"ii:118"],

Cell[TextData[{
  "ExtendGraphics packages, ",
  ButtonBox["9.6.8",
    ButtonData:>{"Chapter9.nb", "i:114"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:119"],

Cell[TextData[{
  "Extrasolar planets, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Planets, extrasolar",
    ButtonData:>"ii:381",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[BoxData[""], "Input"],

Cell[TextData[{
  StyleBox["Factor",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.8.1",
    ButtonData:>{"Chapter9.nb", "i:63"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->{"F", "ii:120"}],

Cell[TextData[{
  "Fermat's spiral, ",
  ButtonBox["9.6.8",
    ButtonData:>{"Chapter9.nb", "i:58"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:121"],

Cell[TextData[{
  "Fermi, Enrico, ",
  ButtonBox["565",
    ButtonData:>{"Chapter7.nb", "i:52"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:122"],

Cell[TextData[{
  "Fermi Pasta Ulam system, ",
  StyleBox[" see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Ordinary Differential Equations",
    ButtonData:>"ii:247",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "FFTs, ",
  ButtonBox["144",
    ButtonData:>{"Chapter2.nb", "c:35"},
    ButtonStyle->"Hyperlink"],
  "\n\tin ",
  StyleBox["Mathematica,",
    FontSlant->"Italic"],
  " ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Fourier and Inverse Fourier",
    ButtonData:>"ii:137",
    ButtonStyle->"Hyperlink"],
  "\n\tfor boundary value problems, ",
  ButtonBox["499",
    ButtonData:>{"Chapter6.nb", "i:36"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor real data, ",
  ButtonBox["151",
    ButtonData:>{"Chapter2.nb", "i:56"},
    ButtonStyle->"Hyperlink"],
  "\n\tin PIC method, ",
  ButtonBox["7.3.4",
    ButtonData:>{"Chapter7.nb", "i:62"},
    ButtonStyle->"Hyperlink"],
  "\n\tused in frequency filtering, ",
  ButtonBox["156",
    ButtonData:>{"Chapter2.nb", "i:57"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:123"],

Cell[TextData[{
  "Fick's law, ",
  ButtonBox["206",
    ButtonData:>{"Chapter3.nb", "i:113"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["567",
    ButtonData:>{"Chapter8.nb", "i:3"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:124"],

Cell[TextData[{
  "Field lines, chaotic magnetic field, ",
  ButtonBox["54",
    ButtonData:>{"Chapter1.nb", "i:63"},
    ButtonStyle->"Hyperlink"],
  "\n\tdifferential equation, ",
  ButtonBox["16",
    ButtonData:>{"Chapter1.nb", "i:36"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor TE modes in a cubic cavity, ",
  ButtonBox["51",
    ButtonData:>{"Chapter1.nb", "i:57"},
    ButtonStyle->"Hyperlink"],
  "\n\tfrom a point dipole, ",
  ButtonBox["22",
    ButtonData:>{"Chapter1.nb", "i:35"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:125"],

Cell[TextData[{
  StyleBox["FindRoot",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.11.1",
    ButtonData:>{"Chapter9.nb", "i:84"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:126"],

Cell[TextData[{
  "Finite element methods, ",
  ButtonBox["491",
    ButtonData:>{"Chapter6.nb", "i:68"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Grid methods",
    ButtonData:>"ii:159",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:277"],

Cell[TextData[{
  StyleBox["Fit",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.11.4",
    ButtonData:>{"Chapter9.nb", "i:95"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:127"],

Cell[TextData[{
  "Fitting data, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  " ",
  StyleBox[ButtonBox["Fit",
    ButtonData:>"ii:127",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ",",
  " ",
  ButtonBox["Least-squares fit",
    ButtonData:>"ii:350",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Fixed points, ",
  ButtonBox["10",
    ButtonData:>{"Chapter1.nb", "i:114"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["12",
    ButtonData:>{"Chapter1.nb", "i:113"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:128"],

Cell[TextData[{
  StyleBox["Flatten",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.5.4",
    ButtonData:>{"Chapter9.nb", "i:41"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Fluctuations, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Average(s)",
    ButtonData:>"ii:29",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Probability",
    ButtonData:>"ii:281",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:129"],

Cell[TextData[{
  "Flux\n\theat, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Energy flux",
    ButtonData:>"ii:109",
    ButtonStyle->"Hyperlink"],
  "\n\tmomentum, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Momentum flux",
    ButtonData:>"ii:230",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:130"],

Cell[TextData[{
  "Fokker-Planck equation, ",
  ButtonBox["583",
    ButtonData:>{"Chapter8.nb", "i:20"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor inhomogeneous system, ",
  ButtonBox["597",
    ButtonData:>{"Chapter8.nb", "i:50"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor the Rosenbluth-Teller-Metropolis Monte Carlo method, ",
  ButtonBox["8.3.1",
    ButtonData:>{"Chapter8.nb", "i:67"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor velocity diffusion, ",
  ButtonBox["611",
    ButtonData:>{"Chapter8.nb", "i:75"},
    ButtonStyle->"Hyperlink"],
  "\n\tirreversible nature of solutions, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Irreversibility",
    ButtonData:>"ii:188",
    ButtonStyle->"Hyperlink"],
  "\n\tnumerical solution via random walk, ",
  ButtonBox["598",
    ButtonData:>{"Chapter8.nb", "c:17"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:131"],

Cell[TextData[{
  "Forcing, ",
  ButtonBox["70",
    ButtonData:>{"Chapter1.nb", "i:104"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["79",
    ButtonData:>{"Chapter1.nb", "i:94"},
    ButtonStyle->"Hyperlink"],
  "\n\tdelta-function, ",
  ButtonBox["161",
    ButtonData:>{"Chapter2.nb", "i:83"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Green's functions",
    ButtonData:>"ii:158",
    ButtonStyle->"Hyperlink"],
  "\n\tgeneral, possibly nonperiodic, ",
  ButtonBox["158",
    ButtonData:>{"Chapter2.nb", "i:54"},
    ButtonStyle->"Hyperlink"],
  "\n\tinclusion of boundary conditions in, ",
  ButtonBox["184",
    ButtonData:>{"Chapter2.nb", "i:76"},
    ButtonStyle->"Hyperlink"],
  "\n\tperiodic, ",
  ButtonBox["87",
    ButtonData:>{"Chapter2.nb", "i:2"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["105",
    ButtonData:>{"Chapter2.nb", "i:22"},
    ButtonStyle->"Hyperlink"],
  "\n\tsinusoidal, ",
  ButtonBox["79",
    ButtonData:>{"Chapter1.nb", "i:103"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:132"],

Cell[TextData[{
  "Forward difference, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Derivatives, finite-differenced forms",
    ButtonData:>"ii:81",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:133"],

Cell[TextData[{
  "Fourier coefficients, ",
  ButtonBox["90",
    ButtonData:>{"Chapter2.nb", "i:5"},
    ButtonStyle->"Hyperlink"],
  "\n\texponential, ",
  ButtonBox["104",
    ButtonData:>{"Chapter2.nb", "i:20"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor a square wave, ",
  ButtonBox["96",
    ButtonData:>{"Chapter2.nb", "i:9"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor a triangle wave, ",
  ButtonBox["94",
    ButtonData:>{"Chapter2.nb", "i:7"},
    ButtonStyle->"Hyperlink"],
  "\n\tgeneralized, ",
  ButtonBox["266",
    ButtonData:>{"Chapter4.nb", "i:21"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:134"],

Cell[TextData[{
  StyleBox["Fourier",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  " and ",
  StyleBox["InverseFourier ",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ButtonBox["152",
    ButtonData:>{"Chapter2.nb", "i:101"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:137"],

Cell[TextData[{
  "Fourier, Jean, ",
  ButtonBox["87",
    ButtonData:>{"Chapter2.nb", "i:2"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:135"],

Cell[TextData[{
  "Fourier series, ",
  ButtonBox["89",
    ButtonData:>{"Chapter2.nb", "i:3"},
    ButtonStyle->"Hyperlink"],
  "\n\tcompleteness, ",
  ButtonBox["268",
    ButtonData:>{"Chapter4.nb", "i:11"},
    ButtonStyle->"Hyperlink"],
  "\n\texponential, for general functions, ",
  ButtonBox["103",
    ButtonData:>{"Chapter2.nb", "i:19"},
    ButtonStyle->"Hyperlink"],
  "\n\texponential, for real functions, ",
  ButtonBox["102",
    ButtonData:>{"Chapter2.nb", "i:18"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor even and odd functions, ",
  ButtonBox["94",
    ButtonData:>{"Chapter2.nb", "i:13"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor functions defined on an interval, ",
  ButtonBox["111",
    ButtonData:>{"Chapter2.nb", "i:15"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor periodic functions, ",
  ButtonBox["87",
    ButtonData:>{"Chapter2.nb", "i:14"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor a square wave, ",
  ButtonBox["96",
    ButtonData:>{"Chapter2.nb", "i:9"},
    ButtonStyle->"Hyperlink"],
  "\n\tgeneralized, ",
  ButtonBox["261",
    ButtonData:>{"Chapter4.nb", "i:3"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["266",
    ButtonData:>{"Chapter4.nb", "i:10"},
    ButtonStyle->"Hyperlink"],
  "\n\tin solution of heat equation, ",
  ButtonBox["214",
    ButtonData:>{"Chapter3.nb", "i:34"},
    ButtonStyle->"Hyperlink"],
  "\n\tin solution of wave equation, ",
  ButtonBox["198",
    ButtonData:>{"Chapter3.nb", "i:13"},
    ButtonStyle->"Hyperlink"],
  "\n\tuniform convergence, ",
  ButtonBox["98",
    ButtonData:>{"Chapter2.nb", "i:11"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Convergence",
    ButtonData:>"ii:66",
    ButtonStyle->"Hyperlink"],
  "\n\tused in solving boundary value problems, ",
  ButtonBox["118",
    ButtonData:>{"Chapter2.nb", "i:33"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  StyleBox["FourierTransform",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  " and ",
  StyleBox["InverseFourierTransform",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["124",
    ButtonData:>{"Chapter2.nb", "i:42"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:138"],

Cell[TextData[{
  "Fourier transforms, ",
  ButtonBox["122",
    ButtonData:>{"Chapter2.nb", "i:38"},
    ButtonStyle->"Hyperlink"],
  "\n\tconnection to Fourier series, ",
  ButtonBox["141",
    ButtonData:>{"Chapter2.nb", "i:49"},
    ButtonStyle->"Hyperlink"],
  "\n\tconventions in time and space, ",
  ButtonBox["123",
    ButtonData:>{"Chapter2.nb", "i:40"},
    ButtonStyle->"Hyperlink"],
  "\n\tdiscrete, ",
  ButtonBox["144",
    ButtonData:>{"Chapter2.nb", "i:53"},
    ButtonStyle->"Hyperlink"],
  "\n\tfast, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["FFTs",
    ButtonData:>"ii:123",
    ButtonStyle->"Hyperlink"],
  "\n\tgeneralized, ",
  ButtonBox["137",
    ButtonData:>{"Chapter2.nb", "i:50"},
    ButtonStyle->"Hyperlink"],
  "\n\tin cylindrical coordinates, ",
  ButtonBox["390",
    ButtonData:>{"Chapter5.nb", "i:52"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["390-393",
    ButtonData:>{"Chapter5.nb", "i:62"},
    ButtonStyle->"Hyperlink"],
  "\n\tin ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  ", ",
  StyleBox["see ",
    FontSlant->"Italic"],
  StyleBox[ButtonBox["FourierTransform",
    ButtonData:>"ii:138",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ButtonBox[" and ",
    ButtonData:>"ii:138",
    ButtonStyle->"Hyperlink"],
  StyleBox[ButtonBox["InverseFourierTransform",
    ButtonData:>"ii:138",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "\n\tin solution of 3D heat equation, ",
  ButtonBox["384",
    ButtonData:>{"Chapter5.nb", "i:60"},
    ButtonStyle->"Hyperlink"],
  "\n\tin solution of 3D wave equation, ",
  ButtonBox["369",
    ButtonData:>{"Chapter5.nb", "i:59"},
    ButtonStyle->"Hyperlink"],
  "\n\tin spherical coordinates, ",
  ButtonBox["378",
    ButtonData:>{"Chapter5.nb", "i:40"},
    ButtonStyle->"Hyperlink"],
  "\n\tinverse, ",
  ButtonBox["123",
    ButtonData:>{"Chapter2.nb", "i:39"},
    ButtonStyle->"Hyperlink"],
  "\n\tsine and cosine, ",
  ButtonBox["129",
    ButtonData:>{"Chapter2.nb", "i:43"},
    ButtonStyle->"Hyperlink"],
  "\n\tused to solve 1D wave equation, ",
  ButtonBox["356",
    ButtonData:>{"Chapter5.nb", "i:5"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:139"],

Cell[TextData[{
  "Free energy, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Irreversibility, in a confined system",
    ButtonData:>"ii:188",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:140"],

Cell[TextData[{
  "Frequency\n\tcollision, ",
  ButtonBox["568",
    ButtonData:>{"Chapter8.nb", "i:5"},
    ButtonStyle->"Hyperlink"],
  "\n\tcyclotron, ",
  ButtonBox["22",
    ButtonData:>{"Chapter1.nb", "i:135"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["395",
    ButtonData:>{"Chapter5.nb", "i:57"},
    ButtonStyle->"Hyperlink"],
  "\n\tfundamental, ",
  ButtonBox["87",
    ButtonData:>{"Chapter2.nb", "i:97"},
    ButtonStyle->"Hyperlink"],
  "\n\tNyquist, ",
  ButtonBox["150",
    ButtonData:>{"Chapter2.nb", "i:55"},
    ButtonStyle->"Hyperlink"],
  "\n\tplasma, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Plasma frequency",
    ButtonData:>"ii:262",
    ButtonStyle->"Hyperlink"],
  "\n\tspectrum, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Spectrum",
    ButtonData:>"ii:377",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:141"],

Cell[TextData[{
  "Front End, ",
  ButtonBox["9.3",
    ButtonData:>{"Chapter9.nb", "i:8"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:142"],

Cell[TextData[{
  "FTCS method, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Grid methods",
    ButtonData:>"ii:159",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  StyleBox["FullSimplify",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.8.1",
    ButtonData:>{"Chapter9.nb", "i:64"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:143"],

Cell[TextData[{
  "Function(s)\n\t adding conditions to the definition (",
  StyleBox["/;",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "), ",
  ButtonBox["9.8.6",
    ButtonData:>{"Chapter9.nb", "i:69"},
    ButtonStyle->"Hyperlink"],
  "\n\tAiry, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Airy functions",
    ButtonData:>"ii:23",
    ButtonStyle->"Hyperlink"],
  "\n\tassociated Legendre, ",
  ButtonBox["241",
    ButtonData:>{"Chapter3.nb", "i:70"},
    ButtonStyle->"Hyperlink"],
  "\n\tbasis, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Basis functions",
    ButtonData:>"ii:32",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Galerkin method",
    ButtonData:>"ii:147",
    ButtonStyle->"Hyperlink"],
  "\n\tBessel, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Bessel functions",
    ButtonData:>"ii:36",
    ButtonStyle->"Hyperlink"],
  "\n\tcorrelation, ",
  ButtonBox["595",
    ButtonData:>{"Chapter8.nb", "i:47"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["8.3.2",
    ButtonData:>{"Chapter8.nb", "i:71"},
    ButtonStyle->"Hyperlink"],
  "\n\tdelayed evaluation of (",
  StyleBox[":=",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "), ",
  ButtonBox["9.8.5",
    ButtonData:>{"Chapter9.nb", "i:68"},
    ButtonStyle->"Hyperlink"],
  "\n\terror, ",
  ButtonBox["177",
    ButtonData:>{"Chapter2.nb", "i:105"},
    ButtonStyle->"Hyperlink"],
  "\n\thypergeometric, ",
  ButtonBox["241",
    ButtonData:>{"Chapter3.nb", "i:69"},
    ButtonStyle->"Hyperlink"],
  "\n\tintrinsic, ",
  ButtonBox["9.2.3",
    ButtonData:>{"Chapter9.nb", "i:18"},
    ButtonStyle->"Hyperlink"],
  "\n\tJacobian Elliptic (",
  StyleBox["JacobiSN,JacobiCN",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "), ",
  ButtonBox["541",
    ButtonData:>{"Chapter7.nb", "i:28"},
    ButtonStyle->"Hyperlink"],
  "\n\tof several variables, ",
  ButtonBox["9.8.3",
    ButtonData:>{"Chapter9.nb", "i:67"},
    ButtonStyle->"Hyperlink"],
  "\n\tperiodic, ",
  ButtonBox["87",
    ButtonData:>{"Chapter2.nb", "i:1"},
    ButtonStyle->"Hyperlink"],
  "\n\tpure (",
  StyleBox["InterpolatingFunction",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  StyleBox["Function",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "), ",
  ButtonBox["24",
    ButtonData:>{"Chapter1.nb", "i:41"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["515",
    ButtonData:>{"Chapter7.nb", "i:78"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["9.11.3",
    ButtonData:>{"Chapter9.nb", "i:101"},
    ButtonStyle->"Hyperlink"],
  "\n\tsectionally continuous, ",
  ButtonBox["89",
    ButtonData:>{"Chapter2.nb", "i:4"},
    ButtonStyle->"Hyperlink"],
  "\n\tstream, ",
  ButtonBox["7.3 Exercise 5",
    ButtonData:>{"Chapter7.nb", "i:64"},
    ButtonStyle->"Hyperlink"],
  "\n\tunknown, ",
  ButtonBox["1",
    ButtonData:>{"Chapter1.nb", "i:4"},
    ButtonStyle->"Hyperlink"],
  "\n\tuse of the underscore when defining, ",
  ButtonBox["9.8.3",
    ButtonData:>{"Chapter9.nb", "i:66"},
    ButtonStyle->"Hyperlink"],
  "\n\tuser-defined, ",
  ButtonBox["9.8.3",
    ButtonData:>{"Chapter9.nb", "i:19"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:144"],

Cell[TextData[{
  "Fundamental period, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Frequency, fundamental",
    ButtonData:>"ii:141",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:145"],

Cell[BoxData[""], "Input"],

Cell[TextData[{
  "Galerkin, Boris G., ",
  ButtonBox["435",
    ButtonData:>{"Chapter6.nb", "i:57"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->{"G", "ii:146"}],

Cell[TextData[{
  "Galerkin method, ",
  ButtonBox["435",
    ButtonData:>{"Chapter6.nb", "i:2"},
    ButtonStyle->"Hyperlink"],
  "\n\tbasis functions, ",
  ButtonBox["436",
    ButtonData:>{"Chapter6.nb", "i:5"},
    ButtonStyle->"Hyperlink"],
  "\n\tboundary curves, smooth vs. cusped, ",
  ButtonBox["438",
    ButtonData:>{"Chapter6.nb", "i:7"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor nonlinear system (KdV equation), ",
  ButtonBox["547",
    ButtonData:>{"Chapter7.nb", "i:74"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor perturbed quantum systems, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Perturbation theory",
    ButtonData:>"ii:257",
    ButtonStyle->"Hyperlink"],
  "\n\tfor time-dependent PDEs, ",
  ButtonBox["451",
    ButtonData:>{"Chapter6.nb", "i:11"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor time-independent boundary value problems, ",
  ButtonBox["435",
    ButtonData:>{"Chapter6.nb", "i:4"},
    ButtonStyle->"Hyperlink"],
  "\n\tmodule, for time-dependent problems, ",
  ButtonBox["456",
    ButtonData:>{"Chapter6.nb", "i:13"},
    ButtonStyle->"Hyperlink"],
  "\n\tmodule, for time-independent problems, ",
  ButtonBox["443",
    ButtonData:>{"Chapter6.nb", "i:8"},
    ButtonStyle->"Hyperlink"],
  "\n\tnumerical eigenmodes, ",
  ButtonBox["6.3.3",
    ButtonData:>{"Chapter6.nb", "i:41"},
    ButtonStyle->"Hyperlink"],
  "\n\tvon-Neumann basis functions, ",
  ButtonBox["534",
    ButtonData:>{"Chapter7.nb", "i:21"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:147"],

Cell[TextData[{
  "Gauss, Johann Carl Friedrich, ",
  ButtonBox["233",
    ButtonData:>{"Chapter3.nb", "i:63"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:148"],

Cell[TextData[{
  "Gaussian quadrature, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Numerical integration",
    ButtonData:>"ii:181",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Gauss's law, ",
  ButtonBox["233",
    ButtonData:>{"Chapter3.nb", "i:63"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["300",
    ButtonData:>{"Chapter4.nb", "i:53"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:149"],

Cell[TextData[{
  "Geometrical optics, ",
  ButtonBox["415",
    ButtonData:>{"Chapter5.nb", "i:79"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Ray trajectories",
    ButtonData:>"ii:288",
    ButtonStyle->"Hyperlink"],
  "\n\tand neglect of dispersion, ",
  ButtonBox["424",
    ButtonData:>{"Chapter5.nb", "i:89"},
    ButtonStyle->"Hyperlink"],
  "\n\tconnection to ray trajectories, ",
  ButtonBox["417",
    ButtonData:>{"Chapter5.nb", "i:82"},
    ButtonStyle->"Hyperlink"],
  "\n\tderivation of, ",
  ButtonBox["5.3.1",
    ButtonData:>{"Chapter5.nb", "i:115"},
    ButtonStyle->"Hyperlink"],
  "\n\tequations of, ",
  ButtonBox["416",
    ButtonData:>{"Chapter5.nb", "i:81"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor quantum system, ",
  ButtonBox["419",
    ButtonData:>{"Chapter5.nb", "i:85"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor whistler waves, ",
  ButtonBox["430",
    ButtonData:>{"Chapter5.nb", "i:103"},
    ButtonStyle->"Hyperlink"],
  "\n\tHamiltonian form, ",
  ButtonBox["417",
    ButtonData:>{"Chapter5.nb", "i:114"},
    ButtonStyle->"Hyperlink"],
  "\n\tturning points, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Turning points",
    ButtonData:>"ii:348",
    ButtonStyle->"Hyperlink"],
  "\n\twavepacket amplitude, ",
  ButtonBox["422",
    ButtonData:>{"Chapter5.nb", "i:88"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["5.3.1",
    ButtonData:>{"Chapter5.nb", "i:136"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Wave action",
    ButtonData:>"ii:360",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:150"],

Cell[TextData[{
  StyleBox["Get",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["<<",
    ButtonData:>"ii:11",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Gibbs\n\tdistribution, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Distribution, Gibbs",
    ButtonData:>"ii:92",
    ButtonStyle->"Hyperlink"],
  "\n\tJosiah, ",
  ButtonBox["98",
    ButtonData:>{"Chapter2.nb", "i:16"},
    ButtonStyle->"Hyperlink"],
  "\n\tphenomenon, ",
  ButtonBox["98",
    ButtonData:>{"Chapter2.nb", "i:16"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["247",
    ButtonData:>{"Chapter3.nb", "i:79"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["253",
    ButtonData:>{"Chapter3.nb", "i:91"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:151"],

Cell[TextData[{
  "Gram, Jorgen P., ",
  ButtonBox["263",
    ButtonData:>{"Chapter4.nb", "i:112"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:153"],

Cell[TextData[{
  "Gram-Schmidt method, ",
  ButtonBox["262",
    ButtonData:>{"Chapter4.nb", "i:6"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:154"],

Cell[TextData[{
  "Gravitational collapse, ",
  ButtonBox["7.3.5",
    ButtonData:>{"Chapter7.nb", "i:56"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:155"],

Cell[TextData[{
  "Greek letters, from keyboard, ",
  ButtonBox["9.4.3",
    ButtonData:>{"Chapter9.nb", "i:11"},
    ButtonStyle->"Hyperlink"],
  "\n\tfrom palletes, ",
  ButtonBox["9.4.3",
    ButtonData:>{"Chapter9.nb", "i:12"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:156"],

Cell[TextData[{
  "Green, George, ",
  ButtonBox["169",
    ButtonData:>{"Chapter2.nb", "i:85"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:157"],

Cell[TextData[{
  "Green's function(s), ",
  ButtonBox["169",
    ButtonData:>{"Chapter2.nb", "i:62"},
    ButtonStyle->"Hyperlink"],
  "\n\tas an inverse operator, ",
  ButtonBox["174",
    ButtonData:>{"Chapter2.nb", "i:108"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["181",
    ButtonData:>{"Chapter2.nb", "i:109"},
    ButtonStyle->"Hyperlink"],
  "\n\tdefinition, for Poisson's equation, ",
  ButtonBox["301",
    ButtonData:>{"Chapter4.nb", "i:55"},
    ButtonStyle->"Hyperlink"],
  "\n\tdiscretized, ",
  ButtonBox["174",
    ButtonData:>{"Chapter2.nb", "i:70"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["181",
    ButtonData:>{"Chapter2.nb", "i:69"},
    ButtonStyle->"Hyperlink"],
  "\n\texpansion in terms of operator eigenmodes, ",
  ButtonBox["304",
    ButtonData:>{"Chapter4.nb", "i:57"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor a charge in free space, ",
  ButtonBox["301",
    ButtonData:>{"Chapter4.nb", "i:56"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor a damped harmonic oscillator, ",
  ButtonBox["161",
    ButtonData:>{"Chapter2.nb", "i:59"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor an Nth order ODE with constant coefficients, ",
  ButtonBox["163",
    ButtonData:>{"Chapter2.nb", "i:61"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor heat equation, ",
  ButtonBox["385",
    ButtonData:>{"Chapter5.nb", "i:41"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor initial value problems, ",
  ButtonBox["170",
    ButtonData:>{"Chapter2.nb", "i:63"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor ODE boundary value problems, ",
  ButtonBox["178",
    ButtonData:>{"Chapter2.nb", "i:65"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor wave equation, ",
  ButtonBox["381",
    ButtonData:>{"Chapter5.nb", "i:37"},
    ButtonStyle->"Hyperlink"],
  "\n\tfrom homogeneous solutions, ",
  ButtonBox["171",
    ButtonData:>{"Chapter2.nb", "i:64"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["180",
    ButtonData:>{"Chapter2.nb", "i:66"},
    ButtonStyle->"Hyperlink"],
  "\n\tof ",
  Cell[BoxData[
      \(TraditionalForm\`\[Del]\^2\)]],
  " in an infinite conducting tube, ",
  ButtonBox["326",
    ButtonData:>{"Chapter4.nb", "i:77"},
    ButtonStyle->"Hyperlink"],
  "\n\twithin a spherical conducting shell, ",
  ButtonBox["329",
    ButtonData:>{"Chapter4.nb", "i:81"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:158"],

Cell[TextData[{
  "Grid methods, ",
  ButtonBox["464",
    ButtonData:>{"Chapter6.nb", "i:17"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Numerical solution of ODEs",
    ButtonData:>"ii:244",
    ButtonStyle->"Hyperlink"],
  "\n\talternating direction implicit method, ",
  ButtonBox["481",
    ButtonData:>{"Chapter6.nb", "i:69"},
    ButtonStyle->"Hyperlink"],
  "\n\tboundary condition at origin, ",
  ButtonBox["506",
    ButtonData:>{"Chapter6.nb", "i:38"},
    ButtonStyle->"Hyperlink"],
  "\n\tboundary conditions, von Neumann and mixed, ",
  ButtonBox["474",
    ButtonData:>{"Chapter6.nb", "i:24"},
    ButtonStyle->"Hyperlink"],
  "\n\tCrank-Nicholson method, ",
  ButtonBox["471",
    ButtonData:>{"Chapter6.nb", "i:23"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["556",
    ButtonData:>{"Chapter7.nb", "i:75"},
    ButtonStyle->"Hyperlink"],
  "\n\tCTCS for wave equation in 2 dimensions, ",
  ButtonBox["478",
    ButtonData:>{"Chapter6.nb", "i:26"},
    ButtonStyle->"Hyperlink"],
  "\n\tCTCS method, ",
  ButtonBox["469",
    ButtonData:>{"Chapter6.nb", "i:20"},
    ButtonStyle->"Hyperlink"],
  "\n\tdirect soluton of BVP's, ",
  ButtonBox["486",
    ButtonData:>{"Chapter6.nb", "i:30"},
    ButtonStyle->"Hyperlink"],
  "\n\texplicit methods, ",
  ButtonBox["471",
    ButtonData:>{"Chapter6.nb", "i:25"},
    ButtonStyle->"Hyperlink"],
  "\n\tFFT method, ",
  ButtonBox["499",
    ButtonData:>{"Chapter6.nb", "i:36"},
    ButtonStyle->"Hyperlink"],
  "\n",
  ButtonBox["\t",
    ButtonData:>{"Chapter6.nb", "i:29"},
    ButtonStyle->"Hyperlink"],
  "for nonlinear systems, ",
  ButtonBox["531",
    ButtonData:>{"Chapter7.nb", "i:87"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["556",
    ButtonData:>{"Chapter7.nb", "i:75"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["564",
    ButtonData:>{"Chapter7.nb", "i:86"},
    ButtonStyle->"Hyperlink"],
  "\n\tFTCS method, ",
  ButtonBox["464",
    ButtonData:>{"Chapter6.nb", "i:18"},
    ButtonStyle->"Hyperlink"],
  "\n\timplicit methods, ",
  ButtonBox["39",
    ButtonData:>{"Chapter1.nb", "i:143"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["470",
    ButtonData:>{"Chapter6.nb", "i:22"},
    ButtonStyle->"Hyperlink"],
  "\n\tJacobi's method, ",
  ButtonBox["494",
    ButtonData:>{"Chapter6.nb", "i:33"},
    ButtonStyle->"Hyperlink"],
  "\n\tLax method, ",
  ButtonBox["469",
    ButtonData:>{"Chapter6.nb", "i:21"},
    ButtonStyle->"Hyperlink"],
  "\n\tnon-rectangular boundaries, ",
  ButtonBox["489,",
    ButtonData:>{"Chapter6.nb", "i:31"},
    ButtonStyle->"Hyperlink"],
  " ",
  ButtonBox["508",
    ButtonData:>{"Chapter6.nb", "i:62"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Finite element methods",
    ButtonData:>"ii:277",
    ButtonStyle->"Hyperlink"],
  "\n\tnumerical eigenmodes, ",
  ButtonBox["6.3.2",
    ButtonData:>{"Chapter6.nb", "i:42"},
    ButtonStyle->"Hyperlink"],
  "\n\toperator splitting, ",
  ButtonBox["481",
    ButtonData:>{"Chapter6.nb", "i:27"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["557",
    ButtonData:>{"Chapter7.nb", "i:79"},
    ButtonStyle->"Hyperlink"],
  "\n\tsimultaneous overrelaxation, ",
  ButtonBox["497",
    ButtonData:>{"Chapter6.nb", "i:34"},
    ButtonStyle->"Hyperlink"],
  "\n\tvon Neumann stability analysis, ",
  ButtonBox["467",
    ButtonData:>{"Chapter6.nb", "i:19"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:159"],

Cell[TextData[{
  "Group velocity, ",
  ButtonBox["363",
    ButtonData:>{"Chapter5.nb", "i:13"},
    ButtonStyle->"Hyperlink"],
  "\n\tdefinition, in 1 dimension, ",
  ButtonBox["364",
    ButtonData:>{"Chapter5.nb", "i:14"},
    ButtonStyle->"Hyperlink"],
  "\n\tdefinition, in 3 dimensions, ",
  ButtonBox["368",
    ButtonData:>{"Chapter5.nb", "i:139"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor complex frequencies (damped waves), ",
  ButtonBox["385",
    ButtonData:>{"Chapter5.nb", "i:42"},
    ButtonStyle->"Hyperlink"],
  "\n\tin an isotropic medium, ",
  ButtonBox["368",
    ButtonData:>{"Chapter5.nb", "i:20"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:160"],

Cell[BoxData[""], "Input"],

Cell[TextData[{
  "Hamiltonian, ",
  ButtonBox["12",
    ButtonData:>{"Chapter1.nb", "i:22"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor system of interacting paticles, ",
  ButtonBox["58",
    ButtonData:>{"Chapter1.nb", "i:78"},
    ButtonStyle->"Hyperlink"],
  "\n\tin geometrical optics, ",
  ButtonBox["417",
    ButtonData:>{"Chapter5.nb", "i:114"},
    ButtonStyle->"Hyperlink"],
  "\n\tmechanics, as WKB limit of quantum mechanics, ",
  ButtonBox["419",
    ButtonData:>{"Chapter5.nb", "i:85"},
    ButtonStyle->"Hyperlink"],
  "\n\tpendulum, ",
  ButtonBox["15",
    ButtonData:>{"Chapter1.nb", "i:108"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->{"H", "ii:161"}],

Cell[TextData[{
  "Hamilton, Sir William, ",
  ButtonBox["12",
    ButtonData:>{"Chapter1.nb", "i:22"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:162"],

Cell[TextData[{
  "Harmonic oscillator, ",
  ButtonBox["2",
    ButtonData:>{"Chapter1.nb", "i:10"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Ordinary differential equations",
    ButtonData:>"ii:247",
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["Linear ODEs",
    ButtonData:>"ii:205",
    ButtonStyle->"Hyperlink"],
  "\n\tdamped, ",
  ButtonBox["70",
    ButtonData:>{"Chapter1.nb", "i:91"},
    ButtonStyle->"Hyperlink"],
  "\n\tquantum eigenmodes, ",
  ButtonBox["276",
    ButtonData:>{"Chapter4.nb", "i:29"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:163"],

Cell[TextData[{
  "Heat equation, ",
  ButtonBox["208",
    ButtonData:>{"Chapter3.nb", "i:25"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Fokker-Planck equation",
    ButtonData:>"ii:131",
    ButtonStyle->"Hyperlink"],
  ";",
  StyleBox[" ",
    FontSlant->"Italic"],
  ButtonBox["Partial Differential Equations",
    ButtonData:>"ii:252",
    ButtonStyle->"Hyperlink"],
  "\n\tapproach to equilibrium, ",
  ButtonBox["216",
    ButtonData:>{"Chapter3.nb", "i:36"},
    ButtonStyle->"Hyperlink"],
  "\n\tconnection to diffusion, ",
  ButtonBox["583",
    ButtonData:>{"Chapter8.nb", "i:29"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Diffusion",
    ButtonData:>"ii:86",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Random walk",
    ButtonData:>"ii:285",
    ButtonStyle->"Hyperlink"],
  "\n\tderivation, ",
  ButtonBox["206",
    ButtonData:>{"Chapter3.nb", "i:108"},
    ButtonStyle->"Hyperlink"],
  "\n\teigenmodes, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Eigenmodes",
    ButtonData:>"ii:100",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Eigenvalue problems",
    ButtonData:>"ii:101",
    ButtonStyle->"Hyperlink"],
  "\n\tgeneral solution with Dirichlet boundary conditions, ",
  ButtonBox["214",
    ButtonData:>{"Chapter3.nb", "i:33"},
    ButtonStyle->"Hyperlink"],
  "\n\tgeneral solution with von Neumann boundary conditions, ",
  ButtonBox["218",
    ButtonData:>{"Chapter3.nb", "i:116"},
    ButtonStyle->"Hyperlink"],
  "\n\tgeneral solution with mixed boundary conditions, ",
  ButtonBox["222",
    ButtonData:>{"Chapter3.nb", "i:42"},
    ButtonStyle->"Hyperlink"],
  "\n\tGreen's function, ",
  ButtonBox["385",
    ButtonData:>{"Chapter5.nb", "i:41"},
    ButtonStyle->"Hyperlink"],
  "\n\tmulitdimensional, ",
  ButtonBox["334",
    ButtonData:>{"Chapter4.nb", "i:89"},
    ButtonStyle->"Hyperlink"],
  "\n\tnumerical solution, ",
  ButtonBox["451",
    ButtonData:>{"Chapter6.nb", "c:10"},
    ButtonStyle->"Hyperlink"],
  ",  ",
  ButtonBox["464",
    ButtonData:>{"Chapter6.nb", "i:18"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["470",
    ButtonData:>{"Chapter6.nb", "i:22"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["476",
    ButtonData:>{"Chapter6.nb", "i:24"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["481",
    ButtonData:>{"Chapter6.nb", "i:27"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["6.3.2",
    ButtonData:>{"Chapter6.nb", "c:32"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also ",
    FontSlant->"Italic"],
  ButtonBox["Numerical solution of PDEs",
    ButtonData:>"ii:245",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:164"],

Cell[TextData[{
  "Heaviside\n\tOliver, ",
  ButtonBox["9.8.6",
    ButtonData:>{"Chapter9.nb", "i:123"},
    ButtonStyle->"Hyperlink"],
  "\n\tstep function, ",
  ButtonBox["9.8.6",
    ButtonData:>{"Chapter9.nb", "i:106"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["140",
    ButtonData:>{"Chapter2.nb", "i:51"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Heisenberg, Werner K., ",
  ButtonBox["134",
    ButtonData:>{"Chapter2.nb", "i:107"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:166"],

Cell[TextData[{
  "Hermite, Charles, ",
  ButtonBox["261",
    ButtonData:>{"Chapter4.nb", "i:108"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["273",
    ButtonData:>{"Chapter4.nb", "i:26"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:167"],

Cell[TextData[{
  "Hermitian operators, ",
  ButtonBox["268",
    ButtonData:>{"Chapter4.nb", "i:13"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also ",
    FontSlant->"Italic"],
  ButtonBox["Differential operators",
    ButtonData:>"ii:85",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Linear ODEs",
    ButtonData:>"ii:205",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Eigenmodes",
    ButtonData:>"ii:100",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Eigenvalue problems",
    ButtonData:>"ii:101",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Sturm-Liouville problems",
    ButtonData:>"ii:331",
    ButtonStyle->"Hyperlink"],
  "\n\tcompleteness and orthogonality of eigenmodes, reality of eigenvalues, \
",
  ButtonBox["270",
    ButtonData:>{"Chapter4.nb", "i:15"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:168"],

Cell[TextData[{
  "Hermite polynomials, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Orthogonal polynomials",
    ButtonData:>"ii:249",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  StyleBox["Histogram",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["527",
    ButtonData:>{"Chapter7.nb", "i:13"},
    ButtonStyle->"Hyperlink"],
  "\n\t",
  StyleBox[" ",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "function, ",
  ButtonBox["570",
    ButtonData:>{"Chapter8.nb", "i:7"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:169"],

Cell[TextData[{
  "Homogeneous\n\tequation, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Linear ODEs, homogeneous",
    ButtonData:>"ii:205",
    ButtonStyle->"Hyperlink"],
  "\n\tsolution, ",
  ButtonBox["71",
    ButtonData:>{"Chapter1.nb", "c:38"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["78",
    ButtonData:>{"Chapter1.nb", "i:88"},
    ButtonStyle->"Hyperlink"],
  "\t\n\tboundary conditions, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Boundary conditions, homogeneous",
    ButtonData:>"ii:45",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Hooke, Robert, ",
  ButtonBox["2",
    ButtonData:>{"Chapter1.nb", "i:9"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:170"],

Cell[TextData[{
  "Hugoniot relation, ",
  ButtonBox["555",
    ButtonData:>{"Chapter7.nb", "i:48"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["563",
    ButtonData:>{"Chapter7.nb", "i:43"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:171"],

Cell[TextData[{
  "Huygens, Christiaan, ",
  ButtonBox["5.3.1",
    ButtonData:>{"Chapter5.nb", "i:135"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Hydrogen atom(s)\n\tenergy levels, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Eigenmodes of the hydrogen atom",
    ButtonData:>"ii:100",
    ButtonStyle->"Hyperlink"],
  "\n\tin electric field, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Stark effect",
    ButtonData:>"ii:326",
    ButtonStyle->"Hyperlink"],
  "\n\tin magnetic field, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Zeeman shift",
    ButtonData:>"ii:376",
    ButtonStyle->"Hyperlink"],
  "\n\treactions to form ",
  Cell[BoxData[
      \(TraditionalForm\`H\_2\)]],
  ", see ",
  ButtonBox["Equilibrium, chemical",
    ButtonData:>"ii:113",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:172"],

Cell[TextData[{
  "Hyperlinks, ",
  ButtonBox["xv",
    ButtonData:>{"Preface.nb", "i:1"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:173"],

Cell[BoxData[""], "Input"],

Cell[TextData[{
  "Ideal gas, ",
  ButtonBox["520",
    ButtonData:>{"Chapter7.nb", "i:7"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Boltzmann equation, collisionless",
    ButtonData:>"ii:42",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Thermal equilibrium",
    ButtonData:>"ii:340",
    ButtonStyle->"Hyperlink"],
  "\n\tas a model of the galaxy, ",
  ButtonBox["7.3.1",
    ButtonData:>{"Chapter7.nb", "i:76"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->{"I", "ii:174"}],

Cell[TextData[{
  StyleBox["If",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.9.3",
    ButtonData:>{"Chapter9.nb", "i:79"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:175"],

Cell[TextData[{
  "Implicit methods, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Grid methods",
    ButtonData:>"ii:159",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  StyleBox["Import",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["153,",
    ButtonData:>{"Chapter2.nb", "i:98"},
    ButtonStyle->"Hyperlink"],
  " ",
  ButtonBox["9.11.4",
    ButtonData:>{"Chapter9.nb", "i:131"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  StyleBox[ButtonBox["Export",
    ButtonData:>"ii:118",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["<<",
    ButtonData:>"ii:11",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:177"],

Cell[TextData[{
  "Initial conditions, ",
  ButtonBox["2",
    ButtonData:>{"Chapter1.nb", "i:3"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also ",
    FontSlant->"Italic"],
  ButtonBox["Initial value problems",
    ButtonData:>"ii:178",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Initial value problems, ",
  ButtonBox["4",
    ButtonData:>{"Chapter1.nb", "i:12"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["5",
    ButtonData:>{"Chapter1.nb", "i:14"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["185",
    ButtonData:>{"Chapter2.nb", "i:79"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Differential equations",
    ButtonData:>"ii:84",
    ButtonStyle->"Hyperlink"],
  "\n\texistence and uniqueness of solution, ",
  ButtonBox["6",
    ButtonData:>{"Chapter1.nb", "i:16"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:178"],

Cell[TextData[{
  "Inner product, ",
  ButtonBox["261",
    ButtonData:>{"Chapter4.nb", "i:4"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Hermitian operators",
    ButtonData:>"ii:168",
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["Orthogonality",
    ButtonData:>"ii:248",
    ButtonStyle->"Hyperlink"],
  "\n\tchoice of, in Galerkin method, ",
  ButtonBox["437",
    ButtonData:>{"Chapter6.nb", "i:6"},
    ButtonStyle->"Hyperlink"],
  "\n\tgeneral properties, ",
  ButtonBox["262",
    ButtonData:>{"Chapter4.nb", "i:5"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:179"],

Cell[TextData[{
  StyleBox["InputForm",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.2.6",
    ButtonData:>{"Chapter9.nb", "i:7"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:180"],

Cell[TextData[{
  "Integrability, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Ordinary differential equations, integrable",
    ButtonData:>"ii:247",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Integral(s)\n\tanalytic, ",
  ButtonBox["9.9.3",
    ButtonData:>{"Chapter9.nb", "i:72"},
    ButtonStyle->"Hyperlink"],
  "\n\tElliptic, of the first kind (",
  StyleBox["EllipticF",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  StyleBox["EllipticK",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "), ",
  ButtonBox["540",
    ButtonData:>{"Chapter7.nb", "i:27"},
    ButtonStyle->"Hyperlink"],
  "\n\tnumerical, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Numerical integration",
    ButtonData:>"ii:181",
    ButtonStyle->"Hyperlink"],
  "\n\tover arbitrary regions (using ",
  StyleBox["Boole",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ") ",
  ButtonBox["443",
    ButtonData:>{"Chapter6.nb", "i:64"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  StyleBox["Integrate",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.9.3",
    ButtonData:>{"Chapter9.nb", "i:74"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  StyleBox[ButtonBox["NIntegrate",
    ButtonData:>"ii:237",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"]
}], "Text",
  CellTags->"ii:182"],

Cell[TextData[{
  StyleBox["InterpolatingFunction",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Function(s), pure",
    ButtonData:>"ii:144",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:184"],

Cell[TextData[{
  StyleBox["Interpolation",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.11.3",
    ButtonData:>{"Chapter9.nb", "i:92"},
    ButtonStyle->"Hyperlink"],
  ".",
  StyleBox[" See also ",
    FontSlant->"Italic"],
  StyleBox[ButtonBox["SplineFit",
    ButtonData:>"ii:382",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "\n\tcubic spline, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Splines",
    ButtonData:>"ii:390",
    ButtonStyle->"Hyperlink"],
  "\n\tlinear, in PIC method, ",
  ButtonBox["7.3.4",
    ButtonData:>{"Chapter7.nb", "i:63"},
    ButtonStyle->"Hyperlink"],
  "\n\torder, ",
  ButtonBox["9.11.3",
    ButtonData:>{"Chapter9.nb", "i:93"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:185"],

Cell[TextData[{
  StyleBox["Interrupt Evaluation",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.3",
    ButtonData:>{"Chapter9.nb", "i:13"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:186"],

Cell[TextData[{
  StyleBox["Inverse",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.5.2",
    ButtonData:>{"Chapter9.nb", "i:34"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:187"],

Cell[TextData[{
  "Irreversibility, ",
  ButtonBox["585",
    ButtonData:>{"Chapter8.nb", "i:26"},
    ButtonStyle->"Hyperlink"],
  "\n\tin a confined system, ",
  ButtonBox["607",
    ButtonData:>{"Chapter8.nb", "i:58"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:188"],

Cell[TextData[{
  "Ising model, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Rosenbluth-Teller-Metropolis Monte Carlo method",
    ButtonData:>"ii:300",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:189"],

Cell[BoxData[""], "Input"],

Cell[TextData[{
  "Jacobi, Carl Gustav Jacob, ",
  ButtonBox["494",
    ButtonData:>{"Chapter6.nb", "i:61"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->{"J", "ii:190"}],

Cell[TextData[{
  "Jacobi's method, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Grid methods",
    ButtonData:>"ii:159",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Jeans \n\tinstability, ",
  ButtonBox["7.3.5",
    ButtonData:>{"Chapter7.nb", "i:80"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["7.3 Exercise 3",
    ButtonData:>{"Chapter7.nb", "i:82"},
    ButtonStyle->"Hyperlink"],
  "\n\tJames H. , ",
  ButtonBox["7.3.5",
    ButtonData:>{"Chapter7.nb", "i:80"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Jeffreys, Harold, ",
  ButtonBox["396",
    ButtonData:>{"Chapter5.nb", "i:128"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:191"],

Cell[TextData[{
  StyleBox["Join",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.5.4",
    ButtonData:>{"Chapter9.nb", "i:40"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[BoxData[""], "Input"],

Cell[TextData[{
  "KdV equation, ",
  ButtonBox["537",
    ButtonData:>{"Chapter7.nb", "i:25"},
    ButtonStyle->"Hyperlink"],
  "\n\tderivation of steady solutions, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Solitons",
    ButtonData:>"ii:317",
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["Waves, cnoidal",
    ButtonData:>"ii:367",
    ButtonStyle->"Hyperlink"],
  "\n\tstability of steady solutions, ",
  ButtonBox["548",
    ButtonData:>{"Chapter7.nb", "i:44"},
    ButtonStyle->"Hyperlink"],
  "\n\tsuppression of wavebreaking, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Wavebreaking, suppression of",
    ButtonData:>"ii:361",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->{"K", "ii:192"}],

Cell[TextData[{
  "Kernel, ",
  ButtonBox["9.3",
    ButtonData:>{"Chapter9.nb", "i:8"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:193"],

Cell[TextData[{
  "Keyboard equivalents, ",
  ButtonBox["9.4.3",
    ButtonData:>{"Chapter9.nb", "i:11"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["9.6.1",
    ButtonData:>{"Chapter9.nb", "i:133"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:194"],

Cell[TextData[{
  "Klein-Gordon equation, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Partial Differential Equations",
    ButtonData:>"ii:252",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Korteweg, Diederik J, ",
  ButtonBox["537",
    ButtonData:>{"Chapter7.nb", "i:25"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Korteweg-de Vries equation, ",
  StyleBox[" see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["KdV equation",
    ButtonData:>"ii:192",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  StyleBox["KroneckerDelta",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["75",
    ButtonData:>{"Chapter1.nb", "i:134"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:195"],

Cell[BoxData[""], "Input"],

Cell[TextData[{
  StyleBox["LabelContour.m",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.6.8",
    ButtonData:>{"Chapter9.nb", "i:114"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Laguerre \n\tEdmond N., ",
  ButtonBox["273",
    ButtonData:>{"Chapter4.nb", "i:22"},
    ButtonStyle->"Hyperlink"],
  "\n\tpolynomials, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Orthogonal polynomials",
    ButtonData:>"ii:249",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->{"L", "ii:196"}],

Cell[TextData[{
  "Landau\n\tdamping, ",
  ButtonBox["7.3 Exercise 6",
    ButtonData:>{"Chapter7.nb", "i:91"},
    ButtonStyle->"Hyperlink"],
  "\n\tLev Davidovich, ",
  ButtonBox["7.3 Exercise 6",
    ButtonData:>{"Chapter7.nb", "i:91"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Langevin equation, ",
  ButtonBox["589",
    ButtonData:>{"Chapter8.nb", "i:36"},
    ButtonStyle->"Hyperlink"],
  "\n\tmaster equation for, ",
  ButtonBox["611",
    ButtonData:>{"Chapter8.nb", "i:74"},
    ButtonStyle->"Hyperlink"],
  "\n\tvelocity correlations in, ",
  ButtonBox["610",
    ButtonData:>{"Chapter8.nb", "i:92"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:197"],

Cell[TextData[{
  "Laplace, Pierre, ",
  ButtonBox["231",
    ButtonData:>{"Chapter3.nb", "i:57"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:198"],

Cell[TextData[{
  "Laplace's equation, ",
  ButtonBox["231",
    ButtonData:>{"Chapter3.nb", "i:57"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also ",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Poisson's equation",
    ButtonData:>"ii:272",
    ButtonStyle->"Hyperlink"],
  "\n\talternate forms for solution, ",
  ButtonBox["326",
    ButtonData:>{"Chapter4.nb", "i:79"},
    ButtonStyle->"Hyperlink"],
  "\n\tanalytic solution via separation of variables, ",
  ButtonBox["233",
    ButtonData:>{"Chapter3.nb", "i:64"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["238",
    ButtonData:>{"Chapter3.nb", "i:65"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["248",
    ButtonData:>{"Chapter3.nb", "i:68"},
    ButtonStyle->"Hyperlink"],
  "\n\tboundary conditions, ",
  ButtonBox["231",
    ButtonData:>{"Chapter3.nb", "i:57"},
    ButtonStyle->"Hyperlink"],
  "\n\teigenmode vs. direct solution methods, ",
  ButtonBox["308",
    ButtonData:>{"Chapter4.nb", "i:67"},
    ButtonStyle->"Hyperlink"],
  "\n\texistence of solution, ",
  ButtonBox["233",
    ButtonData:>{"Chapter3.nb", "i:62"},
    ButtonStyle->"Hyperlink"],
  "\n\tnumerical solution, ",
  ButtonBox["438",
    ButtonData:>{"Chapter6.nb", "c:6"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["446",
    ButtonData:>{"Chapter6.nb", "c:8"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["489",
    ButtonData:>{"Chapter6.nb", "i:31"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Boundary value problems",
    ButtonData:>"ii:46",
    ButtonStyle->"Hyperlink"],
  "\n\tuniqueness of solution, ",
  ButtonBox["232",
    ButtonData:>{"Chapter3.nb", "i:61"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:199"],

Cell[TextData[{
  "Laplacian operator ( ",
  Cell[BoxData[
      \(TraditionalForm\`\[Del]\^2\)]],
  "), ",
  ButtonBox["4",
    ButtonData:>{"Chapter1.nb", "i:8"},
    ButtonStyle->"Hyperlink"],
  "\n\tas a Hermitian operator, ",
  ButtonBox["303",
    ButtonData:>{"Chapter4.nb", "i:72"},
    ButtonStyle->"Hyperlink"],
  "\n\teigenmodes in cylindrical geometry, ",
  ButtonBox["312",
    ButtonData:>{"Chapter4.nb", "i:65"},
    ButtonStyle->"Hyperlink"],
  "\n\teigenmodes in rectangular geometry, ",
  ButtonBox["305",
    ButtonData:>{"Chapter4.nb", "i:64"},
    ButtonStyle->"Hyperlink"],
  "\n\teigenmodes in spherical geometry, ",
  ButtonBox["317",
    ButtonData:>{"Chapter4.nb", "i:66"},
    ButtonStyle->"Hyperlink"],
  "\n\tin cylindrical coordinates, ",
  ButtonBox["238",
    ButtonData:>{"Chapter3.nb", "i:109"},
    ButtonStyle->"Hyperlink"],
  "\n\tin spherical coordinates, ",
  ButtonBox["240",
    ButtonData:>{"Chapter3.nb", "i:110"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:200"],

Cell[TextData[{
  "Lax method, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Grid methods",
    ButtonData:>"ii:159",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Leapfrog method, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Numerical solution of ODEs",
    ButtonData:>"ii:244",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:201"],

Cell[TextData[{
  "Least-squares fit, ",
  ButtonBox["9.11, Exercise 7",
    ButtonData:>{"Chapter9.nb", "i:138"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also ",
    FontSlant->"Italic"],
  " ",
  StyleBox[ButtonBox["Fit",
    ButtonData:>"ii:127",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"]
}], "Text",
  CellTags->"ii:350"],

Cell[TextData[{
  "Legendre\n\tAdrien-Marie, ",
  ButtonBox["265",
    ButtonData:>{"Chapter4.nb", "i:9"},
    ButtonStyle->"Hyperlink"],
  "\n\tfunctions, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Functions",
    ButtonData:>"ii:144",
    ButtonStyle->"Hyperlink"],
  "\n\tpolynomials, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Orthogonal polynomials",
    ButtonData:>"ii:249",
    ButtonStyle->"Hyperlink"],
  "\n\tequation, see ",
  ButtonBox["Ordinary differential equations",
    ButtonData:>"ii:247",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  StyleBox["LegendreP",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["241",
    ButtonData:>{"Chapter3.nb", "i:83"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:203"],

Cell[TextData[{
  "Lens, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Snell's law",
    ButtonData:>"ii:316",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Liebniz, Gottfried, ",
  ButtonBox["1",
    ButtonData:>{"Chapter1.nb", "i:2"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:204"],

Cell[TextData[{
  "Linear ODEs, ",
  ButtonBox["70",
    ButtonData:>{"Chapter1.nb", "i:81"},
    ButtonStyle->"Hyperlink"],
  "\n\tand linear operators, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Differential operators",
    ButtonData:>"ii:85",
    ButtonStyle->"Hyperlink"],
  "\n\tdamped hamonic oscillator, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Damped Harmonic Oscillator",
    ButtonData:>"ii:387",
    ButtonStyle->"Hyperlink"],
  "\n\tdegenerate homogeneous solutions, ",
  ButtonBox["73",
    ButtonData:>{"Chapter1.nb", "i:90"},
    ButtonStyle->"Hyperlink"],
  "\n\tdiscretized form as a matrix equation, ",
  ButtonBox["76",
    ButtonData:>{"Chapter1.nb", "i:101"},
    ButtonStyle->"Hyperlink"],
  "\n\teigenmodes, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Eigenmodes",
    ButtonData:>"ii:100",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Eigenvalue problems",
    ButtonData:>"ii:101",
    ButtonStyle->"Hyperlink"],
  "\n\texact resonance, ",
  ButtonBox["82",
    ButtonData:>{"Chapter1.nb", "i:97"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["120",
    ButtonData:>{"Chapter2.nb", "i:34"},
    ButtonStyle->"Hyperlink"],
  "\n\tgeneral solution, ",
  ButtonBox["72",
    ButtonData:>{"Chapter1.nb", "i:84"},
    ButtonStyle->"Hyperlink"],
  "\n\thomogeneous  ",
  ButtonBox["71",
    ButtonData:>{"Chapter1.nb", "i:85"},
    ButtonStyle->"Hyperlink"],
  "\n\thomogeneous solution, ",
  ButtonBox["78",
    ButtonData:>{"Chapter1.nb", "i:87"},
    ButtonStyle->"Hyperlink"],
  "\n\tinhomogeneous, ",
  ButtonBox["78",
    ButtonData:>{"Chapter1.nb", "i:86"},
    ButtonStyle->"Hyperlink"],
  "\n\tmethod of undetermined coefficients, ",
  ButtonBox["79",
    ButtonData:>{"Chapter1.nb", "i:94"},
    ButtonStyle->"Hyperlink"],
  "\n\tparticular solution, ",
  ButtonBox["78",
    ButtonData:>{"Chapter1.nb", "i:88"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["81",
    ButtonData:>{"Chapter1.nb", "i:95"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["119",
    ButtonData:>{"Chapter2.nb", "i:35"},
    ButtonStyle->"Hyperlink"],
  "\n\tresonance, ",
  ButtonBox["82",
    ButtonData:>{"Chapter1.nb", "i:96"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["105",
    ButtonData:>{"Chapter2.nb", "i:23"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["108",
    ButtonData:>{"Chapter2.nb", "i:94"},
    ButtonStyle->"Hyperlink"],
  "\n\tsuperposition principle, ",
  ButtonBox["71",
    ButtonData:>{"Chapter1.nb", "i:82"},
    ButtonStyle->"Hyperlink"],
  "\n\twith constant coefficients, independent homogeneous solutions, ",
  ButtonBox["73",
    ButtonData:>{"Chapter1.nb", "i:89"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:205"],

Cell[TextData[{
  "Liouville, Joseph, ",
  ButtonBox["261",
    ButtonData:>{"Chapter4.nb", "i:108"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:206"],

Cell[TextData[{
  "Lissajous figure, ",
  ButtonBox["9.6.5",
    ButtonData:>{"Chapter9.nb", "i:119"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  StyleBox["ListPlay",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["157",
    ButtonData:>{"Chapter2.nb", "i:104"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also ",
    FontSlant->"Italic"],
  StyleBox[ButtonBox["Play",
    ButtonData:>"ii:263",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"]
}], "Text",
  CellTags->"ii:207"],

Cell[TextData[{
  StyleBox["ListPlot ",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ButtonBox["9.6.4",
    ButtonData:>{"Chapter9.nb", "i:47"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:208"],

Cell[TextData[{
  "List(s), ",
  ButtonBox["9.5.1",
    ButtonData:>{"Chapter9.nb", "i:26"},
    ButtonStyle->"Hyperlink"],
  "\n\tdimension, ",
  ButtonBox["9.5.1",
    ButtonData:>{"Chapter9.nb", "i:27"},
    ButtonStyle->"Hyperlink"],
  "\n\textracting elements from, ",
  ButtonBox["9.5.1",
    ButtonData:>{"Chapter9.nb", "i:29"},
    ButtonStyle->"Hyperlink"],
  "\n\tin vector/matrix notation (",
  StyleBox["MatrixForm",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "), ",
  ButtonBox["9.5.1",
    ButtonData:>{"Chapter9.nb", "i:28"},
    ButtonStyle->"Hyperlink"],
  "\n\toperations, ",
  ButtonBox["9.5.4",
    ButtonData:>{"Chapter9.nb", "c:24"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:209"],

Cell[TextData[{
  "Logical statements, ",
  ButtonBox["9.8.6",
    ButtonData:>{"Chapter9.nb", "i:111"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["9.9.3",
    ButtonData:>{"Chapter9.nb", "i:79"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["9.10.1",
    ButtonData:>{"Chapter9.nb", "i:78"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:211"],

Cell[TextData[{
  "Lorenz system, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Ordinary differential equations",
    ButtonData:>"ii:247",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Lyapunov\n\tAleksandr, ",
  ButtonBox["28",
    ButtonData:>{"Chapter1.nb", "i:27"},
    ButtonStyle->"Hyperlink"],
  "\n\texponent, ",
  ButtonBox["28",
    ButtonData:>{"Chapter1.nb", "i:27"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["51-52",
    ButtonData:>{"Chapter1.nb", "i:58"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:212"],

Cell[BoxData[""], "Input"],

Cell[TextData[{
  "Mach cone, ",
  ButtonBox["394",
    ButtonData:>{"Chapter5.nb", "i:53"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->{"M", "ii:214"}],

Cell[TextData[{
  "Machine precision, ",
  ButtonBox["9.2.2",
    ButtonData:>{"Chapter9.nb", "i:5"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:215"],

Cell[TextData[{
  "Magnification, ",
  ButtonBox["xvi",
    ButtonData:>{"Preface.nb", "i:2"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:216"],

Cell[TextData[{
  StyleBox["Map",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ",  ",
  ButtonBox["7.3.3",
    ButtonData:>{"Chapter7.nb", "i:60"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:217"],

Cell[TextData[{
  "Master equation\n\tfor fixed stepsize, ",
  ButtonBox["581",
    ButtonData:>{"Chapter8.nb", "i:21"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor Langevin dynamics, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Langevin equation",
    ButtonData:>"ii:197",
    ButtonStyle->"Hyperlink"],
  "\n\tfor a nonuniform random walk, ",
  ButtonBox["596",
    ButtonData:>{"Chapter8.nb", "i:49"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor a uniform random walk, ",
  ButtonBox["595",
    ButtonData:>{"Chapter8.nb", "i:46"},
    ButtonStyle->"Hyperlink"],
  "\n\tin the Rosenbluth-Teller-Metropolis Monte Carlo method, ",
  ButtonBox["8.3.1",
    ButtonData:>{"Chapter8.nb", "i:65"},
    ButtonStyle->"Hyperlink"],
  "\n\tsolution via Fourier transforms, ",
  ButtonBox["610",
    ButtonData:>{"Chapter8.nb", "i:73"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:218"],

Cell[TextData[{
  "Matrix multiplication, ",
  ButtonBox["9.5.2",
    ButtonData:>{"Chapter9.nb", "i:32"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:219"],

Cell[TextData[{
  "Maxwell, James Clerk, ",
  ButtonBox["427",
    ButtonData:>{"Chapter5.nb", "i:126"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["568",
    ButtonData:>{"Chapter8.nb", "i:1"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:220"],

Cell[TextData[{
  StyleBox["Mean",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ",  ",
  ButtonBox["573",
    ButtonData:>{"Chapter8.nb", "i:9"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:221"],

Cell[TextData[{
  "Mean free path, ",
  ButtonBox["568",
    ButtonData:>{"Chapter8.nb", "i:5"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:222"],

Cell[TextData[{
  "Metropolis, Nicholas, ",
  ButtonBox["8.3.1",
    ButtonData:>{"Chapter8.nb", "i:85"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:223"],

Cell[TextData[{
  "Mixed boundary conditions, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Boundary conditions, mixed",
    ButtonData:>"ii:45",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Mixing dye, ",
  ButtonBox["516",
    ButtonData:>{"Chapter7.nb", "i:4"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Boltzmann equation, collisionless",
    ButtonData:>"i::42",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Chaotic systems",
    ButtonData:>"ii:56",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:224"],

Cell[TextData[{
  "Mobius \n\tAugust Ferdinand, ",
  ButtonBox["9.6 Exercise 6",
    ButtonData:>{"Chapter9.nb", "i:52"},
    ButtonStyle->"Hyperlink"],
  "\n\tstrip, ",
  ButtonBox["9.6 Exercise 6",
    ButtonData:>{"Chapter9.nb", "i:52"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:225"],

Cell[TextData[{
  StyleBox["Mod",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.10 Exercise 5",
    ButtonData:>{"Chapter9.nb", "i:89"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["7.3.4",
    ButtonData:>{"Chapter7.nb", "i:59"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:227"],

Cell[TextData[{
  StyleBox["Module",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["36",
    ButtonData:>{"Chapter1.nb", "i:51"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:228"],

Cell[TextData[{
  "Molecular dynamics, ",
  ButtonBox["43",
    ButtonData:>{"Chapter1.nb", "i:54"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["59",
    ButtonData:>{"Chapter1.nb", "i:75"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor charged particles in a Penning trap, ",
  ButtonBox["61",
    ButtonData:>{"Chapter1.nb", "i:72"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor an elastic rod, ",
  ButtonBox["61",
    ButtonData:>{"Chapter1.nb", "i:73"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor determining molecular configuration, ",
  ButtonBox["60",
    ButtonData:>{"Chapter1.nb", "i:74"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:229"],

Cell[TextData[{
  "Momentum, ",
  ButtonBox["12",
    ButtonData:>{"Chapter1.nb", "i:22"},
    ButtonStyle->"Hyperlink"],
  "\n\tdensity, ",
  ButtonBox["377",
    ButtonData:>{"Chapter5.nb", "i:33"},
    ButtonStyle->"Hyperlink"],
  "\n\tequation, ",
  ButtonBox["563",
    ButtonData:>{"Chapter7.nb", "i:38"},
    ButtonStyle->"Hyperlink"],
  "\n\tflux, ",
  ButtonBox["377",
    ButtonData:>{"Chapter5.nb", "i:117"},
    ButtonStyle->"Hyperlink"],
  "\n\ttotal linear, ",
  ButtonBox["58",
    ButtonData:>{"Chapter1.nb", "i:67"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:230"],

Cell[TextData[{
  "Monte Carlo method, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Rosenbluth-Teller-Metropolis Monte Carlo method",
    ButtonData:>"ii:300",
    ButtonStyle->"Hyperlink"],
  ")"
}], "Text",
  CellTags->"ii:231"],

Cell[TextData[{
  "Moving boundary conditions, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Boundary conditions, moving",
    ButtonData:>"ii:46",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Multipole moments\n\tform far from the origin, ",
  ButtonBox["329",
    ButtonData:>{"Chapter4.nb", "i:82"},
    ButtonStyle->"Hyperlink"],
  "\n\tform near the origin, ",
  ButtonBox["331",
    ButtonData:>{"Chapter4.nb", "i:83"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:232"],

Cell[BoxData[""], "Input"],

Cell[TextData[{
  StyleBox["N",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.2.6",
    ButtonData:>{"Chapter9.nb", "i:20"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->{"N", "ii:233"}],

Cell[TextData[{
  "Nanotubes, ",
  ButtonBox["224",
    ButtonData:>{"Chapter3.nb", "i:45"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:234"],

Cell[TextData[{
  "Navier, Claude, ",
  ButtonBox["562",
    ButtonData:>{"Chapter7.nb", "i:41"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Navier-Stokes equations, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Partial Differential Equations",
    ButtonData:>"ii:252",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  StyleBox["NDSolve",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["23",
    ButtonData:>{"Chapter1.nb", "i:40"},
    ButtonStyle->"Hyperlink"],
  "\n\timproving the solution accuracy (",
  StyleBox["AccuracyGoal",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  StyleBox["PrecisionGoal",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "), ",
  ButtonBox["26",
    ButtonData:>{"Chapter1.nb", "i:111"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:235"],

Cell[TextData[{
  "Newton, Sir Isaac, ",
  ButtonBox["1",
    ButtonData:>{"Chapter1.nb", "i:2"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:236"],

Cell[TextData[{
  "Newton's method, ",
  ButtonBox["9.11.1",
    ButtonData:>{"Chapter9.nb", "i:125"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["9.11 Exercise 6",
    ButtonData:>{"Chapter9.nb", "i:124"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:1"],

Cell[TextData[{
  StyleBox["NIntegrate",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.11.2",
    ButtonData:>{"Chapter9.nb", "i:75"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  StyleBox[ButtonBox["Integrate",
    ButtonData:>"ii:182",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"]
}], "Text",
  CellTags->"ii:237"],

Cell[TextData[{
  "Niven, Larry, ",
  ButtonBox["332",
    ButtonData:>{"Chapter4.nb", "i:86"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:238"],

Cell[TextData[{
  StyleBox["NonlinearFit",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.11.4",
    ButtonData:>{"Chapter9.nb", "i:132"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  StyleBox["Normal",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.9.2",
    ButtonData:>{"Chapter9.nb", "i:77"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:239"],

Cell[TextData[{
  "Normal modes, ",
  ButtonBox["197",
    ButtonData:>{"Chapter3.nb", "i:12"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Eigenvalue problems",
    ButtonData:>"ii:101",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Eigenmodes",
    ButtonData:>"ii:100",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:240"],

Cell[TextData[{
  "Notebook, ",
  ButtonBox["9.1",
    ButtonData:>{"Chapter9.nb", "i:3"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:241"],

Cell[TextData[{
  StyleBox["NSolve",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.10.1",
    ButtonData:>{"Chapter9.nb", "i:82"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:242"],

Cell[TextData[{
  StyleBox["NullSpace",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.5.2",
    ButtonData:>{"Chapter9.nb", "i:37"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:243"],

Cell[TextData[{
  "Numerical integration\n\tBode's rule, ",
  ButtonBox["9.11 Exercise 9",
    ButtonData:>{"Chapter9.nb", "i:136"},
    ButtonStyle->"Hyperlink"],
  "\n\tGaussian quadrature, ",
  ButtonBox["9.11 Exercise 9",
    ButtonData:>{"Chapter9.nb", "i:137"},
    ButtonStyle->"Hyperlink"],
  "\n\t",
  StyleBox["NIntegrate",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.11.2",
    ButtonData:>{"Chapter9.nb", "i:73"},
    ButtonStyle->"Hyperlink"],
  "\n\tSimpson's rule, ",
  ButtonBox["9.11 Exercise 9",
    ButtonData:>{"Chapter9.nb", "i:135"},
    ButtonStyle->"Hyperlink"],
  "\n\ttrapezoidal rule, ",
  ButtonBox["9.11 Exercise 8",
    ButtonData:>{"Chapter9.nb", "i:134"},
    ButtonStyle->"Hyperlink"],
  "\t"
}], "Text",
  CellTags->"ii:181"],

Cell[TextData[{
  "Numerical solution of ODEs, ",
  ButtonBox["23",
    ButtonData:>{"Chapter1.nb", "i:42"},
    ButtonStyle->"Hyperlink"],
  "\n\tAdams-Bashforth method, ",
  ButtonBox["57",
    ButtonData:>{"Chapter1.nb", "i:66"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["7.3 Exercise 5",
    ButtonData:>{"Chapter7.nb", "i:68"},
    ButtonStyle->"Hyperlink"],
  "\n\tcentered-difference method, ",
  ButtonBox["56",
    ButtonData:>{"Chapter1.nb", "i:64"},
    ButtonStyle->"Hyperlink"],
  "\n\terror, ",
  ButtonBox["25",
    ButtonData:>{"Chapter1.nb", "i:45"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["28",
    ButtonData:>{"Chapter1.nb", "i:27"},
    ButtonStyle->"Hyperlink"],
  "\n\tEuler's method, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Euler's method",
    ButtonData:>"ii:115",
    ButtonStyle->"Hyperlink"],
  "\n\tleapfrog method, ",
  ButtonBox["57",
    ButtonData:>{"Chapter1.nb", "i:65"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["7.3.3",
    ButtonData:>{"Chapter7.nb", "i:61"},
    ButtonStyle->"Hyperlink"],
  "\n\tmatrix method, for linear ODEs, ",
  ButtonBox["76,",
    ButtonData:>{"Chapter1.nb", "i:105"},
    ButtonStyle->"Hyperlink"],
  " ",
  ButtonBox["175,",
    ButtonData:>{"Chapter2.nb", "i:90"},
    ButtonStyle->"Hyperlink"],
  " ",
  ButtonBox["184",
    ButtonData:>{"Chapter2.nb", "i:78"},
    ButtonStyle->"Hyperlink"],
  "  \n\tmolecular dynamics method, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Molecular dynamics",
    ButtonData:>"ii:229",
    ButtonStyle->"Hyperlink"],
  "\n\torder of a numerical method, ",
  ButtonBox["38",
    ButtonData:>{"Chapter1.nb", "i:48"},
    ButtonStyle->"Hyperlink"],
  "\n\tpredictor-corrector method, ",
  ButtonBox["38",
    ButtonData:>{"Chapter1.nb", "i:49"},
    ButtonStyle->"Hyperlink"],
  "\n\tRunga-Kutta method, ",
  ButtonBox["40",
    ButtonData:>{"Chapter1.nb", "i:53"},
    ButtonStyle->"Hyperlink"],
  "\n\tshooting method, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Shooting method",
    ButtonData:>"ii:308",
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["Boundary value problems",
    ButtonData:>"ii:46",
    ButtonStyle->"Hyperlink"],
  "\n\tusing intrisinc ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " function, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  StyleBox[ButtonBox["NDSolve",
    ButtonData:>"ii:235",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"]
}], "Text",
  CellTags->"ii:244"],

Cell[TextData[{
  "Numerical solution of PDEs, ",
  ButtonBox["435",
    ButtonData:>{"Chapter6.nb", "i:1"},
    ButtonStyle->"Hyperlink"],
  "\n\texpansion in basis functions, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Galerkin method",
    ButtonData:>"ii:147",
    ButtonStyle->"Hyperlink"],
  "\n\ton a grid, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Grid methods",
    ButtonData:>"ii:159",
    ButtonStyle->"Hyperlink"],
  "\n\tnumerical eigenmodes, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Eigenmodes, numerical",
    ButtonData:>"ii:100",
    ButtonStyle->"Hyperlink"],
  "\n\tparticle in cell method, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["PIC method",
    ButtonData:>"ii:261",
    ButtonStyle->"Hyperlink"],
  "\n\trandom-walk simulations for the Fokker-Planck equation, ",
  ButtonBox["601",
    ButtonData:>{"Chapter8.nb", "c:20"},
    ButtonStyle->"Hyperlink"],
  "\n\tray tracing, ",
  ButtonBox["5.3.1",
    ButtonData:>{"Chapter5.nb", "i:141"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " WKB method"
}], "Text",
  CellTags->"ii:245"],

Cell[BoxData[""], "Input"],

Cell[TextData[{
  "One component plasma, ",
  ButtonBox["7.3 Exercise 6",
    ButtonData:>{"Chapter7.nb", "i:92"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->{"O", "ii:389"}],

Cell[TextData[{
  "Operator(s)\n\tdifferential, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Differential operators",
    ButtonData:>"ii:85",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Linear ODEs",
    ButtonData:>"ii:205",
    ButtonStyle->"Hyperlink"],
  "\n\tintegral, ",
  ButtonBox["131",
    ButtonData:>{"Chapter2.nb", "c:23"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["174",
    ButtonData:>{"Chapter2.nb", "i:108"},
    ButtonStyle->"Hyperlink"],
  "\t\n\tsplitting, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  StyleBox[" ",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  ButtonBox["Grid methods",
    ButtonData:>"ii:159",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:246"],

Cell[TextData[{
  "Options for intrinsic functions, ",
  ButtonBox["9.7",
    ButtonData:>{"Chapter9.nb", "i:61"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Orbits of planets, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Planets",
    ButtonData:>"ii:381",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Ordinary differential equations, ",
  ButtonBox["1",
    ButtonData:>{"Chapter1.nb", "i:5"},
    ButtonStyle->"Hyperlink"],
  "\n\tAiry equation, ",
  ButtonBox["18",
    ButtonData:>{"Chapter1.nb", "i:31"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["84",
    ButtonData:>{"Chapter1.nb", "i:106"},
    ButtonStyle->"Hyperlink"],
  "\n\tBessel's equation, ",
  ButtonBox["248",
    ButtonData:>{"Chapter3.nb", "i:81"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also ",
    FontSlant->"Italic"],
  ButtonBox["Bessel functions",
    ButtonData:>"ii:36",
    ButtonStyle->"Hyperlink"],
  "\n\tchaotic, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Chaotic systems",
    ButtonData:>"ii:56",
    ButtonStyle->"Hyperlink"],
  "\n\tdamped harmonic oscillator, ",
  ButtonBox["9",
    ButtonData:>{"Chapter1.nb", "i:25"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["70",
    ButtonData:>{"Chapter1.nb", "i:91"},
    ButtonStyle->"Hyperlink"],
  "\n\tdriven pendulum, ",
  ButtonBox["27",
    ButtonData:>{"Chapter1.nb", "i:50"},
    ButtonStyle->"Hyperlink"],
  "\n\texistence and uniqueness of solutions for BVP's, ",
  ButtonBox["63",
    ButtonData:>{"Chapter1.nb", "i:17"},
    ButtonStyle->"Hyperlink"],
  "\n\texistence and uniqueness of solutions for IVP's, ",
  ButtonBox["6",
    ButtonData:>{"Chapter1.nb", "i:16"},
    ButtonStyle->"Hyperlink"],
  "\n\tFermi Pasta Ulam (FPU) system, ",
  ButtonBox["565",
    ButtonData:>{"Chapter7.nb", "i:52"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor field lines, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Field lines",
    ButtonData:>"ii:125",
    ButtonStyle->"Hyperlink"],
  "\n\tHamiltonian systems, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Hamiltonian",
    ButtonData:>"ii:161",
    ButtonStyle->"Hyperlink"],
  "\n\tharmonic oscillator equation, ",
  ButtonBox["2",
    ButtonData:>{"Chapter1.nb", "i:10"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["17",
    ButtonData:>{"Chapter1.nb", "i:29"},
    ButtonStyle->"Hyperlink"],
  "\n\tintegrable, ",
  ButtonBox["14",
    ButtonData:>{"Chapter1.nb", "i:24"},
    ButtonStyle->"Hyperlink"],
  "\n\tLangevin equation, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Langevin equation",
    ButtonData:>"ii:197",
    ButtonStyle->"Hyperlink"],
  "\n\tLegendre equation, ",
  ButtonBox["241",
    ButtonData:>{"Chapter3.nb", "i:69"},
    ButtonStyle->"Hyperlink"],
  "\n\tlinear, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Linear ODEs",
    ButtonData:>"ii:205",
    ButtonStyle->"Hyperlink"],
  "\n\tLorenz system, ",
  ButtonBox["52",
    ButtonData:>{"Chapter1.nb", "i:60"},
    ButtonStyle->"Hyperlink"],
  "\n\tnumerical solution, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Numerical solution of ODEs",
    ButtonData:>"ii:244",
    ButtonStyle->"Hyperlink"],
  "\n\torder, ",
  ButtonBox["3",
    ButtonData:>{"Chapter1.nb", "i:11"},
    ButtonStyle->"Hyperlink"],
  "\n\tpendulum, ",
  ButtonBox["14",
    ButtonData:>{"Chapter1.nb", "i:37"},
    ButtonStyle->"Hyperlink"],
  "\n\tphase space, ",
  ButtonBox["9",
    ButtonData:>{"Chapter1.nb", "i:20"},
    ButtonStyle->"Hyperlink"],
  "\n\tVan der Pol oscillator, ",
  ButtonBox["15",
    ButtonData:>{"Chapter1.nb", "i:38"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["50",
    ButtonData:>{"Chapter1.nb", "i:55"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["81",
    ButtonData:>{"Chapter1.nb", "i:102"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:247"],

Cell[TextData[{
  "Orthogonality, for complex functions, in Fourier series, ",
  ButtonBox["103",
    ButtonData:>{"Chapter2.nb", "i:6"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor general functions, in terms of inner products, ",
  ButtonBox["262",
    ButtonData:>{"Chapter4.nb", "i:1"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor real functions, in Fourier series, ",
  ButtonBox["90",
    ButtonData:>{"Chapter2.nb", "i:5"},
    ButtonStyle->"Hyperlink"],
  "\n\tof associated Legendre functions, ",
  ButtonBox["243",
    ButtonData:>{"Chapter3.nb", "i:72"},
    ButtonStyle->"Hyperlink"],
  "\n\tof Bessel functions, ",
  ButtonBox["252",
    ButtonData:>{"Chapter3.nb", "i:90"},
    ButtonStyle->"Hyperlink"],
  "\n\tof eigenmodes of ",
  Cell[BoxData[
      \(TraditionalForm\`\[Del]\^2\)]],
  ", ",
  ButtonBox["303",
    ButtonData:>{"Chapter4.nb", "i:73"},
    ButtonStyle->"Hyperlink"],
  "\n\tof eigenmodes of Hermitian operators, ",
  ButtonBox["270",
    ButtonData:>{"Chapter4.nb", "i:15"},
    ButtonStyle->"Hyperlink"],
  "\n\tof eigenmodes of the adjoint operator, ",
  ButtonBox["273",
    ButtonData:>{"Chapter4.nb", "i:20"},
    ButtonStyle->"Hyperlink"],
  "\n\tof eigenmodes satisfying mixed boundary conditions, ",
  ButtonBox["222",
    ButtonData:>{"Chapter3.nb", "i:41"},
    ButtonStyle->"Hyperlink"],
  "\n\tof polynomials, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Orthogonal polynomials",
    ButtonData:>"ii:249",
    ButtonStyle->"Hyperlink"],
  "\n\tof spherical Bessel functions, ",
  ButtonBox["320",
    ButtonData:>{"Chapter4.nb", "i:70"},
    ButtonStyle->"Hyperlink"],
  "\n\tof spherical harmonics, ",
  ButtonBox["243",
    ButtonData:>{"Chapter3.nb", "i:73"},
    ButtonStyle->"Hyperlink"],
  "\n\tvia Gram-Schmidt method, ",
  ButtonBox["262",
    ButtonData:>{"Chapter4.nb", "i:7"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:248"],

Cell[TextData[{
  "Orthogonal polynomials, ",
  ButtonBox["263",
    ButtonData:>{"Chapter4.nb", "i:8"},
    ButtonStyle->"Hyperlink"],
  "\n\tChebyshev, ",
  ButtonBox["273",
    ButtonData:>{"Chapter4.nb", "i:27"},
    ButtonStyle->"Hyperlink"],
  "\n\tHermite, ",
  ButtonBox["273",
    ButtonData:>{"Chapter4.nb", "i:26"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["276",
    ButtonData:>{"Chapter4.nb", "i:30"},
    ButtonStyle->"Hyperlink"],
  "\n\tLaguerre, ",
  ButtonBox["273",
    ButtonData:>{"Chapter4.nb", "i:22"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["350",
    ButtonData:>{"Chapter4.nb", "i:114"},
    ButtonStyle->"Hyperlink"],
  "\n\tLegendre, ",
  ButtonBox["265",
    ButtonData:>{"Chapter4.nb", "i:9"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["275",
    ButtonData:>{"Chapter4.nb", "i:24"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:249"],

Cell[BoxData[""], "Input"],

Cell[TextData[{
  "Palettes, ",
  ButtonBox["9.4.3",
    ButtonData:>{"Chapter9.nb", "i:12"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->{"P", "ii:250"}],

Cell[TextData[{
  "Parametric Plots, ",
  ButtonBox["9.6.5",
    ButtonData:>{"Chapter9.nb", "i:50"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor curves in two dimensions (",
  StyleBox["ParametricPlot",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "), ",
  ButtonBox["9.6.5",
    ButtonData:>{"Chapter9.nb", "i:51"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor curves or surfaces in 3 dimensions (",
  StyleBox["ParametricPlot3D",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "), ",
  ButtonBox["9.6 Exercise 6",
    ButtonData:>{"Chapter9.nb", "i:52"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:251"],

Cell[TextData[{
  "Parseval's theorem, ",
  ButtonBox["165",
    ButtonData:>{"Chapter2.nb", "i:113"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Partial differential equations, ",
  ButtonBox["4",
    ButtonData:>{"Chapter1.nb", "i:7"},
    ButtonStyle->"Hyperlink"],
  "\n\tBoussinesq equations, ",
  ButtonBox["7.2 Exercise 3",
    ButtonData:>{"Chapter7.nb", "i:32"},
    ButtonStyle->"Hyperlink"],
  "\n\tBurgers' equation, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Burgers' equation",
    ButtonData:>"ii:51",
    ButtonStyle->"Hyperlink"],
  "\n\tcollisionless Boltzmann equation, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Boltzmann equation, collisionless",
    ButtonData:>"ii:42",
    ButtonStyle->"Hyperlink"],
  "\n\tEuler equations, ",
  ButtonBox["7.3 Exercise 5",
    ButtonData:>{"Chapter7.nb", "i:84"},
    ButtonStyle->"Hyperlink"],
  "\n\tfirst-order, ",
  ButtonBox["511",
    ButtonData:>{"Chapter7.nb", "i:15"},
    ButtonStyle->"Hyperlink"],
  "\n\tFokker-Planck equation, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Fokker-Planck equation",
    ButtonData:>"ii:131",
    ButtonStyle->"Hyperlink"],
  "\n\theat equation, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Heat equation",
    ButtonData:>"ii:164",
    ButtonStyle->"Hyperlink"],
  "\n\tHelmholtz equation, ",
  ButtonBox["302",
    ButtonData:>{"Chapter4.nb", "i:71"},
    ButtonStyle->"Hyperlink"],
  "\n\tin infinite domains, ",
  ButtonBox["355",
    ButtonData:>{"Chapter5.nb", "i:1"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Fourier transforms",
    ButtonData:>"ii:139",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["WKB method",
    ButtonData:>"ii:374",
    ButtonStyle->"Hyperlink"],
  "\n\tKdV equation, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["KdV equation",
    ButtonData:>"ii:192",
    ButtonStyle->"Hyperlink"],
  "\n\tKlein-Gordon equation, ",
  ButtonBox["562",
    ButtonData:>{"Chapter7.nb", "i:35"},
    ButtonStyle->"Hyperlink"],
  "\n\tLaplace's equation, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Laplace's equation",
    ButtonData:>"ii:199",
    ButtonStyle->"Hyperlink"],
  "\n\tlinear, general solution using operator eigenmodes, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Eigenmodes",
    ButtonData:>"ii:100",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Hermitian operators",
    ButtonData:>"ii:168",
    ButtonStyle->"Hyperlink"],
  "\n\tNavier-Stokes equations, ",
  ButtonBox["562",
    ButtonData:>{"Chapter7.nb", "i:41"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["7.3.5",
    ButtonData:>{"Chapter7.nb", "i:83"},
    ButtonStyle->"Hyperlink"],
  "\n\tnumerical solution, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Numerical solution of PDEs",
    ButtonData:>"ii:245",
    ButtonStyle->"Hyperlink"],
  "\n\tPoisson's equation, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Poisson's equation",
    ButtonData:>"ii:272",
    ButtonStyle->"Hyperlink"],
  "\n\tSchr\[ODoubleDot]dinger's equation, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Schr\[ODoubleDot]dinger's equation",
    ButtonData:>"ii:311",
    ButtonStyle->"Hyperlink"],
  "\n\tsine-Gordon equation, ",
  ButtonBox["562",
    ButtonData:>{"Chapter7.nb", "i:34"},
    ButtonStyle->"Hyperlink"],
  "\n\tstandard form for, ",
  ButtonBox["279",
    ButtonData:>{"Chapter4.nb", "i:35"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["301",
    ButtonData:>{"Chapter4.nb", "i:54"},
    ButtonStyle->"Hyperlink"],
  "\n\ttraffic flow equation, ",
  ButtonBox["536",
    ButtonData:>{"Chapter7.nb", "i:23"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["564",
    ButtonData:>{"Chapter7.nb", "i:51"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Burgers' equation",
    ButtonData:>"ii:51",
    ButtonStyle->"Hyperlink"],
  "\n\twave equation, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Wave equation",
    ButtonData:>"ii:362",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:252"],

Cell[TextData[{
  "Particular solution, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Linear ODEs, particular solution",
    ButtonData:>"ii:205",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Pendulum, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Ordinary differential equations",
    ButtonData:>"ii:247",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Penning trap, ",
  ButtonBox["61",
    ButtonData:>{"Chapter1.nb", "i:72"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["259",
    ButtonData:>{"Chapter3.nb", "i:92"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:253"],

Cell[TextData[{
  "Percolation, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Random walk(s), Eden model",
    ButtonData:>"ii:285",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:254"],

Cell[TextData[{
  "Perihelion, ",
  ButtonBox["22",
    ButtonData:>{"Chapter1.nb", "i:34"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["9.6 Exercise 3",
    ButtonData:>{"Chapter9.nb", "i:60"},
    ButtonStyle->"Hyperlink"],
  "\n\tprecession of Mercury's, ",
  ButtonBox["51",
    ButtonData:>{"Chapter1.nb", "i:56"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:255"],

Cell[TextData[{
  "Periodic extension of a function, ",
  ButtonBox["111",
    ButtonData:>{"Chapter2.nb", "i:29"},
    ButtonStyle->"Hyperlink"],
  "\n\teven, ",
  ButtonBox["113",
    ButtonData:>{"Chapter2.nb", "i:30"},
    ButtonStyle->"Hyperlink"],
  "\n\todd, ",
  ButtonBox["116",
    ButtonData:>{"Chapter2.nb", "i:31"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:256"],

Cell[TextData[{
  "Perturbation theory, ",
  ButtonBox["6.3 Exercise 17",
    ButtonData:>{"Chapter6.nb", "i:52"},
    ButtonStyle->"Hyperlink"],
  "\n\tdegenerate, ",
  ButtonBox["6.3 Exercise 17",
    ButtonData:>{"Chapter6.nb", "i:55"},
    ButtonStyle->"Hyperlink"],
  "\n\tfirst-order energy shift, ",
  ButtonBox["6.3 Exercise 17",
    ButtonData:>{"Chapter6.nb", "i:53"},
    ButtonStyle->"Hyperlink"],
  "\n\tsecond-order energy shift, ",
  ButtonBox["6.3 Exercise 17",
    ButtonData:>{"Chapter6.nb", "i:54"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:257"],

Cell[TextData[{
  "Phase \n\tmixing, ",
  ButtonBox["521\n\t",
    ButtonData:>{"Chapter7.nb", "i:8"},
    ButtonStyle->"Hyperlink"],
  "space, ",
  ButtonBox["9",
    ButtonData:>{"Chapter1.nb", "i:20"},
    ButtonStyle->"Hyperlink"],
  "\n\tWKB, ",
  ButtonBox["397",
    ButtonData:>{"Chapter5.nb", "i:142"},
    ButtonStyle->"Hyperlink"],
  " . ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Eikonal",
    ButtonData:>"ii:104",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Wave packet, phase",
    ButtonData:>"ii:365",
    ButtonStyle->"Hyperlink"],
  " "
}], "Text",
  CellTags->"ii:258"],

Cell[TextData[{
  "Phase velocity, ",
  ButtonBox["360",
    ButtonData:>{"Chapter5.nb", "i:9"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor complex frequencies (damped waves), ",
  ButtonBox["384",
    ButtonData:>{"Chapter5.nb", "i:43"},
    ButtonStyle->"Hyperlink"],
  "\n\tin multidimensions, ",
  ButtonBox["368",
    ButtonData:>{"Chapter5.nb", "i:21"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:260"],

Cell[TextData[{
  "PIC method, ",
  ButtonBox["7.3",
    ButtonData:>{"Chapter7.nb", "i:55"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:261"],

Cell[TextData[{
  "Planet(s), \n\torbits of, ",
  ButtonBox["22",
    ButtonData:>{"Chapter1.nb", "i:146"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["48",
    ButtonData:>{"Chapter1.nb", "i:145"},
    ButtonStyle->"Hyperlink"],
  ",  ",
  ButtonBox["59",
    ButtonData:>{"Chapter1.nb", "i:76"},
    ButtonStyle->"Hyperlink"],
  "\n\textrasolar, ",
  ButtonBox["62",
    ButtonData:>{"Chapter1.nb", "i:144"},
    ButtonStyle->"Hyperlink"],
  "\n\tMercury (",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Perihelion, precession of Mercury's",
    ButtonData:>"ii:255",
    ButtonStyle->"Hyperlink"],
  ")\n\tcooling rate of, ",
  ButtonBox["344",
    ButtonData:>{"Chapter4.nb", "c:41"},
    ButtonStyle->"Hyperlink"],
  "\n\ttidal deformation of, ",
  ButtonBox["332",
    ButtonData:>{"Chapter4.nb", "i:87"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["343",
    ButtonData:>{"Chapter4.nb", "i:93"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:381"],

Cell[TextData[{
  "Plasma, frequency, ",
  ButtonBox["395",
    ButtonData:>{"Chapter5.nb", "i:55"},
    ButtonStyle->"Hyperlink"],
  "\n\tpropagation of radio waves through, ",
  ButtonBox["428",
    ButtonData:>{"Chapter5.nb", "i:100"},
    ButtonStyle->"Hyperlink"],
  "\n\tsingle component, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  " ",
  ButtonBox["One component plasma",
    ButtonData:>"ii:389",
    ButtonStyle->"Hyperlink"],
  "\n\twaves, magnetized, ",
  ButtonBox["394",
    ButtonData:>{"Chapter5.nb", "i:54"},
    ButtonStyle->"Hyperlink"],
  "\n\twaves, whistler, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Whistler waves",
    ButtonData:>"ii:372",
    ButtonStyle->"Hyperlink"],
  "\n\twaves, thermal corrections to, ",
  ButtonBox["7.3 Exercise 6",
    ButtonData:>{"Chapter7.nb", "i:90"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:262"],

Cell[TextData[{
  StyleBox["Play",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["106",
    ButtonData:>{"Chapter2.nb", "i:25"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  StyleBox[" ",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  StyleBox[ButtonBox["ListPlay",
    ButtonData:>"ii:207",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"]
}], "Text",
  CellTags->"ii:263"],

Cell[TextData[{
  StyleBox["Plot",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.6.1",
    ButtonData:>{"Chapter9.nb", "i:43"},
    ButtonStyle->"Hyperlink"],
  "\n\tsome options for, ",
  ButtonBox["9.6.1",
    ButtonData:>{"Chapter9.nb", "i:44"},
    ButtonStyle->"Hyperlink"],
  "\n\tseveral curves, ",
  ButtonBox["9.6.3",
    ButtonData:>{"Chapter9.nb", "i:46"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:264"],

Cell[TextData[{
  StyleBox["Plot3D",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.6.6\n",
    ButtonData:>{"Chapter9.nb", "i:48"},
    ButtonStyle->"Hyperlink"],
  "\tover arbitrary regions (",
  StyleBox["see ",
    FontSlant->"Italic"],
  " ",
  StyleBox[ButtonBox["Boole",
    ButtonData:>"ii:44",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ")"
}], "Text",
  CellTags->"ii:265"],

Cell[TextData[{
  "Plots\n\tchanging the viewpoint in 3D plots, ",
  ButtonBox["9.6.6",
    ButtonData:>{"Chapter9.nb", "i:53"},
    ButtonStyle->"Hyperlink"],
  "\n\tchanging the viewpoint in 3D plots interactively, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  StyleBox[ButtonBox["RealTime3D",
    ButtonData:>"ii:291",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "\n\tcurves or surfaces in 2D or 3D defined by parameter(s), ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Parametric plots",
    ButtonData:>"ii:251",
    ButtonStyle->"Hyperlink"],
  "\n\tdata, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  StyleBox[ButtonBox["ListPlot",
    ButtonData:>"ii:208",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "\n\tfunctions of one variable, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  StyleBox[ButtonBox["Plot",
    ButtonData:>"ii:264",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "\n\tfunctions of two variables, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  StyleBox[ButtonBox["ContourPlot",
    ButtonData:>"ii:65",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "; ",
  StyleBox[ButtonBox["Plot3D",
    ButtonData:>"ii:265",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "\n\tover arbitrary regions defined by inequalities, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  StyleBox[ButtonBox["Boole",
    ButtonData:>"ii:44",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "\n\trepeating a previous plot, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  StyleBox[ButtonBox["Show",
    ButtonData:>"ii:309",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"]
}], "Text",
  CellTags->"ii:267"],

Cell[TextData[{
  StyleBox["PlotVectorField",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["7",
    ButtonData:>{"Chapter1.nb", "i:18"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:268"],

Cell[TextData[{
  "Poincar\[EAcute] \n\tJules Henri, ",
  ButtonBox["54",
    ButtonData:>{"Chapter1.nb", "i:107"},
    ButtonStyle->"Hyperlink"],
  "\n\tplot, ",
  ButtonBox["54",
    ButtonData:>{"Chapter1.nb", "i:107"},
    ButtonStyle->"Hyperlink"],
  "\n\trecurrence, ",
  ButtonBox["585",
    ButtonData:>{"Chapter8.nb", "i:27"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["590",
    ButtonData:>{"Chapter8.nb", "i:84"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:269"],

Cell[TextData[{
  "Poisson's equation, ",
  ButtonBox["300",
    ButtonData:>{"Chapter4.nb", "i:52"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also ",
    FontSlant->"Italic"],
  ButtonBox["Partial Differential Equations",
    ButtonData:>"ii:252",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Laplace's equation",
    ButtonData:>"ii:199",
    ButtonStyle->"Hyperlink"],
  "\n\tboundary conditions, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Laplace's equation, boundary conditions",
    ButtonData:>"ii:199",
    ButtonStyle->"Hyperlink"],
  "\n\teigenmodes, ",
  ButtonBox["302",
    ButtonData:>{"Chapter4.nb", "i:107"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Laplacian operator",
    ButtonData:>"ii:200",
    ButtonStyle->"Hyperlink"],
  "\n\texistence of solution, ",
  ButtonBox["304",
    ButtonData:>{"Chapter4.nb", "i:61"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["325",
    ButtonData:>{"Chapter4.nb", "i:76"},
    ButtonStyle->"Hyperlink"],
  "\n\tgeneral solution via generalized Fourier series, ",
  ButtonBox["304",
    ButtonData:>{"Chapter4.nb", "i:60"},
    ButtonStyle->"Hyperlink"],
  "\n\tgeneral solution via Green's function, ",
  ButtonBox["302",
    ButtonData:>{"Chapter4.nb", "i:59"},
    ButtonStyle->"Hyperlink"],
  "\n\tnumerical solution of, ",
  ButtonBox["442",
    ButtonData:>{"Chapter6.nb", "c:7"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["486",
    ButtonData:>{"Chapter6.nb", "i:30"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["494",
    ButtonData:>{"Chapter6.nb", "i:33"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["497",
    ButtonData:>{"Chapter6.nb", "i:34"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["499",
    ButtonData:>{"Chapter6.nb", "i:36"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Boundary value problems",
    ButtonData:>"ii:46",
    ButtonStyle->"Hyperlink"],
  "\n\tsolution in terms of multipole moments, ",
  ButtonBox["329",
    ButtonData:>{"Chapter4.nb", "i:84"},
    ButtonStyle->"Hyperlink"],
  "\n\tstandard form, ",
  ButtonBox["301",
    ButtonData:>{"Chapter4.nb", "i:54"},
    ButtonStyle->"Hyperlink"],
  "\n\tuniqueness of solution, ",
  ButtonBox["300",
    ButtonData:>{"Chapter4.nb", "i:62"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:272"],

Cell[TextData[{
  "Poisson, Simeon Denis, ",
  ButtonBox["4",
    ButtonData:>{"Chapter1.nb", "i:6"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:273"],

Cell[TextData[{
  "Polarization, circular, ",
  ButtonBox["228",
    ButtonData:>{"Chapter3.nb", "i:52"},
    ButtonStyle->"Hyperlink"],
  "\n\tof electromagnetic waves, ",
  ButtonBox["427",
    ButtonData:>{"Chapter5.nb", "i:126"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Polymers, ",
  ButtonBox["591",
    ButtonData:>{"Chapter8.nb", "i:83"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:274"],

Cell[TextData[{
  "Potential\n\tCoulomb, ",
  ButtonBox["301",
    ButtonData:>{"Chapter4.nb", "i:111"},
    ButtonStyle->"Hyperlink"],
  "\n\telectrostatic, ",
  ButtonBox["231",
    ButtonData:>{"Chapter3.nb", "i:112"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["300",
    ButtonData:>{"Chapter4.nb", "i:109"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Laplace's equation",
    ButtonData:>"ii:199",
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["Poisson's equation",
    ButtonData:>"ii:272",
    ButtonStyle->"Hyperlink"],
  "\n\tflow, ",
  ButtonBox["352",
    ButtonData:>{"Chapter4.nb", "i:100"},
    ButtonStyle->"Hyperlink"],
  "\n\tgravitational, ",
  ButtonBox["331",
    ButtonData:>{"Chapter4.nb", "i:110"},
    ButtonStyle->"Hyperlink"],
  "\n\tLennard-Jones, ",
  ButtonBox["60",
    ButtonData:>{"Chapter1.nb", "i:71"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["8.3.2",
    ButtonData:>{"Chapter8.nb", "i:69"},
    ButtonStyle->"Hyperlink"],
  "\n\tretarded, ",
  ButtonBox["381",
    ButtonData:>{"Chapter5.nb", "i:37"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:275"],

Cell[TextData[{
  "Power series, ",
  ButtonBox["9.9.2",
    ButtonData:>{"Chapter9.nb", "i:71"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  StyleBox[ButtonBox["Series",
    ButtonData:>"ii:305",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"]
}], "Text",
  CellTags->"ii:276"],

Cell[TextData[{
  "Poynting flux, ",
  ButtonBox["389",
    ButtonData:>{"Chapter5.nb", "i:51"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["427",
    ButtonData:>{"Chapter5.nb", "i:99"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Energy, flux",
    ButtonData:>"ii:109",
    ButtonStyle->"Hyperlink"],
  ")"
}], "Text",
  CellTags->"ii:2771"],

Cell[TextData[{
  StyleBox["Precision",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.2.6",
    ButtonData:>{"Chapter9.nb", "i:21"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:278"],

Cell[TextData[{
  StyleBox["PrecisionGoal",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.11.2",
    ButtonData:>{"Chapter9.nb", "i:103"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["26",
    ButtonData:>{"Chapter1.nb", "i:111"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:279"],

Cell[TextData[{
  "Predictor corrector method, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Numerical solution of ODEs",
    ButtonData:>"ii:244",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:280"],

Cell[TextData[{
  "Probability, conditional, ",
  ButtonBox["594",
    ButtonData:>{"Chapter8.nb", "i:45"},
    ButtonStyle->"Hyperlink"],
  "\n\tdefinition of, ",
  ButtonBox["569",
    ButtonData:>{"Chapter8.nb", "i:6"},
    ButtonStyle->"Hyperlink"],
  "\n\tdensity, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Density, probability",
    ButtonData:>"ii:80",
    ButtonStyle->"Hyperlink"],
  "\n\tdistribution, definition, ",
  ButtonBox["572",
    ButtonData:>{"Chapter8.nb", "i:10"},
    ButtonStyle->"Hyperlink"],
  "\n\ttransition, ",
  ButtonBox["8.3.1",
    ButtonData:>{"Chapter8.nb", "i:62"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:281"],

Cell[BoxData[""], "Input"],

Cell[TextData[{
  StyleBox["Quotient",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["7.3.4",
    ButtonData:>{"Chapter7.nb", "i:58"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->{"Q", "ii:282"}],

Cell[BoxData[""], "Input"],

Cell[TextData[{
  "Radiation, ",
  ButtonBox["230",
    ButtonData:>{"Chapter3.nb", "i:55"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Wavepacket energy and momentum flux",
    ButtonData:>"ii:365",
    ButtonStyle->"Hyperlink"],
  "\n\tfrom a stationary point source, ",
  ButtonBox["381",
    ButtonData:>{"Chapter5.nb", "i:37"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->{"R", "ii:283"}],

Cell[TextData[{
  "Radius of convergence ",
  ButtonBox["9.9.2",
    ButtonData:>{"Chapter9.nb", "i:117"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  StyleBox["Random",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.2.3",
    ButtonData:>{"Chapter9.nb", "i:96"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["9.11 Exercise 5",
    ButtonData:>{"Chapter9.nb", "i:97"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["569",
    ButtonData:>{"Chapter8.nb", "i:6"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:2841"],

Cell[TextData[{
  "Random walk(s), ",
  ButtonBox["567",
    ButtonData:>{"Chapter8.nb", "i:30"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Rosenbluth-Teller-Metropolis Monte Carlo method",
    ButtonData:>"ii:300",
    ButtonStyle->"Hyperlink"],
  "\n\tEden model, ",
  ButtonBox["613",
    ButtonData:>{"Chapter8.nb", "i:78"},
    ButtonStyle->"Hyperlink"],
  "\n\tfluctuations from the mean, ",
  ButtonBox["8.3.2",
    ButtonData:>{"Chapter8.nb", "i:70"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Average(s)",
    ButtonData:>"ii:29",
    ButtonStyle->"Hyperlink"],
  "\n\tinhomogeneous, ",
  ButtonBox["596",
    ButtonData:>{"Chapter8.nb", "i:48"},
    ButtonStyle->"Hyperlink"],
  "\n\tself-avoiding, ",
  ButtonBox["591",
    ButtonData:>{"Chapter8.nb", "i:41"},
    ButtonStyle->"Hyperlink"],
  "\n\twith arbitrary steps, ",
  ButtonBox["592",
    ButtonData:>{"Chapter8.nb", "i:43"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:285"],

Cell[TextData[{
  "Rayleigh\n\tlength, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Dispersion, longitudinal and transverse\n\t",
    ButtonData:>"ii:91",
    ButtonStyle->"Hyperlink"],
  "Lord (William Strutt, Lord Rayleigh), ",
  ButtonBox["396",
    ButtonData:>{"Chapter5.nb", "i:128"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:286"],

Cell[TextData[{
  "Ray trajectories, ",
  ButtonBox["412",
    ButtonData:>{"Chapter5.nb", "i:107"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also ",
    FontSlant->"Italic"],
  ButtonBox["Refraction",
    ButtonData:>"ii:293",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Geometrical optics",
    ButtonData:>"ii:150",
    ButtonStyle->"Hyperlink"],
  "\n\tfor P waves in the earth, ",
  ButtonBox["429",
    ButtonData:>{"Chapter5.nb", "i:102"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor shallow water waves near the beach, ",
  ButtonBox["413",
    ButtonData:>{"Chapter5.nb", "i:108"},
    ButtonStyle->"Hyperlink"],
  "\n\tin a lens, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Snell's law",
    ButtonData:>"ii:316",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:288"],

Cell[TextData[{
  "Reading data from external files, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  StyleBox[ButtonBox["Import",
    ButtonData:>"ii:177",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["<<",
    ButtonData:>"ii:11",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:290"],

Cell[TextData[{
  StyleBox["RealTime3D",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.6.6",
    ButtonData:>{"Chapter9.nb", "i:54"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:291"],

Cell[TextData[{
  "Recursion relations, \n\tdefinition, ",
  ButtonBox["31",
    ButtonData:>{"Chapter1.nb", "i:138"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor perturbed energy levels, ",
  ButtonBox["6.3 Exercise 17",
    ButtonData:>{"Chapter6.nb", "i:55"},
    ButtonStyle->"Hyperlink"],
  "\n\tused in WKB method, ",
  ButtonBox["401",
    ButtonData:>{"Chapter5.nb", "i:96"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["424",
    ButtonData:>{"Chapter5.nb", "i:95"},
    ButtonStyle->"Hyperlink"],
  "\n\tused to find polynomial roots, ",
  ButtonBox["425",
    ButtonData:>{"Chapter5.nb", "i:97"},
    ButtonStyle->"Hyperlink"],
  "\n\tused to solve algebraic equations, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Newton's method",
    ButtonData:>"ii:1",
    ButtonStyle->"Hyperlink"],
  "\n\tused to solve ODEs, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Euler's method",
    ButtonData:>"ii:115",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Numerical solution of ODEs",
    ButtonData:>"ii:244",
    ButtonStyle->"Hyperlink"],
  "\n\tused to solve PDEs, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Relaxation methods",
    ButtonData:>"ii:295",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Grid methods",
    ButtonData:>"ii:159",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:292"],

Cell[TextData[{
  "Refraction, ",
  ButtonBox["412",
    ButtonData:>{"Chapter5.nb", "i:76"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["WKB method",
    ButtonData:>"ii:374",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Ray trajectories",
    ButtonData:>"ii:288",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Snell's law",
    ButtonData:>"ii:316",
    ButtonStyle->"Hyperlink"],
  "\n\tindex of, ",
  ButtonBox["375",
    ButtonData:>{"Chapter5.nb", "i:112"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["415",
    ButtonData:>{"Chapter5.nb", "i:113"},
    ButtonStyle->"Hyperlink"],
  "\n\tindex of, nonlinear, ",
  ButtonBox["546",
    ButtonData:>{"Chapter7.nb", "i:73"},
    ButtonStyle->"Hyperlink"],
  "\n\tin optical fibres, ",
  ButtonBox["429",
    ButtonData:>{"Chapter5.nb", "i:101"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:293"],

Cell[TextData[{
  "Rejection method, ",
  ButtonBox["599",
    ButtonData:>{"Chapter8.nb", "i:53"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:294"],

Cell[TextData[{
  "Relaxation methods, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Grid methods",
    ButtonData:>"ii:159",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:295"],

Cell[TextData[{
  StyleBox["Remove",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.4.2",
    ButtonData:>{"Chapter9.nb", "i:23"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  StyleBox[ButtonBox["Clear",
    ButtonData:>"ii:379",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "; ",
  StyleBox[ButtonBox["Unset",
    ButtonData:>"ii:352",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"]
}], "Text",
  CellTags->"ii:378"],

Cell[TextData[{
  "Replacing variables (",
  StyleBox["/.",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "), ",
  ButtonBox["9.8.2",
    ButtonData:>{"Chapter9.nb", "i:65"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:296"],

Cell[TextData[{
  "Resistivity, ",
  ButtonBox["588",
    ButtonData:>{"Chapter8.nb", "i:35"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Density, current",
    ButtonData:>"ii:80",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:297"],

Cell[TextData[{
  "Retarded time, ",
  ButtonBox["382",
    ButtonData:>{"Chapter5.nb", "i:130"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Riemann, Georg, ",
  ButtonBox["122",
    ButtonData:>{"Chapter2.nb", "i:37"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:298"],

Cell[TextData[{
  "Rosenbluth, Marshall, ",
  ButtonBox["8.3.1",
    ButtonData:>{"Chapter8.nb", "i:85"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:299"],

Cell[TextData[{
  "Rosenbluth-Teller-Metropolis Monte Carlo method, ",
  ButtonBox["8.3",
    ButtonData:>{"Chapter8.nb", "i:59"},
    ButtonStyle->"Hyperlink"],
  "\n\tapplied to Ising model, ",
  ButtonBox["8.3 Exercise 5",
    ButtonData:>{"Chapter8.nb", "i:77"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor interacting classical particles, ",
  ButtonBox["8.3.2",
    ButtonData:>{"Chapter8.nb", "i:72"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor ideal gas, ",
  ButtonBox["8.3.2",
    ButtonData:>{"Chapter8.nb", "i:68"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:300"],

Cell[TextData[{
  "Runga-Kutta method, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Numerical solution of ODEs",
    ButtonData:>"ii:244",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[BoxData[""], "Input"],

Cell[TextData[{
  StyleBox["SampledSoundList",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["154",
    ButtonData:>{"Chapter2.nb", "i:99"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->{"S", "ii:301"}],

Cell[TextData[{
  "Schmidt, Erhard, ",
  ButtonBox["263",
    ButtonData:>{"Chapter4.nb", "i:112"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:302"],

Cell[TextData[{
  "Schr\[ODoubleDot]dinger, Erwin, ",
  ButtonBox["229",
    ButtonData:>{"Chapter3.nb", "i:53"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:310"],

Cell[TextData[{
  "Schr\[ODoubleDot]dinger's equation, ",
  ButtonBox["229",
    ButtonData:>{"Chapter3.nb", "i:53"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also ",
    FontSlant->"Italic"],
  ButtonBox["Partial Differential Equations",
    ButtonData:>"ii:252",
    ButtonStyle->"Hyperlink"],
  "\n\tconservation law for probability density, ",
  ButtonBox["388",
    ButtonData:>{"Chapter5.nb", "i:48"},
    ButtonStyle->"Hyperlink"],
  "\n\tenergy levels, ",
  ButtonBox["276",
    ButtonData:>{"Chapter4.nb", "i:106"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Eigenmodes",
    ButtonData:>"ii:100",
    ButtonStyle->"Hyperlink"],
  "\n\tmultidimensional, ",
  ButtonBox["366",
    ButtonData:>{"Chapter5.nb", "i:17"},
    ButtonStyle->"Hyperlink"],
  "\n\tnonlinear, ",
  ButtonBox["562",
    ButtonData:>{"Chapter7.nb", "i:36"},
    ButtonStyle->"Hyperlink"],
  "\n\tnumerical solution of, ",
  ButtonBox["457",
    ButtonData:>{"Chapter6.nb", "i:14"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["6.3.3",
    ButtonData:>{"Chapter6.nb", "c:36"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["6.3.4",
    ButtonData:>{"Chapter6.nb", "i:46"},
    ButtonStyle->"Hyperlink"],
  "\n\tperturbed eigenmodes, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Perturbation theory",
    ButtonData:>"ii:257",
    ButtonStyle->"Hyperlink"],
  "\n\ttime-independent, ",
  ButtonBox["276",
    ButtonData:>{"Chapter4.nb", "i:28"},
    ButtonStyle->"Hyperlink"],
  "\n\ttunneling, ",
  ButtonBox["460",
    ButtonData:>{"Chapter6.nb", "i:16"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:311"],

Cell[TextData[{
  "Scott-Russell, J., ",
  ButtonBox["546",
    ButtonData:>{"Chapter7.nb", "i:31"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:303"],

Cell[TextData[{
  "Self-adjoint, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Hermitian operators",
    ButtonData:>"ii:168",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Separation of variables, ",
  ButtonBox["195",
    ButtonData:>{"Chapter3.nb", "i:6"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor heat equation, ",
  ButtonBox["213",
    ButtonData:>{"Chapter3.nb", "i:43"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor Laplace's equation in cylindrical coordinates, ",
  ButtonBox["238",
    ButtonData:>{"Chapter3.nb", "i:75"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["248",
    ButtonData:>{"Chapter3.nb", "i:100"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor Laplace's equation in rectangular coordinates, ",
  ButtonBox["233",
    ButtonData:>{"Chapter3.nb", "i:76"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor Laplace's equation in spherical coordinates, ",
  ButtonBox["240",
    ButtonData:>{"Chapter3.nb", "i:67"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:304"],

Cell[TextData[{
  StyleBox["Series",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.9.2",
    ButtonData:>{"Chapter9.nb", "i:76"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  StyleBox[ButtonBox["Normal",
    ButtonData:>"ii:239",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"]
}], "Text",
  CellTags->"ii:305"],

Cell[TextData[{
  StyleBox["SetDirectory",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.11.4",
    ButtonData:>{"Chapter9.nb", "i:129"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["153",
    ButtonData:>{"Chapter2.nb", "i:98"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:306"],

Cell[TextData[{
  "Shadowing, ",
  ButtonBox["9.6.8",
    ButtonData:>{"Chapter9.nb", "i:120"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:380"],

Cell[TextData[{
  StyleBox["Shallow",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["154",
    ButtonData:>{"Chapter2.nb", "i:99"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:307"],

Cell[TextData[{
  "Shock waves, ",
  ButtonBox["554",
    ButtonData:>{"Chapter7.nb", "i:46"},
    ButtonStyle->"Hyperlink"],
  ".",
  StyleBox[" See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Equations, Navier-Stokes",
    ButtonData:>"ii:112",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Partial differential equations",
    ButtonData:>"ii:252",
    ButtonStyle->"Hyperlink"],
  "\n\tjump condition, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Hugoniot relation",
    ButtonData:>"ii:171",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:368"],

Cell[TextData[{
  "Shooting method, ",
  ButtonBox["64",
    ButtonData:>{"Chapter1.nb", "i:43"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor numerical eigenmodes, ",
  ButtonBox["6.3.4",
    ButtonData:>{"Chapter6.nb", "i:40"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor problems with turning points, ",
  ButtonBox["6.3.4",
    ButtonData:>{"Chapter6.nb", "i:46"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["6.3 Exercise 7",
    ButtonData:>{"Chapter6.nb", "i:56"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:308"],

Cell[TextData[{
  StyleBox["Show",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.6.2",
    ButtonData:>{"Chapter9.nb", "i:45"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["154",
    ButtonData:>{"Chapter2.nb", "i:114"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:309"],

Cell[TextData[{
  StyleBox["Simplify",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.8.1",
    ButtonData:>{"Chapter9.nb", "i:64"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:312"],

Cell[TextData[{
  "Simplifying expressions, ",
  ButtonBox["9.8.1",
    ButtonData:>{"Chapter9.nb", "i:64"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:313"],

Cell[TextData[{
  "Simpson's rule, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Numerical integration",
    ButtonData:>"ii:181",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Simultaneous over-relaxation, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Grid methods",
    ButtonData:>"ii:159",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Sine-Gordon equation, ",
  StyleBox[" see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Partial Differential Equations",
    ButtonData:>"ii:252",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Sine integral, ",
  ButtonBox["100",
    ButtonData:>{"Chapter2.nb", "i:21"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:314"],

Cell[TextData[{
  "Skin depth, ",
  ButtonBox["294",
    ButtonData:>{"Chapter4.nb", "i:117"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Skipping rope, ",
  ButtonBox["228",
    ButtonData:>{"Chapter3.nb", "i:52"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["294",
    ButtonData:>{"Chapter4.nb", "i:43"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:315"],

Cell[TextData[{
  "Snell's law, ",
  ButtonBox["414",
    ButtonData:>{"Chapter5.nb", "i:78"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["WKB method",
    ButtonData:>"ii:374",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Ray trajectories",
    ButtonData:>"ii:288",
    ButtonStyle->"Hyperlink"],
  "\n\tand lensing effect, ",
  ButtonBox["428",
    ButtonData:>{"Chapter5.nb", "i:111"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["481",
    ButtonData:>{"Chapter6.nb", "i:28"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["5.3.1",
    ButtonData:>{"Chapter5.nb", "i:132"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:316"],

Cell[TextData[{
  "Solitons, ",
  ButtonBox["537",
    ButtonData:>{"Chapter7.nb", "i:26"},
    ButtonStyle->"Hyperlink"],
  "\n\tin the KdV equation, ",
  ButtonBox["544",
    ButtonData:>{"Chapter7.nb", "i:30"},
    ButtonStyle->"Hyperlink"],
  "\n\tin other systems, ",
  ButtonBox["546",
    ButtonData:>{"Chapter7.nb", "i:73"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["561",
    ButtonData:>{"Chapter7.nb", "i:33"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:317"],

Cell[TextData[{
  "Solution of algebraic equations\n\tanalytic (",
  StyleBox["Solve",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "), ",
  ButtonBox["9.10.1",
    ButtonData:>{"Chapter9.nb", "i:83"},
    ButtonStyle->"Hyperlink"],
  "\n\tgraphical, one variable, ",
  ButtonBox["9.11.1",
    ButtonData:>{"Chapter9.nb", "i:86"},
    ButtonStyle->"Hyperlink"],
  "\n\tgraphical, two variables, ",
  ButtonBox["9.11.1",
    ButtonData:>{"Chapter9.nb", "i:87"},
    ButtonStyle->"Hyperlink"],
  "\n\tnumerical (",
  StyleBox["FindRoot",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "), ",
  ButtonBox["9.11.1",
    ButtonData:>{"Chapter9.nb", "i:84"},
    ButtonStyle->"Hyperlink"],
  "\n\tnumerical (Newton's method), ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Newton's method",
    ButtonData:>"ii:1",
    ButtonStyle->"Hyperlink"],
  "\n\tnumerical (",
  StyleBox["NSolve",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "), ",
  ButtonBox["9.10.1",
    ButtonData:>{"Chapter9.nb", "i:110"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:318"],

Cell[TextData[{
  StyleBox["Solve",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.10.1",
    ButtonData:>{"Chapter9.nb", "i:81"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:319"],

Cell[TextData[{
  "Sound, ",
  ButtonBox["106",
    ButtonData:>{"Chapter2.nb", "i:24"},
    ButtonStyle->"Hyperlink"],
  "\n\tperception of phase vs. amplitude, ",
  ButtonBox["108",
    ButtonData:>{"Chapter2.nb", "i:26"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["111",
    ButtonData:>{"Chapter2.nb", "i:27"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["169",
    ButtonData:>{"Chapter2.nb", "i:47"},
    ButtonStyle->"Hyperlink"],
  "\n\tspeed, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Speed of sound",
    ButtonData:>"ii:323",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Wave speed",
    ButtonData:>"ii:366",
    ButtonStyle->"Hyperlink"],
  "\n\tunit of amplitude, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Decibel",
    ButtonData:>"ii:383",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:320"],

Cell[TextData[{
  "Special characters, ",
  ButtonBox["9.4.3",
    ButtonData:>{"Chapter9.nb", "i:12"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:321"],

Cell[TextData[{
  "Specific heat(s), ",
  ButtonBox["208",
    ButtonData:>{"Chapter3.nb", "i:24"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor various materials, ",
  ButtonBox["Front Matter Tables",
    ButtonData:>{"Frontmattertables.nb", "i:1"},
    ButtonStyle->"Hyperlink"],
  "\n\tratio of, ",
  ButtonBox["563",
    ButtonData:>{"Chapter7.nb", "i:39"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:322"],

Cell[TextData[{
  "Spectrum, ",
  ButtonBox["123",
    ButtonData:>{"Chapter2.nb", "i:110"},
    ButtonStyle->"Hyperlink"],
  "\n\tnumerical, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["FFTs",
    ButtonData:>"ii:123",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:377"],

Cell[TextData[{
  "Speed of sound, ",
  ButtonBox["Front Matter Tables;",
    ButtonData:>{"Frontmattertables.nb", "i:1"},
    ButtonStyle->"Hyperlink"],
  " ",
  ButtonBox["194",
    ButtonData:>{"Chapter3.nb", "i:95"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Wave speed",
    ButtonData:>"ii:366",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:323"],

Cell[TextData[{
  "Spherical harmonics, ",
  ButtonBox["243",
    ButtonData:>{"Chapter3.nb", "i:71"},
    ButtonStyle->"Hyperlink"],
  "\n\tin multipole expansions, ",
  ButtonBox["329",
    ButtonData:>{"Chapter4.nb", "i:84"},
    ButtonStyle->"Hyperlink"],
  "\n\tin spherical eigenmodes of ",
  Cell[BoxData[
      \(TraditionalForm\`\[Del]\^2\)]],
  ", ",
  ButtonBox["321",
    ButtonData:>{"Chapter4.nb", "i:78"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:324"],

Cell[TextData[{
  StyleBox["SphericalHarmonicY",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["243",
    ButtonData:>{"Chapter3.nb", "i:84"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:325"],

Cell[TextData[{
  "Splines, ",
  ButtonBox["9.11.3",
    ButtonData:>{"Chapter9.nb", "i:127"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Interpolation",
    ButtonData:>"ii:185",
    ButtonStyle->"Hyperlink"],
  "; ",
  StyleBox[ButtonBox["SplineFit",
    ButtonData:>"ii:382",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "\n\tcubic, ",
  ButtonBox["9.11 Exercise 10",
    ButtonData:>{"Chapter9.nb", "i:139"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:390"],

Cell[TextData[{
  StyleBox["SplineFit",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.11.3",
    ButtonData:>{"Chapter9.nb", "i:127"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:382"],

Cell[TextData[{
  "Standard form, ",
  ButtonBox["279",
    ButtonData:>{"Chapter4.nb", "i:35"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["280",
    ButtonData:>{"Chapter4.nb", "i:38"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also ",
    FontSlant->"Italic"],
  ButtonBox["Partial Differential Equations",
    ButtonData:>"ii:252",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Stark effect, ",
  ButtonBox["6.3 Exercise 14",
    ButtonData:>{"Chapter6.nb", "i:49"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:326"],

Cell[TextData[{
  "Stokes, George, ",
  ButtonBox["562",
    ButtonData:>{"Chapter7.nb", "i:41"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Stefan-Boltzmann constant, ",
  ButtonBox["230",
    ButtonData:>{"Chapter3.nb", "i:55"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:327"],

Cell[TextData[{
  "Step size, ",
  ButtonBox["31",
    ButtonData:>{"Chapter1.nb", "i:139"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Stirling's formula, ",
  ButtonBox["587",
    ButtonData:>{"Chapter8.nb", "i:32"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:328"],

Cell[TextData[{
  "Strange attractors, ",
  ButtonBox["52",
    ButtonData:>{"Chapter1.nb", "i:60"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["81",
    ButtonData:>{"Chapter1.nb", "i:102"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:329"],

Cell[TextData[{
  "Sturm, Jacques, ",
  ButtonBox["261",
    ButtonData:>{"Chapter4.nb", "i:108"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:330"],

Cell[TextData[{
  "Sturm-Liouville problems, ",
  ButtonBox["261",
    ButtonData:>{"Chapter4.nb", "i:108"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["269",
    ButtonData:>{"Chapter4.nb", "i:14"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Hermitian operators",
    ButtonData:>"ii:168",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:331"],

Cell[TextData[{
  "Superposition principle, ",
  ButtonBox["71",
    ButtonData:>{"Chapter1.nb", "i:82"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["78",
    ButtonData:>{"Chapter1.nb", "i:119"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["160",
    ButtonData:>{"Chapter2.nb", "i:84"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["205",
    ButtonData:>{"Chapter3.nb", "i:16"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:332"],

Cell[BoxData[""], "Input"],

Cell[TextData[{
  StyleBox["Table",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.5.3",
    ButtonData:>{"Chapter9.nb", "i:38"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->{"T", "ii:333"}],

Cell[TextData[{
  "Taylor \n\tBrook, ",
  ButtonBox["9.9.2",
    ButtonData:>{"Chapter9.nb", "i:116"},
    ButtonStyle->"Hyperlink"],
  "\n\texpansion, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Power series",
    ButtonData:>"ii:276",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:334"],

Cell[TextData[{
  "Teller, Edward, ",
  ButtonBox["8.3.1",
    ButtonData:>{"Chapter8.nb", "i:85"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:336"],

Cell[TextData[{
  "Tether, ",
  ButtonBox["224",
    ButtonData:>{"Chapter3.nb", "i:45"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:337"],

Cell[TextData[{
  "Thermal conductivity, ",
  ButtonBox["206",
    ButtonData:>{"Chapter3.nb", "i:21"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor various materials, ",
  ButtonBox["Front Matter Tables",
    ButtonData:>{"Frontmattertables.nb", "i:1"},
    ButtonStyle->"Hyperlink"],
  "\n\tmicroscopic model, ",
  ButtonBox["568",
    ButtonData:>{"Chapter8.nb", "i:2"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Diffusion",
    ButtonData:>"ii:86",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:338"],

Cell[TextData[{
  "Thermal diffusivity, ",
  ButtonBox["209",
    ButtonData:>{"Chapter3.nb", "i:26"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:339"],

Cell[TextData[{
  "Thermal equilibrium, ",
  ButtonBox["526",
    ButtonData:>{"Chapter7.nb", "i:11"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["605",
    ButtonData:>{"Chapter8.nb", "i:80"},
    ButtonStyle->"Hyperlink"],
  "\n\tBoltzmann distribution, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Distribution, Boltzmann",
    ButtonData:>"ii:92",
    ButtonStyle->"Hyperlink"],
  "\n\tGibbs distribution, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Distribution, Gibbs",
    ButtonData:>"ii:92",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:340"],

Cell[TextData[{
  "Tidal acceleration, ",
  ButtonBox["332",
    ButtonData:>{"Chapter4.nb", "i:85"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:341"],

Cell[TextData[{
  "Tidal deformation of the earth, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Planets",
    ButtonData:>"ii:381",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:342"],

Cell[TextData[{
  "Tidal waves, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Waves, tidal",
    ButtonData:>"ii:367",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Time step, ",
  ButtonBox["31",
    ButtonData:>{"Chapter1.nb", "i:140"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Tonotopic map, ",
  ButtonBox["108",
    ButtonData:>{"Chapter2.nb", "i:94"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Total internal reflection, ",
  ButtonBox["419",
    ButtonData:>{"Chapter5.nb", "i:83"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Turning points",
    ButtonData:>"ii:348",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Geometrical optics",
    ButtonData:>"ii:150",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:386"],

Cell[TextData[{
  "Traffic flow, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Partial differential equations",
    ButtonData:>"ii:252",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Transformation method, ",
  ButtonBox["598",
    ButtonData:>{"Chapter8.nb", "i:52"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:343"],

Cell[TextData[{
  "Transition probability, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Probability",
    ButtonData:>"ii:281",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:344"],

Cell[TextData[{
  StyleBox["Transpose",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.5.2",
    ButtonData:>{"Chapter9.nb", "i:33"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:345"],

Cell[TextData[{
  "Trapezoidal rule, ",
  StyleBox[" see ",
    FontSlant->"Italic"],
  ButtonBox["Numerical integration",
    ButtonData:>"ii:181",
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Tree codes, ",
  ButtonBox["7.3.2",
    ButtonData:>{"Chapter7.nb", "i:89"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Tuning fork, ",
  ButtonBox["162",
    ButtonData:>{"Chapter2.nb", "i:60"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:346"],

Cell[TextData[{
  "Turbulence, ",
  ButtonBox["7.3 Exercise 5",
    ButtonData:>{"Chapter7.nb", "i:72"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:347"],

Cell[TextData[{
  "Turning points, ",
  ButtonBox["419",
    ButtonData:>{"Chapter5.nb", "i:83"},
    ButtonStyle->"Hyperlink"],
  "\n\tand breakdown of WKB method, ",
  ButtonBox["421",
    ButtonData:>{"Chapter5.nb", "i:86"},
    ButtonStyle->"Hyperlink"],
  "\n\tand total internal reflection, ",
  ButtonBox["419",
    ButtonData:>{"Chapter5.nb", "i:84"},
    ButtonStyle->"Hyperlink"],
  "\n\tbehavior of a wave near, ",
  ButtonBox["422",
    ButtonData:>{"Chapter5.nb", "i:87"},
    ButtonStyle->"Hyperlink"],
  "\n\teffect on WKB eigenvalues, ",
  ButtonBox["6.3.4",
    ButtonData:>{"Chapter6.nb", "i:45"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:348"],

Cell[BoxData[""], "Input"],

Cell[TextData[{
  "Uncertainty principle, ",
  ButtonBox["133",
    ButtonData:>{"Chapter2.nb", "i:45"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["165",
    ButtonData:>{"Chapter2.nb", "i:106"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Bandwidth",
    ButtonData:>"ii:31",
    ButtonStyle->"Hyperlink"],
  "\n\tand Rayleigh length, ",
  ButtonBox["373",
    ButtonData:>{"Chapter5.nb", "i:26"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->{"U", "ii:349"}],

Cell[TextData[{
  "Underdetermined systems, ",
  ButtonBox["9.10.1",
    ButtonData:>{"Chapter9.nb", "c:57"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Undetermined coefficients, method of ",
  ButtonBox["79",
    ButtonData:>{"Chapter1.nb", "i:94"},
    ButtonStyle->"Hyperlink"],
  "\n"
}], "Text"],

Cell[TextData[{
  "Unit matrix, ",
  ButtonBox["9.5.2",
    ButtonData:>{"Chapter9.nb", "i:104"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Delta function, Kronecker",
    ButtonData:>"ii:79",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:351"],

Cell[TextData[{
  StyleBox["Unset",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["466",
    ButtonData:>{"Chapter6.nb", "i:70"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["7.3 Exercise 5",
    ButtonData:>{"Chapter7.nb", "i:68"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:352"],

Cell[BoxData[""], "Input"],

Cell[TextData[{
  "Van der Pol oscillator, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Ordinary differential equations",
    ButtonData:>"ii:247",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->{"V", "ii:353"}],

Cell[TextData[{
  "Variables, ",
  ButtonBox["9.4.2",
    ButtonData:>{"Chapter9.nb", "c:14"},
    ButtonStyle->"Hyperlink"],
  "\n\tinternal, ",
  ButtonBox["36",
    ButtonData:>{"Chapter1.nb", "i:142"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Vector and Matrix Operations, ",
  ButtonBox["9.5.1",
    ButtonData:>{"Chapter9.nb", "i:98"},
    ButtonStyle->"Hyperlink"],
  "\n\teigenvalues and eigenvectors, ",
  ButtonBox["9.5.2",
    ButtonData:>{"Chapter9.nb", "i:35"},
    ButtonStyle->"Hyperlink"],
  "\n\tvector magnitude (length), ",
  ButtonBox["9.5.2",
    ButtonData:>{"Chapter9.nb", "i:42"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Velocity, ",
  ButtonBox["1",
    ButtonData:>{"Chapter1.nb", "i:4"},
    ButtonStyle->"Hyperlink"],
  "\n\tas rate of change of position, ",
  ButtonBox["2",
    ButtonData:>{"Chapter1.nb", "i:70"},
    ButtonStyle->"Hyperlink"],
  "\n\tcenter of mass, ",
  ButtonBox["59",
    ButtonData:>{"Chapter1.nb", "i:69"},
    ButtonStyle->"Hyperlink"],
  "\n\tdrift, in the Fokker Planck equation, ",
  ButtonBox["583",
    ButtonData:>{"Chapter8.nb", "i:29"},
    ButtonStyle->"Hyperlink"],
  "\n\t",
  StyleBox["E",
    FontWeight->"Bold"],
  "\[Times]",
  StyleBox["B ",
    FontWeight->"Bold"],
  "drift, ",
  StyleBox[" ",
    FontWeight->"Bold"],
  ButtonBox["22",
    ButtonData:>{"Chapter1.nb", "i:135"},
    ButtonStyle->"Hyperlink"],
  "\n\tgroup, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Group velocity",
    ButtonData:>"ii:160",
    ButtonStyle->"Hyperlink"],
  "\n\tphase, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Phase velocity",
    ButtonData:>"ii:260",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Wave speed",
    ButtonData:>"ii:366",
    ButtonStyle->"Hyperlink"],
  "\n\tsuperluminal, ",
  ButtonBox["461",
    ButtonData:>{"Chapter6.nb", "i:15"},
    ButtonStyle->"Hyperlink"],
  "\n\tterminal, ",
  ButtonBox["583",
    ButtonData:>{"Chapter8.nb", "i:24"},
    ButtonStyle->"Hyperlink"],
  "\n\tthermal, ",
  ButtonBox["590",
    ButtonData:>{"Chapter8.nb", "i:38"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:354"],

Cell[TextData[{
  "Viscosity, ",
  ButtonBox["563",
    ButtonData:>{"Chapter7.nb", "i:77"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:355"],

Cell[TextData[{
  "Vlasov equation, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Boltzmann equation, collisionless",
    ButtonData:>"ii:42",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:356"],

Cell[TextData[{
  "Von Neumann\n\tboundary conditions, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Boundary conditions, von Neumann",
    ButtonData:>"ii:45",
    ButtonStyle->"Hyperlink"],
  "\n\tJohn, ",
  ButtonBox["467",
    ButtonData:>{"Chapter6.nb", "i:58"},
    ButtonStyle->"Hyperlink"],
  "\n\tstability analysis, ",
  StyleBox["see  ",
    FontSlant->"Italic"],
  ButtonBox["Grid methods",
    ButtonData:>"ii:159",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:357"],

Cell[TextData[{
  "Vortices and vorticity, ",
  ButtonBox["7.3 Exercise 5",
    ButtonData:>{"Chapter7.nb", "i:66"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:359"],

Cell[BoxData[""], "Input"],

Cell[TextData[{
  "Wave action\n\tconnection to adiabatic invariants, ",
  ButtonBox["5.3.2",
    ButtonData:>{"Chapter5.nb", "i:93"},
    ButtonStyle->"Hyperlink"],
  "\n\tconservation law, ",
  ButtonBox["5.3.2",
    ButtonData:>{"Chapter5.nb", "i:92"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor general wave equations, ",
  ButtonBox["5.3",
    ButtonData:>{"Chapter5.nb", "i:90"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor quantum wave equations, ",
  ButtonBox["388",
    ButtonData:>{"Chapter5.nb", "i:50"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->{"W", "ii:360"}],

Cell[TextData[{
  "Wavebreaking  \n\ttime, in Burgers' equation without diffusion, ",
  ButtonBox["532",
    ButtonData:>{"Chapter7.nb", "i:16"},
    ButtonStyle->"Hyperlink"],
  "\n\tsuppression of, ",
  ButtonBox["551",
    ButtonData:>{"Chapter7.nb", "i:45"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:361"],

Cell[TextData[{
  "Wave equation, ",
  ButtonBox["194",
    ButtonData:>{"Chapter3.nb", "i:1"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also ",
    FontSlant->"Italic"],
  ButtonBox["Partial Differential Equations",
    ButtonData:>"ii:252",
    ButtonStyle->"Hyperlink"],
  "\n\tbiharmonic, ",
  ButtonBox["295",
    ButtonData:>{"Chapter4.nb", "i:44"},
    ButtonStyle->"Hyperlink"],
  "\n\td'Alembert's solution, ",
  ButtonBox["203",
    ButtonData:>{"Chapter3.nb", "i:15"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["358",
    ButtonData:>{"Chapter5.nb", "i:6"},
    ButtonStyle->"Hyperlink"],
  "\n\tderivation, ",
  ButtonBox["191",
    ButtonData:>{"Chapter3.nb", "i:3"},
    ButtonStyle->"Hyperlink"],
  "\n\teigenmodes, ",
  ButtonBox["280",
    ButtonData:>{"Chapter4.nb", "i:105"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Eigenmodes",
    ButtonData:>"ii:100",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Eigenvalue problems",
    ButtonData:>"ii:101",
    ButtonStyle->"Hyperlink"],
  "\n\tfor uniform system, ",
  ButtonBox["194",
    ButtonData:>{"Chapter3.nb", "i:2"},
    ButtonStyle->"Hyperlink"],
  "\n\tgeneral classical form, ",
  ButtonBox["375",
    ButtonData:>{"Chapter5.nb", "i:35"},
    ButtonStyle->"Hyperlink"],
  "\n\tgeneral quantum form, ",
  ButtonBox["388",
    ButtonData:>{"Chapter5.nb", "i:49"},
    ButtonStyle->"Hyperlink"],
  "\n\tgeneral solution for arbitrary source, b.c.'s, ",
  ButtonBox["281",
    ButtonData:>{"Chapter4.nb", "i:36"},
    ButtonStyle->"Hyperlink"],
  "\n\tin an inhomogeneous medium, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["WKB method",
    ButtonData:>"ii:374",
    ButtonStyle->"Hyperlink"],
  ";  ",
  ButtonBox["Geometrical optics",
    ButtonData:>"ii:150",
    ButtonStyle->"Hyperlink"],
  "\n\tmultidimensional, ",
  ButtonBox["333",
    ButtonData:>{"Chapter4.nb", "i:88"},
    ButtonStyle->"Hyperlink"],
  "\n",
  "\tnumerical solution, ",
  ButtonBox["478",
    ButtonData:>{"Chapter6.nb", "i:26"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["5.3.1",
    ButtonData:>{"Chapter5.nb", "i:141"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["6.3.2",
    ButtonData:>{"Chapter6.nb", "i:47"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["6.3.3",
    ButtonData:>{"Chapter6.nb", "i:48"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["6.3.4",
    ButtonData:>{"Chapter6.nb", "i:40"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also ",
    FontSlant->"Italic"],
  ButtonBox["Numerical solution of PDEs",
    ButtonData:>"ii:245",
    ButtonStyle->"Hyperlink"],
  "\n",
  "\tsolution for a uniform string, ",
  ButtonBox["197",
    ButtonData:>{"Chapter3.nb", "i:18"},
    ButtonStyle->"Hyperlink"],
  "\n\tvector, ",
  ButtonBox["228",
    ButtonData:>{"Chapter3.nb", "i:51"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["427",
    ButtonData:>{"Chapter5.nb", "i:118"},
    ButtonStyle->"Hyperlink"],
  "\n\twith a source, ",
  ButtonBox["204",
    ButtonData:>{"Chapter3.nb", "i:17"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:362"],

Cell[TextData[{
  "Wavefunction, ",
  ButtonBox["229",
    ButtonData:>{"Chapter3.nb", "i:111"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Schrodinger's equation",
    ButtonData:>"ii:311",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Eigenmodes",
    ButtonData:>"ii:100",
    ButtonStyle->"Hyperlink"],
  "\n\tbehavior of, in reflection from a barrier, ",
  ButtonBox["457",
    ButtonData:>{"Chapter6.nb", "i:14"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:363"],

Cell[TextData[{
  "Wavenumber, ",
  ButtonBox["123",
    ButtonData:>{"Chapter2.nb", "i:95"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:364"],

Cell[TextData[{
  "Wave packet, ",
  ButtonBox["361",
    ButtonData:>{"Chapter5.nb", "i:12"},
    ButtonStyle->"Hyperlink"],
  "\n\tamplitude in nonuniform medium, ",
  ButtonBox["422",
    ButtonData:>{"Chapter5.nb", "i:88"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["5.3.1",
    ButtonData:>{"Chapter5.nb", "i:136"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Wave action",
    ButtonData:>"ii:360",
    ButtonStyle->"Hyperlink"],
  "\n\taverage energy density and flux, ",
  ButtonBox["374",
    ButtonData:>{"Chapter5.nb", "i:30"},
    ButtonStyle->"Hyperlink"],
  "\n\taverage momentum density, ",
  ButtonBox["377",
    ButtonData:>{"Chapter5.nb", "i:33"},
    ButtonStyle->"Hyperlink"],
  "\n\tdispersion, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Dispersion",
    ButtonData:>"ii:91",
    ButtonStyle->"Hyperlink"],
  "\n\tenergy density and flux for general classical wave equation, ",
  ButtonBox["377",
    ButtonData:>{"Chapter5.nb", "i:32"},
    ButtonStyle->"Hyperlink"],
  "\n\tenergy density, neglecting dispersion, ",
  ButtonBox["373",
    ButtonData:>{"Chapter5.nb", "i:28"},
    ButtonStyle->"Hyperlink"],
  "\n\tenergy flux, neglecting dispersion, ",
  ButtonBox["374",
    ButtonData:>{"Chapter5.nb", "i:29"},
    ButtonStyle->"Hyperlink"],
  "\n\tform neglecting dispersion, in 1D, ",
  ButtonBox["364",
    ButtonData:>{"Chapter5.nb", "i:22"},
    ButtonStyle->"Hyperlink"],
  "\n\tform neglecting dispersion, in 3D, ",
  ButtonBox["371",
    ButtonData:>{"Chapter5.nb", "i:23"},
    ButtonStyle->"Hyperlink"],
  "\n\tphase in nonuniform medium, ",
  ButtonBox["5.3.1",
    ButtonData:>{"Chapter5.nb", "i:141"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Phase",
    ButtonData:>"ii:258",
    ButtonStyle->"Hyperlink"],
  ",",
  " ",
  ButtonBox["Eikonal",
    ButtonData:>"ii:104",
    ButtonStyle->"Hyperlink"],
  "\n\ttrajectory in nonuniform medium, ",
  ButtonBox["415",
    ButtonData:>{"Chapter5.nb", "i:80"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Geometrical optics",
    ButtonData:>"ii:150",
    ButtonStyle->"Hyperlink"],
  "\n\tvelocity, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Group velocity",
    ButtonData:>"ii:160",
    ButtonStyle->"Hyperlink"],
  "\n\twidth, Gaussian, in 1 dimension, ",
  ButtonBox["366",
    ButtonData:>{"Chapter5.nb", "i:16"},
    ButtonStyle->"Hyperlink"],
  "\n\tWKB, on a nonuniform string, ",
  ButtonBox["407",
    ButtonData:>{"Chapter5.nb", "i:74"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:365"],

Cell[TextData[{
  "Wave speed, ",
  ButtonBox["194",
    ButtonData:>{"Chapter3.nb", "i:49"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Phase velocity",
    ButtonData:>"ii:260",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Group velocity",
    ButtonData:>"ii:160",
    ButtonStyle->"Hyperlink"],
  "\n\tfor shallow water waves, ",
  ButtonBox["227",
    ButtonData:>{"Chapter3.nb", "i:50"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor sound waves, ",
  ButtonBox["296",
    ButtonData:>{"Chapter4.nb", "i:47"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Speed of sound",
    ButtonData:>"ii:323",
    ButtonStyle->"Hyperlink"],
  "\n\tin various materials, ",
  ButtonBox["Front Matter Tables",
    ButtonData:>{"Frontmattertables.nb", "i:1"},
    ButtonStyle->"Hyperlink"],
  "\n\ton a string, ",
  ButtonBox["194",
    ButtonData:>{"Chapter3.nb", "i:49"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:366"],

Cell[TextData[{
  "Waves, ",
  StyleBox["see also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Eigenmodes",
    ButtonData:>"ii:100",
    ButtonStyle->"Hyperlink"],
  " \n\tcnoidal, ",
  ButtonBox["537",
    ButtonData:>{"Chapter7.nb", "i:26"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["541",
    ButtonData:>{"Chapter7.nb", "i:28"},
    ButtonStyle->"Hyperlink"],
  "\n\tdiffraction of, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Diffraction",
    ButtonData:>"ii:284",
    ButtonStyle->"Hyperlink"],
  "\n\tdispersion of, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Dispersion",
    ButtonData:>"ii:91",
    ButtonStyle->"Hyperlink"],
  "\n\telectromagnetic, ",
  ButtonBox["415",
    ButtonData:>{"Chapter5.nb", "i:124"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["423",
    ButtonData:>{"Chapter5.nb", "i:125"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["427",
    ButtonData:>{"Chapter5.nb", "i:126"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["5.3.2",
    ButtonData:>{"Chapter5.nb", "i:93"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Refraction",
    ButtonData:>"ii:293",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Radiation",
    ButtonData:>"ii:283",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Wave equation",
    ButtonData:>"ii:362",
    ButtonStyle->"Hyperlink"],
  "\n\t in an anisotropic medium, ",
  ButtonBox["382",
    ButtonData:>{"Chapter5.nb", "i:38"},
    ButtonStyle->"Hyperlink"],
  "\n\t in an inhomogeneous medium, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["WKB method",
    ButtonData:>"ii:374",
    ButtonStyle->"Hyperlink"],
  "\n\t nonlinear, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Burgers' equation",
    ButtonData:>"ii:51",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["KdV equation",
    ButtonData:>"ii:192",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Schr\[ODoubleDot]dinger's equation",
    ButtonData:>"ii:311",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Partial differential equations",
    ButtonData:>"ii:252",
    ButtonStyle->"Hyperlink"],
  "\n\t on a uniform string with fixed ends, ",
  ButtonBox["197",
    ButtonData:>{"Chapter3.nb", "i:99"},
    ButtonStyle->"Hyperlink"],
  "\n\tP - , ",
  ButtonBox["429",
    ButtonData:>{"Chapter5.nb", "i:102"},
    ButtonStyle->"Hyperlink"],
  "\n\tphase of, ",
  ButtonBox["367",
    ButtonData:>{"Chapter5.nb", "i:19"},
    ButtonStyle->"Hyperlink"],
  "\n\tplasma, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Plasma waves",
    ButtonData:>"ii:262",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Whistler waves",
    ButtonData:>"ii:372",
    ButtonStyle->"Hyperlink"],
  "\n\treflection of, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Total internal reflection ",
    ButtonData:>"ii:386",
    ButtonStyle->"Hyperlink"],
  "\n\trefraction of, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Refraction",
    ButtonData:>"ii:293",
    ButtonStyle->"Hyperlink"],
  "\n\tshallow water, ",
  ButtonBox["226",
    ButtonData:>{"Chapter3.nb", "i:48"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["297",
    ButtonData:>{"Chapter4.nb", "i:48"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["352",
    ButtonData:>{"Chapter4.nb", "i:103"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["410",
    ButtonData:>{"Chapter5.nb", "i:75"},
    ButtonStyle->"Hyperlink"],
  "\t\n\tshock, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  ButtonBox["Shock waves",
    ButtonData:>"ii:368",
    ButtonStyle->"Hyperlink"],
  "\n\tsound, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Speed of sound",
    ButtonData:>"ii:323",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Wave speed",
    ButtonData:>"ii:366",
    ButtonStyle->"Hyperlink"],
  "; ",
  ButtonBox["Sound",
    ButtonData:>"ii:320",
    ButtonStyle->"Hyperlink"],
  "\n\ttidal, ",
  ButtonBox["227",
    ButtonData:>{"Chapter3.nb", "i:97"},
    ButtonStyle->"Hyperlink"],
  "\n\ttravelling, in 1D, ",
  ButtonBox["356",
    ButtonData:>{"Chapter5.nb", "i:2"},
    ButtonStyle->"Hyperlink"],
  "\n\ttravelling, on a circular drumhead, ",
  ButtonBox["338",
    ButtonData:>{"Chapter4.nb", "i:91"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:367"],

Cell[TextData[{
  "Wave vector, ",
  ButtonBox["366",
    ButtonData:>{"Chapter5.nb", "i:18"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:369"],

Cell[TextData[{
  StyleBox["While",
    FontFamily->"Courier",
    FontWeight->"Bold"],
  ", ",
  ButtonBox["9.11 Exercise 6",
    ButtonData:>{"Chapter9.nb", "i:126"},
    ButtonStyle->"Hyperlink"],
  ",  ",
  ButtonBox["600",
    ButtonData:>{"Chapter8.nb", "i:63"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:370"],

Cell[TextData[{
  "Whipcrack, ",
  ButtonBox["292",
    ButtonData:>{"Chapter4.nb", "i:42"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:371"],

Cell[TextData[{
  "Whistler waves, ",
  ButtonBox["395",
    ButtonData:>{"Chapter5.nb", "i:56"},
    ButtonStyle->"Hyperlink"],
  "\n\ttrajectories through magnetosphere, ",
  ButtonBox["430",
    ButtonData:>{"Chapter5.nb", "i:103"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:372"],

Cell[TextData[{
  "WKB limit, ",
  ButtonBox["398",
    ButtonData:>{"Chapter5.nb", "i:69"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:373"],

Cell[TextData[{
  "WKB method, ",
  ButtonBox["396",
    ButtonData:>{"Chapter5.nb", "i:66"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  "  ",
  ButtonBox["Eikonal",
    ButtonData:>"ii:104",
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["Wave packet ",
    ButtonData:>"ii:365",
    ButtonStyle->"Hyperlink"],
  "\n\tand adiabatic invariants, ",
  ButtonBox["404",
    ButtonData:>{"Chapter5.nb", "i:73"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor a string with time-varying length, ",
  ButtonBox["431",
    ButtonData:>{"Chapter5.nb", "i:104"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor eigenmodes, ",
  ButtonBox["6.3.4",
    ButtonData:>{"Chapter6.nb", "i:43"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor shallow water waves near a beach, ",
  ButtonBox["410",
    ButtonData:>{"Chapter5.nb", "i:75"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor travelling waves on a nonuniform string, ",
  ButtonBox["402",
    ButtonData:>{"Chapter5.nb", "i:72"},
    ButtonStyle->"Hyperlink"],
  "\n\tfor travelling waves in multiple dimensions, ",
  ButtonBox["5.3.1",
    ButtonData:>{"Chapter5.nb", "i:141"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Geometrical optics",
    ButtonData:>"ii:150",
    ButtonStyle->"Hyperlink"],
  " \n\tfor the wave equation in 1D, ",
  ButtonBox["426",
    ButtonData:>{"Chapter5.nb", "i:98"},
    ButtonStyle->"Hyperlink"],
  "\n\thigher-order corrections, ",
  ButtonBox["401",
    ButtonData:>{"Chapter5.nb", "i:71"},
    ButtonStyle->"Hyperlink"],
  "\n\tnear turning points, ",
  StyleBox["see",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Turning points",
    ButtonData:>"ii:348",
    ButtonStyle->"Hyperlink"],
  "\n\tray trajectories, ",
  ButtonBox["413",
    ButtonData:>{"Chapter5.nb", "i:77"},
    ButtonStyle->"Hyperlink"],
  "\n\tSnell's law, ",
  ButtonBox["414",
    ButtonData:>{"Chapter5.nb", "i:78"},
    ButtonStyle->"Hyperlink"],
  "\n\twave-packet trajectory, ",
  ButtonBox["415",
    ButtonData:>{"Chapter5.nb", "i:80"},
    ButtonStyle->"Hyperlink"],
  ". ",
  StyleBox["See also",
    FontSlant->"Italic"],
  " ",
  ButtonBox["Geometrical optics",
    ButtonData:>"ii:150",
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:374"],

Cell[TextData[{
  "Work-kinetic-energy theorem, ",
  ButtonBox["9.9 Exercise 7",
    ButtonData:>{"Chapter9.nb", "i:118"},
    ButtonStyle->"Hyperlink"]
}], "Text"],

Cell[TextData[{
  "Writing data to a file, ",
  StyleBox["see ",
    FontSlant->"Italic"],
  StyleBox[ButtonBox["Export",
    ButtonData:>"ii:118",
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"]
}], "Text"],

Cell[TextData[{
  "Wronskian, ",
  ButtonBox["172",
    ButtonData:>{"Chapter2.nb", "i:68"},
    ButtonStyle->"Hyperlink"],
  ", ",
  ButtonBox["180",
    ButtonData:>{"Chapter2.nb", "i:67"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ii:375"],

Cell[BoxData[""], "Input"],

Cell[TextData[{
  "Zeeman shift, ",
  ButtonBox["6.3 Exercise 15",
    ButtonData:>{"Chapter6.nb", "i:50"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->{"Z", "ii:376"}]
}, Open  ]]
},
FrontEndVersion->"4.1 for Macintosh",
ScreenRectangle->{{0, 1024}, {0, 746}},
WindowSize->{498, 724},
WindowMargins->{{Automatic, -1}, {Automatic, 0}},
PrintingCopies->1,
PrintingPageRange->{1, Automatic},
PageHeaders->{{Inherited, Inherited, Cell[ 
        TextData[ "Index"], "Header"]}, {Cell[ 
        TextData[ "Dubin"], "Header"], Cell[ 
        TextData[ 
        "Numerical and Analytical Methods for Scientists and Engineers"], 
        FontWeight -> Bold, FontSlant -> Italic, FontFamily -> Times], 
      Inherited}},
PrintingOptions->{"FacingPages"->True},
TaggingRules:>{"NextIndexingNumber" -> 2, "IndexEntries" -> {{"i:1", \
"Newton's method"}}},
ScriptSizeMultipliers->0.85,
ScriptMinSize->9,
Magnification->1.25,
StyleDefinitions -> Notebook[{
  
  Cell[CellGroupData[{
  Cell["Style Definitions", "Subtitle"],
  
  Cell["\<\
Modify the definitions below to change the default appearance of \
all cells in a given style.  Make modifications to any definition using \
commands in the Format menu.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell["Style Environment Names", "Section"],
  
  Cell[StyleData[All, "Working"],
    PageWidth->WindowWidth,
    CellLabelMargins->{{12, Inherited}, {Inherited, Inherited}},
    ScriptMinSize->9],
  
  Cell[StyleData[All, "Presentation"],
    PageWidth->WindowWidth,
    CellLabelMargins->{{24, Inherited}, {Inherited, Inherited}},
    ScriptMinSize->12],
  
  Cell[StyleData[All, "Condensed"],
    PageWidth->WindowWidth,
    CellLabelMargins->{{8, Inherited}, {Inherited, Inherited}},
    ScriptMinSize->8],
  
  Cell[StyleData[All, "Printout"],
    PageWidth->PaperWidth,
    CellLabelMargins->{{2, Inherited}, {Inherited, Inherited}},
    ScriptMinSize->5,
    PrivateFontOptions->{"FontType"->"Outline"}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Notebook Options", "Section"],
  
  Cell["\<\
The options defined for the style below will be used at the \
Notebook level.\
\>", "Text"],
  
  Cell[StyleData["Notebook"],
    PageHeaders->{{Cell[ 
            TextData[ {
              CounterBox[ "Page"]}], "PageNumber"], None, Cell[ 
            TextData[ {
              ValueBox[ "FileName"]}], "Header"]}, {Cell[ 
            TextData[ {
              ValueBox[ "FileName"]}], "Header"], None, Cell[ 
            TextData[ {
              CounterBox[ "Page"]}], "PageNumber"]}},
    CellFrameLabelMargins->6,
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Styles for Headings", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Title"],
    CellMargins->{{12, Inherited}, {20, 40}},
    CellGroupingRules->{"TitleGrouping", 0},
    PageBreakBelow->False,
    DefaultNewInlineCellStyle->"None",
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.36, -0.1}, {0, -0}}, 
                  BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "mma"->"Mathematica", "Mma"->"Mathematica", 
        "MMA"->"Mathematica", Inherited},
    LineSpacing->{1, 11},
    LanguageCategory->"NaturalLanguage",
    CounterIncrements->"Title",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
        "Subtitle", 0}, {"Subsubtitle", 0}},
    FontFamily->"Helvetica",
    FontSize->36,
    FontWeight->"Bold"],
  
  Cell[StyleData["Title", "Presentation"],
    CellMargins->{{24, 10}, {20, 40}},
    LineSpacing->{1, 0},
    FontSize->44],
  
  Cell[StyleData["Title", "Condensed"],
    CellMargins->{{8, 10}, {4, 8}},
    FontSize->20],
  
  Cell[StyleData["Title", "Printout"],
    CellMargins->{{2, 10}, {12, 30}},
    FontSize->24]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subtitle"],
    CellMargins->{{12, Inherited}, {20, 15}},
    CellGroupingRules->{"TitleGrouping", 10},
    PageBreakBelow->False,
    DefaultNewInlineCellStyle->"None",
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.36, -0.1}, {0, -0}}, 
                  BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "mma"->"Mathematica", "Mma"->"Mathematica", 
        "MMA"->"Mathematica", Inherited},
    LanguageCategory->"NaturalLanguage",
    CounterIncrements->"Subtitle",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
        "Subsubtitle", 0}},
    FontFamily->"Helvetica",
    FontSize->24],
  
  Cell[StyleData["Subtitle", "Presentation"],
    CellMargins->{{24, 10}, {20, 20}},
    LineSpacing->{1, 0},
    FontSize->36],
  
  Cell[StyleData["Subtitle", "Condensed"],
    CellMargins->{{8, 10}, {4, 4}},
    FontSize->14],
  
  Cell[StyleData["Subtitle", "Printout"],
    CellMargins->{{2, 10}, {12, 8}},
    FontSize->18]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsubtitle"],
    CellMargins->{{12, Inherited}, {20, 15}},
    CellGroupingRules->{"TitleGrouping", 20},
    PageBreakBelow->False,
    DefaultNewInlineCellStyle->"None",
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.36, -0.1}, {0, -0}}, 
                  BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "mma"->"Mathematica", "Mma"->"Mathematica", 
        "MMA"->"Mathematica", Inherited},
    LanguageCategory->"NaturalLanguage",
    CounterIncrements->"Subsubtitle",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}},
    FontFamily->"Helvetica",
    FontSize->14,
    FontSlant->"Italic"],
  
  Cell[StyleData["Subsubtitle", "Presentation"],
    CellMargins->{{24, 10}, {20, 20}},
    LineSpacing->{1, 0},
    FontSize->24],
  
  Cell[StyleData["Subsubtitle", "Condensed"],
    CellMargins->{{8, 10}, {8, 8}},
    FontSize->12],
  
  Cell[StyleData["Subsubtitle", "Printout"],
    CellMargins->{{2, 10}, {12, 8}},
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Section"],
    CellDingbat->"\[FilledSquare]",
    CellMargins->{{25, Inherited}, {8, 24}},
    CellGroupingRules->{"SectionGrouping", 30},
    PageBreakBelow->False,
    DefaultNewInlineCellStyle->"None",
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.36, -0.1}, {0, -0}}, 
                  BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "mma"->"Mathematica", "Mma"->"Mathematica", 
        "MMA"->"Mathematica", Inherited},
    LineSpacing->{1, 7},
    LanguageCategory->"NaturalLanguage",
    CounterIncrements->"Section",
    CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}},
    FontFamily->"Helvetica",
    FontSize->16,
    FontWeight->"Bold"],
  
  Cell[StyleData["Section", "Presentation"],
    CellMargins->{{40, 10}, {11, 32}},
    LineSpacing->{1, 0},
    FontSize->24],
  
  Cell[StyleData["Section", "Condensed"],
    CellMargins->{{18, Inherited}, {6, 12}},
    FontSize->12],
  
  Cell[StyleData["Section", "Printout"],
    CellMargins->{{13, 0}, {7, 22}},
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsection"],
    CellDingbat->"\[FilledSmallSquare]",
    CellMargins->{{22, Inherited}, {8, 20}},
    CellGroupingRules->{"SectionGrouping", 40},
    PageBreakBelow->False,
    DefaultNewInlineCellStyle->"None",
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.36, -0.1}, {0, -0}}, 
                  BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "mma"->"Mathematica", "Mma"->"Mathematica", 
        "MMA"->"Mathematica", Inherited},
    LanguageCategory->"NaturalLanguage",
    CounterIncrements->"Subsection",
    CounterAssignments->{{"Subsubsection", 0}},
    FontFamily->"Times",
    FontSize->14,
    FontWeight->"Bold"],
  
  Cell[StyleData["Subsection", "Presentation"],
    CellMargins->{{36, 10}, {11, 32}},
    LineSpacing->{1, 0},
    FontSize->22],
  
  Cell[StyleData["Subsection", "Condensed"],
    CellMargins->{{16, Inherited}, {6, 12}},
    FontSize->12],
  
  Cell[StyleData["Subsection", "Printout"],
    CellMargins->{{9, 0}, {7, 22}},
    FontSize->12]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsubsection"],
    CellDingbat->"\[FilledSmallSquare]",
    CellMargins->{{22, Inherited}, {8, 18}},
    CellGroupingRules->{"SectionGrouping", 50},
    PageBreakBelow->False,
    DefaultNewInlineCellStyle->"None",
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.36, -0.1}, {0, -0}}, 
                  BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "mma"->"Mathematica", "Mma"->"Mathematica", 
        "MMA"->"Mathematica", Inherited},
    LanguageCategory->"NaturalLanguage",
    CounterIncrements->"Subsubsection",
    FontFamily->"Times",
    FontWeight->"Bold"],
  
  Cell[StyleData["Subsubsection", "Presentation"],
    CellMargins->{{34, 10}, {11, 26}},
    LineSpacing->{1, 0},
    FontSize->18],
  
  Cell[StyleData["Subsubsection", "Condensed"],
    CellMargins->{{17, Inherited}, {6, 12}},
    FontSize->10],
  
  Cell[StyleData["Subsubsection", "Printout"],
    CellMargins->{{9, 0}, {7, 14}},
    FontSize->11]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Styles for Body Text", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Text"],
    CellMargins->{{12, 10}, {7, 7}},
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.36, -0.1}, {0, -0}}, 
                  BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "mma"->"Mathematica", "Mma"->"Mathematica", 
        "MMA"->"Mathematica", Inherited},
    Hyphenation->True,
    LineSpacing->{1, 3},
    CounterIncrements->"Text"],
  
  Cell[StyleData["Text", "Presentation"],
    CellMargins->{{24, 10}, {10, 10}},
    LineSpacing->{1, 5},
    FontSize->16],
  
  Cell[StyleData["Text", "Condensed"],
    CellMargins->{{8, 10}, {6, 6}},
    LineSpacing->{1, 1},
    FontSize->11],
  
  Cell[StyleData["Text", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->0.5,
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SmallText"],
    CellMargins->{{12, 10}, {6, 6}},
    DefaultNewInlineCellStyle->"None",
    Hyphenation->True,
    LineSpacing->{1, 3},
    LanguageCategory->"NaturalLanguage",
    CounterIncrements->"SmallText",
    FontFamily->"Helvetica",
    FontSize->9],
  
  Cell[StyleData["SmallText", "Presentation"],
    CellMargins->{{24, 10}, {8, 8}},
    LineSpacing->{1, 5},
    FontSize->12],
  
  Cell[StyleData["SmallText", "Condensed"],
    CellMargins->{{8, 10}, {5, 5}},
    LineSpacing->{1, 2},
    FontSize->9],
  
  Cell[StyleData["SmallText", "Printout"],
    CellMargins->{{2, 2}, {5, 5}},
    TextJustification->0.5,
    FontSize->7]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Styles for Input/Output", "Section"],
  
  Cell["\<\
The cells in this section define styles used for input and output \
to the kernel.  Be careful when modifying, renaming, or removing these \
styles, because the front end associates special meanings with these style \
names. Some attributes for these styles are actually set in FormatType Styles \
(in the last section of this stylesheet). \
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Input"],
    CellMargins->{{45, 10}, {5, 7}},
    Evaluatable->True,
    CellGroupingRules->"InputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    DefaultFormatType->DefaultInputFormatType,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    LanguageCategory->"Mathematica",
    FormatType->InputForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    LinebreakAdjustments->{0.85, 2, 10, 0, 1},
    CounterIncrements->"Input",
    FontWeight->"Bold"],
  
  Cell[StyleData["Input", "Presentation"],
    CellMargins->{{72, Inherited}, {8, 10}},
    LineSpacing->{1, 0},
    FontSize->16],
  
  Cell[StyleData["Input", "Condensed"],
    CellMargins->{{40, 10}, {2, 3}},
    FontSize->11],
  
  Cell[StyleData["Input", "Printout"],
    CellMargins->{{39, 0}, {4, 6}},
    LinebreakAdjustments->{0.85, 2, 10, 1, 1},
    FontSize->9]
  }, Closed]],
  
  Cell[StyleData["InputOnly"],
    Evaluatable->True,
    CellGroupingRules->"InputGrouping",
    CellHorizontalScrolling->True,
    DefaultFormatType->DefaultInputFormatType,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    LanguageCategory->"Mathematica",
    FormatType->InputForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    LinebreakAdjustments->{0.85, 2, 10, 0, 1},
    CounterIncrements->"Input",
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Output"],
    CellMargins->{{47, 10}, {7, 5}},
    CellEditDuplicate->True,
    CellGroupingRules->"OutputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    DefaultFormatType->DefaultOutputFormatType,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    LanguageCategory->None,
    FormatType->InputForm,
    CounterIncrements->"Output"],
  
  Cell[StyleData["Output", "Presentation"],
    CellMargins->{{72, Inherited}, {10, 8}},
    LineSpacing->{1, 0},
    FontSize->16],
  
  Cell[StyleData["Output", "Condensed"],
    CellMargins->{{41, Inherited}, {3, 2}},
    FontSize->11],
  
  Cell[StyleData["Output", "Printout"],
    CellMargins->{{39, 0}, {6, 4}},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Message"],
    CellMargins->{{45, Inherited}, {Inherited, Inherited}},
    CellGroupingRules->"OutputGrouping",
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    DefaultFormatType->DefaultOutputFormatType,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    LanguageCategory->None,
    FormatType->InputForm,
    CounterIncrements->"Message",
    StyleMenuListing->None,
    FontSize->11,
    FontColor->RGBColor[0, 0, 1]],
  
  Cell[StyleData["Message", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    LineSpacing->{1, 0},
    FontSize->16],
  
  Cell[StyleData["Message", "Condensed"],
    CellMargins->{{41, Inherited}, {Inherited, Inherited}},
    FontSize->11],
  
  Cell[StyleData["Message", "Printout"],
    CellMargins->{{39, Inherited}, {Inherited, Inherited}},
    FontSize->7,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Print"],
    CellMargins->{{45, Inherited}, {Inherited, Inherited}},
    CellGroupingRules->"OutputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    DefaultFormatType->DefaultOutputFormatType,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    LanguageCategory->None,
    FormatType->InputForm,
    CounterIncrements->"Print",
    StyleMenuListing->None],
  
  Cell[StyleData["Print", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    LineSpacing->{1, 0},
    FontSize->16],
  
  Cell[StyleData["Print", "Condensed"],
    CellMargins->{{41, Inherited}, {Inherited, Inherited}},
    FontSize->11],
  
  Cell[StyleData["Print", "Printout"],
    CellMargins->{{39, Inherited}, {Inherited, Inherited}},
    FontSize->8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Graphics"],
    CellMargins->{{4, Inherited}, {Inherited, Inherited}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    DefaultFormatType->DefaultOutputFormatType,
    LanguageCategory->None,
    FormatType->InputForm,
    CounterIncrements->"Graphics",
    ImageMargins->{{43, Inherited}, {Inherited, 0}},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->10],
  
  Cell[StyleData["Graphics", "Presentation"],
    ImageMargins->{{62, Inherited}, {Inherited, 0}}],
  
  Cell[StyleData["Graphics", "Condensed"],
    ImageMargins->{{38, Inherited}, {Inherited, 0}},
    Magnification->0.6],
  
  Cell[StyleData["Graphics", "Printout"],
    ImageMargins->{{30, Inherited}, {Inherited, 0}},
    Magnification->0.8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["CellLabel"],
    LanguageCategory->None,
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9,
    FontColor->RGBColor[0, 0, 1]],
  
  Cell[StyleData["CellLabel", "Presentation"],
    FontSize->12],
  
  Cell[StyleData["CellLabel", "Condensed"],
    FontSize->9],
  
  Cell[StyleData["CellLabel", "Printout"],
    FontFamily->"Courier",
    FontSize->8,
    FontSlant->"Italic",
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FrameLabel"],
    LanguageCategory->None,
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9],
  
  Cell[StyleData["FrameLabel", "Presentation"],
    FontSize->12],
  
  Cell[StyleData["FrameLabel", "Condensed"],
    FontSize->9],
  
  Cell[StyleData["FrameLabel", "Printout"],
    FontFamily->"Courier",
    FontSize->8,
    FontSlant->"Italic",
    FontColor->GrayLevel[0]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Inline Formatting", "Section"],
  
  Cell["\<\
These styles are for modifying individual words or letters in a \
cell exclusive of the cell tag.\
\>", "Text"],
  
  Cell[StyleData["RM"],
    StyleMenuListing->None,
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["BF"],
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["IT"],
    StyleMenuListing->None,
    FontSlant->"Italic"],
  
  Cell[StyleData["TR"],
    StyleMenuListing->None,
    FontFamily->"Times",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["TI"],
    StyleMenuListing->None,
    FontFamily->"Times",
    FontWeight->"Plain",
    FontSlant->"Italic"],
  
  Cell[StyleData["TB"],
    StyleMenuListing->None,
    FontFamily->"Times",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  
  Cell[StyleData["TBI"],
    StyleMenuListing->None,
    FontFamily->"Times",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  
  Cell[StyleData["MR"],
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["MO"],
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontWeight->"Plain",
    FontSlant->"Italic"],
  
  Cell[StyleData["MB"],
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  
  Cell[StyleData["MBO"],
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  
  Cell[StyleData["SR"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["SO"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Plain",
    FontSlant->"Italic"],
  
  Cell[StyleData["SB"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  
  Cell[StyleData["SBO"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SO10"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10,
    FontWeight->"Plain",
    FontSlant->"Italic"],
  
  Cell[StyleData["SO10", "Printout"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->7,
    FontWeight->"Plain",
    FontSlant->"Italic"],
  
  Cell[StyleData["SO10", "EnhancedPrintout"],
    StyleMenuListing->None,
    FontFamily->"Futura",
    FontSize->7,
    FontWeight->"Plain",
    FontSlant->"Italic"]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Formulas and Programming", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["InlineFormula"],
    CellMargins->{{10, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    LanguageCategory->"Formula",
    ScriptLevel->1,
    SingleLetterItalics->True],
  
  Cell[StyleData["InlineFormula", "Presentation"],
    CellMargins->{{24, 10}, {10, 10}},
    LineSpacing->{1, 5},
    FontSize->16],
  
  Cell[StyleData["InlineFormula", "Condensed"],
    CellMargins->{{8, 10}, {6, 6}},
    LineSpacing->{1, 1},
    FontSize->11],
  
  Cell[StyleData["InlineFormula", "Printout"],
    CellMargins->{{2, 0}, {6, 6}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DisplayFormula"],
    CellMargins->{{42, Inherited}, {Inherited, Inherited}},
    CellHorizontalScrolling->True,
    DefaultFormatType->DefaultInputFormatType,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    LanguageCategory->"Formula",
    ScriptLevel->0,
    SingleLetterItalics->True,
    UnderoverscriptBoxOptions->{LimitsPositioning->True}],
  
  Cell[StyleData["DisplayFormula", "Presentation"],
    LineSpacing->{1, 5},
    FontSize->16],
  
  Cell[StyleData["DisplayFormula", "Condensed"],
    LineSpacing->{1, 1},
    FontSize->11],
  
  Cell[StyleData["DisplayFormula", "Printout"],
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Program"],
    CellFrame->{{0, 0}, {0.5, 0.5}},
    CellMargins->{{10, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    Hyphenation->False,
    LanguageCategory->"Formula",
    ScriptLevel->1,
    FontFamily->"Courier"],
  
  Cell[StyleData["Program", "Presentation"],
    CellMargins->{{24, 10}, {10, 10}},
    LineSpacing->{1, 5},
    FontSize->16],
  
  Cell[StyleData["Program", "Condensed"],
    CellMargins->{{8, 10}, {6, 6}},
    LineSpacing->{1, 1},
    FontSize->11],
  
  Cell[StyleData["Program", "Printout"],
    CellMargins->{{2, 0}, {6, 6}},
    FontSize->9]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Outline Styles", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Outline1"],
    CellMargins->{{12, 10}, {7, 7}},
    CellGroupingRules->{"SectionGrouping", 50},
    ParagraphIndent->-38,
    CounterIncrements->"Outline1",
    FontSize->18,
    FontWeight->"Bold",
    CounterBoxOptions->{CounterFunction:>CapitalRomanNumeral}],
  
  Cell[StyleData["Outline1", "Printout"],
    CounterBoxOptions->{CounterFunction:>CapitalRomanNumeral}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Outline2"],
    CellMargins->{{59, 10}, {7, 7}},
    CellGroupingRules->{"SectionGrouping", 60},
    ParagraphIndent->-27,
    CounterIncrements->"Outline2",
    FontSize->15,
    FontWeight->"Bold",
    CounterBoxOptions->{CounterFunction:>(Part[ 
        CharacterRange[ "A", "Z"], #]&)}],
  
  Cell[StyleData["Outline2", "Printout"],
    CounterBoxOptions->{CounterFunction:>(Part[ 
        CharacterRange[ "A", "Z"], #]&)}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Outline3"],
    CellMargins->{{108, 10}, {7, 7}},
    CellGroupingRules->{"SectionGrouping", 70},
    ParagraphIndent->-21,
    CounterIncrements->"Outline3",
    FontSize->12,
    CounterBoxOptions->{CounterFunction:>Identity}],
  
  Cell[StyleData["Outline3", "Printout"],
    CounterBoxOptions->{CounterFunction:>Identity}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Outline4"],
    CellMargins->{{158, 10}, {7, 7}},
    CellGroupingRules->{"SectionGrouping", 80},
    ParagraphIndent->-18,
    CounterIncrements->"Outline4",
    FontSize->10,
    CounterBoxOptions->{CounterFunction:>(Part[ 
        CharacterRange[ "a", "z"], #]&)}],
  
  Cell[StyleData["Outline4", "Printout"]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Hyperlink Styles", "Section"],
  
  Cell["\<\
The cells below define styles useful for making hypertext \
ButtonBoxes.  The \"Hyperlink\" style is for links within the same Notebook, \
or between Notebooks.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Hyperlink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0, 0, 1],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #2]}]&),
    Active->True,
    ButtonNote->ButtonData}],
  
  Cell[StyleData["Hyperlink", "Presentation"],
    FontSize->16],
  
  Cell[StyleData["Hyperlink", "Condensed"],
    FontSize->11],
  
  Cell[StyleData["Hyperlink", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell["\<\
The following styles are for linking automatically to the on-line \
help system.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MainBookLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0, 0, 1],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "MainBook", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["MainBookLink", "Presentation"],
    FontSize->16],
  
  Cell[StyleData["MainBookLink", "Condensed"],
    FontSize->11],
  
  Cell[StyleData["MainBookLink", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["AddOnsLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontFamily->"Courier",
    FontColor->RGBColor[0, 0, 1],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "AddOns", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["AddOnsLink", "Presentation"],
    FontSize->16],
  
  Cell[StyleData["AddOnsLink", "Condensed"],
    FontSize->11],
  
  Cell[StyleData["AddOnsLink", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["RefGuideLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontFamily->"Courier",
    FontColor->RGBColor[0, 0, 1],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "RefGuide", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["RefGuideLink", "Presentation"],
    FontSize->16],
  
  Cell[StyleData["RefGuideLink", "Condensed"],
    FontSize->11],
  
  Cell[StyleData["RefGuideLink", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["GettingStartedLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0, 0, 1],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "GettingStarted", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["GettingStartedLink", "Presentation"],
    FontSize->16],
  
  Cell[StyleData["GettingStartedLink", "Condensed"],
    FontSize->11],
  
  Cell[StyleData["GettingStartedLink", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["OtherInformationLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0, 0, 1],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "OtherInformation", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["OtherInformationLink", "Presentation"],
    FontSize->16],
  
  Cell[StyleData["OtherInformationLink", "Condensed"],
    FontSize->11],
  
  Cell[StyleData["OtherInformationLink", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Styles for Headers and Footers", "Section"],
  
  Cell[StyleData["Header"],
    CellMargins->{{0, 0}, {4, 1}},
    DefaultNewInlineCellStyle->"None",
    LanguageCategory->"NaturalLanguage",
    StyleMenuListing->None,
    FontSize->10,
    FontSlant->"Italic"],
  
  Cell[StyleData["Footer"],
    CellMargins->{{0, 0}, {0, 4}},
    DefaultNewInlineCellStyle->"None",
    LanguageCategory->"NaturalLanguage",
    StyleMenuListing->None,
    FontSize->9,
    FontSlant->"Italic"],
  
  Cell[StyleData["PageNumber"],
    CellMargins->{{0, 0}, {4, 1}},
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Palette Styles", "Section"],
  
  Cell["\<\
The cells below define styles that define standard \
ButtonFunctions, for use in palette buttons.\
\>", "Text"],
  
  Cell[StyleData["Paste"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookApply[ 
          FrontEnd`InputNotebook[ ], #, After]}]&)}],
  
  Cell[StyleData["Evaluate"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookApply[ 
          FrontEnd`InputNotebook[ ], #, All], 
        SelectionEvaluate[ 
          FrontEnd`InputNotebook[ ], All]}]&)}],
  
  Cell[StyleData["EvaluateCell"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookApply[ 
          FrontEnd`InputNotebook[ ], #, All], 
        FrontEnd`SelectionMove[ 
          FrontEnd`InputNotebook[ ], All, Cell, 1], 
        FrontEnd`SelectionEvaluateCreateCell[ 
          FrontEnd`InputNotebook[ ], All]}]&)}],
  
  Cell[StyleData["CopyEvaluate"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`SelectionCreateCell[ 
          FrontEnd`InputNotebook[ ], All], 
        FrontEnd`NotebookApply[ 
          FrontEnd`InputNotebook[ ], #, All], 
        FrontEnd`SelectionEvaluate[ 
          FrontEnd`InputNotebook[ ], All]}]&)}],
  
  Cell[StyleData["CopyEvaluateCell"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`SelectionCreateCell[ 
          FrontEnd`InputNotebook[ ], All], 
        FrontEnd`NotebookApply[ 
          FrontEnd`InputNotebook[ ], #, All], 
        FrontEnd`SelectionEvaluateCreateCell[ 
          FrontEnd`InputNotebook[ ], All]}]&)}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Placeholder Styles", "Section"],
  
  Cell["\<\
The cells below define styles useful for making placeholder \
objects in palette templates.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Placeholder"],
    Placeholder->True,
    StyleMenuListing->None,
    FontSlant->"Italic",
    FontColor->RGBColor[0.890623, 0.864698, 0.384756],
    TagBoxOptions->{Editable->False,
    Selectable->False,
    StripWrapperBoxes->False}],
  
  Cell[StyleData["Placeholder", "Presentation"]],
  
  Cell[StyleData["Placeholder", "Condensed"]],
  
  Cell[StyleData["Placeholder", "Printout"]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PrimaryPlaceholder"],
    StyleMenuListing->None,
    DrawHighlighted->True,
    FontSlant->"Italic",
    Background->RGBColor[0.912505, 0.891798, 0.507774],
    TagBoxOptions->{Editable->False,
    Selectable->False,
    StripWrapperBoxes->False}],
  
  Cell[StyleData["PrimaryPlaceholder", "Presentation"]],
  
  Cell[StyleData["PrimaryPlaceholder", "Condensed"]],
  
  Cell[StyleData["PrimaryPlaceholder", "Printout"]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["FormatType Styles", "Section"],
  
  Cell["\<\
The cells below define styles that are mixed in with the styles \
of most cells.  If a cell's FormatType matches the name of one of the styles \
defined below, then that style is applied between the cell's style and its \
own options. This is particularly true of Input and Output.\
\>", "Text"],
  
  Cell[StyleData["CellExpression"],
    PageWidth->Infinity,
    CellMargins->{{6, Inherited}, {Inherited, Inherited}},
    ShowCellLabel->False,
    ShowSpecialCharacters->False,
    AllowInlineCells->False,
    Hyphenation->False,
    AutoItalicWords->{},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->12,
    Background->GrayLevel[1]],
  
  Cell[StyleData["InputForm"],
    InputAutoReplacements->{},
    AllowInlineCells->False,
    Hyphenation->False,
    StyleMenuListing->None,
    FontFamily->"Courier"],
  
  Cell[StyleData["OutputForm"],
    PageWidth->Infinity,
    TextAlignment->Left,
    LineSpacing->{0.6, 1},
    StyleMenuListing->None,
    FontFamily->"Courier"],
  
  Cell[StyleData["StandardForm"],
    InputAutoReplacements->{
      "->"->"\[Rule]", ":>"->"\[RuleDelayed]", "<="->"\[LessEqual]", 
        ">="->"\[GreaterEqual]", "!="->"\[NotEqual]", "=="->"\[Equal]", 
        Inherited},
    LineSpacing->{1.25, 0},
    StyleMenuListing->None,
    FontFamily->"Courier"],
  
  Cell[StyleData["TraditionalForm"],
    InputAutoReplacements->{
      "->"->"\[Rule]", ":>"->"\[RuleDelayed]", "<="->"\[LessEqual]", 
        ">="->"\[GreaterEqual]", "!="->"\[NotEqual]", "=="->"\[Equal]", 
        Inherited},
    LineSpacing->{1.25, 0},
    SingleLetterItalics->True,
    TraditionalFunctionNotation->True,
    DelimiterMatching->None,
    StyleMenuListing->None],
  
  Cell["\<\
The style defined below is mixed in to any cell that is in an \
inline cell within another.\
\>", "Text"],
  
  Cell[StyleData["InlineCell"],
    LanguageCategory->"Formula",
    ScriptLevel->1,
    StyleMenuListing->None],
  
  Cell[StyleData["InlineCellEditing"],
    StyleMenuListing->None,
    Background->RGBColor[1, 0.749996, 0.8]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Automatic Styles", "Section"],
  
  Cell["\<\
The cells below define styles that are used to affect the display \
of certain types of objects in typeset expressions.  For example, \
\"UnmatchedBracket\" style defines how unmatched bracket, curly bracket, and \
parenthesis characters are displayed (typically by coloring them to make them \
stand out).\
\>", "Text"],
  
  Cell[StyleData["UnmatchedBracket"],
    StyleMenuListing->None,
    FontColor->RGBColor[0.760006, 0.330007, 0.8]]
  }, Closed]]
  }, Open  ]]
  }]
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "ii:3"->{
    Cell[5172, 207, 194, 6, 36, "Text",
      CellTags->"ii:3"]},
  "ii:385"->{
    Cell[5369, 215, 250, 8, 36, "Text",
      CellTags->"ii:385"]},
  "ii:388"->{
    Cell[5768, 232, 196, 6, 36, "Text",
      CellTags->"ii:388"]},
  "ii:4"->{
    Cell[5967, 240, 210, 7, 36, "Text",
      CellTags->"ii:4"]},
  "ii:7"->{
    Cell[6180, 249, 182, 6, 36, "Text",
      CellTags->"ii:7"]},
  "ii:5"->{
    Cell[6365, 257, 204, 6, 36, "Text",
      CellTags->"ii:5"]},
  "ii:6"->{
    Cell[6572, 265, 193, 6, 36, "Text",
      CellTags->"ii:6"]},
  "ii:9"->{
    Cell[7398, 299, 168, 6, 36, "Text",
      CellTags->"ii:9"]},
  "ii:8"->{
    Cell[7569, 307, 192, 6, 36, "Text",
      CellTags->"ii:8"]},
  "ii:10"->{
    Cell[7921, 322, 457, 11, 36, "Text",
      CellTags->"ii:10"]},
  "ii:11"->{
    Cell[8381, 335, 633, 26, 36, "Text",
      CellTags->"ii:11"]},
  "ii:12"->{
    Cell[9017, 363, 181, 6, 36, "Text",
      CellTags->"ii:12"]},
  "ii:13"->{
    Cell[9201, 371, 174, 6, 36, "Text",
      CellTags->"ii:13"]},
  "ii:14"->{
    Cell[9378, 379, 162, 6, 36, "Text",
      CellTags->"ii:14"]},
  "A"->{
    Cell[10250, 422, 314, 13, 36, "Text",
      CellTags->{"A", "ii:15"}]},
  "ii:15"->{
    Cell[10250, 422, 314, 13, 36, "Text",
      CellTags->{"A", "ii:15"}]},
  "ii:16"->{
    Cell[10567, 437, 163, 6, 36, "Text",
      CellTags->"ii:16"]},
  "ii:17"->{
    Cell[10733, 445, 328, 13, 36, "Text",
      CellTags->"ii:17"]},
  "ii:18"->{
    Cell[11064, 460, 401, 17, 36, "Text",
      CellTags->"ii:18"]},
  "ii:19"->{
    Cell[11468, 479, 227, 9, 36, "Text",
      CellTags->"ii:19"]},
  "ii:20"->{
    Cell[11698, 490, 168, 6, 36, "Text",
      CellTags->"ii:20"]},
  "ii:21"->{
    Cell[11869, 498, 438, 17, 55, "Text",
      CellTags->"ii:21"]},
  "ii:22"->{
    Cell[12684, 535, 309, 13, 36, "Text",
      CellTags->"ii:22"]},
  "ii:23"->{
    Cell[12996, 550, 524, 18, 74, "Text",
      CellTags->"ii:23"]},
  "ii:25"->{
    Cell[14023, 595, 278, 10, 55, "Text",
      CellTags->"ii:25"]},
  "ii:26"->{
    Cell[14304, 607, 158, 6, 36, "Text",
      CellTags->"ii:26"]},
  "ii:27"->{
    Cell[14675, 626, 171, 6, 36, "Text",
      CellTags->"ii:27"]},
  "ii:28"->{
    Cell[14849, 634, 180, 7, 36, "Text",
      CellTags->"ii:28"]},
  "ii:29"->{
    Cell[15561, 667, 1454, 50, 188, "Text",
      CellTags->"ii:29"]},
  "B"->{
    Cell[17047, 721, 241, 9, 36, "Text",
      CellTags->{"B", "ii:30"}]},
  "ii:30"->{
    Cell[17047, 721, 241, 9, 36, "Text",
      CellTags->{"B", "ii:30"}]},
  "ii:31"->{
    Cell[17291, 732, 412, 14, 74, "Text",
      CellTags->"ii:31"]},
  "ii:32"->{
    Cell[17706, 748, 805, 29, 93, "Text",
      CellTags->"ii:32"]},
  "ii:33"->{
    Cell[18647, 786, 161, 6, 36, "Text",
      CellTags->"ii:33"]},
  "ii:34"->{
    Cell[18811, 794, 277, 10, 74, "Text",
      CellTags->"ii:34"]},
  "ii:36"->{
    Cell[19091, 806, 1493, 49, 228, "Text",
      CellTags->"ii:36"]},
  "ii:37"->{
    Cell[20587, 857, 305, 13, 36, "Text",
      CellTags->"ii:37"]},
  "ii:38"->{
    Cell[20895, 872, 305, 13, 36, "Text",
      CellTags->"ii:38"]},
  "ii:39"->{
    Cell[21203, 887, 315, 13, 36, "Text",
      CellTags->"ii:39"]},
  "ii:40"->{
    Cell[21521, 902, 163, 6, 36, "Text",
      CellTags->"ii:40"]},
  "ii:41"->{
    Cell[21687, 910, 254, 10, 36, "Text",
      CellTags->"ii:41"]},
  "ii:42"->{
    Cell[22386, 942, 435, 14, 93, "Text",
      CellTags->"ii:42"]},
  "ii:43"->{
    Cell[22824, 958, 162, 6, 36, "Text",
      CellTags->"ii:43"]},
  "ii:44"->{
    Cell[22989, 966, 545, 21, 36, "Text",
      CellTags->"ii:44"]},
  "ii:45"->{
    Cell[23537, 989, 3328, 124, 302, "Text",
      CellTags->"ii:45"]},
  "ii:46"->{
    Cell[26868, 1115, 1854, 64, 188, "Text",
      CellTags->"ii:46"]},
  "ii:47"->{
    Cell[28725, 1181, 149, 6, 36, "Text",
      CellTags->"ii:47"]},
  "ii:48"->{
    Cell[29089, 1199, 170, 6, 36, "Text",
      CellTags->"ii:48"]},
  "ii:49"->{
    Cell[29262, 1207, 274, 10, 55, "Text",
      CellTags->"ii:49"]},
  "ii:50"->{
    Cell[29539, 1219, 159, 6, 36, "Text",
      CellTags->"ii:50"]},
  "ii:51"->{
    Cell[29701, 1227, 292, 11, 55, "Text",
      CellTags->"ii:51"]},
  "C"->{
    Cell[30025, 1242, 176, 6, 36, "Text",
      CellTags->{"C", "ii:52"}]},
  "ii:52"->{
    Cell[30025, 1242, 176, 6, 36, "Text",
      CellTags->{"C", "ii:52"}]},
  "ii:53"->{
    Cell[30204, 1250, 154, 6, 36, "Text",
      CellTags->"ii:53"]},
  "ii:54"->{
    Cell[30500, 1265, 149, 6, 36, "Text",
      CellTags->"ii:54"]},
  "ii:55"->{
    Cell[30652, 1273, 608, 23, 74, "Text",
      CellTags->"ii:55"]},
  "ii:56"->{
    Cell[31263, 1298, 721, 29, 55, "Text",
      CellTags->"ii:56"]},
  "ii:57"->{
    Cell[31987, 1329, 567, 18, 112, "Text",
      CellTags->"ii:57"]},
  "ii:58"->{
    Cell[32557, 1349, 167, 6, 36, "Text",
      CellTags->"ii:58"]},
  "ii:59"->{
    Cell[32727, 1357, 168, 6, 36, "Text",
      CellTags->"ii:59"]},
  "ii:60"->{
    Cell[32898, 1365, 163, 6, 36, "Text",
      CellTags->"ii:60"]},
  "ii:379"->{
    Cell[33064, 1373, 572, 24, 36, "Text",
      CellTags->"ii:379"]},
  "ii:61"->{
    Cell[33639, 1399, 184, 6, 36, "Text",
      CellTags->"ii:61"]},
  "ii:62"->{
    Cell[34010, 1417, 166, 6, 36, "Text",
      CellTags->"ii:62"]},
  "ii:63"->{
    Cell[34179, 1425, 404, 17, 36, "Text",
      CellTags->"ii:63"]},
  "ii:64"->{
    Cell[34586, 1444, 527, 18, 93, "Text",
      CellTags->"ii:64"]},
  "ii:65"->{
    Cell[35116, 1464, 571, 21, 74, "Text",
      CellTags->"ii:65"]},
  "ii:66"->{
    Cell[35690, 1487, 545, 21, 93, "Text",
      CellTags->"ii:66"]},
  "ii:67"->{
    Cell[36238, 1510, 165, 6, 36, "Text",
      CellTags->"ii:67"]},
  "ii:68"->{
    Cell[36406, 1518, 513, 18, 112, "Text",
      CellTags->"ii:68"]},
  "ii:69"->{
    Cell[36922, 1538, 335, 13, 74, "Text",
      CellTags->"ii:69"]},
  "ii:70"->{
    Cell[37260, 1553, 163, 6, 36, "Text",
      CellTags->"ii:70"]},
  "ii:71"->{
    Cell[37566, 1568, 630, 24, 93, "Text",
      CellTags->"ii:71"]},
  "D"->{
    Cell[38906, 1628, 223, 9, 36, "Text",
      CellTags->{"D", "ii:73"}]},
  "ii:73"->{
    Cell[38906, 1628, 223, 9, 36, "Text",
      CellTags->{"D", "ii:73"}]},
  "ii:387"->{
    Cell[39283, 1647, 739, 24, 131, "Text",
      CellTags->"ii:387"]},
  "ii:74"->{
    Cell[40025, 1673, 355, 14, 36, "Text",
      CellTags->"ii:74"]},
  "ii:75"->{
    Cell[40383, 1689, 921, 34, 131, "Text",
      CellTags->"ii:75"]},
  "ii:76"->{
    Cell[41307, 1725, 158, 6, 36, "Text",
      CellTags->"ii:76"]},
  "ii:383"->{
    Cell[41468, 1733, 155, 6, 36, "Text",
      CellTags->"ii:383"]},
  "ii:77"->{
    Cell[41626, 1741, 159, 6, 36, "Text",
      CellTags->"ii:77"]},
  "ii:78"->{
    Cell[41788, 1749, 224, 9, 36, "Text",
      CellTags->"ii:78"]},
  "ii:79"->{
    Cell[42015, 1760, 491, 18, 93, "Text",
      CellTags->"ii:79"]},
  "ii:80"->{
    Cell[42509, 1780, 1254, 47, 169, "Text",
      CellTags->"ii:80"]},
  "ii:81"->{
    Cell[43766, 1829, 1009, 38, 131, "Text",
      CellTags->"ii:81"]},
  "ii:82"->{
    Cell[44778, 1869, 218, 9, 36, "Text",
      CellTags->"ii:82"]},
  "ii:83"->{
    Cell[44999, 1880, 164, 6, 36, "Text",
      CellTags->"ii:83"]},
  "ii:84"->{
    Cell[45166, 1888, 1239, 46, 169, "Text",
      CellTags->"ii:84"]},
  "ii:85"->{
    Cell[46408, 1936, 1638, 60, 207, "Text",
      CellTags->"ii:85"]},
  "ii:284"->{
    Cell[48049, 1998, 261, 10, 36, "Text",
      CellTags->"ii:284"]},
  "ii:86"->{
    Cell[48313, 2010, 914, 36, 112, "Text",
      CellTags->"ii:86"]},
  "ii:87"->{
    Cell[49230, 2048, 223, 9, 36, "Text",
      CellTags->"ii:87"]},
  "ii:88"->{
    Cell[49596, 2066, 159, 6, 36, "Text",
      CellTags->"ii:88"]},
  "ii:89"->{
    Cell[49758, 2074, 535, 22, 36, "Text",
      CellTags->"ii:89"]},
  "ii:90"->{
    Cell[50296, 2098, 343, 12, 74, "Text",
      CellTags->"ii:90"]},
  "ii:91"->{
    Cell[50642, 2112, 1012, 34, 150, "Text",
      CellTags->"ii:91"]},
  "ii:92"->{
    Cell[52912, 2191, 983, 37, 169, "Text",
      CellTags->"ii:92"]},
  "ii:93"->{
    Cell[53898, 2230, 215, 9, 36, "Text",
      CellTags->"ii:93"]},
  "ii:94"->{
    Cell[54116, 2241, 262, 10, 36, "Text",
      CellTags->"ii:94"]},
  "ii:95"->{
    Cell[54381, 2253, 159, 6, 36, "Text",
      CellTags->"ii:95"]},
  "ii:96"->{
    Cell[54543, 2261, 309, 13, 36, "Text",
      CellTags->"ii:96"]},
  "ii:97"->{
    Cell[54855, 2276, 218, 9, 36, "Text",
      CellTags->"ii:97"]},
  "E"->{
    Cell[55105, 2289, 675, 28, 36, "Text",
      CellTags->{"E", "ii:98"}]},
  "ii:98"->{
    Cell[55105, 2289, 675, 28, 36, "Text",
      CellTags->{"E", "ii:98"}]},
  "ii:99"->{
    Cell[56063, 2333, 267, 10, 36, "Text",
      CellTags->"ii:99"]},
  "ii:100"->{
    Cell[56518, 2355, 4253, 142, 589, "Text",
      CellTags->"ii:100"]},
  "ii:101"->{
    Cell[60774, 2499, 1326, 47, 188, "Text",
      CellTags->"ii:101"]},
  "ii:102"->{
    Cell[62103, 2548, 318, 13, 36, "Text",
      CellTags->"ii:102"]},
  "ii:103"->{
    Cell[62424, 2563, 301, 13, 36, "Text",
      CellTags->"ii:103"]},
  "ii:104"->{
    Cell[62728, 2578, 415, 17, 55, "Text",
      CellTags->"ii:104"]},
  "ii:105"->{
    Cell[63146, 2597, 474, 18, 74, "Text",
      CellTags->"ii:105"]},
  "ii:107"->{
    Cell[63623, 2617, 223, 9, 36, "Text",
      CellTags->"ii:107"]},
  "ii:108"->{
    Cell[63849, 2628, 223, 9, 36, "Text",
      CellTags->"ii:108"]},
  "ii:109"->{
    Cell[64075, 2639, 2498, 97, 226, "Text",
      CellTags->"ii:109"]},
  "ii:110"->{
    Cell[66576, 2738, 157, 6, 36, "Text",
      CellTags->"ii:110"]},
  "ii:111"->{
    Cell[66736, 2746, 154, 6, 36, "Text",
      CellTags->"ii:111"]},
  "ii:112"->{
    Cell[66893, 2754, 896, 32, 150, "Text",
      CellTags->"ii:112"]},
  "ii:113"->{
    Cell[67792, 2788, 2444, 84, 264, "Text",
      CellTags->"ii:113"]},
  "ii:115"->{
    Cell[71500, 2925, 938, 37, 74, "Text",
      CellTags->"ii:115"]},
  "ii:116"->{
    Cell[72732, 2978, 166, 6, 36, "Text",
      CellTags->"ii:116"]},
  "ii:117"->{
    Cell[72901, 2986, 222, 9, 36, "Text",
      CellTags->"ii:117"]},
  "ii:118"->{
    Cell[73604, 3021, 429, 17, 36, "Text",
      CellTags->"ii:118"]},
  "ii:119"->{
    Cell[74036, 3040, 173, 6, 36, "Text",
      CellTags->"ii:119"]},
  "F"->{
    Cell[74439, 3060, 229, 9, 36, "Text",
      CellTags->{"F", "ii:120"}]},
  "ii:120"->{
    Cell[74439, 3060, 229, 9, 36, "Text",
      CellTags->{"F", "ii:120"}]},
  "ii:121"->{
    Cell[74671, 3071, 164, 6, 36, "Text",
      CellTags->"ii:121"]},
  "ii:122"->{
    Cell[74838, 3079, 160, 6, 36, "Text",
      CellTags->"ii:122"]},
  "ii:123"->{
    Cell[75217, 3097, 863, 31, 131, "Text",
      CellTags->"ii:123"]},
  "ii:124"->{
    Cell[76083, 3130, 256, 10, 36, "Text",
      CellTags->"ii:124"]},
  "ii:125"->{
    Cell[76342, 3142, 557, 18, 93, "Text",
      CellTags->"ii:125"]},
  "ii:126"->{
    Cell[76902, 3162, 225, 9, 36, "Text",
      CellTags->"ii:126"]},
  "ii:277"->{
    Cell[77130, 3173, 318, 13, 36, "Text",
      CellTags->"ii:277"]},
  "ii:127"->{
    Cell[77451, 3188, 220, 9, 36, "Text",
      CellTags->"ii:127"]},
  "ii:128"->{
    Cell[78016, 3216, 258, 10, 36, "Text",
      CellTags->"ii:128"]},
  "ii:129"->{
    Cell[78481, 3238, 293, 13, 36, "Text",
      CellTags->"ii:129"]},
  "ii:130"->{
    Cell[78777, 3253, 360, 16, 74, "Text",
      CellTags->"ii:130"]},
  "ii:131"->{
    Cell[79140, 3271, 901, 29, 150, "Text",
      CellTags->"ii:131"]},
  "ii:132"->{
    Cell[80044, 3302, 1114, 41, 131, "Text",
      CellTags->"ii:132"]},
  "ii:133"->{
    Cell[81161, 3345, 234, 9, 36, "Text",
      CellTags->"ii:133"]},
  "ii:134"->{
    Cell[81398, 3356, 631, 22, 112, "Text",
      CellTags->"ii:134"]},
  "ii:137"->{
    Cell[82032, 3380, 307, 12, 36, "Text",
      CellTags->"ii:137"]},
  "ii:135"->{
    Cell[82342, 3394, 158, 6, 36, "Text",
      CellTags->"ii:135"]},
  "ii:138"->{
    Cell[84422, 3468, 331, 13, 36, "Text",
      CellTags->"ii:138"]},
  "ii:139"->{
    Cell[84756, 3483, 2287, 80, 302, "Text",
      CellTags->"ii:139"]},
  "ii:140"->{
    Cell[87046, 3565, 228, 9, 36, "Text",
      CellTags->"ii:140"]},
  "ii:141"->{
    Cell[87277, 3576, 906, 35, 150, "Text",
      CellTags->"ii:141"]},
  "ii:142"->{
    Cell[88186, 3613, 155, 6, 36, "Text",
      CellTags->"ii:142"]},
  "ii:143"->{
    Cell[88522, 3630, 228, 9, 36, "Text",
      CellTags->"ii:143"]},
  "ii:144"->{
    Cell[88753, 3641, 3262, 123, 416, "Text",
      CellTags->"ii:144"]},
  "ii:145"->{
    Cell[92018, 3766, 220, 9, 36, "Text",
      CellTags->"ii:145"]},
  "G"->{
    Cell[92270, 3779, 172, 6, 36, "Text",
      CellTags->{"G", "ii:146"}]},
  "ii:146"->{
    Cell[92270, 3779, 172, 6, 36, "Text",
      CellTags->{"G", "ii:146"}]},
  "ii:147"->{
    Cell[92445, 3787, 1540, 49, 226, "Text",
      CellTags->"ii:147"]},
  "ii:148"->{
    Cell[93988, 3838, 175, 6, 36, "Text",
      CellTags->"ii:148"]},
  "ii:149"->{
    Cell[94367, 3856, 257, 10, 36, "Text",
      CellTags->"ii:149"]},
  "ii:150"->{
    Cell[94627, 3868, 1707, 62, 207, "Text",
      CellTags->"ii:150"]},
  "ii:151"->{
    Cell[96563, 3944, 637, 25, 93, "Text",
      CellTags->"ii:151"]},
  "ii:153"->{
    Cell[97203, 3971, 163, 6, 36, "Text",
      CellTags->"ii:153"]},
  "ii:154"->{
    Cell[97369, 3979, 165, 6, 36, "Text",
      CellTags->"ii:154"]},
  "ii:155"->{
    Cell[97537, 3987, 171, 6, 36, "Text",
      CellTags->"ii:155"]},
  "ii:156"->{
    Cell[97711, 3995, 295, 10, 55, "Text",
      CellTags->"ii:156"]},
  "ii:157"->{
    Cell[98009, 4007, 160, 6, 36, "Text",
      CellTags->"ii:157"]},
  "ii:158"->{
    Cell[98172, 4015, 2368, 77, 304, "Text",
      CellTags->"ii:158"]},
  "ii:159"->{
    Cell[100543, 4094, 3549, 124, 416, "Text",
      CellTags->"ii:159"]},
  "ii:160"->{
    Cell[104095, 4220, 687, 22, 112, "Text",
      CellTags->"ii:160"]},
  "H"->{
    Cell[104814, 4246, 683, 22, 112, "Text",
      CellTags->{"H", "ii:161"}]},
  "ii:161"->{
    Cell[104814, 4246, 683, 22, 112, "Text",
      CellTags->{"H", "ii:161"}]},
  "ii:162"->{
    Cell[105500, 4270, 167, 6, 36, "Text",
      CellTags->"ii:162"]},
  "ii:163"->{
    Cell[105670, 4278, 653, 25, 93, "Text",
      CellTags->"ii:163"]},
  "ii:164"->{
    Cell[106326, 4305, 2805, 103, 264, "Text",
      CellTags->"ii:164"]},
  "ii:166"->{
    Cell[109502, 4425, 169, 6, 36, "Text",
      CellTags->"ii:166"]},
  "ii:167"->{
    Cell[109674, 4433, 263, 10, 36, "Text",
      CellTags->"ii:167"]},
  "ii:168"->{
    Cell[109940, 4445, 879, 33, 93, "Text",
      CellTags->"ii:168"]},
  "ii:169"->{
    Cell[111024, 4490, 407, 17, 55, "Text",
      CellTags->"ii:169"]},
  "ii:170"->{
    Cell[112038, 4534, 157, 6, 36, "Text",
      CellTags->"ii:170"]},
  "ii:171"->{
    Cell[112198, 4542, 263, 10, 36, "Text",
      CellTags->"ii:171"]},
  "ii:172"->{
    Cell[112614, 4561, 760, 30, 112, "Text",
      CellTags->"ii:172"]},
  "ii:173"->{
    Cell[113377, 4593, 154, 6, 36, "Text",
      CellTags->"ii:173"]},
  "I"->{
    Cell[113563, 4603, 560, 21, 74, "Text",
      CellTags->{"I", "ii:174"}]},
  "ii:174"->{
    Cell[113563, 4603, 560, 21, 74, "Text",
      CellTags->{"I", "ii:174"}]},
  "ii:175"->{
    Cell[114126, 4626, 218, 9, 36, "Text",
      CellTags->"ii:175"]},
  "ii:177"->{
    Cell[114536, 4647, 609, 26, 36, "Text",
      CellTags->"ii:177"]},
  "ii:178"->{
    Cell[115444, 4688, 658, 25, 55, "Text",
      CellTags->"ii:178"]},
  "ii:179"->{
    Cell[116105, 4715, 660, 25, 74, "Text",
      CellTags->"ii:179"]},
  "ii:180"->{
    Cell[116768, 4742, 224, 9, 36, "Text",
      CellTags->"ii:180"]},
  "ii:182"->{
    Cell[118035, 4796, 433, 18, 36, "Text",
      CellTags->"ii:182"]},
  "ii:184"->{
    Cell[118471, 4816, 279, 11, 36, "Text",
      CellTags->"ii:184"]},
  "ii:185"->{
    Cell[118753, 4829, 817, 31, 93, "Text",
      CellTags->"ii:185"]},
  "ii:186"->{
    Cell[119573, 4862, 234, 9, 36, "Text",
      CellTags->"ii:186"]},
  "ii:187"->{
    Cell[119810, 4873, 223, 9, 36, "Text",
      CellTags->"ii:187"]},
  "ii:188"->{
    Cell[120036, 4884, 285, 10, 55, "Text",
      CellTags->"ii:188"]},
  "ii:189"->{
    Cell[120324, 4896, 238, 9, 36, "Text",
      CellTags->"ii:189"]},
  "J"->{
    Cell[120594, 4909, 179, 6, 36, "Text",
      CellTags->{"J", "ii:190"}]},
  "ii:190"->{
    Cell[120594, 4909, 179, 6, 36, "Text",
      CellTags->{"J", "ii:190"}]},
  "ii:191"->{
    Cell[121339, 4942, 164, 6, 36, "Text",
      CellTags->"ii:191"]},
  "K"->{
    Cell[121736, 4962, 758, 28, 112, "Text",
      CellTags->{"K", "ii:192"}]},
  "ii:192"->{
    Cell[121736, 4962, 758, 28, 112, "Text",
      CellTags->{"K", "ii:192"}]},
  "ii:193"->{
    Cell[122497, 4992, 152, 6, 36, "Text",
      CellTags->"ii:193"]},
  "ii:194"->{
    Cell[122652, 5000, 271, 10, 36, "Text",
      CellTags->"ii:194"]},
  "ii:195"->{
    Cell[123486, 5039, 228, 9, 36, "Text",
      CellTags->"ii:195"]},
  "L"->{
    Cell[123958, 5062, 339, 12, 74, "Text",
      CellTags->{"L", "ii:196"}]},
  "ii:196"->{
    Cell[123958, 5062, 339, 12, 74, "Text",
      CellTags->{"L", "ii:196"}]},
  "ii:197"->{
    Cell[124584, 5087, 413, 14, 74, "Text",
      CellTags->"ii:197"]},
  "ii:198"->{
    Cell[125000, 5103, 162, 6, 36, "Text",
      CellTags->"ii:198"]},
  "ii:199"->{
    Cell[125165, 5111, 1785, 64, 188, "Text",
      CellTags->"ii:199"]},
  "ii:200"->{
    Cell[126953, 5177, 1021, 33, 152, "Text",
      CellTags->"ii:200"]},
  "ii:201"->{
    Cell[128161, 5222, 221, 9, 36, "Text",
      CellTags->"ii:201"]},
  "ii:350"->{
    Cell[128385, 5233, 380, 15, 36, "Text",
      CellTags->"ii:350"]},
  "ii:203"->{
    Cell[129365, 5274, 223, 9, 36, "Text",
      CellTags->"ii:203"]},
  "ii:204"->{
    Cell[129767, 5295, 162, 6, 36, "Text",
      CellTags->"ii:204"]},
  "ii:205"->{
    Cell[129932, 5303, 2781, 98, 340, "Text",
      CellTags->"ii:205"]},
  "ii:206"->{
    Cell[132716, 5403, 165, 6, 36, "Text",
      CellTags->"ii:206"]},
  "ii:207"->{
    Cell[133031, 5418, 419, 17, 36, "Text",
      CellTags->"ii:207"]},
  "ii:208"->{
    Cell[133453, 5437, 217, 8, 36, "Text",
      CellTags->"ii:208"]},
  "ii:209"->{
    Cell[133673, 5447, 730, 26, 112, "Text",
      CellTags->"ii:209"]},
  "ii:211"->{
    Cell[134406, 5475, 371, 14, 36, "Text",
      CellTags->"ii:211"]},
  "ii:212"->{
    Cell[134985, 5501, 378, 14, 74, "Text",
      CellTags->"ii:212"]},
  "M"->{
    Cell[135395, 5519, 163, 6, 36, "Text",
      CellTags->{"M", "ii:214"}]},
  "ii:214"->{
    Cell[135395, 5519, 163, 6, 36, "Text",
      CellTags->{"M", "ii:214"}]},
  "ii:215"->{
    Cell[135561, 5527, 165, 6, 36, "Text",
      CellTags->"ii:215"]},
  "ii:216"->{
    Cell[135729, 5535, 158, 6, 36, "Text",
      CellTags->"ii:216"]},
  "ii:217"->{
    Cell[135890, 5543, 220, 9, 36, "Text",
      CellTags->"ii:217"]},
  "ii:218"->{
    Cell[136113, 5554, 910, 29, 169, "Text",
      CellTags->"ii:218"]},
  "ii:219"->{
    Cell[137026, 5585, 170, 6, 36, "Text",
      CellTags->"ii:219"]},
  "ii:220"->{
    Cell[137199, 5593, 266, 10, 36, "Text",
      CellTags->"ii:220"]},
  "ii:221"->{
    Cell[137468, 5605, 218, 9, 36, "Text",
      CellTags->"ii:221"]},
  "ii:222"->{
    Cell[137689, 5616, 160, 6, 36, "Text",
      CellTags->"ii:222"]},
  "ii:223"->{
    Cell[137852, 5624, 169, 6, 36, "Text",
      CellTags->"ii:223"]},
  "ii:224"->{
    Cell[138235, 5642, 420, 17, 55, "Text",
      CellTags->"ii:224"]},
  "ii:225"->{
    Cell[138658, 5661, 304, 10, 74, "Text",
      CellTags->"ii:225"]},
  "ii:227"->{
    Cell[138965, 5673, 330, 13, 36, "Text",
      CellTags->"ii:227"]},
  "ii:228"->{
    Cell[139298, 5688, 219, 9, 36, "Text",
      CellTags->"ii:228"]},
  "ii:229"->{
    Cell[139520, 5699, 664, 22, 93, "Text",
      CellTags->"ii:229"]},
  "ii:230"->{
    Cell[140187, 5723, 597, 22, 112, "Text",
      CellTags->"ii:230"]},
  "ii:231"->{
    Cell[140787, 5747, 252, 10, 55, "Text",
      CellTags->"ii:231"]},
  "ii:232"->{
    Cell[141249, 5768, 315, 10, 74, "Text",
      CellTags->"ii:232"]},
  "N"->{
    Cell[141596, 5782, 224, 9, 36, "Text",
      CellTags->{"N", "ii:233"}]},
  "ii:233"->{
    Cell[141596, 5782, 224, 9, 36, "Text",
      CellTags->{"N", "ii:233"}]},
  "ii:234"->{
    Cell[141823, 5793, 156, 6, 36, "Text",
      CellTags->"ii:234"]},
  "ii:235"->{
    Cell[142332, 5817, 530, 21, 74, "Text",
      CellTags->"ii:235"]},
  "ii:236"->{
    Cell[142865, 5840, 161, 6, 36, "Text",
      CellTags->"ii:236"]},
  "ii:1"->{
    Cell[143029, 5848, 276, 10, 36, "Text",
      CellTags->"ii:1"]},
  "ii:237"->{
    Cell[143308, 5860, 434, 18, 36, "Text",
      CellTags->"ii:237"]},
  "ii:238"->{
    Cell[143745, 5880, 159, 6, 36, "Text",
      CellTags->"ii:238"]},
  "ii:239"->{
    Cell[144118, 5898, 222, 9, 36, "Text",
      CellTags->"ii:239"]},
  "ii:240"->{
    Cell[144343, 5909, 406, 17, 36, "Text",
      CellTags->"ii:240"]},
  "ii:241"->{
    Cell[144752, 5928, 154, 6, 36, "Text",
      CellTags->"ii:241"]},
  "ii:242"->{
    Cell[144909, 5936, 223, 9, 36, "Text",
      CellTags->"ii:242"]},
  "ii:243"->{
    Cell[145135, 5947, 225, 9, 36, "Text",
      CellTags->"ii:243"]},
  "ii:181"->{
    Cell[145363, 5958, 790, 27, 131, "Text",
      CellTags->"ii:181"]},
  "ii:244"->{
    Cell[146156, 5987, 2548, 92, 283, "Text",
      CellTags->"ii:244"]},
  "ii:245"->{
    Cell[148707, 6081, 1202, 46, 150, "Text",
      CellTags->"ii:245"]},
  "O"->{
    Cell[149941, 6131, 185, 6, 36, "Text",
      CellTags->{"O", "ii:389"}]},
  "ii:389"->{
    Cell[149941, 6131, 185, 6, 36, "Text",
      CellTags->{"O", "ii:389"}]},
  "ii:246"->{
    Cell[150129, 6139, 751, 30, 93, "Text",
      CellTags->"ii:246"]},
  "ii:247"->{
    Cell[151227, 6188, 3613, 130, 435, "Text",
      CellTags->"ii:247"]},
  "ii:248"->{
    Cell[154843, 6320, 1909, 59, 266, "Text",
      CellTags->"ii:248"]},
  "ii:249"->{
    Cell[156755, 6381, 909, 34, 112, "Text",
      CellTags->"ii:249"]},
  "P"->{
    Cell[157696, 6419, 164, 6, 36, "Text",
      CellTags->{"P", "ii:250"}]},
  "ii:250"->{
    Cell[157696, 6419, 164, 6, 36, "Text",
      CellTags->{"P", "ii:250"}]},
  "ii:251"->{
    Cell[157863, 6427, 632, 22, 93, "Text",
      CellTags->"ii:251"]},
  "ii:252"->{
    Cell[158645, 6458, 4136, 152, 492, "Text",
      CellTags->"ii:252"]},
  "ii:253"->{
    Cell[163190, 6631, 257, 10, 50, "Text",
      CellTags->"ii:253"]},
  "ii:254"->{
    Cell[163450, 6643, 217, 9, 50, "Text",
      CellTags->"ii:254"]},
  "ii:255"->{
    Cell[163670, 6654, 391, 14, 55, "Text",
      CellTags->"ii:255"]},
  "ii:256"->{
    Cell[164064, 6670, 392, 14, 74, "Text",
      CellTags->"ii:256"]},
  "ii:257"->{
    Cell[164459, 6686, 582, 18, 93, "Text",
      CellTags->"ii:257"]},
  "ii:258"->{
    Cell[165044, 6706, 626, 26, 93, "Text",
      CellTags->"ii:258"]},
  "ii:260"->{
    Cell[165673, 6734, 422, 14, 74, "Text",
      CellTags->"ii:260"]},
  "ii:261"->{
    Cell[166098, 6750, 157, 6, 36, "Text",
      CellTags->"ii:261"]},
  "ii:381"->{
    Cell[166258, 6758, 995, 36, 131, "Text",
      CellTags->"ii:381"]},
  "ii:262"->{
    Cell[167256, 6796, 903, 32, 131, "Text",
      CellTags->"ii:262"]},
  "ii:263"->{
    Cell[168162, 6830, 485, 20, 36, "Text",
      CellTags->"ii:263"]},
  "ii:264"->{
    Cell[168650, 6852, 460, 17, 74, "Text",
      CellTags->"ii:264"]},
  "ii:265"->{
    Cell[169113, 6871, 453, 19, 69, "Text",
      CellTags->"ii:265"]},
  "ii:267"->{
    Cell[169569, 6892, 1942, 73, 240, "Text",
      CellTags->"ii:267"]},
  "ii:268"->{
    Cell[171514, 6967, 227, 9, 50, "Text",
      CellTags->"ii:268"]},
  "ii:269"->{
    Cell[171744, 6978, 498, 18, 93, "Text",
      CellTags->"ii:269"]},
  "ii:272"->{
    Cell[172245, 6998, 2461, 89, 264, "Text",
      CellTags->"ii:272"]},
  "ii:273"->{
    Cell[174709, 7089, 165, 6, 36, "Text",
      CellTags->"ii:273"]},
  "ii:274"->{
    Cell[175155, 7108, 155, 6, 36, "Text",
      CellTags->"ii:274"]},
  "ii:275"->{
    Cell[175313, 7116, 1191, 45, 169, "Text",
      CellTags->"ii:275"]},
  "ii:276"->{
    Cell[176507, 7163, 365, 15, 36, "Text",
      CellTags->"ii:276"]},
  "ii:2771"->{
    Cell[176875, 7180, 416, 18, 36, "Text",
      CellTags->"ii:2771"]},
  "ii:278"->{
    Cell[177294, 7200, 225, 9, 36, "Text",
      CellTags->"ii:278"]},
  "ii:279"->{
    Cell[177522, 7211, 330, 13, 50, "Text",
      CellTags->"ii:279"]},
  "ii:280"->{
    Cell[177855, 7226, 232, 9, 50, "Text",
      CellTags->"ii:280"]},
  "ii:281"->{
    Cell[178090, 7237, 690, 25, 112, "Text",
      CellTags->"ii:281"]},
  "Q"->{
    Cell[178812, 7266, 231, 9, 36, "Text",
      CellTags->{"Q", "ii:282"}]},
  "ii:282"->{
    Cell[178812, 7266, 231, 9, 36, "Text",
      CellTags->{"Q", "ii:282"}]},
  "R"->{
    Cell[179075, 7279, 468, 17, 55, "Text",
      CellTags->{"R", "ii:283"}]},
  "ii:283"->{
    Cell[179075, 7279, 468, 17, 55, "Text",
      CellTags->{"R", "ii:283"}]},
  "ii:2841"->{
    Cell[179697, 7305, 432, 17, 36, "Text",
      CellTags->"ii:2841"]},
  "ii:285"->{
    Cell[180132, 7324, 1090, 40, 150, "Text",
      CellTags->"ii:285"]},
  "ii:286"->{
    Cell[181225, 7366, 376, 13, 74, "Text",
      CellTags->"ii:286"]},
  "ii:288"->{
    Cell[181604, 7381, 831, 31, 93, "Text",
      CellTags->"ii:288"]},
  "ii:290"->{
    Cell[182438, 7414, 355, 14, 36, "Text",
      CellTags->"ii:290"]},
  "ii:291"->{
    Cell[182796, 7430, 226, 9, 36, "Text",
      CellTags->"ii:291"]},
  "ii:292"->{
    Cell[183025, 7441, 1398, 51, 188, "Text",
      CellTags->"ii:292"]},
  "ii:293"->{
    Cell[184426, 7494, 948, 37, 93, "Text",
      CellTags->"ii:293"]},
  "ii:294"->{
    Cell[185377, 7533, 163, 6, 36, "Text",
      CellTags->"ii:294"]},
  "ii:295"->{
    Cell[185543, 7541, 210, 9, 36, "Text",
      CellTags->"ii:295"]},
  "ii:378"->{
    Cell[185756, 7552, 572, 24, 36, "Text",
      CellTags->"ii:378"]},
  "ii:296"->{
    Cell[186331, 7578, 246, 10, 36, "Text",
      CellTags->"ii:296"]},
  "ii:297"->{
    Cell[186580, 7590, 310, 13, 36, "Text",
      CellTags->"ii:297"]},
  "ii:298"->{
    Cell[187035, 7612, 161, 6, 36, "Text",
      CellTags->"ii:298"]},
  "ii:299"->{
    Cell[187199, 7620, 169, 6, 36, "Text",
      CellTags->"ii:299"]},
  "ii:300"->{
    Cell[187371, 7628, 588, 18, 93, "Text",
      CellTags->"ii:300"]},
  "S"->{
    Cell[188196, 7660, 237, 9, 36, "Text",
      CellTags->{"S", "ii:301"}]},
  "ii:301"->{
    Cell[188196, 7660, 237, 9, 36, "Text",
      CellTags->{"S", "ii:301"}]},
  "ii:302"->{
    Cell[188436, 7671, 163, 6, 36, "Text",
      CellTags->"ii:302"]},
  "ii:310"->{
    Cell[188602, 7679, 177, 6, 36, "Text",
      CellTags->"ii:310"]},
  "ii:311"->{
    Cell[188782, 7687, 1712, 62, 188, "Text",
      CellTags->"ii:311"]},
  "ii:303"->{
    Cell[190497, 7751, 164, 6, 36, "Text",
      CellTags->"ii:303"]},
  "ii:304"->{
    Cell[190850, 7768, 843, 26, 112, "Text",
      CellTags->"ii:304"]},
  "ii:305"->{
    Cell[191696, 7796, 426, 18, 36, "Text",
      CellTags->"ii:305"]},
  "ii:306"->{
    Cell[192125, 7816, 329, 13, 36, "Text",
      CellTags->"ii:306"]},
  "ii:380"->{
    Cell[192457, 7831, 159, 6, 36, "Text",
      CellTags->"ii:380"]},
  "ii:307"->{
    Cell[192619, 7839, 221, 9, 36, "Text",
      CellTags->"ii:307"]},
  "ii:368"->{
    Cell[192843, 7850, 597, 24, 74, "Text",
      CellTags->"ii:368"]},
  "ii:308"->{
    Cell[193443, 7876, 537, 18, 74, "Text",
      CellTags->"ii:308"]},
  "ii:309"->{
    Cell[193983, 7896, 320, 13, 36, "Text",
      CellTags->"ii:309"]},
  "ii:312"->{
    Cell[194306, 7911, 224, 9, 36, "Text",
      CellTags->"ii:312"]},
  "ii:313"->{
    Cell[194533, 7922, 172, 6, 36, "Text",
      CellTags->"ii:313"]},
  "ii:314"->{
    Cell[195317, 7960, 160, 6, 36, "Text",
      CellTags->"ii:314"]},
  "ii:315"->{
    Cell[195619, 7975, 259, 10, 36, "Text",
      CellTags->"ii:315"]},
  "ii:316"->{
    Cell[195881, 7987, 725, 29, 55, "Text",
      CellTags->"ii:316"]},
  "ii:317"->{
    Cell[196609, 8018, 495, 18, 74, "Text",
      CellTags->"ii:317"]},
  "ii:318"->{
    Cell[197107, 8038, 1106, 41, 150, "Text",
      CellTags->"ii:318"]},
  "ii:319"->{
    Cell[198216, 8081, 222, 9, 36, "Text",
      CellTags->"ii:319"]},
  "ii:320"->{
    Cell[198441, 8092, 886, 35, 93, "Text",
      CellTags->"ii:320"]},
  "ii:321"->{
    Cell[199330, 8129, 167, 6, 36, "Text",
      CellTags->"ii:321"]},
  "ii:322"->{
    Cell[199500, 8137, 422, 14, 74, "Text",
      CellTags->"ii:322"]},
  "ii:377"->{
    Cell[199925, 8153, 299, 12, 55, "Text",
      CellTags->"ii:377"]},
  "ii:323"->{
    Cell[200227, 8167, 431, 17, 36, "Text",
      CellTags->"ii:323"]},
  "ii:324"->{
    Cell[200661, 8186, 484, 17, 76, "Text",
      CellTags->"ii:324"]},
  "ii:325"->{
    Cell[201148, 8205, 232, 9, 36, "Text",
      CellTags->"ii:325"]},
  "ii:390"->{
    Cell[201383, 8216, 581, 23, 55, "Text",
      CellTags->"ii:390"]},
  "ii:382"->{
    Cell[201967, 8241, 227, 9, 36, "Text",
      CellTags->"ii:382"]},
  "ii:326"->{
    Cell[202598, 8269, 171, 6, 36, "Text",
      CellTags->"ii:326"]},
  "ii:327"->{
    Cell[202914, 8284, 172, 6, 36, "Text",
      CellTags->"ii:327"]},
  "ii:328"->{
    Cell[203226, 8299, 165, 6, 36, "Text",
      CellTags->"ii:328"]},
  "ii:329"->{
    Cell[203394, 8307, 263, 10, 36, "Text",
      CellTags->"ii:329"]},
  "ii:330"->{
    Cell[203660, 8319, 162, 6, 36, "Text",
      CellTags->"ii:330"]},
  "ii:331"->{
    Cell[203825, 8327, 427, 17, 36, "Text",
      CellTags->"ii:331"]},
  "ii:332"->{
    Cell[204255, 8346, 466, 18, 36, "Text",
      CellTags->"ii:332"]},
  "T"->{
    Cell[204753, 8368, 228, 9, 36, "Text",
      CellTags->{"T", "ii:333"}]},
  "ii:333"->{
    Cell[204753, 8368, 228, 9, 36, "Text",
      CellTags->{"T", "ii:333"}]},
  "ii:334"->{
    Cell[204984, 8379, 317, 12, 74, "Text",
      CellTags->"ii:334"]},
  "ii:336"->{
    Cell[205304, 8393, 163, 6, 36, "Text",
      CellTags->"ii:336"]},
  "ii:337"->{
    Cell[205470, 8401, 153, 6, 36, "Text",
      CellTags->"ii:337"]},
  "ii:338"->{
    Cell[205626, 8409, 579, 21, 74, "Text",
      CellTags->"ii:338"]},
  "ii:339"->{
    Cell[206208, 8432, 166, 6, 36, "Text",
      CellTags->"ii:339"]},
  "ii:340"->{
    Cell[206377, 8440, 617, 24, 74, "Text",
      CellTags->"ii:340"]},
  "ii:341"->{
    Cell[206997, 8466, 165, 6, 36, "Text",
      CellTags->"ii:341"]},
  "ii:342"->{
    Cell[207165, 8474, 211, 8, 36, "Text",
      CellTags->"ii:342"]},
  "ii:386"->{
    Cell[207835, 8507, 422, 17, 55, "Text",
      CellTags->"ii:386"]},
  "ii:343"->{
    Cell[208463, 8536, 168, 6, 36, "Text",
      CellTags->"ii:343"]},
  "ii:344"->{
    Cell[208634, 8544, 213, 9, 36, "Text",
      CellTags->"ii:344"]},
  "ii:345"->{
    Cell[208850, 8555, 225, 9, 36, "Text",
      CellTags->"ii:345"]},
  "ii:346"->{
    Cell[209411, 8582, 158, 6, 36, "Text",
      CellTags->"ii:346"]},
  "ii:347"->{
    Cell[209572, 8590, 168, 6, 36, "Text",
      CellTags->"ii:347"]},
  "ii:348"->{
    Cell[209743, 8598, 679, 22, 112, "Text",
      CellTags->"ii:348"]},
  "U"->{
    Cell[210454, 8624, 542, 21, 55, "Text",
      CellTags->{"U", "ii:349"}]},
  "ii:349"->{
    Cell[210454, 8624, 542, 21, 55, "Text",
      CellTags->{"U", "ii:349"}]},
  "ii:351"->{
    Cell[211323, 8662, 322, 13, 36, "Text",
      CellTags->"ii:351"]},
  "ii:352"->{
    Cell[211648, 8677, 329, 13, 36, "Text",
      CellTags->"ii:352"]},
  "V"->{
    Cell[212009, 8694, 240, 9, 36, "Text",
      CellTags->{"V", "ii:353"}]},
  "ii:353"->{
    Cell[212009, 8694, 240, 9, 36, "Text",
      CellTags->{"V", "ii:353"}]},
  "ii:354"->{
    Cell[212923, 8731, 1526, 60, 207, "Text",
      CellTags->"ii:354"]},
  "ii:355"->{
    Cell[214452, 8793, 156, 6, 36, "Text",
      CellTags->"ii:355"]},
  "ii:356"->{
    Cell[214611, 8801, 227, 9, 36, "Text",
      CellTags->"ii:356"]},
  "ii:357"->{
    Cell[214841, 8812, 507, 18, 93, "Text",
      CellTags->"ii:357"]},
  "ii:359"->{
    Cell[215351, 8832, 180, 6, 36, "Text",
      CellTags->"ii:359"]},
  "W"->{
    Cell[215563, 8842, 584, 18, 112, "Text",
      CellTags->{"W", "ii:360"}]},
  "ii:360"->{
    Cell[215563, 8842, 584, 18, 112, "Text",
      CellTags->{"W", "ii:360"}]},
  "ii:361"->{
    Cell[216150, 8862, 326, 10, 74, "Text",
      CellTags->"ii:361"]},
  "ii:362"->{
    Cell[216479, 8874, 3187, 118, 340, "Text",
      CellTags->"ii:362"]},
  "ii:363"->{
    Cell[219669, 8994, 554, 21, 55, "Text",
      CellTags->"ii:363"]},
  "ii:364"->{
    Cell[220226, 9017, 157, 6, 36, "Text",
      CellTags->"ii:364"]},
  "ii:365"->{
    Cell[220386, 9025, 2747, 98, 359, "Text",
      CellTags->"ii:365"]},
  "ii:366"->{
    Cell[223136, 9125, 1059, 40, 112, "Text",
      CellTags->"ii:366"]},
  "ii:367"->{
    Cell[224198, 9167, 4443, 175, 435, "Text",
      CellTags->"ii:367"]},
  "ii:369"->{
    Cell[228644, 9344, 158, 6, 36, "Text",
      CellTags->"ii:369"]},
  "ii:370"->{
    Cell[228805, 9352, 332, 13, 36, "Text",
      CellTags->"ii:370"]},
  "ii:371"->{
    Cell[229140, 9367, 156, 6, 36, "Text",
      CellTags->"ii:371"]},
  "ii:372"->{
    Cell[229299, 9375, 299, 10, 55, "Text",
      CellTags->"ii:372"]},
  "ii:373"->{
    Cell[229601, 9387, 156, 6, 36, "Text",
      CellTags->"ii:373"]},
  "ii:374"->{
    Cell[229760, 9395, 2311, 82, 283, "Text",
      CellTags->"ii:374"]},
  "ii:375"->{
    Cell[232485, 9497, 255, 10, 36, "Text",
      CellTags->"ii:375"]},
  "Z"->{
    Cell[232772, 9511, 178, 6, 36, "Text",
      CellTags->{"Z", "ii:376"}]},
  "ii:376"->{
    Cell[232772, 9511, 178, 6, 36, "Text",
      CellTags->{"Z", "ii:376"}]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"ii:3", 271462, 10833},
  {"ii:385", 271542, 10836},
  {"ii:388", 271624, 10839},
  {"ii:4", 271704, 10842},
  {"ii:7", 271782, 10845},
  {"ii:5", 271860, 10848},
  {"ii:6", 271938, 10851},
  {"ii:9", 272016, 10854},
  {"ii:8", 272094, 10857},
  {"ii:10", 272173, 10860},
  {"ii:11", 272254, 10863},
  {"ii:12", 272335, 10866},
  {"ii:13", 272415, 10869},
  {"ii:14", 272495, 10872},
  {"A", 272571, 10875},
  {"ii:15", 272660, 10878},
  {"ii:16", 272749, 10881},
  {"ii:17", 272830, 10884},
  {"ii:18", 272912, 10887},
  {"ii:19", 272994, 10890},
  {"ii:20", 273075, 10893},
  {"ii:21", 273156, 10896},
  {"ii:22", 273238, 10899},
  {"ii:23", 273320, 10902},
  {"ii:25", 273402, 10905},
  {"ii:26", 273484, 10908},
  {"ii:27", 273565, 10911},
  {"ii:28", 273646, 10914},
  {"ii:29", 273727, 10917},
  {"B", 273807, 10920},
  {"ii:30", 273895, 10923},
  {"ii:31", 273983, 10926},
  {"ii:32", 274065, 10929},
  {"ii:33", 274147, 10932},
  {"ii:34", 274228, 10935},
  {"ii:36", 274310, 10938},
  {"ii:37", 274394, 10941},
  {"ii:38", 274476, 10944},
  {"ii:39", 274558, 10947},
  {"ii:40", 274640, 10950},
  {"ii:41", 274721, 10953},
  {"ii:42", 274803, 10956},
  {"ii:43", 274885, 10959},
  {"ii:44", 274966, 10962},
  {"ii:45", 275048, 10965},
  {"ii:46", 275133, 10968},
  {"ii:47", 275218, 10971},
  {"ii:48", 275300, 10974},
  {"ii:49", 275382, 10977},
  {"ii:50", 275465, 10980},
  {"ii:51", 275547, 10983},
  {"C", 275626, 10986},
  {"ii:52", 275715, 10989},
  {"ii:53", 275804, 10992},
  {"ii:54", 275886, 10995},
  {"ii:55", 275968, 10998},
  {"ii:56", 276051, 11001},
  {"ii:57", 276134, 11004},
  {"ii:58", 276218, 11007},
  {"ii:59", 276300, 11010},
  {"ii:60", 276382, 11013},
  {"ii:379", 276465, 11016},
  {"ii:61", 276549, 11019},
  {"ii:62", 276631, 11022},
  {"ii:63", 276713, 11025},
  {"ii:64", 276796, 11028},
  {"ii:65", 276879, 11031},
  {"ii:66", 276962, 11034},
  {"ii:67", 277045, 11037},
  {"ii:68", 277127, 11040},
  {"ii:69", 277211, 11043},
  {"ii:70", 277294, 11046},
  {"ii:71", 277376, 11049},
  {"D", 277455, 11052},
  {"ii:73", 277544, 11055},
  {"ii:387", 277634, 11058},
  {"ii:74", 277719, 11061},
  {"ii:75", 277802, 11064},
  {"ii:76", 277886, 11067},
  {"ii:383", 277969, 11070},
  {"ii:77", 278052, 11073},
  {"ii:78", 278134, 11076},
  {"ii:79", 278216, 11079},
  {"ii:80", 278299, 11082},
  {"ii:81", 278384, 11085},
  {"ii:82", 278469, 11088},
  {"ii:83", 278551, 11091},
  {"ii:84", 278633, 11094},
  {"ii:85", 278718, 11097},
  {"ii:284", 278804, 11100},
  {"ii:86", 278888, 11103},
  {"ii:87", 278972, 11106},
  {"ii:88", 279054, 11109},
  {"ii:89", 279136, 11112},
  {"ii:90", 279219, 11115},
  {"ii:91", 279302, 11118},
  {"ii:92", 279387, 11121},
  {"ii:93", 279471, 11124},
  {"ii:94", 279553, 11127},
  {"ii:95", 279636, 11130},
  {"ii:96", 279718, 11133},
  {"ii:97", 279801, 11136},
  {"E", 279879, 11139},
  {"ii:98", 279969, 11142},
  {"ii:99", 280059, 11145},
  {"ii:100", 280143, 11148},
  {"ii:101", 280231, 11151},
  {"ii:102", 280318, 11154},
  {"ii:103", 280403, 11157},
  {"ii:104", 280488, 11160},
  {"ii:105", 280573, 11163},
  {"ii:107", 280658, 11166},
  {"ii:108", 280742, 11169},
  {"ii:109", 280826, 11172},
  {"ii:110", 280913, 11175},
  {"ii:111", 280997, 11178},
  {"ii:112", 281081, 11181},
  {"ii:113", 281167, 11184},
  {"ii:115", 281254, 11187},
  {"ii:116", 281339, 11190},
  {"ii:117", 281423, 11193},
  {"ii:118", 281507, 11196},
  {"ii:119", 281592, 11199},
  {"F", 281671, 11202},
  {"ii:120", 281762, 11205},
  {"ii:121", 281853, 11208},
  {"ii:122", 281937, 11211},
  {"ii:123", 282021, 11214},
  {"ii:124", 282107, 11217},
  {"ii:125", 282192, 11220},
  {"ii:126", 282277, 11223},
  {"ii:277", 282361, 11226},
  {"ii:127", 282446, 11229},
  {"ii:128", 282530, 11232},
  {"ii:129", 282615, 11235},
  {"ii:130", 282700, 11238},
  {"ii:131", 282785, 11241},
  {"ii:132", 282871, 11244},
  {"ii:133", 282958, 11247},
  {"ii:134", 283042, 11250},
  {"ii:137", 283128, 11253},
  {"ii:135", 283213, 11256},
  {"ii:138", 283297, 11259},
  {"ii:139", 283382, 11262},
  {"ii:140", 283469, 11265},
  {"ii:141", 283553, 11268},
  {"ii:142", 283639, 11271},
  {"ii:143", 283723, 11274},
  {"ii:144", 283807, 11277},
  {"ii:145", 283895, 11280},
  {"G", 283974, 11283},
  {"ii:146", 284065, 11286},
  {"ii:147", 284156, 11289},
  {"ii:148", 284243, 11292},
  {"ii:149", 284327, 11295},
  {"ii:150", 284412, 11298},
  {"ii:151", 284499, 11301},
  {"ii:153", 284584, 11304},
  {"ii:154", 284668, 11307},
  {"ii:155", 284752, 11310},
  {"ii:156", 284836, 11313},
  {"ii:157", 284921, 11316},
  {"ii:158", 285005, 11319},
  {"ii:159", 285092, 11322},
  {"ii:160", 285181, 11325},
  {"H", 285263, 11328},
  {"ii:161", 285357, 11331},
  {"ii:162", 285451, 11334},
  {"ii:163", 285536, 11337},
  {"ii:164", 285622, 11340},
  {"ii:166", 285711, 11343},
  {"ii:167", 285796, 11346},
  {"ii:168", 285882, 11349},
  {"ii:169", 285968, 11352},
  {"ii:170", 286054, 11355},
  {"ii:171", 286139, 11358},
  {"ii:172", 286225, 11361},
  {"ii:173", 286312, 11364},
  {"I", 286392, 11367},
  {"ii:174", 286485, 11370},
  {"ii:175", 286578, 11373},
  {"ii:177", 286663, 11376},
  {"ii:178", 286749, 11379},
  {"ii:179", 286835, 11382},
  {"ii:180", 286921, 11385},
  {"ii:182", 287006, 11388},
  {"ii:184", 287092, 11391},
  {"ii:185", 287178, 11394},
  {"ii:186", 287264, 11397},
  {"ii:187", 287349, 11400},
  {"ii:188", 287434, 11403},
  {"ii:189", 287520, 11406},
  {"J", 287600, 11409},
  {"ii:190", 287692, 11412},
  {"ii:191", 287784, 11415},
  {"K", 287864, 11418},
  {"ii:192", 287958, 11421},
  {"ii:193", 288052, 11424},
  {"ii:194", 288137, 11427},
  {"ii:195", 288223, 11430},
  {"L", 288303, 11433},
  {"ii:196", 288396, 11436},
  {"ii:197", 288489, 11439},
  {"ii:198", 288575, 11442},
  {"ii:199", 288660, 11445},
  {"ii:200", 288748, 11448},
  {"ii:201", 288836, 11451},
  {"ii:350", 288921, 11454},
  {"ii:203", 289007, 11457},
  {"ii:204", 289092, 11460},
  {"ii:205", 289177, 11463},
  {"ii:206", 289265, 11466},
  {"ii:207", 289350, 11469},
  {"ii:208", 289436, 11472},
  {"ii:209", 289521, 11475},
  {"ii:211", 289608, 11478},
  {"ii:212", 289694, 11481},
  {"M", 289775, 11484},
  {"ii:214", 289867, 11487},
  {"ii:215", 289959, 11490},
  {"ii:216", 290044, 11493},
  {"ii:217", 290129, 11496},
  {"ii:218", 290214, 11499},
  {"ii:219", 290301, 11502},
  {"ii:220", 290386, 11505},
  {"ii:221", 290472, 11508},
  {"ii:222", 290557, 11511},
  {"ii:223", 290642, 11514},
  {"ii:224", 290727, 11517},
  {"ii:225", 290813, 11520},
  {"ii:227", 290899, 11523},
  {"ii:228", 290985, 11526},
  {"ii:229", 291070, 11529},
  {"ii:230", 291156, 11532},
  {"ii:231", 291243, 11535},
  {"ii:232", 291329, 11538},
  {"N", 291410, 11541},
  {"ii:233", 291502, 11544},
  {"ii:234", 291594, 11547},
  {"ii:235", 291679, 11550},
  {"ii:236", 291765, 11553},
  {"ii:1", 291848, 11556},
  {"ii:237", 291932, 11559},
  {"ii:238", 292018, 11562},
  {"ii:239", 292103, 11565},
  {"ii:240", 292188, 11568},
  {"ii:241", 292274, 11571},
  {"ii:242", 292359, 11574},
  {"ii:243", 292444, 11577},
  {"ii:181", 292529, 11580},
  {"ii:244", 292616, 11583},
  {"ii:245", 292704, 11586},
  {"O", 292787, 11589},
  {"ii:389", 292879, 11592},
  {"ii:246", 292971, 11595},
  {"ii:247", 293057, 11598},
  {"ii:248", 293146, 11601},
  {"ii:249", 293234, 11604},
  {"P", 293316, 11607},
  {"ii:250", 293408, 11610},
  {"ii:251", 293500, 11613},
  {"ii:252", 293586, 11616},
  {"ii:253", 293675, 11619},
  {"ii:254", 293761, 11622},
  {"ii:255", 293846, 11625},
  {"ii:256", 293932, 11628},
  {"ii:257", 294018, 11631},
  {"ii:258", 294104, 11634},
  {"ii:260", 294190, 11637},
  {"ii:261", 294276, 11640},
  {"ii:381", 294361, 11643},
  {"ii:262", 294448, 11646},
  {"ii:263", 294535, 11649},
  {"ii:264", 294621, 11652},
  {"ii:265", 294707, 11655},
  {"ii:267", 294793, 11658},
  {"ii:268", 294881, 11661},
  {"ii:269", 294966, 11664},
  {"ii:272", 295052, 11667},
  {"ii:273", 295140, 11670},
  {"ii:274", 295225, 11673},
  {"ii:275", 295310, 11676},
  {"ii:276", 295398, 11679},
  {"ii:2771", 295485, 11682},
  {"ii:278", 295572, 11685},
  {"ii:279", 295657, 11688},
  {"ii:280", 295743, 11691},
  {"ii:281", 295828, 11694},
  {"Q", 295910, 11697},
  {"ii:282", 296002, 11700},
  {"R", 296089, 11703},
  {"ii:283", 296182, 11706},
  {"ii:2841", 296276, 11709},
  {"ii:285", 296363, 11712},
  {"ii:286", 296451, 11715},
  {"ii:288", 296537, 11718},
  {"ii:290", 296623, 11721},
  {"ii:291", 296709, 11724},
  {"ii:292", 296794, 11727},
  {"ii:293", 296882, 11730},
  {"ii:294", 296968, 11733},
  {"ii:295", 297053, 11736},
  {"ii:378", 297138, 11739},
  {"ii:296", 297224, 11742},
  {"ii:297", 297310, 11745},
  {"ii:298", 297396, 11748},
  {"ii:299", 297481, 11751},
  {"ii:300", 297566, 11754},
  {"S", 297647, 11757},
  {"ii:301", 297739, 11760},
  {"ii:302", 297831, 11763},
  {"ii:310", 297916, 11766},
  {"ii:311", 298001, 11769},
  {"ii:303", 298089, 11772},
  {"ii:304", 298174, 11775},
  {"ii:305", 298261, 11778},
  {"ii:306", 298347, 11781},
  {"ii:380", 298433, 11784},
  {"ii:307", 298518, 11787},
  {"ii:368", 298603, 11790},
  {"ii:308", 298689, 11793},
  {"ii:309", 298775, 11796},
  {"ii:312", 298861, 11799},
  {"ii:313", 298946, 11802},
  {"ii:314", 299031, 11805},
  {"ii:315", 299116, 11808},
  {"ii:316", 299202, 11811},
  {"ii:317", 299288, 11814},
  {"ii:318", 299374, 11817},
  {"ii:319", 299462, 11820},
  {"ii:320", 299547, 11823},
  {"ii:321", 299633, 11826},
  {"ii:322", 299718, 11829},
  {"ii:377", 299804, 11832},
  {"ii:323", 299890, 11835},
  {"ii:324", 299976, 11838},
  {"ii:325", 300062, 11841},
  {"ii:390", 300147, 11844},
  {"ii:382", 300233, 11847},
  {"ii:326", 300318, 11850},
  {"ii:327", 300403, 11853},
  {"ii:328", 300488, 11856},
  {"ii:329", 300573, 11859},
  {"ii:330", 300659, 11862},
  {"ii:331", 300744, 11865},
  {"ii:332", 300830, 11868},
  {"T", 300911, 11871},
  {"ii:333", 301003, 11874},
  {"ii:334", 301095, 11877},
  {"ii:336", 301181, 11880},
  {"ii:337", 301266, 11883},
  {"ii:338", 301351, 11886},
  {"ii:339", 301437, 11889},
  {"ii:340", 301522, 11892},
  {"ii:341", 301608, 11895},
  {"ii:342", 301693, 11898},
  {"ii:386", 301778, 11901},
  {"ii:343", 301864, 11904},
  {"ii:344", 301949, 11907},
  {"ii:345", 302034, 11910},
  {"ii:346", 302119, 11913},
  {"ii:347", 302204, 11916},
  {"ii:348", 302289, 11919},
  {"U", 302371, 11922},
  {"ii:349", 302464, 11925},
  {"ii:351", 302557, 11928},
  {"ii:352", 302643, 11931},
  {"V", 302724, 11934},
  {"ii:353", 302816, 11937},
  {"ii:354", 302908, 11940},
  {"ii:355", 302996, 11943},
  {"ii:356", 303081, 11946},
  {"ii:357", 303166, 11949},
  {"ii:359", 303252, 11952},
  {"W", 303332, 11955},
  {"ii:360", 303426, 11958},
  {"ii:361", 303520, 11961},
  {"ii:362", 303606, 11964},
  {"ii:363", 303695, 11967},
  {"ii:364", 303781, 11970},
  {"ii:365", 303866, 11973},
  {"ii:366", 303954, 11976},
  {"ii:367", 304042, 11979},
  {"ii:369", 304131, 11982},
  {"ii:370", 304216, 11985},
  {"ii:371", 304302, 11988},
  {"ii:372", 304387, 11991},
  {"ii:373", 304473, 11994},
  {"ii:374", 304558, 11997},
  {"ii:375", 304646, 12000},
  {"Z", 304727, 12003},
  {"ii:376", 304819, 12006}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1727, 52, 50, 1, 77, "Subtitle"],
Cell[1780, 55, 142, 3, 55, "Text"],
Cell[1925, 60, 3244, 145, 104, "Text"],
Cell[5172, 207, 194, 6, 36, "Text",
  CellTags->"ii:3"],
Cell[5369, 215, 250, 8, 36, "Text",
  CellTags->"ii:385"],
Cell[5622, 225, 143, 5, 36, "Text"],
Cell[5768, 232, 196, 6, 36, "Text",
  CellTags->"ii:388"],
Cell[5967, 240, 210, 7, 36, "Text",
  CellTags->"ii:4"],
Cell[6180, 249, 182, 6, 36, "Text",
  CellTags->"ii:7"],
Cell[6365, 257, 204, 6, 36, "Text",
  CellTags->"ii:5"],
Cell[6572, 265, 193, 6, 36, "Text",
  CellTags->"ii:6"],
Cell[6768, 273, 481, 17, 55, "Text"],
Cell[7252, 292, 143, 5, 36, "Text"],
Cell[7398, 299, 168, 6, 36, "Text",
  CellTags->"ii:9"],
Cell[7569, 307, 192, 6, 36, "Text",
  CellTags->"ii:8"],
Cell[7764, 315, 154, 5, 36, "Text"],
Cell[7921, 322, 457, 11, 36, "Text",
  CellTags->"ii:10"],
Cell[8381, 335, 633, 26, 36, "Text",
  CellTags->"ii:11"],
Cell[9017, 363, 181, 6, 36, "Text",
  CellTags->"ii:12"],
Cell[9201, 371, 174, 6, 36, "Text",
  CellTags->"ii:13"],
Cell[9378, 379, 162, 6, 36, "Text",
  CellTags->"ii:14"],
Cell[9543, 387, 208, 8, 36, "Text"],
Cell[9754, 397, 260, 11, 36, "Text"],
Cell[10017, 410, 201, 8, 36, "Text"],
Cell[10221, 420, 26, 0, 33, "Input"],
Cell[10250, 422, 314, 13, 36, "Text",
  CellTags->{"A", "ii:15"}],
Cell[10567, 437, 163, 6, 36, "Text",
  CellTags->"ii:16"],
Cell[10733, 445, 328, 13, 36, "Text",
  CellTags->"ii:17"],
Cell[11064, 460, 401, 17, 36, "Text",
  CellTags->"ii:18"],
Cell[11468, 479, 227, 9, 36, "Text",
  CellTags->"ii:19"],
Cell[11698, 490, 168, 6, 36, "Text",
  CellTags->"ii:20"],
Cell[11869, 498, 438, 17, 55, "Text",
  CellTags->"ii:21"],
Cell[12310, 517, 371, 16, 36, "Text"],
Cell[12684, 535, 309, 13, 36, "Text",
  CellTags->"ii:22"],
Cell[12996, 550, 524, 18, 74, "Text",
  CellTags->"ii:23"],
Cell[13523, 570, 150, 6, 36, "Text"],
Cell[13676, 578, 134, 5, 36, "Text"],
Cell[13813, 585, 207, 8, 36, "Text"],
Cell[14023, 595, 278, 10, 55, "Text",
  CellTags->"ii:25"],
Cell[14304, 607, 158, 6, 36, "Text",
  CellTags->"ii:26"],
Cell[14465, 615, 207, 9, 36, "Text"],
Cell[14675, 626, 171, 6, 36, "Text",
  CellTags->"ii:27"],
Cell[14849, 634, 180, 7, 36, "Text",
  CellTags->"ii:28"],
Cell[15032, 643, 376, 15, 36, "Text"],
Cell[15411, 660, 147, 5, 36, "Text"],
Cell[15561, 667, 1454, 50, 188, "Text",
  CellTags->"ii:29"],
Cell[17018, 719, 26, 0, 33, "Input"],
Cell[17047, 721, 241, 9, 36, "Text",
  CellTags->{"B", "ii:30"}],
Cell[17291, 732, 412, 14, 74, "Text",
  CellTags->"ii:31"],
Cell[17706, 748, 805, 29, 93, "Text",
  CellTags->"ii:32"],
Cell[18514, 779, 130, 5, 36, "Text"],
Cell[18647, 786, 161, 6, 36, "Text",
  CellTags->"ii:33"],
Cell[18811, 794, 277, 10, 74, "Text",
  CellTags->"ii:34"],
Cell[19091, 806, 1493, 49, 228, "Text",
  CellTags->"ii:36"],
Cell[20587, 857, 305, 13, 36, "Text",
  CellTags->"ii:37"],
Cell[20895, 872, 305, 13, 36, "Text",
  CellTags->"ii:38"],
Cell[21203, 887, 315, 13, 36, "Text",
  CellTags->"ii:39"],
Cell[21521, 902, 163, 6, 36, "Text",
  CellTags->"ii:40"],
Cell[21687, 910, 254, 10, 36, "Text",
  CellTags->"ii:41"],
Cell[21944, 922, 184, 7, 36, "Text"],
Cell[22131, 931, 252, 9, 74, "Text"],
Cell[22386, 942, 435, 14, 93, "Text",
  CellTags->"ii:42"],
Cell[22824, 958, 162, 6, 36, "Text",
  CellTags->"ii:43"],
Cell[22989, 966, 545, 21, 36, "Text",
  CellTags->"ii:44"],
Cell[23537, 989, 3328, 124, 302, "Text",
  CellTags->"ii:45"],
Cell[26868, 1115, 1854, 64, 188, "Text",
  CellTags->"ii:46"],
Cell[28725, 1181, 149, 6, 36, "Text",
  CellTags->"ii:47"],
Cell[28877, 1189, 209, 8, 36, "Text"],
Cell[29089, 1199, 170, 6, 36, "Text",
  CellTags->"ii:48"],
Cell[29262, 1207, 274, 10, 55, "Text",
  CellTags->"ii:49"],
Cell[29539, 1219, 159, 6, 36, "Text",
  CellTags->"ii:50"],
Cell[29701, 1227, 292, 11, 55, "Text",
  CellTags->"ii:51"],
Cell[29996, 1240, 26, 0, 33, "Input"],
Cell[30025, 1242, 176, 6, 36, "Text",
  CellTags->{"C", "ii:52"}],
Cell[30204, 1250, 154, 6, 36, "Text",
  CellTags->"ii:53"],
Cell[30361, 1258, 136, 5, 36, "Text"],
Cell[30500, 1265, 149, 6, 36, "Text",
  CellTags->"ii:54"],
Cell[30652, 1273, 608, 23, 74, "Text",
  CellTags->"ii:55"],
Cell[31263, 1298, 721, 29, 55, "Text",
  CellTags->"ii:56"],
Cell[31987, 1329, 567, 18, 112, "Text",
  CellTags->"ii:57"],
Cell[32557, 1349, 167, 6, 36, "Text",
  CellTags->"ii:58"],
Cell[32727, 1357, 168, 6, 36, "Text",
  CellTags->"ii:59"],
Cell[32898, 1365, 163, 6, 36, "Text",
  CellTags->"ii:60"],
Cell[33064, 1373, 572, 24, 36, "Text",
  CellTags->"ii:379"],
Cell[33639, 1399, 184, 6, 36, "Text",
  CellTags->"ii:61"],
Cell[33826, 1407, 181, 8, 36, "Text"],
Cell[34010, 1417, 166, 6, 36, "Text",
  CellTags->"ii:62"],
Cell[34179, 1425, 404, 17, 36, "Text",
  CellTags->"ii:63"],
Cell[34586, 1444, 527, 18, 93, "Text",
  CellTags->"ii:64"],
Cell[35116, 1464, 571, 21, 74, "Text",
  CellTags->"ii:65"],
Cell[35690, 1487, 545, 21, 93, "Text",
  CellTags->"ii:66"],
Cell[36238, 1510, 165, 6, 36, "Text",
  CellTags->"ii:67"],
Cell[36406, 1518, 513, 18, 112, "Text",
  CellTags->"ii:68"],
Cell[36922, 1538, 335, 13, 74, "Text",
  CellTags->"ii:69"],
Cell[37260, 1553, 163, 6, 36, "Text",
  CellTags->"ii:70"],
Cell[37426, 1561, 137, 5, 36, "Text"],
Cell[37566, 1568, 630, 24, 93, "Text",
  CellTags->"ii:71"],
Cell[38199, 1594, 185, 7, 36, "Text"],
Cell[38387, 1603, 175, 7, 36, "Text"],
Cell[38565, 1612, 309, 12, 74, "Text"],
Cell[38877, 1626, 26, 0, 33, "Input"],
Cell[38906, 1628, 223, 9, 36, "Text",
  CellTags->{"D", "ii:73"}],
Cell[39132, 1639, 148, 6, 36, "Text"],
Cell[39283, 1647, 739, 24, 131, "Text",
  CellTags->"ii:387"],
Cell[40025, 1673, 355, 14, 36, "Text",
  CellTags->"ii:74"],
Cell[40383, 1689, 921, 34, 131, "Text",
  CellTags->"ii:75"],
Cell[41307, 1725, 158, 6, 36, "Text",
  CellTags->"ii:76"],
Cell[41468, 1733, 155, 6, 36, "Text",
  CellTags->"ii:383"],
Cell[41626, 1741, 159, 6, 36, "Text",
  CellTags->"ii:77"],
Cell[41788, 1749, 224, 9, 36, "Text",
  CellTags->"ii:78"],
Cell[42015, 1760, 491, 18, 93, "Text",
  CellTags->"ii:79"],
Cell[42509, 1780, 1254, 47, 169, "Text",
  CellTags->"ii:80"],
Cell[43766, 1829, 1009, 38, 131, "Text",
  CellTags->"ii:81"],
Cell[44778, 1869, 218, 9, 36, "Text",
  CellTags->"ii:82"],
Cell[44999, 1880, 164, 6, 36, "Text",
  CellTags->"ii:83"],
Cell[45166, 1888, 1239, 46, 169, "Text",
  CellTags->"ii:84"],
Cell[46408, 1936, 1638, 60, 207, "Text",
  CellTags->"ii:85"],
Cell[48049, 1998, 261, 10, 36, "Text",
  CellTags->"ii:284"],
Cell[48313, 2010, 914, 36, 112, "Text",
  CellTags->"ii:86"],
Cell[49230, 2048, 223, 9, 36, "Text",
  CellTags->"ii:87"],
Cell[49456, 2059, 137, 5, 36, "Text"],
Cell[49596, 2066, 159, 6, 36, "Text",
  CellTags->"ii:88"],
Cell[49758, 2074, 535, 22, 36, "Text",
  CellTags->"ii:89"],
Cell[50296, 2098, 343, 12, 74, "Text",
  CellTags->"ii:90"],
Cell[50642, 2112, 1012, 34, 150, "Text",
  CellTags->"ii:91"],
Cell[51657, 2148, 1252, 41, 207, "Text"],
Cell[52912, 2191, 983, 37, 169, "Text",
  CellTags->"ii:92"],
Cell[53898, 2230, 215, 9, 36, "Text",
  CellTags->"ii:93"],
Cell[54116, 2241, 262, 10, 36, "Text",
  CellTags->"ii:94"],
Cell[54381, 2253, 159, 6, 36, "Text",
  CellTags->"ii:95"],
Cell[54543, 2261, 309, 13, 36, "Text",
  CellTags->"ii:96"],
Cell[54855, 2276, 218, 9, 36, "Text",
  CellTags->"ii:97"],
Cell[55076, 2287, 26, 0, 33, "Input"],
Cell[55105, 2289, 675, 28, 36, "Text",
  CellTags->{"E", "ii:98"}],
Cell[55783, 2319, 277, 12, 36, "Text"],
Cell[56063, 2333, 267, 10, 36, "Text",
  CellTags->"ii:99"],
Cell[56333, 2345, 182, 8, 36, "Text"],
Cell[56518, 2355, 4253, 142, 589, "Text",
  CellTags->"ii:100"],
Cell[60774, 2499, 1326, 47, 188, "Text",
  CellTags->"ii:101"],
Cell[62103, 2548, 318, 13, 36, "Text",
  CellTags->"ii:102"],
Cell[62424, 2563, 301, 13, 36, "Text",
  CellTags->"ii:103"],
Cell[62728, 2578, 415, 17, 55, "Text",
  CellTags->"ii:104"],
Cell[63146, 2597, 474, 18, 74, "Text",
  CellTags->"ii:105"],
Cell[63623, 2617, 223, 9, 36, "Text",
  CellTags->"ii:107"],
Cell[63849, 2628, 223, 9, 36, "Text",
  CellTags->"ii:108"],
Cell[64075, 2639, 2498, 97, 226, "Text",
  CellTags->"ii:109"],
Cell[66576, 2738, 157, 6, 36, "Text",
  CellTags->"ii:110"],
Cell[66736, 2746, 154, 6, 36, "Text",
  CellTags->"ii:111"],
Cell[66893, 2754, 896, 32, 150, "Text",
  CellTags->"ii:112"],
Cell[67792, 2788, 2444, 84, 264, "Text",
  CellTags->"ii:113"],
Cell[70239, 2874, 191, 8, 36, "Text"],
Cell[70433, 2884, 797, 28, 112, "Text"],
Cell[71233, 2914, 264, 9, 74, "Text"],
Cell[71500, 2925, 938, 37, 74, "Text",
  CellTags->"ii:115"],
Cell[72441, 2964, 288, 12, 36, "Text"],
Cell[72732, 2978, 166, 6, 36, "Text",
  CellTags->"ii:116"],
Cell[72901, 2986, 222, 9, 36, "Text",
  CellTags->"ii:117"],
Cell[73126, 2997, 285, 12, 36, "Text"],
Cell[73414, 3011, 187, 8, 36, "Text"],
Cell[73604, 3021, 429, 17, 36, "Text",
  CellTags->"ii:118"],
Cell[74036, 3040, 173, 6, 36, "Text",
  CellTags->"ii:119"],
Cell[74212, 3048, 195, 8, 36, "Text"],
Cell[74410, 3058, 26, 0, 33, "Input"],
Cell[74439, 3060, 229, 9, 36, "Text",
  CellTags->{"F", "ii:120"}],
Cell[74671, 3071, 164, 6, 36, "Text",
  CellTags->"ii:121"],
Cell[74838, 3079, 160, 6, 36, "Text",
  CellTags->"ii:122"],
Cell[75001, 3087, 213, 8, 36, "Text"],
Cell[75217, 3097, 863, 31, 131, "Text",
  CellTags->"ii:123"],
Cell[76083, 3130, 256, 10, 36, "Text",
  CellTags->"ii:124"],
Cell[76342, 3142, 557, 18, 93, "Text",
  CellTags->"ii:125"],
Cell[76902, 3162, 225, 9, 36, "Text",
  CellTags->"ii:126"],
Cell[77130, 3173, 318, 13, 36, "Text",
  CellTags->"ii:277"],
Cell[77451, 3188, 220, 9, 36, "Text",
  CellTags->"ii:127"],
Cell[77674, 3199, 339, 15, 36, "Text"],
Cell[78016, 3216, 258, 10, 36, "Text",
  CellTags->"ii:128"],
Cell[78277, 3228, 201, 8, 36, "Text"],
Cell[78481, 3238, 293, 13, 36, "Text",
  CellTags->"ii:129"],
Cell[78777, 3253, 360, 16, 74, "Text",
  CellTags->"ii:130"],
Cell[79140, 3271, 901, 29, 150, "Text",
  CellTags->"ii:131"],
Cell[80044, 3302, 1114, 41, 131, "Text",
  CellTags->"ii:132"],
Cell[81161, 3345, 234, 9, 36, "Text",
  CellTags->"ii:133"],
Cell[81398, 3356, 631, 22, 112, "Text",
  CellTags->"ii:134"],
Cell[82032, 3380, 307, 12, 36, "Text",
  CellTags->"ii:137"],
Cell[82342, 3394, 158, 6, 36, "Text",
  CellTags->"ii:135"],
Cell[82503, 3402, 1916, 64, 264, "Text"],
Cell[84422, 3468, 331, 13, 36, "Text",
  CellTags->"ii:138"],
Cell[84756, 3483, 2287, 80, 302, "Text",
  CellTags->"ii:139"],
Cell[87046, 3565, 228, 9, 36, "Text",
  CellTags->"ii:140"],
Cell[87277, 3576, 906, 35, 150, "Text",
  CellTags->"ii:141"],
Cell[88186, 3613, 155, 6, 36, "Text",
  CellTags->"ii:142"],
Cell[88344, 3621, 175, 7, 36, "Text"],
Cell[88522, 3630, 228, 9, 36, "Text",
  CellTags->"ii:143"],
Cell[88753, 3641, 3262, 123, 416, "Text",
  CellTags->"ii:144"],
Cell[92018, 3766, 220, 9, 36, "Text",
  CellTags->"ii:145"],
Cell[92241, 3777, 26, 0, 33, "Input"],
Cell[92270, 3779, 172, 6, 36, "Text",
  CellTags->{"G", "ii:146"}],
Cell[92445, 3787, 1540, 49, 226, "Text",
  CellTags->"ii:147"],
Cell[93988, 3838, 175, 6, 36, "Text",
  CellTags->"ii:148"],
Cell[94166, 3846, 198, 8, 36, "Text"],
Cell[94367, 3856, 257, 10, 36, "Text",
  CellTags->"ii:149"],
Cell[94627, 3868, 1707, 62, 207, "Text",
  CellTags->"ii:150"],
Cell[96337, 3932, 223, 10, 36, "Text"],
Cell[96563, 3944, 637, 25, 93, "Text",
  CellTags->"ii:151"],
Cell[97203, 3971, 163, 6, 36, "Text",
  CellTags->"ii:153"],
Cell[97369, 3979, 165, 6, 36, "Text",
  CellTags->"ii:154"],
Cell[97537, 3987, 171, 6, 36, "Text",
  CellTags->"ii:155"],
Cell[97711, 3995, 295, 10, 55, "Text",
  CellTags->"ii:156"],
Cell[98009, 4007, 160, 6, 36, "Text",
  CellTags->"ii:157"],
Cell[98172, 4015, 2368, 77, 304, "Text",
  CellTags->"ii:158"],
Cell[100543, 4094, 3549, 124, 416, "Text",
  CellTags->"ii:159"],
Cell[104095, 4220, 687, 22, 112, "Text",
  CellTags->"ii:160"],
Cell[104785, 4244, 26, 0, 33, "Input"],
Cell[104814, 4246, 683, 22, 112, "Text",
  CellTags->{"H", "ii:161"}],
Cell[105500, 4270, 167, 6, 36, "Text",
  CellTags->"ii:162"],
Cell[105670, 4278, 653, 25, 93, "Text",
  CellTags->"ii:163"],
Cell[106326, 4305, 2805, 103, 264, "Text",
  CellTags->"ii:164"],
Cell[109134, 4410, 365, 13, 74, "Text"],
Cell[109502, 4425, 169, 6, 36, "Text",
  CellTags->"ii:166"],
Cell[109674, 4433, 263, 10, 36, "Text",
  CellTags->"ii:167"],
Cell[109940, 4445, 879, 33, 93, "Text",
  CellTags->"ii:168"],
Cell[110822, 4480, 199, 8, 36, "Text"],
Cell[111024, 4490, 407, 17, 55, "Text",
  CellTags->"ii:169"],
Cell[111434, 4509, 601, 23, 93, "Text"],
Cell[112038, 4534, 157, 6, 36, "Text",
  CellTags->"ii:170"],
Cell[112198, 4542, 263, 10, 36, "Text",
  CellTags->"ii:171"],
Cell[112464, 4554, 147, 5, 36, "Text"],
Cell[112614, 4561, 760, 30, 112, "Text",
  CellTags->"ii:172"],
Cell[113377, 4593, 154, 6, 36, "Text",
  CellTags->"ii:173"],
Cell[113534, 4601, 26, 0, 33, "Input"],
Cell[113563, 4603, 560, 21, 74, "Text",
  CellTags->{"I", "ii:174"}],
Cell[114126, 4626, 218, 9, 36, "Text",
  CellTags->"ii:175"],
Cell[114347, 4637, 186, 8, 36, "Text"],
Cell[114536, 4647, 609, 26, 36, "Text",
  CellTags->"ii:177"],
Cell[115148, 4675, 293, 11, 36, "Text"],
Cell[115444, 4688, 658, 25, 55, "Text",
  CellTags->"ii:178"],
Cell[116105, 4715, 660, 25, 74, "Text",
  CellTags->"ii:179"],
Cell[116768, 4742, 224, 9, 36, "Text",
  CellTags->"ii:180"],
Cell[116995, 4753, 208, 7, 36, "Text"],
Cell[117206, 4762, 826, 32, 112, "Text"],
Cell[118035, 4796, 433, 18, 36, "Text",
  CellTags->"ii:182"],
Cell[118471, 4816, 279, 11, 36, "Text",
  CellTags->"ii:184"],
Cell[118753, 4829, 817, 31, 93, "Text",
  CellTags->"ii:185"],
Cell[119573, 4862, 234, 9, 36, "Text",
  CellTags->"ii:186"],
Cell[119810, 4873, 223, 9, 36, "Text",
  CellTags->"ii:187"],
Cell[120036, 4884, 285, 10, 55, "Text",
  CellTags->"ii:188"],
Cell[120324, 4896, 238, 9, 36, "Text",
  CellTags->"ii:189"],
Cell[120565, 4907, 26, 0, 33, "Input"],
Cell[120594, 4909, 179, 6, 36, "Text",
  CellTags->{"J", "ii:190"}],
Cell[120776, 4917, 185, 8, 36, "Text"],
Cell[120964, 4927, 372, 13, 74, "Text"],
Cell[121339, 4942, 164, 6, 36, "Text",
  CellTags->"ii:191"],
Cell[121506, 4950, 198, 8, 36, "Text"],
Cell[121707, 4960, 26, 0, 33, "Input"],
Cell[121736, 4962, 758, 28, 112, "Text",
  CellTags->{"K", "ii:192"}],
Cell[122497, 4992, 152, 6, 36, "Text",
  CellTags->"ii:193"],
Cell[122652, 5000, 271, 10, 36, "Text",
  CellTags->"ii:194"],
Cell[122926, 5012, 209, 8, 36, "Text"],
Cell[123138, 5022, 145, 5, 36, "Text"],
Cell[123286, 5029, 197, 8, 36, "Text"],
Cell[123486, 5039, 228, 9, 36, "Text",
  CellTags->"ii:195"],
Cell[123717, 5050, 26, 0, 33, "Input"],
Cell[123746, 5052, 209, 8, 36, "Text"],
Cell[123958, 5062, 339, 12, 74, "Text",
  CellTags->{"L", "ii:196"}],
Cell[124300, 5076, 281, 9, 74, "Text"],
Cell[124584, 5087, 413, 14, 74, "Text",
  CellTags->"ii:197"],
Cell[125000, 5103, 162, 6, 36, "Text",
  CellTags->"ii:198"],
Cell[125165, 5111, 1785, 64, 188, "Text",
  CellTags->"ii:199"],
Cell[126953, 5177, 1021, 33, 152, "Text",
  CellTags->"ii:200"],
Cell[127977, 5212, 181, 8, 36, "Text"],
Cell[128161, 5222, 221, 9, 36, "Text",
  CellTags->"ii:201"],
Cell[128385, 5233, 380, 15, 36, "Text",
  CellTags->"ii:350"],
Cell[128768, 5250, 594, 22, 112, "Text"],
Cell[129365, 5274, 223, 9, 36, "Text",
  CellTags->"ii:203"],
Cell[129591, 5285, 173, 8, 36, "Text"],
Cell[129767, 5295, 162, 6, 36, "Text",
  CellTags->"ii:204"],
Cell[129932, 5303, 2781, 98, 340, "Text",
  CellTags->"ii:205"],
Cell[132716, 5403, 165, 6, 36, "Text",
  CellTags->"ii:206"],
Cell[132884, 5411, 144, 5, 36, "Text"],
Cell[133031, 5418, 419, 17, 36, "Text",
  CellTags->"ii:207"],
Cell[133453, 5437, 217, 8, 36, "Text",
  CellTags->"ii:208"],
Cell[133673, 5447, 730, 26, 112, "Text",
  CellTags->"ii:209"],
Cell[134406, 5475, 371, 14, 36, "Text",
  CellTags->"ii:211"],
Cell[134780, 5491, 202, 8, 36, "Text"],
Cell[134985, 5501, 378, 14, 74, "Text",
  CellTags->"ii:212"],
Cell[135366, 5517, 26, 0, 33, "Input"],
Cell[135395, 5519, 163, 6, 36, "Text",
  CellTags->{"M", "ii:214"}],
Cell[135561, 5527, 165, 6, 36, "Text",
  CellTags->"ii:215"],
Cell[135729, 5535, 158, 6, 36, "Text",
  CellTags->"ii:216"],
Cell[135890, 5543, 220, 9, 36, "Text",
  CellTags->"ii:217"],
Cell[136113, 5554, 910, 29, 169, "Text",
  CellTags->"ii:218"],
Cell[137026, 5585, 170, 6, 36, "Text",
  CellTags->"ii:219"],
Cell[137199, 5593, 266, 10, 36, "Text",
  CellTags->"ii:220"],
Cell[137468, 5605, 218, 9, 36, "Text",
  CellTags->"ii:221"],
Cell[137689, 5616, 160, 6, 36, "Text",
  CellTags->"ii:222"],
Cell[137852, 5624, 169, 6, 36, "Text",
  CellTags->"ii:223"],
Cell[138024, 5632, 208, 8, 36, "Text"],
Cell[138235, 5642, 420, 17, 55, "Text",
  CellTags->"ii:224"],
Cell[138658, 5661, 304, 10, 74, "Text",
  CellTags->"ii:225"],
Cell[138965, 5673, 330, 13, 36, "Text",
  CellTags->"ii:227"],
Cell[139298, 5688, 219, 9, 36, "Text",
  CellTags->"ii:228"],
Cell[139520, 5699, 664, 22, 93, "Text",
  CellTags->"ii:229"],
Cell[140187, 5723, 597, 22, 112, "Text",
  CellTags->"ii:230"],
Cell[140787, 5747, 252, 10, 55, "Text",
  CellTags->"ii:231"],
Cell[141042, 5759, 204, 7, 36, "Text"],
Cell[141249, 5768, 315, 10, 74, "Text",
  CellTags->"ii:232"],
Cell[141567, 5780, 26, 0, 33, "Input"],
Cell[141596, 5782, 224, 9, 36, "Text",
  CellTags->{"N", "ii:233"}],
Cell[141823, 5793, 156, 6, 36, "Text",
  CellTags->"ii:234"],
Cell[141982, 5801, 139, 5, 36, "Text"],
Cell[142124, 5808, 205, 7, 36, "Text"],
Cell[142332, 5817, 530, 21, 74, "Text",
  CellTags->"ii:235"],
Cell[142865, 5840, 161, 6, 36, "Text",
  CellTags->"ii:236"],
Cell[143029, 5848, 276, 10, 36, "Text",
  CellTags->"ii:1"],
Cell[143308, 5860, 434, 18, 36, "Text",
  CellTags->"ii:237"],
Cell[143745, 5880, 159, 6, 36, "Text",
  CellTags->"ii:238"],
Cell[143907, 5888, 208, 8, 36, "Text"],
Cell[144118, 5898, 222, 9, 36, "Text",
  CellTags->"ii:239"],
Cell[144343, 5909, 406, 17, 36, "Text",
  CellTags->"ii:240"],
Cell[144752, 5928, 154, 6, 36, "Text",
  CellTags->"ii:241"],
Cell[144909, 5936, 223, 9, 36, "Text",
  CellTags->"ii:242"],
Cell[145135, 5947, 225, 9, 36, "Text",
  CellTags->"ii:243"],
Cell[145363, 5958, 790, 27, 131, "Text",
  CellTags->"ii:181"],
Cell[146156, 5987, 2548, 92, 283, "Text",
  CellTags->"ii:244"],
Cell[148707, 6081, 1202, 46, 150, "Text",
  CellTags->"ii:245"],
Cell[149912, 6129, 26, 0, 33, "Input"],
Cell[149941, 6131, 185, 6, 36, "Text",
  CellTags->{"O", "ii:389"}],
Cell[150129, 6139, 751, 30, 93, "Text",
  CellTags->"ii:246"],
Cell[150883, 6171, 156, 5, 36, "Text"],
Cell[151042, 6178, 182, 8, 36, "Text"],
Cell[151227, 6188, 3613, 130, 435, "Text",
  CellTags->"ii:247"],
Cell[154843, 6320, 1909, 59, 266, "Text",
  CellTags->"ii:248"],
Cell[156755, 6381, 909, 34, 112, "Text",
  CellTags->"ii:249"],
Cell[157667, 6417, 26, 0, 33, "Input"],
Cell[157696, 6419, 164, 6, 36, "Text",
  CellTags->{"P", "ii:250"}],
Cell[157863, 6427, 632, 22, 93, "Text",
  CellTags->"ii:251"],
Cell[158498, 6451, 144, 5, 36, "Text"],
Cell[158645, 6458, 4136, 152, 492, "Text",
  CellTags->"ii:252"],
Cell[162784, 6612, 209, 8, 36, "Text"],
Cell[162996, 6622, 191, 7, 36, "Text"],
Cell[163190, 6631, 257, 10, 50, "Text",
  CellTags->"ii:253"],
Cell[163450, 6643, 217, 9, 50, "Text",
  CellTags->"ii:254"],
Cell[163670, 6654, 391, 14, 55, "Text",
  CellTags->"ii:255"],
Cell[164064, 6670, 392, 14, 74, "Text",
  CellTags->"ii:256"],
Cell[164459, 6686, 582, 18, 93, "Text",
  CellTags->"ii:257"],
Cell[165044, 6706, 626, 26, 93, "Text",
  CellTags->"ii:258"],
Cell[165673, 6734, 422, 14, 74, "Text",
  CellTags->"ii:260"],
Cell[166098, 6750, 157, 6, 36, "Text",
  CellTags->"ii:261"],
Cell[166258, 6758, 995, 36, 131, "Text",
  CellTags->"ii:381"],
Cell[167256, 6796, 903, 32, 131, "Text",
  CellTags->"ii:262"],
Cell[168162, 6830, 485, 20, 36, "Text",
  CellTags->"ii:263"],
Cell[168650, 6852, 460, 17, 74, "Text",
  CellTags->"ii:264"],
Cell[169113, 6871, 453, 19, 69, "Text",
  CellTags->"ii:265"],
Cell[169569, 6892, 1942, 73, 240, "Text",
  CellTags->"ii:267"],
Cell[171514, 6967, 227, 9, 50, "Text",
  CellTags->"ii:268"],
Cell[171744, 6978, 498, 18, 93, "Text",
  CellTags->"ii:269"],
Cell[172245, 6998, 2461, 89, 264, "Text",
  CellTags->"ii:272"],
Cell[174709, 7089, 165, 6, 36, "Text",
  CellTags->"ii:273"],
Cell[174877, 7097, 275, 9, 55, "Text"],
Cell[175155, 7108, 155, 6, 36, "Text",
  CellTags->"ii:274"],
Cell[175313, 7116, 1191, 45, 169, "Text",
  CellTags->"ii:275"],
Cell[176507, 7163, 365, 15, 36, "Text",
  CellTags->"ii:276"],
Cell[176875, 7180, 416, 18, 36, "Text",
  CellTags->"ii:2771"],
Cell[177294, 7200, 225, 9, 36, "Text",
  CellTags->"ii:278"],
Cell[177522, 7211, 330, 13, 50, "Text",
  CellTags->"ii:279"],
Cell[177855, 7226, 232, 9, 50, "Text",
  CellTags->"ii:280"],
Cell[178090, 7237, 690, 25, 112, "Text",
  CellTags->"ii:281"],
Cell[178783, 7264, 26, 0, 33, "Input"],
Cell[178812, 7266, 231, 9, 36, "Text",
  CellTags->{"Q", "ii:282"}],
Cell[179046, 7277, 26, 0, 33, "Input"],
Cell[179075, 7279, 468, 17, 55, "Text",
  CellTags->{"R", "ii:283"}],
Cell[179546, 7298, 148, 5, 36, "Text"],
Cell[179697, 7305, 432, 17, 36, "Text",
  CellTags->"ii:2841"],
Cell[180132, 7324, 1090, 40, 150, "Text",
  CellTags->"ii:285"],
Cell[181225, 7366, 376, 13, 74, "Text",
  CellTags->"ii:286"],
Cell[181604, 7381, 831, 31, 93, "Text",
  CellTags->"ii:288"],
Cell[182438, 7414, 355, 14, 36, "Text",
  CellTags->"ii:290"],
Cell[182796, 7430, 226, 9, 36, "Text",
  CellTags->"ii:291"],
Cell[183025, 7441, 1398, 51, 188, "Text",
  CellTags->"ii:292"],
Cell[184426, 7494, 948, 37, 93, "Text",
  CellTags->"ii:293"],
Cell[185377, 7533, 163, 6, 36, "Text",
  CellTags->"ii:294"],
Cell[185543, 7541, 210, 9, 36, "Text",
  CellTags->"ii:295"],
Cell[185756, 7552, 572, 24, 36, "Text",
  CellTags->"ii:378"],
Cell[186331, 7578, 246, 10, 36, "Text",
  CellTags->"ii:296"],
Cell[186580, 7590, 310, 13, 36, "Text",
  CellTags->"ii:297"],
Cell[186893, 7605, 139, 5, 36, "Text"],
Cell[187035, 7612, 161, 6, 36, "Text",
  CellTags->"ii:298"],
Cell[187199, 7620, 169, 6, 36, "Text",
  CellTags->"ii:299"],
Cell[187371, 7628, 588, 18, 93, "Text",
  CellTags->"ii:300"],
Cell[187962, 7648, 202, 8, 36, "Text"],
Cell[188167, 7658, 26, 0, 33, "Input"],
Cell[188196, 7660, 237, 9, 36, "Text",
  CellTags->{"S", "ii:301"}],
Cell[188436, 7671, 163, 6, 36, "Text",
  CellTags->"ii:302"],
Cell[188602, 7679, 177, 6, 36, "Text",
  CellTags->"ii:310"],
Cell[188782, 7687, 1712, 62, 188, "Text",
  CellTags->"ii:311"],
Cell[190497, 7751, 164, 6, 36, "Text",
  CellTags->"ii:303"],
Cell[190664, 7759, 183, 7, 36, "Text"],
Cell[190850, 7768, 843, 26, 112, "Text",
  CellTags->"ii:304"],
Cell[191696, 7796, 426, 18, 36, "Text",
  CellTags->"ii:305"],
Cell[192125, 7816, 329, 13, 36, "Text",
  CellTags->"ii:306"],
Cell[192457, 7831, 159, 6, 36, "Text",
  CellTags->"ii:380"],
Cell[192619, 7839, 221, 9, 36, "Text",
  CellTags->"ii:307"],
Cell[192843, 7850, 597, 24, 74, "Text",
  CellTags->"ii:368"],
Cell[193443, 7876, 537, 18, 74, "Text",
  CellTags->"ii:308"],
Cell[193983, 7896, 320, 13, 36, "Text",
  CellTags->"ii:309"],
Cell[194306, 7911, 224, 9, 36, "Text",
  CellTags->"ii:312"],
Cell[194533, 7922, 172, 6, 36, "Text",
  CellTags->"ii:313"],
Cell[194708, 7930, 193, 8, 36, "Text"],
Cell[194904, 7940, 198, 8, 36, "Text"],
Cell[195105, 7950, 209, 8, 36, "Text"],
Cell[195317, 7960, 160, 6, 36, "Text",
  CellTags->"ii:314"],
Cell[195480, 7968, 136, 5, 36, "Text"],
Cell[195619, 7975, 259, 10, 36, "Text",
  CellTags->"ii:315"],
Cell[195881, 7987, 725, 29, 55, "Text",
  CellTags->"ii:316"],
Cell[196609, 8018, 495, 18, 74, "Text",
  CellTags->"ii:317"],
Cell[197107, 8038, 1106, 41, 150, "Text",
  CellTags->"ii:318"],
Cell[198216, 8081, 222, 9, 36, "Text",
  CellTags->"ii:319"],
Cell[198441, 8092, 886, 35, 93, "Text",
  CellTags->"ii:320"],
Cell[199330, 8129, 167, 6, 36, "Text",
  CellTags->"ii:321"],
Cell[199500, 8137, 422, 14, 74, "Text",
  CellTags->"ii:322"],
Cell[199925, 8153, 299, 12, 55, "Text",
  CellTags->"ii:377"],
Cell[200227, 8167, 431, 17, 36, "Text",
  CellTags->"ii:323"],
Cell[200661, 8186, 484, 17, 76, "Text",
  CellTags->"ii:324"],
Cell[201148, 8205, 232, 9, 36, "Text",
  CellTags->"ii:325"],
Cell[201383, 8216, 581, 23, 55, "Text",
  CellTags->"ii:390"],
Cell[201967, 8241, 227, 9, 36, "Text",
  CellTags->"ii:382"],
Cell[202197, 8252, 398, 15, 36, "Text"],
Cell[202598, 8269, 171, 6, 36, "Text",
  CellTags->"ii:326"],
Cell[202772, 8277, 139, 5, 36, "Text"],
Cell[202914, 8284, 172, 6, 36, "Text",
  CellTags->"ii:327"],
Cell[203089, 8292, 134, 5, 36, "Text"],
Cell[203226, 8299, 165, 6, 36, "Text",
  CellTags->"ii:328"],
Cell[203394, 8307, 263, 10, 36, "Text",
  CellTags->"ii:329"],
Cell[203660, 8319, 162, 6, 36, "Text",
  CellTags->"ii:330"],
Cell[203825, 8327, 427, 17, 36, "Text",
  CellTags->"ii:331"],
Cell[204255, 8346, 466, 18, 36, "Text",
  CellTags->"ii:332"],
Cell[204724, 8366, 26, 0, 33, "Input"],
Cell[204753, 8368, 228, 9, 36, "Text",
  CellTags->{"T", "ii:333"}],
Cell[204984, 8379, 317, 12, 74, "Text",
  CellTags->"ii:334"],
Cell[205304, 8393, 163, 6, 36, "Text",
  CellTags->"ii:336"],
Cell[205470, 8401, 153, 6, 36, "Text",
  CellTags->"ii:337"],
Cell[205626, 8409, 579, 21, 74, "Text",
  CellTags->"ii:338"],
Cell[206208, 8432, 166, 6, 36, "Text",
  CellTags->"ii:339"],
Cell[206377, 8440, 617, 24, 74, "Text",
  CellTags->"ii:340"],
Cell[206997, 8466, 165, 6, 36, "Text",
  CellTags->"ii:341"],
Cell[207165, 8474, 211, 8, 36, "Text",
  CellTags->"ii:342"],
Cell[207379, 8484, 175, 7, 36, "Text"],
Cell[207557, 8493, 134, 5, 36, "Text"],
Cell[207694, 8500, 138, 5, 36, "Text"],
Cell[207835, 8507, 422, 17, 55, "Text",
  CellTags->"ii:386"],
Cell[208260, 8526, 200, 8, 36, "Text"],
Cell[208463, 8536, 168, 6, 36, "Text",
  CellTags->"ii:343"],
Cell[208634, 8544, 213, 9, 36, "Text",
  CellTags->"ii:344"],
Cell[208850, 8555, 225, 9, 36, "Text",
  CellTags->"ii:345"],
Cell[209078, 8566, 190, 7, 36, "Text"],
Cell[209271, 8575, 137, 5, 36, "Text"],
Cell[209411, 8582, 158, 6, 36, "Text",
  CellTags->"ii:346"],
Cell[209572, 8590, 168, 6, 36, "Text",
  CellTags->"ii:347"],
Cell[209743, 8598, 679, 22, 112, "Text",
  CellTags->"ii:348"],
Cell[210425, 8622, 26, 0, 33, "Input"],
Cell[210454, 8624, 542, 21, 55, "Text",
  CellTags->{"U", "ii:349"}],
Cell[210999, 8647, 151, 5, 36, "Text"],
Cell[211153, 8654, 167, 6, 55, "Text"],
Cell[211323, 8662, 322, 13, 36, "Text",
  CellTags->"ii:351"],
Cell[211648, 8677, 329, 13, 36, "Text",
  CellTags->"ii:352"],
Cell[211980, 8692, 26, 0, 33, "Input"],
Cell[212009, 8694, 240, 9, 36, "Text",
  CellTags->{"V", "ii:353"}],
Cell[212252, 8705, 247, 9, 55, "Text"],
Cell[212502, 8716, 418, 13, 74, "Text"],
Cell[212923, 8731, 1526, 60, 207, "Text",
  CellTags->"ii:354"],
Cell[214452, 8793, 156, 6, 36, "Text",
  CellTags->"ii:355"],
Cell[214611, 8801, 227, 9, 36, "Text",
  CellTags->"ii:356"],
Cell[214841, 8812, 507, 18, 93, "Text",
  CellTags->"ii:357"],
Cell[215351, 8832, 180, 6, 36, "Text",
  CellTags->"ii:359"],
Cell[215534, 8840, 26, 0, 33, "Input"],
Cell[215563, 8842, 584, 18, 112, "Text",
  CellTags->{"W", "ii:360"}],
Cell[216150, 8862, 326, 10, 74, "Text",
  CellTags->"ii:361"],
Cell[216479, 8874, 3187, 118, 340, "Text",
  CellTags->"ii:362"],
Cell[219669, 8994, 554, 21, 55, "Text",
  CellTags->"ii:363"],
Cell[220226, 9017, 157, 6, 36, "Text",
  CellTags->"ii:364"],
Cell[220386, 9025, 2747, 98, 359, "Text",
  CellTags->"ii:365"],
Cell[223136, 9125, 1059, 40, 112, "Text",
  CellTags->"ii:366"],
Cell[224198, 9167, 4443, 175, 435, "Text",
  CellTags->"ii:367"],
Cell[228644, 9344, 158, 6, 36, "Text",
  CellTags->"ii:369"],
Cell[228805, 9352, 332, 13, 36, "Text",
  CellTags->"ii:370"],
Cell[229140, 9367, 156, 6, 36, "Text",
  CellTags->"ii:371"],
Cell[229299, 9375, 299, 10, 55, "Text",
  CellTags->"ii:372"],
Cell[229601, 9387, 156, 6, 36, "Text",
  CellTags->"ii:373"],
Cell[229760, 9395, 2311, 82, 283, "Text",
  CellTags->"ii:374"],
Cell[232074, 9479, 164, 5, 36, "Text"],
Cell[232241, 9486, 241, 9, 36, "Text"],
Cell[232485, 9497, 255, 10, 36, "Text",
  CellTags->"ii:375"],
Cell[232743, 9509, 26, 0, 33, "Input"],
Cell[232772, 9511, 178, 6, 36, "Text",
  CellTags->{"Z", "ii:376"}]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

