(************** Content-type: application/mathematica **************

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    174959,       6635]*)
(*NotebookOutlinePosition[    249317,       9415]*)
(*  CellTagsIndexPosition[    249273,       9411]*)
(*WindowFrame->Normal*)



Notebook[{
Cell["Table Of Contents", "ContentsTitle"],

Cell[TextData[{
  StyleBox[ButtonBox["Preface",
    ButtonData:>{"Preface.nb", None},
    ButtonStyle->"Hyperlink"],
    FontSize->18,
    FontWeight->"Bold"],
  "\t    xiii"
}], "Text",
  CellMargins->{{12, 0}, {0, 18}},
  CellGroupingRules->{"TitleGrouping", 0},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox[ButtonBox["Chapter 1: Ordinary Differential Equations in the \
Physical Sciences",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:1"},
    ButtonStyle->"Hyperlink"],
    FontSize->18,
    FontWeight->"Bold"],
  "\t  1"
}], "Text",
  CellMargins->{{12, 0}, {0, 18}},
  CellGroupingRules->{"TitleGrouping", 0},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["1.1 Introduction",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:2"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t  1"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["1.1.1 Definitions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:3"},
    ButtonStyle->"Hyperlink"],
  "\t  1"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Differential Equations, Unknown Functions, and Initial \
Conditions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:4"},
    ButtonStyle->"Hyperlink"],
  "\t  1"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Order of a Differential Equation",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:5"},
    ButtonStyle->"Hyperlink"],
  "\t  3"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Partial Differential Equations",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:6"},
    ButtonStyle->"Hyperlink"],
  "\t  4"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Initial Value and Boundary Value Problems",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:7"},
    ButtonStyle->"Hyperlink"],
  "\t  4"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 1.1",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:8"},
    ButtonStyle->"Hyperlink"],
  "\t  5"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["1.2 Graphical Solution of Initial-Value Problems",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:9"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t  5"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["1.2.1 Direction Fields; Existence and Uniqueness of Solutions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:10"},
    ButtonStyle->"Hyperlink"],
  "\t  5"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["1.2.2 Direction Fields for Second-Order ODEs: Phase-Space \
Portraits",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:11"},
    ButtonStyle->"Hyperlink"],
  "\t  9"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Phase-Space",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:12"},
    ButtonStyle->"Hyperlink"],
  "\t  9"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Conservation of Phase-Space Area",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:13"},
    ButtonStyle->"Hyperlink"],
  "\t  11"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Hamiltonian Systems",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:14"},
    ButtonStyle->"Hyperlink"],
  "\t  12"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 1.2",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:15"},
    ButtonStyle->"Hyperlink"],
  "\t  14"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["1.3  Analytic Solution of Initial-Value Problems via ",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:16"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  StyleBox[ButtonBox["DSolve",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:16"},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontSize->12,
    FontWeight->"Bold"],
  "\t  17"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["1.3.1 ",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:17"},
    ButtonStyle->"Hyperlink"],
  StyleBox[ButtonBox["DSolve",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:17"},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "\t  17"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 1.3",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:18"},
    ButtonStyle->"Hyperlink"],
  "\t  20"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["1.4 Numerical Solution of Initial-Value Problems",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:19"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t  23"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["1.4.1 ",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:20"},
    ButtonStyle->"Hyperlink"],
  StyleBox[ButtonBox["NDSolve",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:20"},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold"],
  "\t  23"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["1.4.2 Error in Chaotic Systems",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:21"},
    ButtonStyle->"Hyperlink"],
  "\t  27"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["A Chaotic System: The Driven Pendulum",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:22"},
    ButtonStyle->"Hyperlink"],
  "\t  27"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["The Lyapunov Exponent",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:23"},
    ButtonStyle->"Hyperlink"],
  "\t  29"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["1.4.3 Euler's Method",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:24"},
    ButtonStyle->"Hyperlink"],
  "\t  31"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["1.4.4 The Predictor-Corrector Method of Order 2",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:25"},
    ButtonStyle->"Hyperlink"],
  "\t  38"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["1.4.5 Euler's Method for Systems of ODEs",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:26"},
    ButtonStyle->"Hyperlink"],
  "\t  41"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["1.4.6 The Numerical ",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:27"},
    ButtonStyle->"Hyperlink"],
  StyleBox[ButtonBox["N",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:27"},
    ButtonStyle->"Hyperlink"],
    FontSlant->"Italic"],
  ButtonBox["-Body Problem: An Introduction to Molecular Dynamics",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:27"},
    ButtonStyle->"Hyperlink"],
  "\t  43"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 1.4",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:28"},
    ButtonStyle->"Hyperlink"],
  "\t50"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["1.5 Boundary-Value Problems",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:29"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold",
    FontSlant->"Plain"],
  "\t62"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["1.5.1 Introduction",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:30"},
    ButtonStyle->"Hyperlink"],
  "\t62"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["1.5.2 Numerical Solution of Boundary-Value Problems: The \
Shooting Method",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:31"},
    ButtonStyle->"Hyperlink"],
  "\t64"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 1.5",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:32"},
    ButtonStyle->"Hyperlink"],
  "\t67"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["1.6 Linear ODEs",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:33"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t70"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["1.6.1 The Principle of Superposition",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:34"},
    ButtonStyle->"Hyperlink"],
  "\t70"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  Cell[BoxData[
      FormBox[
        ButtonBox[
          StyleBox[
            
            RowBox[{\(\(Linear\)\(\ \)\(ODEs\)\(\ \)\(of\)\(\ \)\(order\)\(\ \
\)\), 
              FormBox["N",
                "TraditionalForm"]}],
            SingleLetterItalics->False],
          ButtonFunction:>(FrontEndExecute[ {
              FrontEnd`NotebookLocate[ #2]}]&),
          ButtonData:>{
            
            FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
              "MacintoshRoman"], "c:35"},
          Active->True,
          ButtonStyle->"Hyperlink",
          ButtonFrame->"None",
          Background->GrayLevel[1],
          ButtonNote->ButtonData], TraditionalForm]]],
  "\t70"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Linear Differential Operators",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:36"},
    ButtonStyle->"Hyperlink"],
  "\t70"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["The Superposition Principle",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:37"},
    ButtonStyle->"Hyperlink"],
  "\t71"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["1.6.2 The General Solution to the Homogeneous Equation",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:38"},
    ButtonStyle->"Hyperlink"],
  "\t71"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Introduction",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:39"},
    ButtonStyle->"Hyperlink"],
  "\t71"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Different Functional Forms for the General Solution",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:40"},
    ButtonStyle->"Hyperlink"],
  "\t73"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["1.6.3 Linear Differential Operators and Linear Algebra",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:41"},
    ButtonStyle->"Hyperlink"],
  "\t74"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["1.6.4 Inhomogeneous Linear ODEs",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:42"},
    ButtonStyle->"Hyperlink"],
  "\t78"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Homogeneous and Particular Solutions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:43"},
    ButtonStyle->"Hyperlink"],
  "\t78"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Method of Undetermined Coefficients",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:44"},
    ButtonStyle->"Hyperlink"],
  "\t79"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Response to Sinusoidal Forcing",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:45"},
    ButtonStyle->"Hyperlink"],
  "\t79"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Resonance",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:46"},
    ButtonStyle->"Hyperlink"],
  "\t82"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 1.6",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:47"},
    ButtonStyle->"Hyperlink"],
  "\t84"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["References",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter1.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:48"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t86"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox[ButtonBox["Chapter 2: Fourier Series and Transforms",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:1"},
    ButtonStyle->"Hyperlink"],
    FontSize->18,
    FontWeight->"Bold"],
  "\t87"
}], "Text",
  CellMargins->{{12, 0}, {0, 18}},
  CellGroupingRules->{"TitleGrouping", 0},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["2.1 Fourier Representation of Periodic Functions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:2"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t87"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["2.1.1 Introduction",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:3"},
    ButtonStyle->"Hyperlink"],
  "\t87"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["2.1.2 Fourier Coefficients and Orthogonality Relations",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:4"},
    ButtonStyle->"Hyperlink"],
  "\t90"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["2.1.3 Triangle Wave",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:5"},
    ButtonStyle->"Hyperlink"],
  "\t92"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["2.1.4 Square Wave",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:6"},
    ButtonStyle->"Hyperlink"],
  "\t95"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["2.1.5 Uniform and Nonuniform Convergence",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:7"},
    ButtonStyle->"Hyperlink"],
  "\t97"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["2.1.6 Gibbs Phenomenon for the Square Wave",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:8"},
    ButtonStyle->"Hyperlink"],
  "\t99"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["2.1.7 Exponential Notation for Fourier Series",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:9"},
    ButtonStyle->"Hyperlink"],
  "\t102"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["2.1.8 Response of a Damped Oscillator to Periodic Forcing",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:10"},
    ButtonStyle->"Hyperlink"],
  "\t105"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["2.1.9 Fourier Analysis, Sound, and Hearing",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:11"},
    ButtonStyle->"Hyperlink"],
  "\t106"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 2.1",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:12"},
    ButtonStyle->"Hyperlink"],
  "\t109"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["2.2 Fourier Representation of Functions Defined on a \
Finite Interval",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:13"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t111"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["2.2.1 Periodic Extension of a Function",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:14"},
    ButtonStyle->"Hyperlink"],
  "\t111"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["2.2.2 Even Periodic Extension",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:15"},
    ButtonStyle->"Hyperlink"],
  "\t113"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["2.2.3 Odd Periodic Extension",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:16"},
    ButtonStyle->"Hyperlink"],
  "\t116"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["2.2.4 Solution of Boundary-Value Problems Using Fourier Series",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:17"},
    ButtonStyle->"Hyperlink"],
  "\t118"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 2.2",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:18"},
    ButtonStyle->"Hyperlink"],
  "\t121"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["2.3 Fourier Transforms",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:19"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t122"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["2.3.1 Fourier Representation of Functions on the Real Line",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:20"},
    ButtonStyle->"Hyperlink"],
  "\t122"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["2.3.2 Fourier sine and cosine Transforms",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:21"},
    ButtonStyle->"Hyperlink"],
  "\t129"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["2.3.3 Some properties of Fourier Transforms",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:22"},
    ButtonStyle->"Hyperlink"],
  "\t131"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Fourier Transforms as Linear Integral Operators",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:23"},
    ButtonStyle->"Hyperlink"],
  "\t131"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Fourier Transforms of Derivatives and Integrals",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:24"},
    ButtonStyle->"Hyperlink"],
  "\t131"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Convolution Theorem",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:25"},
    ButtonStyle->"Hyperlink"],
  "\t132"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["The Uncertainty Principle of Fourier Analysis",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:26"},
    ButtonStyle->"Hyperlink"],
  "\t133"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["2.3.4 The Dirac \[Delta]-Function",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:27"},
    ButtonStyle->"Hyperlink"],
  "\t135"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Introduction",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:28"},
    ButtonStyle->"Hyperlink"],
  "\t135"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Integral of a \[Delta]-Function",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:29"},
    ButtonStyle->"Hyperlink"],
  "\t136"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["\[Delta]-Functions of More Complicated Arguments",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:30"},
    ButtonStyle->"Hyperlink"],
  "\t136"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Generalized Fourier Integrals",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:31"},
    ButtonStyle->"Hyperlink"],
  "\t137"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Derivatives of a \[Delta]-Function",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:32"},
    ButtonStyle->"Hyperlink"],
  "\t139"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Heaviside Step Function",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:33"},
    ButtonStyle->"Hyperlink"],
  "\t140"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Connection of Fourier Transforms to Fourier Series",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:34"},
    ButtonStyle->"Hyperlink"],
  "\t141"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["2.3.5 Fast Fourier Transforms",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:35"},
    ButtonStyle->"Hyperlink"],
  "\t144"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Discrete Fourier Transforms",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:36"},
    ButtonStyle->"Hyperlink"],
  "\t144"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Fast Fourier Transforms",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:37"},
    ButtonStyle->"Hyperlink"],
  "\t151"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["2.3.6 Response of a Damped Oscillator to General Forcing. \
Green's Function for the Oscillator.",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:38"},
    ButtonStyle->"Hyperlink"],
  "\t158"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 2.3",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:39"},
    ButtonStyle->"Hyperlink"],
  "\t164"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["2.4 Green's Functions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:40"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t169"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["2.4.1 Introduction",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:41"},
    ButtonStyle->"Hyperlink"],
  "\t169"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["2.4.2 Constructing the Green's Function from Homogeneous \
Solutions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:42"},
    ButtonStyle->"Hyperlink"],
  "\t171"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Second-Order ODEs",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:43"},
    ButtonStyle->"Hyperlink"],
  "\t171"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Example",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:44"},
    ButtonStyle->"Hyperlink"],
  "\t173"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  StyleBox[ButtonBox["N",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:45"},
    ButtonStyle->"Hyperlink"],
    FontSlant->"Italic"],
  ButtonBox["th Order ODEs",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:45"},
    ButtonStyle->"Hyperlink"],
  "\t173"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["2.4.3 Discretized Green's Function I : Initial-Value Problems by \
Matrix Inversion.",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:46"},
    ButtonStyle->"Hyperlink"],
  "\t174"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["2.4.4 Green's Function for Boundary-Value Problems",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:47"},
    ButtonStyle->"Hyperlink"],
  "\t178"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["2.4.5 Discretized Green's Functions II: Boundary-Value Problems \
by Matrix Inversion",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:48"},
    ButtonStyle->"Hyperlink"],
  "\t181"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Theory for Second-Order ODEs",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:49"},
    ButtonStyle->"Hyperlink"],
  "\t181"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Example",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:50"},
    ButtonStyle->"Hyperlink"],
  "\t185"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 2.4",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:51"},
    ButtonStyle->"Hyperlink"],
  "\t187"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["References",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter2.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:52"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t190"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox[ButtonBox["Chapter 3: Introduction to Linear Partial Differential \
Equations",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:1"},
    ButtonStyle->"Hyperlink"],
    FontSize->18,
    FontWeight->"Bold"],
  "\t191"
}], "Text",
  CellMargins->{{12, 0}, {0, 18}},
  CellGroupingRules->{"TitleGrouping", 0},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["3.1 Separation of Variables and Fourier Series Methods \
in Solutions of the Wave and Heat Equations",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:3"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t191"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["3.1.1 Derivation of the Wave Equation",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:4"},
    ButtonStyle->"Hyperlink"],
  "\t191"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Introduction",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:5"},
    ButtonStyle->"Hyperlink"],
  "\t191"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["String Equilibrium",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:6"},
    ButtonStyle->"Hyperlink"],
  "\t191"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["String Dynamics: The Wave Equation",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:7"},
    ButtonStyle->"Hyperlink"],
  "\t193"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["3.1.2 Solution of the Wave Equation Using Separation of \
Variables",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:8"},
    ButtonStyle->"Hyperlink"],
  "\t195"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Solution of the Wave Equation for a Uniform String and Fixed \
Ends",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:9"},
    ButtonStyle->"Hyperlink"],
  "\t195"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Examples",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:10"},
    ButtonStyle->"Hyperlink"],
  "\t199"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Static Sources and Inhomogeneous Boundary Conditions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:11"},
    ButtonStyle->"Hyperlink"],
  "\t203"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Summary",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:12"},
    ButtonStyle->"Hyperlink"],
  "\t206"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["3.1.3 Derivation of the Heat Equation",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:13"},
    ButtonStyle->"Hyperlink"],
  "\t206"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Heat Flux",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:14"},
    ButtonStyle->"Hyperlink"],
  "\t206"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Energy Conservation",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:15"},
    ButtonStyle->"Hyperlink"],
  "\t207"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["The Heat and Diffusion Equations. Dirichlet, von Neumann and \
Mixed Boundary Conditions.",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:16"},
    ButtonStyle->"Hyperlink"],
  "\t208"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["3.1.4 Solution of the Heat Equation Using Separation of \
Variables",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:17"},
    ButtonStyle->"Hyperlink"],
  "\t210"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Introduction",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:18"},
    ButtonStyle->"Hyperlink"],
  "\t210"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Static Boundary Conditions and a Static Source",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:19"},
    ButtonStyle->"Hyperlink"],
  "\t210"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Homogeneous von Neumann Boundary Conditions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:20"},
    ButtonStyle->"Hyperlink"],
  "\t217"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Homogeneous Mixed Boundary Conditions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:21"},
    ButtonStyle->"Hyperlink"],
  "\t220"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Summary",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:22"},
    ButtonStyle->"Hyperlink"],
  "\t223"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 3.1",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:23"},
    ButtonStyle->"Hyperlink"],
  "\t224"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["3.2 Laplace's Equation in Some Separable Geometries",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:24"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t231"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["3.2.1 Existence and Uniqueness of the Solution",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:26"},
    ButtonStyle->"Hyperlink"],
  "\t232"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["3.2.2 Rectangular Geometry",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:27"},
    ButtonStyle->"Hyperlink"],
  "\t233"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["General Solution",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:28"},
    ButtonStyle->"Hyperlink"],
  "\t233"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Example 1: Dirichlet Boundary Conditions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:29"},
    ButtonStyle->"Hyperlink"],
  "\t234"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Example 2: von Neumann Boundary Conditions; the Current Density \
in a Conducting Wire",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:30"},
    ButtonStyle->"Hyperlink"],
  "\t236"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["3.2.3 2D Cylindrical Geometry",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:31"},
    ButtonStyle->"Hyperlink"],
  "\t238"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Separation of Variables",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:32"},
    ButtonStyle->"Hyperlink"],
  "\t238"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Example",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:33"},
    ButtonStyle->"Hyperlink"],
  "\t239"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["3.2.4 Spherical Geometry",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:34"},
    ButtonStyle->"Hyperlink"],
  "\t240"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Separation of Variables",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:35"},
    ButtonStyle->"Hyperlink"],
  "\t240"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Eigenmodes in \[Theta]: Associated Legendre Functions",
    ButtonData:>{"Chapter3.nb", "c:36"},
    ButtonStyle->"Hyperlink"],
  "\t241"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Spherical Harmonics",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:37"},
    ButtonStyle->"Hyperlink"],
  "\t243"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Example",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:38"},
    ButtonStyle->"Hyperlink"],
  "\t245"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["3.2.5 3D Cylindrical Geometry",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:39"},
    ButtonStyle->"Hyperlink"],
  "\t247"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Introduction",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:40"},
    ButtonStyle->"Hyperlink"],
  "\t247"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Nonzero Potential on One Cylinder End: Bessel Functions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:41"},
    ButtonStyle->"Hyperlink"],
  "\t248"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Nonzero Potential on the Cylinder Sides: Modified Bessel \
Functions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:42"},
    ButtonStyle->"Hyperlink"],
  "\t254"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 3.2",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:43"},
    ButtonStyle->"Hyperlink"],
  "\t256"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["References",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter3.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:44"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t260"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox[ButtonBox["Chapter 4: Eigenmode Analysis",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:1"},
    ButtonStyle->"Hyperlink"],
    FontSize->18,
    FontWeight->"Bold"],
  "\t261"
}], "Text",
  CellMargins->{{12, 0}, {0, 18}},
  CellGroupingRules->{"TitleGrouping", 0},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["4.1 Generalized Fourier Series",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:2"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t261"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["4.1.1 Inner Products and Orthogonal Functions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:4"},
    ButtonStyle->"Hyperlink"],
  "\t261"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Definition of an Inner Product",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:5"},
    ButtonStyle->"Hyperlink"],
  "\t261"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Sets of Orthogonal Functions. The Gram- Schmidt Method.",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:6"},
    ButtonStyle->"Hyperlink"],
  "\t262"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["4.1.2 Series of Orthogonal Functions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:7"},
    ButtonStyle->"Hyperlink"],
  "\t266"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["4.1.3 Eigenmodes of Hermitian Operators",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:8"},
    ButtonStyle->"Hyperlink"],
  "\t268"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Hermitian Operators, and Sturm-Liouville Problems",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:9"},
    ButtonStyle->"Hyperlink"],
  "\t268"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Eigenmodes",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:10"},
    ButtonStyle->"Hyperlink"],
  "\t270"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Completeness",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:11"},
    ButtonStyle->"Hyperlink"],
  "\t271"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["4.1.4 Eigenmodes of Non-Hermitian Operators",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:12"},
    ButtonStyle->"Hyperlink"],
  "\t272"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 4.1",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:13"},
    ButtonStyle->"Hyperlink"],
  "\t273"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["4.2 Beyond Separation of Variables: The General \
Solution of the 1D Wave and Heat Equations",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:14"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t277"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["4.2.1 Standard Form for the PDE",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:16"},
    ButtonStyle->"Hyperlink"],
  "\t278"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["4.2.2 Generalized Fourier Series Expansion for the Solution",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:17"},
    ButtonStyle->"Hyperlink"],
  "\t280"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["General Solution for the Wave Equation",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:18"},
    ButtonStyle->"Hyperlink"],
  "\t280"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Wave Energy",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:19"},
    ButtonStyle->"Hyperlink"],
  "\t282"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Example 1: Temperature Oscillations",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:20"},
    ButtonStyle->"Hyperlink"],
  "\t283"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Example 2: Cracking the Whip",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:21"},
    ButtonStyle->"Hyperlink"],
  "\t287"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 4.2",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:22"},
    ButtonStyle->"Hyperlink"],
  "\t294"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["4.3 Poisson's Equation in Two and Three Dimensions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:23"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t300"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["4.3.1 Introduction. Uniqueness and Standard Form",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:24"},
    ButtonStyle->"Hyperlink"],
  "\t300"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["4.3.2 Green's Function",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:25"},
    ButtonStyle->"Hyperlink"],
  "\t301"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["4.3.3 Expansion of ",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:26"},
    ButtonStyle->"Hyperlink"],
  StyleBox[ButtonBox["g",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:25"},
    ButtonStyle->"Hyperlink"],
    FontSlant->"Italic"],
  ButtonBox[" and \[Phi] in Eigenmodes of the Laplacian Operator",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:25"},
    ButtonStyle->"Hyperlink"],
  "\t302"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  Cell[BoxData[
      FormBox[
        ButtonBox[
          RowBox[{
            StyleBox[
              RowBox[{"4", 
                StyleBox[".3",
                  SingleLetterItalics->False]}]], 
            StyleBox[".3",
              SingleLetterItalics->False], 
            StyleBox[" ",
              SingleLetterItalics->False], 
            StyleBox["Eigenmodes",
              SingleLetterItalics->False], 
            StyleBox[" ",
              SingleLetterItalics->False], 
            StyleBox["of",
              SingleLetterItalics->False], 
            StyleBox[" ",
              SingleLetterItalics->False], 
            StyleBox[
              RowBox[{
                FormBox[\(\[Del]\^2\),
                  "TraditionalForm"], \(in\ Separable\ Geometries\)}],
              SingleLetterItalics->False]}],
          ButtonFunction:>(FrontEndExecute[ {
              FrontEnd`NotebookLocate[ #2]}]&),
          ButtonData:>{
            
            FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
              "MacintoshRoman"], "c:27"},
          Active->True,
          ButtonStyle->"Hyperlink",
          ButtonFrame->"None",
          Background->GrayLevel[1],
          ButtonNote->ButtonData], TraditionalForm]]],
  "\t304"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Introduction",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:28"},
    ButtonStyle->"Hyperlink"],
  "\t304"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Rectangular Geometry",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:29"},
    ButtonStyle->"Hyperlink"],
  "\t305"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Cylindrical Geometry",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:30"},
    ButtonStyle->"Hyperlink"],
  "\t312"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Spherical Geometry",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:31"},
    ButtonStyle->"Hyperlink"],
  "\t317"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 4.3",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:32"},
    ButtonStyle->"Hyperlink"],
  "\t324"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["4.4 The Wave and Heat Equations in Two and Three \
Dimensions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:33"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t333"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["4.4.1 Oscillations of a Circular Drumhead",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:35"},
    ButtonStyle->"Hyperlink"],
  "\t334"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["General Solution",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:36"},
    ButtonStyle->"Hyperlink"],
  "\t334"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Drumhead Eigenmodes",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:37"},
    ButtonStyle->"Hyperlink"],
  "\t336"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Travelling Waves in \[Theta]",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:38"},
    ButtonStyle->"Hyperlink"],
  "\t338"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Sources and Inhomogeneous Boundary Conditions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:39"},
    ButtonStyle->"Hyperlink"],
  "\t339"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["4.4.2 Large Scale Ocean Modes",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:40"},
    ButtonStyle->"Hyperlink"],
  "\t340"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["4.4.3 The Rate of Cooling of the Earth",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:41"},
    ButtonStyle->"Hyperlink"],
  "\t344"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 4.4",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:42"},
    ButtonStyle->"Hyperlink"],
  "\t346"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["References",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter4.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:43"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t354"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox[ButtonBox["Chapter 5: Partial Differential Equations in Infinite \
Domains",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:1"},
    ButtonStyle->"Hyperlink"],
    FontSize->18,
    FontWeight->"Bold"],
  "\t355"
}], "Text",
  CellMargins->{{12, 0}, {0, 18}},
  CellGroupingRules->{"TitleGrouping", 0},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["5.1 Fourier Transform Methods",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:3"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t356"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["5.1.1 The Wave Equation in One Dimension",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:4"},
    ButtonStyle->"Hyperlink"],
  "\t356"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Travelling Waves",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:5"},
    ButtonStyle->"Hyperlink"],
  "\t356"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["General Solution",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:6"},
    ButtonStyle->"Hyperlink"],
  "\t358"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["5.1.2 Dispersion; Phase and Group Velocities",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:7"},
    ButtonStyle->"Hyperlink"],
  "\t359"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["The Shr\[ODoubleDot]dinger Equation for a Free Particle Moving \
in One Dimension",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:8"},
    ButtonStyle->"Hyperlink"],
  "\t359"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Group Velocity",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:9"},
    ButtonStyle->"Hyperlink"],
  "\t363"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Dispersion",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:10"},
    ButtonStyle->"Hyperlink"],
  "\t365"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["5.1.3 Waves in Two and Three Dimensions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:11"},
    ButtonStyle->"Hyperlink"],
  "\t366"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Shr\[ODoubleDot]dinger's Equation in Three Dimensions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:12"},
    ButtonStyle->"Hyperlink"],
  "\t366"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Group Velocity in an Isotropic Medium",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:13"},
    ButtonStyle->"Hyperlink"],
  "\t368"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["The Wave Equation  in Three Dimensions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:14"},
    ButtonStyle->"Hyperlink"],
  "\t368"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Response to a Source",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:15"},
    ButtonStyle->"Hyperlink"],
  "\t379"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Wave Propagation in an Anisotropic Medium",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:16"},
    ButtonStyle->"Hyperlink"],
  "\t382"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Heat Equation",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:17"},
    ButtonStyle->"Hyperlink"],
  "\t384"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 5.1",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:18"},
    ButtonStyle->"Hyperlink"],
  "\t386"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["5.2 The WKB method",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:19"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t396"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["5.2.1 WKB Analysis without Dispersion",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:20"},
    ButtonStyle->"Hyperlink"],
  "\t396"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["The Eikonal",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:21"},
    ButtonStyle->"Hyperlink"],
  "\t396"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Example: Waves on an String with Varying Mass Density.",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:22"},
    ButtonStyle->"Hyperlink"],
  "\t402"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["WKB Method for Problems that Vary Slowly in Time: Adiabatic \
Invariance",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:23"},
    ButtonStyle->"Hyperlink"],
  "\t404"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["WKB Wavepackets",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:24"},
    ButtonStyle->"Hyperlink"],
  "\t407"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["WKB Waves in Two Dimensions: Water Waves Near the Shore",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:25"},
    ButtonStyle->"Hyperlink"],
  "\t410"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Ray Trajectories",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:26"},
    ButtonStyle->"Hyperlink"],
  "\t412"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["5.2.2 WKB with Dispersion: Geometrical Optics",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:27"},
    ButtonStyle->"Hyperlink"],
  "\t415"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Wave-Packet Trajectory",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:28"},
    ButtonStyle->"Hyperlink"],
  "\t415"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Hamiltonian Mechanics as the WKB Limit of Quantum Mechanics",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:29"},
    ButtonStyle->"Hyperlink"],
  "\t419"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Turning Points",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:30"},
    ButtonStyle->"Hyperlink"],
  "\t421"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Wave-Packet Amplitude",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:31"},
    ButtonStyle->"Hyperlink"],
  "\t422"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 5.2",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:33"},
    ButtonStyle->"Hyperlink"],
  "\t424"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["5.3 Wave Action",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:32"},
    ButtonStyle->"Hyperlink"],
    FontWeight->"Bold",
    FontColor->RGBColor[1, 0, 0]],
  " (Electronic Version Only)"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic",
  FontColor->RGBColor[1, 0, 0]],

Cell[TextData[{
  "          ",
  ButtonBox["5.3.1 The Eikonal Equation",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:35"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["5.3.2 Conservation of Wave Action",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:36"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 5.3",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:37"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"]
}, Closed]],

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["References",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter5.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:34"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t432"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox[ButtonBox["Chapter 6: Numerical Solution of Linear Partial \
Differential Equations",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:1"},
    ButtonStyle->"Hyperlink"],
    FontSize->18,
    FontWeight->"Bold"],
  "\t435"
}], "Text",
  CellMargins->{{12, 0}, {0, 18}},
  CellGroupingRules->{"TitleGrouping", 0},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["6.1 The Galerkin Method",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:2"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t435"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["6.1.1 Introduction",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:3"},
    ButtonStyle->"Hyperlink"],
  "\t435"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["6.1.2 Boundary-Value Problems",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:4"},
    ButtonStyle->"Hyperlink"],
  "\t435"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Theory",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:5"},
    ButtonStyle->"Hyperlink"],
  "\t435"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Example 1",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:6"},
    ButtonStyle->"Hyperlink"],
  "\t438"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Example 2",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:7"},
    ButtonStyle->"Hyperlink"],
  "\t442"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Example 3",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:8"},
    ButtonStyle->"Hyperlink"],
  "\t446"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["6.1.3 Time-Dependent Problems",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:9"},
    ButtonStyle->"Hyperlink"],
  "\t451"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["The Heat Equation",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:10"},
    ButtonStyle->"Hyperlink"],
  "\t451"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Reflection of a Quantum Particle From a Barrier",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:11"},
    ButtonStyle->"Hyperlink"],
  "\t457"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 6.1",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:12"},
    ButtonStyle->"Hyperlink"],
  "\t461"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["6.2 Grid Methods",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:13"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t464"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["6.2.1 Time-Dependent Problems",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:14"},
    ButtonStyle->"Hyperlink"],
  "\t464"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["FTCS Method for the Heat Equation",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:15"},
    ButtonStyle->"Hyperlink"],
  "\t464"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Von Neumann Stability Analysis",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:16"},
    ButtonStyle->"Hyperlink"],
  "\t467"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["CTCS Method",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:17"},
    ButtonStyle->"Hyperlink"],
  "\t469"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Lax Method",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:18"},
    ButtonStyle->"Hyperlink"],
  "\t469"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Implicit Methods. The Crank-Nicolson Algorithm.",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:19"},
    ButtonStyle->"Hyperlink"],
  "\t470"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Von Neumann and Mixed Boundary Conditions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:20"},
    ButtonStyle->"Hyperlink"],
  "\t474"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Multiple Spatial Dimensions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:21"},
    ButtonStyle->"Hyperlink"],
  "\t477"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["6.2.2 Boundary-Value Problems",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:22"},
    ButtonStyle->"Hyperlink"],
  "\t486"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Direct Solution",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:23"},
    ButtonStyle->"Hyperlink"],
  "\t486"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Nonrectangular Boundaries",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:24"},
    ButtonStyle->"Hyperlink"],
  "\t489"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Relaxation Methods",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:25"},
    ButtonStyle->"Hyperlink"],
  "\t494"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["FFT Method",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:26"},
    ButtonStyle->"Hyperlink"],
  "\t499"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 6.2",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:27"},
    ButtonStyle->"Hyperlink"],
  "\t504"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["6.3 Numerical Eigenmode methods",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:28"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold",
    FontColor->RGBColor[1, 0, 0]],
  " (Electronic version only)"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic",
  FontColor->RGBColor[1, 0, 0]],

Cell[TextData[{
  "          ",
  ButtonBox["6.3.1 Introduction",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:29"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["6.3.2 Grid-Method Eigenmodes",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:30"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["General Theory",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:31"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Example 1: 1D Heat Equation with Mixed Boundary Conditions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:32"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Example 2: 2D Drumhead Eigenmodes",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:33"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["6.3.3 Galerkin-Method Eigenmodes",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:34"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["General Theory",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:35"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Example 1: 1D Quantum Harmonic Oscillator Eigenmodes",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:36"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Example 2: 2D Drumhead Eigenmodes",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:37"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["6.3.4 WKB Eigenmodes",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:38"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["The Wave Equation",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:39"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Eigenmode Correction Using the Shooting Method",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:40"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Eigenvalues in the Presence of Turning Points",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:41"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Example: Quantum Harmonic Oscillator Frequencies",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:42"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Shooting Method for Problems with Turning Points",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:43"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 6.3",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:44"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"]
}, Closed]],

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["References",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter6.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:45"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t510"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox[ButtonBox["Chapter 7: Nonlinear Partial Differential Equations",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:1"},
    ButtonStyle->"Hyperlink"],
    FontSize->18,
    FontWeight->"Bold"],
  "\t511"
}], "Text",
  CellMargins->{{12, 0}, {0, 18}},
  CellGroupingRules->{"TitleGrouping", 0},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["7.1 The Method of Characteristics for First-Order PDES",
    
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:3"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t511"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["7.1.1 Characteristics",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:4"},
    ButtonStyle->"Hyperlink"],
  "\t511"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["7.1.2 Linear Cases",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:5"},
    ButtonStyle->"Hyperlink"],
  "\t513"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  Cell[BoxData[
      FormBox[
        ButtonBox[
          StyleBox[
            RowBox[{\(\(Example\ 1\)\(:\)\(\ \ \)\), 
              FormBox[\(s = 0\),
                "TraditionalForm"], \(\(\ \)\(and\)\(\ \)\), 
              FormBox[\(v(x, t, f) = c\),
                "TraditionalForm"]}],
            SingleLetterItalics->False],
          ButtonFunction:>(FrontEndExecute[ {
              FrontEnd`NotebookLocate[ #2]}]&),
          ButtonData:>{
            
            FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
              "MacintoshRoman"], "c:6"},
          Active->True,
          ButtonStyle->"Hyperlink",
          ButtonFrame->"None",
          Background->GrayLevel[1],
          ButtonNote->ButtonData], TraditionalForm]]],
  "\t514"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  Cell[BoxData[
      FormBox[
        ButtonBox[
          StyleBox[
            RowBox[{\(\(Example\ 2\)\(:\)\(\ \)\), 
              FormBox[\(s = a\ x\^n\),
                "TraditionalForm"], \(\(\ \)\(and\)\(\ \)\), 
              FormBox[\(v = b\ x\),
                "TraditionalForm"], "."}],
            SingleLetterItalics->False],
          ButtonFunction:>(FrontEndExecute[ {
              FrontEnd`NotebookLocate[ #2]}]&),
          ButtonData:>{
            
            FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
              "MacintoshRoman"], "c:7"},
          Active->True,
          ButtonStyle->"Hyperlink",
          ButtonFrame->"None",
          Background->GrayLevel[1],
          ButtonNote->ButtonData], TraditionalForm]]],
  "\t515"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Example 3: Mixing Dye",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:8"},
    ButtonStyle->"Hyperlink"],
  "\t516"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Example 4: The Collisionless Boltzmann Equation",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:9"},
    ButtonStyle->"Hyperlink"],
  "\t519"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["7.1.3 Nonlinear Waves",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:10"},
    ButtonStyle->"Hyperlink"],
  "\t529"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["A First-Order Nonlinear Wave Equation",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:11"},
    ButtonStyle->"Hyperlink"],
  "\t529"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Solution",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:12"},
    ButtonStyle->"Hyperlink"],
  "\t530"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Wavebreaking Time",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:13"},
    ButtonStyle->"Hyperlink"],
  "\t532"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 7.1",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:14"},
    ButtonStyle->"Hyperlink"],
  "\t534"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["7.2 The K-dV Equation",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:15"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t536"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["7.2.1 Shallow-Water Waves with Dispersion",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:16"},
    ButtonStyle->"Hyperlink"],
  "\t536"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["7.2.2 Steady Solutions: Cnoidal Waves and Solitons",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:17"},
    ButtonStyle->"Hyperlink"],
  "\t537"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["7.2.3 Time-Dependent Solutions: the Galerkin Method",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:18"},
    ButtonStyle->"Hyperlink"],
  "\t546"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Introduction",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:19"},
    ButtonStyle->"Hyperlink"],
  "\t546"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Example 1: Cnoidal Wave",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:20"},
    ButtonStyle->"Hyperlink"],
  "\t548"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Example 2: Interacting Solitons",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:21"},
    ButtonStyle->"Hyperlink"],
  "\t550"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Example 3: Suppression of Wavebreaking",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:22"},
    ButtonStyle->"Hyperlink"],
  "\t551"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["7.2.4 Shock waves: Burgers' Equation",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:23"},
    ButtonStyle->"Hyperlink"],
  "\t554"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Steady Solutions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:24"},
    ButtonStyle->"Hyperlink"],
  "\t554"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["CTCS/Crank-Nicolson Approach",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:25"},
    ButtonStyle->"Hyperlink"],
  "\t556"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 7.2",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:26"},
    ButtonStyle->"Hyperlink"],
  "\t560"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["7.3 The Particle-in-Cell Method",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:27"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold",
    FontColor->RGBColor[1, 0, 0]],
  " (Electronic Version Only)"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic",
  FontColor->RGBColor[1, 0, 0]],

Cell[TextData[{
  "          ",
  ButtonBox["7.3.1 Galactic Dynamics",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:28"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["7.3.2 Strategy of the PIC Method",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:29"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["7.3.3 Leapfrog Method",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:30"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["7.3.4 Force",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:31"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["1) Mass Density on the Grid",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:32"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["2) FFT for the Potential",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:33"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["3) Interpolation of the Force From the Grid to Particle \
Positions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:34"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["7.3.5 Examples",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:35"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Code Tests",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:36"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Gravitational Collapse in a Cold Gas",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:37"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Stability of a Hot Gas to Gravitational Collapse",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:38"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Rotation",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:39"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 7.3",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:40"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"]
}, Closed]],

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["References",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter7.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:41"},
    ButtonStyle->"Hyperlink"],
    FontWeight->"Bold"],
  "\t566"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox[ButtonBox["Chapter 8: Introduction to Random Processes",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:1"},
    ButtonStyle->"Hyperlink"],
    FontSize->18,
    FontWeight->"Bold"],
  "\t567"
}], "Text",
  CellMargins->{{12, 0}, {0, 18}},
  CellGroupingRules->{"TitleGrouping", 0},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["8.1 Random Walks",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:2"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t567"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "          ",
  ButtonBox["8.1.1 Introduction",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:3"},
    ButtonStyle->"Hyperlink"],
  "\t567"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["8.1.2 The Statistics of Random Walks",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:4"},
    ButtonStyle->"Hyperlink"],
  "\t568"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["The Random Walk Model",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:5"},
    ButtonStyle->"Hyperlink"],
  "\t568"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Simulations",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:6"},
    ButtonStyle->"Hyperlink"],
  "\t569"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["The Binomial Distribution",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:7"},
    ButtonStyle->"Hyperlink"],
  "\t575"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Averages",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:8"},
    ButtonStyle->"Hyperlink"],
  "\t578"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["The Heat and Fokker-Planck Equations from the Random Walk Model",
    
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:9"},
    ButtonStyle->"Hyperlink"],
  "\t581"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 8.1",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:10"},
    ButtonStyle->"Hyperlink"],
  "\t586"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["8.2 Thermal Equilibrium",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:11"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t592"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["8.2.1 Random Walks with Arbitrary Steps",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:12"},
    ButtonStyle->"Hyperlink"],
  "\t592"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Averages",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:13"},
    ButtonStyle->"Hyperlink"],
  "\t592"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Conditional Probability and the Master Equation",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:14"},
    ButtonStyle->"Hyperlink"],
  "\t594"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Correlation Functions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:15"},
    ButtonStyle->"Hyperlink"],
  "\t595"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Inhomogeneous Random Walks",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:16"},
    ButtonStyle->"Hyperlink"],
  "\t596"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["8.2.2 Simulations",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:17"},
    ButtonStyle->"Hyperlink"],
  "\t598"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Transformation Method",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:18"},
    ButtonStyle->"Hyperlink"],
  "\t598"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Rejection Method",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:19"},
    ButtonStyle->"Hyperlink"],
  "\t599"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Two Simulations of a Random Walk with Bias",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:20"},
    ButtonStyle->"Hyperlink"],
  "\t601"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["8.2.3 Thermal Equilibrium",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:21"},
    ButtonStyle->"Hyperlink"],
  "\t605"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["The Boltzmann Distribution",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:22"},
    ButtonStyle->"Hyperlink"],
  "\t605"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Einstein Relations",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:23"},
    ButtonStyle->"Hyperlink"],
  "\t606"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Irreversibility and the Free Energy",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:24"},
    ButtonStyle->"Hyperlink"],
  "\t607"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  "               ",
  ButtonBox["Comparison with Simulations",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:25"},
    ButtonStyle->"Hyperlink"],
  "\t607"
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 8.2",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:30"},
    ButtonStyle->"Hyperlink"],
  "\t609"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["8.3 The Rosenbluth-Teller-Metropolis Monte Carlo \
method",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:26"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold",
    FontColor->RGBColor[1, 0, 0]],
  " (Electronic Version Only)"
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic",
  FontColor->RGBColor[1, 0, 0]],

Cell[TextData[{
  "          ",
  ButtonBox["8.3.1 Theory",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:27"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["8.3.2 Simulations",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:32"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Example 1: Ideal Gas in Gravity",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:28"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Example 2: Lennard-Jones Clusters",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:29"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 8.3",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:33"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"]
}, Closed]],

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["References",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter8.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:31"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  "\t615"
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox[ButtonBox["Chapter 9: Introduction to ",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:1"},
    ButtonStyle->"Hyperlink"],
    FontSize->18,
    FontWeight->"Bold",
    FontColor->RGBColor[1, 0, 0]],
  StyleBox[ButtonBox["Mathematica",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:1"},
    ButtonStyle->"Hyperlink"],
    FontSize->18,
    FontWeight->"Bold",
    FontSlant->"Italic",
    FontColor->RGBColor[1, 0, 0]],
  " (Electronic Version Only)"
}], "Text",
  CellMargins->{{12, 0}, {0, 18}},
  CellGroupingRules->{"TitleGrouping", 0},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic",
  FontColor->RGBColor[1, 0, 0]],

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["9.1 Starting ",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:2"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  StyleBox[ButtonBox["Mathematica",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:2"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold",
    FontSlant->"Italic"]
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["9.2 ",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:3"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  StyleBox[ButtonBox["Mathematica",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:3"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold",
    FontSlant->"Italic"],
  StyleBox[ButtonBox[" Calculations",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:3"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"]
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.2.1 Arithmetic",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:4"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.2.2 Exact vs. Approximate Results",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:5"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.2.3 Some Intrinsic Functions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:6"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.2.4 Special Numbers",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:7"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.2.5 Complex Arithmetic",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:8"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.2.6 The Function ",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:9"},
    ButtonStyle->"Hyperlink"],
  StyleBox[ButtonBox["N",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:9"},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  ButtonBox[" and Arbitrary-Precision Numbers",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:9"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 9.2",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:10"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"]
}, Closed]],

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["9.3 The ",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:11"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  StyleBox[ButtonBox["Mathematica",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:11"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold",
    FontSlant->"Italic"],
  StyleBox[ButtonBox[" Front End and Kernel",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:11"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"]
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["9.4 Using Previous Results",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:12"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"]
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.4.1 The % Symbol",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:13"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.4.2 Variables",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:14"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.4.3 Palettes and Keyboard Equivalents",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:15"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["9.5 Lists, Vectors, and Matrices",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:16"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"]
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.5.1 Defining Lists, Vectors, and Matrices",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:17"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["9.5.2 Vector and Matrix Operations",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:18"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Vector Addition",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:19"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Dot Product",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:20"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Matrix Multiplication",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:21"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Other Matrix Operations",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:22"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["9.5.3 Creating Lists, Vectors, and Matrices with the Table \
Command",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:23"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.5.4 Operations on Lists",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:24"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 9.5",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:25"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["9.6 Plotting Results",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:26"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"]
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.6.1 The ",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:27"},
    ButtonStyle->"Hyperlink"],
  StyleBox[ButtonBox["Plot",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:27"},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  ButtonBox[" Command",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:27"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.6.2 The ",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:28"},
    ButtonStyle->"Hyperlink"],
  StyleBox[ButtonBox["Show",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:28"},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  ButtonBox[" Command",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:28"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.6.3 Plotting Several Curves on the Same Graph",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:29"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.6.4 The ",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:30"},
    ButtonStyle->"Hyperlink"],
  StyleBox[ButtonBox["ListPlot",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:30"},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  ButtonBox[" Function",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:30"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.6.5 Parametric Plots",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:31"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.6.6 3D Plots",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:32"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.6.7 Animations",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:33"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.6.8 Add-On Packages",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:34"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 9.6",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:35"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"]
}, Closed]],

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["9.7 Help for Mathematica Users",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:36"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"]
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["9.8 Computer Algebra",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:37"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"]
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.8.1 Manipulating Expressions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:38"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.8.2 Replacement",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:39"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["9.8.3 Defining Functions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:40"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Functions of One Variable",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:41"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Checking the Definition of a Function",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:42"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Functions of Several Variables",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:43"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["9.8.4 Applying Functions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:44"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.8.5 Delayed Evaluation of Functions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:45"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.8.6 Putting Conditions on Function Definitions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:46"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 9.8",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:47"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["9.9 Calculus",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:48"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"]
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.9.1 Derivatives",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:49"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.9.2 Power Series",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:50"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.9.3 Integration",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:51"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 9.9",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:52"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["9.10 Analytic Solution of Algebraic Equations",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:53"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"]
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["9.10.1 ",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:54"},
    ButtonStyle->"Hyperlink"],
  StyleBox[ButtonBox["Solve",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:54"},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  ButtonBox[" and ",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:54"},
    ButtonStyle->"Hyperlink"],
  StyleBox[ButtonBox["NSolve",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:54"},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["One Equation in a Single Variable",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:55"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Coupled Equations in Several Variables",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:56"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Linear Equations and Under-Determined Systems",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:57"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Nonlinear Equations",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:58"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 9.10",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:59"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["9.11 Numerical Analysis",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:60"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"]
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.11.1 Numerical Solution of Algebraic Equations",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:61"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.11.2 Numerical Integration",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:62"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.11.3 Interpolation",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:63"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["9.11.4 Fitting",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:64"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Reading Data from External Files",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:82"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"]
}, Closed]],

Cell[TextData[{
  "          ",
  ButtonBox["Exercises for Sec. 9.11",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:65"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["9.12 Summary of Basic ",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:67"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"],
  StyleBox[ButtonBox["Mathematica",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:67"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold",
    FontSlant->"Italic"],
  StyleBox[ButtonBox[" Commands",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:67"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"]
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.12.1 Elementary Functions",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:68"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.12.2 Using Previous Results; Substitution and Defining \
Variables",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:69"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "          ",
  ButtonBox["9.12.3 Lists, Tables, Vectors and Matrices",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:70"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["9.12.4 Graphics",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:72"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Basic Plotting",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:73"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Contour and Density Plots",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:74"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Three-Dimensional Surface Plots",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:75"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Plotting Lists of Data",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:76"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Parametric Plots",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:77"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Some Other Plots",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:78"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "          ",
  ButtonBox["9.12.5 Symbolic Mathematics",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:79"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 8}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Algebraic Equations",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:80"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"],

Cell[TextData[{
  "               ",
  ButtonBox["Differential Equations",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "c:81"},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellMargins->{{12, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"]
}, Closed]]
}, Closed]],

Cell[TextData[{
  "  ",
  StyleBox[ButtonBox["References",
    ButtonData:>{
      FrontEnd`FileName[ {}, "Chapter9.nb", CharacterEncoding -> 
        "MacintoshRoman"], "refs"},
    ButtonStyle->"Hyperlink"],
    FontSize->12,
    FontWeight->"Bold"]
}], "Text",
  CellMargins->{{12, 0}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  TabFilling->".",
  TabSpacings->45,
  FontSlant->"Italic"]
}, Closed]],

Cell[TextData[{
  StyleBox[ButtonBox["Appendix: Finite-Differenced Derivatives",
    ButtonData:>{"Appendix.nb", None},
    ButtonStyle->"Hyperlink"],
    FontSize->18,
    FontWeight->"Bold"],
  "\t617"
}], "Text",
  CellMargins->{{12, 0}, {0, 18}},
  CellGroupingRules->{"TitleGrouping", 0},
  TabFilling->".",
  TabSpacings->45],

Cell[TextData[{
  StyleBox[ButtonBox["Index",
    ButtonData:>{"Index.nb", None},
    ButtonStyle->"Hyperlink"],
    FontSize->18,
    FontWeight->"Bold"],
  "\t   620"
}], "Text",
  CellMargins->{{12, 0}, {0, 18}},
  CellGroupingRules->{"TitleGrouping", 0},
  TabFilling->".",
  TabSpacings->45]
},
FrontEndVersion->"4.1 for Macintosh",
ScreenRectangle->{{0, 1024}, {0, 746}},
ScreenStyleEnvironment->"AllBrackets",
CellGrouping->Manual,
WindowSize->{800, 556},
WindowMargins->{{1, Automatic}, {Automatic, 0}},
PageHeaders->{{Inherited, Inherited, Cell[ 
        TextData[ "Table of Contents"], "Header"]}, {Cell[ 
        TextData[ "Dubin"], "Header"], Cell[ 
        TextData[ 
        "Numerical and Analytical Methods for Scientists and Engineers"], 
        FontWeight -> Bold, FontSlant -> Italic, FontFamily -> Times], 
      Inherited}},
Magnification->1.25,
StyleDefinitions -> Notebook[{
  
  Cell[CellGroupData[{
  Cell["Style Definitions", "Subtitle"],
  
  Cell["\<\
Modify the definitions below to change the default appearance of \
all cells in a given style.  Make modifications to any definition using \
commands in the Format menu.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell["Style Environment Names", "Section"],
  
  Cell[StyleData[All, "Working"],
    PageWidth->WindowWidth,
    ShowCellBracket->False,
    CellLabelMargins->{{10, Inherited}, {Inherited, Inherited}},
    ScriptMinSize->9],
  
  Cell[StyleData[All, "AllBrackets"],
    PageWidth->WindowWidth,
    ShowCellBracket->True,
    ScriptMinSize->9],
  
  Cell[StyleData[All, "Presentation"],
    PageWidth->WindowWidth,
    ShowCellBracket->False,
    ShowGroupOpenCloseIcon->True,
    ScriptMinSize->9],
  
  Cell[StyleData[All, "Printout"],
    PageWidth->PaperWidth,
    ShowCellBracket->False,
    CellLabelMargins->{{2, Inherited}, {Inherited, Inherited}},
    ScriptMinSize->5,
    PrivateFontOptions->{"FontType"->"Outline"}],
  
  Cell[StyleData[All, "EnhancedPrintout"],
    PageWidth->PaperWidth,
    ShowCellBracket->False,
    CellLabelMargins->{{2, Inherited}, {Inherited, Inherited}},
    ScriptMinSize->5,
    PrivateFontOptions->{"FontType"->"Outline"}],
  
  Cell[StyleData[All, "EnhancedPrintoutNonGray"],
    PageWidth->PaperWidth,
    ShowCellBracket->False,
    CellLabelMargins->{{2, Inherited}, {Inherited, Inherited}},
    ScriptMinSize->5,
    PrivateFontOptions->{"FontType"->"Outline"}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Notebook Options", "Section"],
  
  Cell["\<\
The options defined for the style below will be used at the \
Notebook level.\
\>", "Text"],
  
  Cell[StyleData["Notebook"],
    PrintingStyleEnvironment->"Printout",
    PageHeaders->{{Cell[ 
            TextData[ {
              CounterBox[ "Page"]}], "PageNumber"], None, Cell[ 
            TextData[ {
              ValueBox[ "FileName"]}], "Header"]}, {Cell[ 
            TextData[ {
              ValueBox[ "FileName"]}], "Header"], None, Cell[ 
            TextData[ {
              CounterBox[ "Page"]}], "PageNumber"]}},
    PrintingOptions->{"PrintingMargins"->{{97, 97}, {180, 64}},
    "FirstPageHeader"->False,
    "FacingPages"->True},
    CellLabelAutoDelete->False,
    CellFrameLabelMargins->6,
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Styles for Headings", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Title"],
    CellMargins->{{12, Inherited}, {20, 40}},
    CellGroupingRules->{"TitleGrouping", 0},
    PageBreakAbove->True,
    PageBreakBelow->False,
    LineSpacing->{1, 11},
    CounterIncrements->"Title",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
        "Subtitle", 0}, {"Subsubtitle", 0}},
    FontFamily->"Helvetica",
    FontSize->36,
    FontWeight->"Bold"],
  
  Cell[StyleData["Title", "Printout"],
    CellMargins->{{2, 10}, {15, 30}},
    FontSize->30],
  
  Cell[StyleData["Title", "EnhancedPrintout"],
    CellMargins->{{2, 10}, {15, 30}},
    FontFamily->"Futura",
    FontSize->30],
  
  Cell[StyleData["Title", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 10}, {15, 30}},
    FontFamily->"Futura",
    FontSize->30]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subtitle"],
    CellMargins->{{12, Inherited}, {10, 2}},
    CellGroupingRules->{"TitleGrouping", 10},
    PageBreakBelow->False,
    LineSpacing->{1, 11},
    CounterIncrements->"Subtitle",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
        "Subsubtitle", 0}},
    FontFamily->"Helvetica",
    FontSize->28],
  
  Cell[StyleData["Subtitle", "Printout"],
    CellMargins->{{2, 10}, {10, 15}},
    FontSize->24],
  
  Cell[StyleData["Subtitle", "EnhancedPrintout"],
    CellMargins->{{2, 10}, {10, 15}},
    FontFamily->"Futura",
    FontSize->24],
  
  Cell[StyleData["Subtitle", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 10}, {10, 15}},
    FontFamily->"Futura",
    FontSize->24]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsubtitle"],
    CellMargins->{{12, Inherited}, {10, 20}},
    CellGroupingRules->{"TitleGrouping", 20},
    PageBreakBelow->False,
    CounterIncrements->"Subsubtitle",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}},
    FontFamily->"Helvetica",
    FontSize->14,
    FontSlant->"Italic"],
  
  Cell[StyleData["Subsubtitle", "Printout"],
    CellMargins->{{2, 10}, {8, 10}},
    FontSize->12],
  
  Cell[StyleData["Subsubtitle", "EnhancedPrintout"],
    CellMargins->{{2, 10}, {8, 10}},
    FontFamily->"Futura",
    FontSize->12],
  
  Cell[StyleData["Subsubtitle", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 10}, {8, 10}},
    FontFamily->"Futura",
    FontSize->12]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Section"],
    CellFrame->{{0, 0}, {0.5, 0}},
    CellMargins->{{10, Inherited}, {8, 30}},
    CellGroupingRules->{"SectionGrouping", 30},
    PageBreakBelow->False,
    CellFrameMargins->8,
    LineSpacing->{1, 7},
    CounterIncrements->"Section",
    CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}},
    FontFamily->"Helvetica",
    FontSize->20,
    FontWeight->"Bold",
    CellTags->"Section"],
  
  Cell[StyleData["Section", "Printout"],
    CellMargins->{{2, 0}, {7, 24}},
    FontSize->16],
  
  Cell[StyleData["Section", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {7, 24}},
    FontFamily->"Futura",
    FontSize->16],
  
  Cell[StyleData["Section", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {7, 24}},
    FontFamily->"Futura",
    FontSize->16]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsection"],
    CellDingbat->"\[FilledSquare]",
    CellMargins->{{24, Inherited}, {8, 30}},
    CellGroupingRules->{"SectionGrouping", 40},
    PageBreakBelow->False,
    CounterIncrements->"Subsection",
    CounterAssignments->{{"Subsubsection", 0}},
    FontFamily->"Helvetica",
    FontSize->14,
    FontWeight->"Bold",
    CellTags->"Subsection"],
  
  Cell[StyleData["Subsection", "Printout"],
    CellMargins->{{9, 0}, {7, 24}},
    FontSize->12],
  
  Cell[StyleData["Subsection", "EnhancedPrintout"],
    CellMargins->{{9, 0}, {7, 24}},
    FontFamily->"Futura",
    FontSize->14],
  
  Cell[StyleData["Subsection", "EnhancedPrintoutNonGray"],
    CellMargins->{{9, 0}, {7, 24}},
    FontFamily->"Futura",
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsubsection"],
    CellMargins->{{12, Inherited}, {8, 24}},
    CellGroupingRules->{"SectionGrouping", 50},
    PageBreakBelow->False,
    CounterIncrements->"Subsubsection",
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    CellTags->"Subsubsection"],
  
  Cell[StyleData["Subsubsection", "Printout"],
    CellMargins->{{2, 0}, {7, 18}},
    FontSize->10],
  
  Cell[StyleData["Subsubsection", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {7, 18}},
    FontFamily->"Futura",
    FontSize->10],
  
  Cell[StyleData["Subsubsection", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {7, 18}},
    FontFamily->"Futura",
    FontSize->10]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Styles for Body Text", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Text"],
    CellMargins->{{12, 10}, {7, 7}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0.7, 0},
    CounterIncrements->"Text"],
  
  Cell[StyleData["Text", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    FontSize->11],
  
  Cell[StyleData["Text", "EnhancedPrintout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["Text", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SmallText"],
    CellMargins->{{12, 10}, {6, 6}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0.7, 0},
    CounterIncrements->"SmallText",
    FontSize->9],
  
  Cell[StyleData["SmallText", "Printout"],
    CellMargins->{{2, 2}, {5, 5}},
    TextJustification->1,
    FontSize->7],
  
  Cell[StyleData["SmallText", "EnhancedPrintout"],
    CellMargins->{{2, 2}, {5, 5}},
    TextJustification->1,
    FontFamily->"Palatino",
    FontSize->7],
  
  Cell[StyleData["SmallText", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 2}, {5, 5}},
    TextJustification->1,
    FontFamily->"Palatino",
    FontSize->7]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["CopyrightText"],
    CellMargins->{{10, 4}, {0, 8}},
    ParagraphSpacing->{0, 0},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10],
  
  Cell[StyleData["CopyrightText", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->8]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Styles for Input/Output", "Section"],
  
  Cell["\<\
The cells in this section define styles used for input and output \
to the kernel.  Be careful when modifying, renaming, or removing these \
styles, because the front end associates special meanings with these style \
names.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Input"],
    ShowCellBracket->True,
    CellMargins->{{45, 10}, {5, 7}},
    Evaluatable->True,
    CellGroupingRules->"InputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    DefaultFormatType->DefaultInputFormatType,
    AutoItalicWords->{},
    FormatType->InputForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    CounterIncrements->"Input",
    FontWeight->"Bold"],
  
  Cell[StyleData["Input", "Printout"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {4, 6}},
    FontSize->9],
  
  Cell[StyleData["Input", "EnhancedPrintout"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {4, 6}},
    FontSize->9],
  
  Cell[StyleData["Input", "EnhancedPrintoutNonGray"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {4, 6}},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Output"],
    ShowCellBracket->True,
    CellMargins->{{46, 10}, {7, 5}},
    CellEditDuplicate->True,
    CellGroupingRules->"OutputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    DefaultFormatType->DefaultOutputFormatType,
    AutoItalicWords->{},
    FormatType->InputForm,
    CounterIncrements->"Output"],
  
  Cell[StyleData["Output", "Printout"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {6, 4}},
    FontSize->9],
  
  Cell[StyleData["Output", "EnhancedPrintout"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {6, 4}},
    FontSize->9],
  
  Cell[StyleData["Output", "EnhancedPrintoutNonGray"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {6, 4}},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Message"],
    ShowCellBracket->True,
    CellMargins->{{45, Inherited}, {Inherited, Inherited}},
    CellGroupingRules->"OutputGrouping",
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    CellLabelMargins->{{11, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultOutputFormatType,
    AutoItalicWords->{},
    FormatType->InputForm,
    CounterIncrements->"Message",
    StyleMenuListing->None,
    FontSlant->"Italic",
    FontColor->RGBColor[1, 0, 0]],
  
  Cell[StyleData["Message", "Printout"],
    ShowCellBracket->False,
    CellMargins->{{39, Inherited}, {Inherited, Inherited}},
    FontSize->9,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Message", "EnhancedPrintout"],
    ShowCellBracket->False,
    CellMargins->{{39, Inherited}, {Inherited, Inherited}},
    FontFamily->"Courier",
    FontSize->9,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Message", "EnhancedPrintoutNonGray"],
    ShowCellBracket->False,
    CellMargins->{{39, Inherited}, {Inherited, Inherited}},
    FontFamily->"Courier",
    FontSize->9,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Print"],
    ShowCellBracket->True,
    CellMargins->{{75, Inherited}, {Inherited, Inherited}},
    CellGroupingRules->"OutputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    CellLabelMargins->{{11, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultOutputFormatType,
    AutoItalicWords->{},
    FormatType->InputForm,
    CounterIncrements->"Print",
    StyleMenuListing->None],
  
  Cell[StyleData["Print", "Printout"],
    ShowCellBracket->False,
    CellMargins->{{57, Inherited}, {Inherited, Inherited}},
    FontSize->9],
  
  Cell[StyleData["Print", "EnhancedPrintout"],
    ShowCellBracket->False,
    CellMargins->{{57, Inherited}, {Inherited, Inherited}},
    FontFamily->"Courier",
    FontSize->9],
  
  Cell[StyleData["Print", "EnhancedPrintoutNonGray"],
    ShowCellBracket->False,
    CellMargins->{{57, Inherited}, {Inherited, Inherited}},
    FontFamily->"Courier",
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Graphics"],
    ShowCellBracket->True,
    CellMargins->{{47, Inherited}, {Inherited, Inherited}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    DefaultFormatType->DefaultOutputFormatType,
    FormatType->InputForm,
    CounterIncrements->"Graphics",
    StyleMenuListing->None],
  
  Cell[StyleData["Graphics", "Printout"],
    ShowCellBracket->False,
    CellMargins->{{39, Inherited}, {Inherited, Inherited}},
    ImageSize->{250, 250},
    FontSize->9],
  
  Cell[StyleData["Graphics", "EnhancedPrintout"],
    ShowCellBracket->False,
    CellMargins->{{39, Inherited}, {Inherited, Inherited}},
    ImageSize->{250, 250},
    FontFamily->"Courier",
    FontSize->9],
  
  Cell[StyleData["Graphics", "EnhancedPrintoutNonGray"],
    ShowCellBracket->False,
    CellMargins->{{39, Inherited}, {Inherited, Inherited}},
    ImageSize->{250, 250},
    FontFamily->"Courier",
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["CellLabel"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9,
    FontColor->RGBColor[0, 0, 1]],
  
  Cell[StyleData["CellLabel", "Printout"],
    FontFamily->"Courier",
    FontSize->8,
    FontSlant->"Italic",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["CellLabel", "EnhancedPrintout"],
    FontFamily->"Courier",
    FontSize->8,
    FontSlant->"Italic",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["CellLabel", "EnhancedPrintoutNonGray"],
    FontFamily->"Courier",
    FontSize->8,
    FontSlant->"Italic",
    FontColor->GrayLevel[0]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Inline Formatting", "Section"],
  
  Cell["\<\
These styles are for modifying individual words or letters in a \
cell exclusive of the cell tag.\
\>", "Text"],
  
  Cell[StyleData["RM"],
    StyleMenuListing->None,
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["BF"],
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["IT"],
    StyleMenuListing->None,
    FontSlant->"Italic"],
  
  Cell[StyleData["TR"],
    StyleMenuListing->None,
    FontFamily->"Times",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["TI"],
    StyleMenuListing->None,
    FontFamily->"Times",
    FontWeight->"Plain",
    FontSlant->"Italic"],
  
  Cell[StyleData["TB"],
    StyleMenuListing->None,
    FontFamily->"Times",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  
  Cell[StyleData["TBI"],
    StyleMenuListing->None,
    FontFamily->"Times",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  
  Cell[StyleData["MR"],
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["MO"],
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontWeight->"Plain",
    FontSlant->"Italic"],
  
  Cell[StyleData["MB"],
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  
  Cell[StyleData["MBO"],
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  
  Cell[StyleData["SR"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["SO"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Plain",
    FontSlant->"Italic"],
  
  Cell[StyleData["SB"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  
  Cell[StyleData["SBO"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SO10"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10,
    FontWeight->"Plain",
    FontSlant->"Italic"],
  
  Cell[StyleData["SO10", "Printout"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->7,
    FontWeight->"Plain",
    FontSlant->"Italic"],
  
  Cell[StyleData["SO10", "EnhancedPrintout"],
    StyleMenuListing->None,
    FontFamily->"Futura",
    FontSize->7,
    FontWeight->"Plain",
    FontSlant->"Italic"]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Miscellaneous Styles", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MathCaption"],
    CellDingbat->"\[FilledSmallSquare]",
    CellMargins->{{46, 42}, {0, 14}},
    PageBreakBelow->False,
    LineSpacing->{1, 1},
    ParagraphSpacing->{0, 8},
    FontColor->RGBColor[0, 0, 0.6]],
  
  Cell[StyleData["MathCaption", "Printout"],
    CellMargins->{{42, 42}, {0, 14}},
    FontSize->10,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["MathCaption", "EnhancedPrintout"],
    CellMargins->{{42, 42}, {0, 14}},
    FontFamily->"Palatino",
    FontSize->10,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["MathCaption", "EnhancedPrintoutNonGray"],
    CellMargins->{{42, 42}, {0, 14}},
    FontFamily->"Palatino",
    FontSize->10,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Commentary"],
    CellFrame->{{2, 0}, {0, 0}},
    CellMargins->{{36, 10}, {7, 7}},
    PageBreakBelow->False,
    CellFrameMargins->8,
    CellFrameColor->RGBColor[0, 0.2, 1],
    LineSpacing->{1, 3},
    ParagraphSpacing->{0, 8},
    FontSlant->"Italic"],
  
  Cell[StyleData["Commentary", "Printout"],
    CellMargins->{{36, 0}, {6, 6}},
    CellFrameColor->GrayLevel[0.8],
    FontSize->10],
  
  Cell[StyleData["Commentary", "EnhancedPrintout"],
    CellMargins->{{36, 0}, {6, 6}},
    CellFrameColor->GrayLevel[0.8],
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["Commentary", "EnhancedPrintoutNonGray"],
    CellMargins->{{36, 0}, {6, 6}},
    CellFrameColor->GrayLevel[0.8],
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedText"],
    CellMargins->{{20, 4}, {0, 4}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0, 4},
    ParagraphIndent->-21,
    CounterIncrements->"ItemizedText"],
  
  Cell[StyleData["ItemizedText", "Printout"],
    ParagraphIndent->-18,
    FontSize->11],
  
  Cell[StyleData["ItemizedText", "EnhancedPrintout"],
    ParagraphIndent->-18,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["ItemizedText", "EnhancedPrintoutNonGray"],
    ParagraphIndent->-18,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedTextNote"],
    CellMargins->{{41, 4}, {0, 4}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0, 4},
    CounterIncrements->"Text"],
  
  Cell[StyleData["ItemizedTextNote", "Printout"],
    CellMargins->{{38, 4}, {0, 4}},
    FontSize->11],
  
  Cell[StyleData["ItemizedTextNote", "EnhancedPrintout"],
    CellMargins->{{38, 4}, {0, 4}},
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["ItemizedTextNote", "EnhancedPrintoutNonGray"],
    CellMargins->{{38, 4}, {0, 4}},
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["BulletText"],
    CellMargins->{{20, 4}, {0, 4}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0, 4},
    ParagraphIndent->-21],
  
  Cell[StyleData["BulletText", "Printout"],
    ParagraphIndent->-18,
    FontSize->11],
  
  Cell[StyleData["BulletText", "EnhancedPrintout"],
    ParagraphIndent->-18,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["BulletText", "EnhancedPrintoutNonGray"],
    ParagraphIndent->-18,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["IndentedText"],
    CellMargins->{{20, 4}, {0, 6}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0, 8},
    CounterIncrements->"Text"],
  
  Cell[StyleData["IndentedText", "Printout"],
    FontSize->10],
  
  Cell[StyleData["IndentedText", "EnhancedPrintout"],
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["IndentedText", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Emphasis Boxes and Pictures", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DefinitionBox"],
    CellFrame->0.5,
    CellMargins->{{10, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    AutoIndent->False,
    AutoSpacing->False,
    ShowStringCharacters->True,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[1, 0.6, 0.6],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.3, 0.7},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["DefinitionBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["DefinitionBox", "EnhancedPrintout"],
    CellMargins->{{2, 4}, {0, 8}},
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["DefinitionBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 4}, {0, 8}},
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DefinitionBox3Col"],
    CellFrame->0.5,
    CellMargins->{{10, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    AutoIndent->False,
    AutoSpacing->False,
    ShowStringCharacters->True,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[1, 0.6, 0.6],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.2, 0.3, 0.5},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["DefinitionBox3Col", "Printout"],
    CellMargins->{{2, 4}, {0, 8}},
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["DefinitionBox3Col", "EnhancedPrintout"],
    CellMargins->{{2, 4}, {0, 8}},
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["DefinitionBox3Col", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 4}, {0, 8}},
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DefinitionBox4Col"],
    CellFrame->0.5,
    CellMargins->{{10, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    AutoIndent->False,
    AutoSpacing->False,
    ShowStringCharacters->True,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[1, 0.6, 0.6],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.15, 0.35, 0.15, 0.35},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["DefinitionBox4Col", "Printout"],
    CellMargins->{{2, 4}, {0, 8}},
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["DefinitionBox4Col", "EnhancedPrintout"],
    CellMargins->{{2, 4}, {0, 8}},
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["DefinitionBox4Col", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 4}, {0, 8}},
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DefinitionBox5Col"],
    CellFrame->0.5,
    CellMargins->{{10, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    AutoIndent->False,
    AutoSpacing->False,
    ShowStringCharacters->True,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[1, 0.6, 0.6],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->0.2,
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["DefinitionBox5Col", "Printout"],
    CellMargins->{{2, 4}, {0, 8}},
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["DefinitionBox5Col", "EnhancedPrintout"],
    CellMargins->{{2, 4}, {0, 8}},
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["DefinitionBox5Col", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 4}, {0, 8}},
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DefinitionBox6Col"],
    CellFrame->0.5,
    CellMargins->{{10, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    AutoIndent->False,
    AutoSpacing->False,
    ShowStringCharacters->True,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[1, 0.6, 0.6],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.13, 0.24, 0.13, 0.13, 0.24, 0.13},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["DefinitionBox6Col", "Printout"],
    CellMargins->{{2, 4}, {0, 8}},
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["DefinitionBox6Col", "EnhancedPrintout"],
    CellMargins->{{2, 4}, {0, 8}},
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["DefinitionBox6Col", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 4}, {0, 8}},
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TopBox"],
    CellFrame->{{0.5, 0.5}, {0, 0.5}},
    CellMargins->{{11, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakBelow->False,
    AutoIndent->False,
    AutoSpacing->False,
    ShowStringCharacters->True,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[1, 0.6, 0.6],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.31, 0.62},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["TopBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["TopBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["TopBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MiddleBox"],
    CellFrame->{{0.5, 0.5}, {0, 0}},
    CellMargins->{{11, 4}, {0, -7}},
    CellHorizontalScrolling->True,
    PageBreakAbove->False,
    PageBreakBelow->False,
    AutoIndent->False,
    AutoSpacing->False,
    ShowStringCharacters->True,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[1, 0.6, 0.6],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.31, 0.62},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["MiddleBox", "Printout"],
    CellMargins->{{2, 0}, {0, 2}},
    ShowStringCharacters->True,
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["MiddleBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 4}},
    ShowStringCharacters->True,
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["MiddleBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 4}},
    ShowStringCharacters->True,
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MiddleSpacedBox"],
    CellFrame->{{0.5, 0.5}, {0, 0}},
    CellMargins->{{11, 4}, {0, -7}},
    CellHorizontalScrolling->True,
    PageBreakAbove->False,
    PageBreakBelow->False,
    AutoIndent->False,
    AutoSpacing->False,
    ShowStringCharacters->True,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[1, 0.6, 0.6],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.31, 0.62},
    ColumnAlignments->{Left},
    RowMinHeight->1.2}],
  
  Cell[StyleData["MiddleSpacedBox", "Printout"],
    CellMargins->{{2, 0}, {0, 0}},
    FontSize->10,
    Background->GrayLevel[0.900008],
    GridBoxOptions->{RowMinHeight->1.8}],
  
  Cell[StyleData["MiddleSpacedBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 0}},
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[0.900008],
    GridBoxOptions->{RowMinHeight->1.8}],
  
  Cell[StyleData["MiddleSpacedBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 0}},
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1],
    GridBoxOptions->{RowMinHeight->1.8}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["BottomBox"],
    CellFrame->{{0.5, 0.5}, {0.5, 0}},
    CellMargins->{{11, 4}, {0, -7}},
    CellHorizontalScrolling->True,
    PageBreakAbove->False,
    PageBreakBelow->False,
    AutoIndent->False,
    AutoSpacing->False,
    ShowStringCharacters->True,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[1, 0.6, 0.6],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.31, 0.62},
    ColumnAlignments->{Left},
    RowMinHeight->1.2}],
  
  Cell[StyleData["BottomBox", "Printout"],
    CellMargins->{{2, 0}, {0, -5}},
    FontSize->10,
    Background->GrayLevel[0.900008],
    GridBoxOptions->{RowMinHeight->2.2}],
  
  Cell[StyleData["BottomBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, -5}},
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[0.900008],
    GridBoxOptions->{RowMinHeight->2.2}],
  
  Cell[StyleData["BottomBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, -5}},
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1],
    GridBoxOptions->{RowMinHeight->2.2}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TopSpanBox"],
    CellFrame->{{0.5, 0.5}, {0, 0.5}},
    CellMargins->{{11, 4}, {-2, 8}},
    CellHorizontalScrolling->True,
    PageBreakBelow->False,
    AutoIndent->False,
    AutoSpacing->False,
    ShowStringCharacters->True,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[1, 0.6, 0.6],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.9, 0.03},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["TopSpanBox", "Printout"],
    CellMargins->{{2, 0}, {-2, 8}},
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["TopSpanBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {-4, 8}},
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["TopSpanBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {-4, 8}},
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MiddleSpanBox"],
    CellFrame->{{0.5, 0.5}, {0, 0}},
    CellMargins->{{11, 4}, {-3, -8}},
    CellHorizontalScrolling->True,
    PageBreakAbove->False,
    PageBreakBelow->False,
    AutoIndent->False,
    AutoSpacing->False,
    ShowStringCharacters->True,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[1, 0.6, 0.6],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.9, 0.03},
    ColumnAlignments->{Left},
    RowMinHeight->1.2}],
  
  Cell[StyleData["MiddleSpanBox", "Printout"],
    CellMargins->{{2, 0}, {-5, 0}},
    FontSize->10,
    Background->GrayLevel[0.900008],
    GridBoxOptions->{RowMinHeight->1.8}],
  
  Cell[StyleData["MiddleSpanBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {-7, 0}},
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[0.900008],
    GridBoxOptions->{RowMinHeight->1.8}],
  
  Cell[StyleData["MiddleSpanBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {-7, 0}},
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1],
    GridBoxOptions->{RowMinHeight->1.8}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Picture"],
    CellMargins->{{12, Inherited}, {0, 8}},
    CellHorizontalScrolling->True],
  
  Cell[StyleData["Picture", "Printout"],
    CellMargins->{{2, Inherited}, {0, 8}}],
  
  Cell[StyleData["Picture", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {0, 8}}],
  
  Cell[StyleData["Picture", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {0, 8}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Caption"],
    CellMargins->{{12, 4}, {0, 2}},
    PageBreakAbove->False,
    FontFamily->"Helvetica",
    FontSize->9],
  
  Cell[StyleData["Caption", "Printout"],
    CellMargins->{{2, 4}, {2, 4}},
    FontSize->7],
  
  Cell[StyleData["Caption", "EnhancedPrintout"],
    CellMargins->{{2, 4}, {2, 4}},
    FontFamily->"Futura",
    FontSize->7],
  
  Cell[StyleData["Caption", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 4}, {2, 4}},
    FontFamily->"Futura",
    FontSize->7]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Tables", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SingleRowTable"],
    CellMargins->{{10, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    AutoIndent->False,
    AutoSpacing->False,
    ShowStringCharacters->True,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->2,
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["SingleRowTable", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10],
  
  Cell[StyleData["SingleRowTable", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10],
  
  Cell[StyleData["SingleRowTable", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["2ColumnTable"],
    CellMargins->{{10, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    AutoIndent->False,
    AutoSpacing->False,
    ShowStringCharacters->True,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->2,
    ColumnWidths->{0.34, 0.64},
    ColumnAlignments->{Left, Center}}],
  
  Cell[StyleData["2ColumnTable", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10],
  
  Cell[StyleData["2ColumnTable", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10],
  
  Cell[StyleData["2ColumnTable", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["2ColumnEvenTable"],
    CellMargins->{{10, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    AutoIndent->False,
    AutoSpacing->False,
    ShowStringCharacters->True,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->2,
    ColumnWidths->0.49,
    ColumnAlignments->{Left, Center}}],
  
  Cell[StyleData["2ColumnEvenTable", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10],
  
  Cell[StyleData["2ColumnEvenTable", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10],
  
  Cell[StyleData["2ColumnEvenTable", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["3ColumnTable"],
    PageWidth->400,
    CellMargins->{{10, 10}, {1, 1}},
    CellHorizontalScrolling->True,
    ShowStringCharacters->True,
    CounterIncrements->"Table",
    StyleMenuListing->None,
    GridBoxOptions->{ColumnWidths->0.336,
    RowAlignments->Center,
    ColumnAlignments->{Left, Center},
    GridFrame->{{0, 0}, {0.5, 2}},
    RowLines->{True, False},
    ColumnLines->False,
    GridDefaultElement:>Cell[ "Your Data", "TableText"]}],
  
  Cell[StyleData["3ColumnTable", "Printout"],
    CellMargins->{{2, 10}, {1, 1}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["3ColumnTablePlain"],
    PageWidth->400,
    CellMargins->{{12, 10}, {7, 7}},
    CellHorizontalScrolling->True,
    ShowStringCharacters->True,
    CounterIncrements->"Table",
    StyleMenuListing->None,
    GridBoxOptions->{ColumnWidths->0.336,
    RowAlignments->Center,
    ColumnAlignments->{Left, Center},
    GridFrame->{{0, 0}, {0.5, 2}},
    RowLines->{True, False},
    ColumnLines->False,
    GridDefaultElement:>Cell[ "Your Data", "TableText"]}],
  
  Cell[StyleData["3ColumnTablePlain", "Printout"],
    CellMargins->{{2, 10}, {4, 4}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["4ColumnTable"],
    PageWidth->400,
    CellMargins->{{10, 10}, {1, 1}},
    CellHorizontalScrolling->True,
    ShowStringCharacters->True,
    CounterIncrements->"Table",
    StyleMenuListing->None,
    GridBoxOptions->{ColumnWidths->0.251,
    RowAlignments->Center,
    ColumnAlignments->{Left, Center},
    GridFrame->{{0, 0}, {0.5, 2}},
    RowLines->{True, False},
    ColumnLines->False,
    GridDefaultElement:>Cell[ "Your Data", "TableText"]}],
  
  Cell[StyleData["4ColumnTable", "Printout"],
    CellMargins->{{2, 10}, {1, 1}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["4ColumnTablePlain"],
    PageWidth->400,
    CellMargins->{{12, 10}, {7, 7}},
    CellHorizontalScrolling->True,
    ShowStringCharacters->True,
    CounterIncrements->"Table",
    StyleMenuListing->None,
    GridBoxOptions->{ColumnWidths->0.251,
    RowAlignments->Center,
    ColumnAlignments->{Left, Center},
    GridFrame->{{0, 0}, {0.5, 2}},
    RowLines->{True, False},
    ColumnLines->False,
    GridDefaultElement:>Cell[ "Your Data", "TableText"]}],
  
  Cell[StyleData["4ColumnTablePlain", "Printout"],
    CellMargins->{{2, 10}, {4, 4}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["5ColumnTable"],
    PageWidth->400,
    CellMargins->{{10, 10}, {1, 1}},
    CellHorizontalScrolling->True,
    ShowStringCharacters->True,
    CounterIncrements->"Table",
    StyleMenuListing->None,
    GridBoxOptions->{ColumnWidths->0.201,
    RowAlignments->Center,
    ColumnAlignments->{Left, Center},
    GridFrame->{{0, 0}, {0.5, 2}},
    RowLines->{True, False},
    ColumnLines->False,
    GridDefaultElement:>Cell[ "Your Data", "TableText"]}],
  
  Cell[StyleData["5ColumnTable", "Printout"],
    CellMargins->{{2, 10}, {1, 1}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["5ColumnTablePlain"],
    PageWidth->400,
    CellMargins->{{12, 10}, {7, 7}},
    CellHorizontalScrolling->True,
    ShowStringCharacters->True,
    CounterIncrements->"Table",
    StyleMenuListing->None,
    GridBoxOptions->{ColumnWidths->0.201,
    RowAlignments->Center,
    ColumnAlignments->{Left, Center},
    GridFrame->{{0, 0}, {0.5, 2}},
    RowLines->{True, False},
    ColumnLines->False,
    GridDefaultElement:>Cell[ "Your Data", "TableText"]}],
  
  Cell[StyleData["5ColumnTablePlain", "Printout"],
    CellMargins->{{2, 10}, {4, 4}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["6ColumnTable"],
    CellMargins->{{10, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    AutoIndent->False,
    AutoSpacing->False,
    ShowStringCharacters->True,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->2,
    ColumnWidths->0.16,
    ColumnAlignments->{Left, Center}}],
  
  Cell[StyleData["6ColumnTable", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10],
  
  Cell[StyleData["6ColumnTable", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10],
  
  Cell[StyleData["6ColumnTable", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["7ColumnTable"],
    CellMargins->{{10, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    AutoIndent->False,
    AutoSpacing->False,
    ShowStringCharacters->True,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->2,
    ColumnWidths->0.14,
    ColumnAlignments->{Left, Center}}],
  
  Cell[StyleData["7ColumnTable", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10],
  
  Cell[StyleData["7ColumnTable", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10],
  
  Cell[StyleData["7ColumnTable", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["8ColumnTable"],
    CellMargins->{{10, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    AutoIndent->False,
    AutoSpacing->False,
    ShowStringCharacters->True,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->2,
    ColumnWidths->0.12,
    ColumnAlignments->{Left, Center}}],
  
  Cell[StyleData["8ColumnTable", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10],
  
  Cell[StyleData["8ColumnTable", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10],
  
  Cell[StyleData["8ColumnTable", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TableHead"],
    PageWidth->400,
    CellMargins->{{12, 10}, {1, 7}},
    LineSpacing->{1, 2},
    CounterIncrements->"TableHead",
    StyleMenuListing->None,
    FontFamily->"Times",
    FontWeight->"Bold",
    GridBoxOptions->{ColumnWidths->40,
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["TableHead", "Printout"],
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Table"],
    PageWidth->400,
    CellMargins->{{10, 10}, {1, 1}},
    CellHorizontalScrolling->True,
    ShowStringCharacters->True,
    CounterIncrements->"Table",
    StyleMenuListing->None,
    GridBoxOptions->{ColumnWidths->0.503,
    RowAlignments->Center,
    ColumnAlignments->{Left, Center},
    GridFrame->{{0, 0}, {0.5, 2}},
    RowLines->{True, False},
    ColumnLines->False,
    GridDefaultElement:>Cell[ "Your Data", "TableText"]}],
  
  Cell[StyleData["Table", "Printout"],
    CellMargins->{{2, 10}, {1, 1}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TablePlain"],
    PageWidth->400,
    CellMargins->{{12, 10}, {7, 7}},
    CellHorizontalScrolling->True,
    ShowStringCharacters->True,
    CounterIncrements->"Table",
    StyleMenuListing->None,
    GridBoxOptions->{ColumnWidths->0.503,
    RowAlignments->Center,
    ColumnAlignments->{Left, Center},
    GridFrame->{{0, 0}, {0.5, 2}},
    RowLines->{True, False},
    ColumnLines->False,
    GridDefaultElement:>Cell[ "Your Data", "TableText"]}],
  
  Cell[StyleData["TablePlain", "Printout"],
    CellMargins->{{2, 10}, {4, 4}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TableNote"],
    PageWidth->400,
    CellMargins->{{12, 10}, {7, 1}},
    LineSpacing->{1, 1},
    ParagraphSpacing->{0.3, 0},
    FontFamily->"Times",
    FontSize->10],
  
  Cell[StyleData["TableNote", "Printout"],
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Inline Styles for Tables", "Subsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TableHeadText"],
    CounterIncrements->"TableHead",
    FontFamily->"Times",
    FontWeight->"Plain"],
  
  Cell[StyleData["TableHeadText", "Printout"],
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ColumnHead"],
    CounterIncrements->"Table",
    FontFamily->"Times",
    FontSlant->"Italic"],
  
  Cell[StyleData["ColumnHead", "Printout"],
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TableText"],
    TextAlignment->Left,
    LineSpacing->{1, 1},
    FontFamily->"Times",
    FontSize->12],
  
  Cell[StyleData["TableText", "Printout"],
    FontSize->10]
  }, Closed]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Styles for Automatic Numbering", "Section"],
  
  Cell["\<\
The following styles are useful for numbered equations, figures, \
etc.  They automatically give the cell a FrameLabel containing a reference to \
a particular counter, and also increment that counter.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["NumberedEquation"],
    CellMargins->{{45, 10}, {7, 7}},
    CellFrameLabels->{{None, Cell[ 
            TextData[ {"(", 
              CounterBox[ "NumberedEquation"], ")"}]]}, {None, None}},
    DefaultFormatType->DefaultTextFormatType,
    SpanMaxSize->Infinity,
    CounterIncrements->"NumberedEquation",
    FormatTypeAutoConvert->False],
  
  Cell[StyleData["NumberedEquation", "Printout"],
    CellMargins->{{39, 55}, {0, 10}},
    FontSize->10],
  
  Cell[StyleData["NumberedEquation", "EnhancedPrintout"],
    CellMargins->{{39, 55}, {0, 10}},
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["NumberedEquation", "EnhancedPrintoutNonGray"],
    CellMargins->{{39, 55}, {0, 10}},
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Formulas and Programming", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DisplayFormula"],
    CellMargins->{{45, Inherited}, {7, 7}},
    CellHorizontalScrolling->True,
    ScriptLevel->0,
    SingleLetterItalics->True,
    SpanMaxSize->Infinity,
    UnderoverscriptBoxOptions->{LimitsPositioning->True}],
  
  Cell[StyleData["DisplayFormula", "Printout"],
    FontSize->10],
  
  Cell[StyleData["DisplayFormula", "EnhancedPrintout"],
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["DisplayFormula", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DisplayMath"],
    CellMargins->{{45, 10}, {7, 7}},
    Evaluatable->False,
    CellGroupingRules->"InputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    DefaultFormatType->DefaultInputFormatType,
    AutoItalicWords->{},
    FormatType->InputForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    CounterIncrements->"Input"],
  
  Cell[StyleData["DisplayMath", "Printout"],
    CellMargins->{{39, 0}, {6, 6}},
    FontSize->9],
  
  Cell[StyleData["DisplayMath", "EnhancedPrintout"],
    CellMargins->{{39, 0}, {4, 6}},
    FontFamily->"WRICourier",
    FontSize->9],
  
  Cell[StyleData["DisplayMath", "EnhancedPrintoutNonGray"],
    CellMargins->{{39, 0}, {4, 6}},
    FontFamily->"WRICourier",
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["EquationNumber"],
    LineSpacing->{1.83, 0}],
  
  Cell[StyleData["EquationNumber", "Printout"],
    LineSpacing->{1.7, 0},
    FontSize->10],
  
  Cell[StyleData["EquationNumber", "EnhancedPrintout"],
    LineSpacing->{1.7, 0},
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["EquationNumber", "EnhancedPrintoutNonGray"],
    LineSpacing->{1.7, 0},
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Program"],
    CellFrame->{{0, 0}, {0.5, 0.5}},
    CellMargins->{{12, Inherited}, {7, 7}},
    CellFrameMargins->{{0, 0}, {7, 5}},
    FontFamily->"Courier"],
  
  Cell[StyleData["Program", "Printout"],
    CellMargins->{{18, 30}, {Inherited, 4}},
    FontSize->9.5],
  
  Cell[StyleData["Program", "EnhancedPrintout"],
    CellMargins->{{18, 30}, {Inherited, 4}},
    FontFamily->"WRICourier",
    FontSize->9.5],
  
  Cell[StyleData["Program", "EnhancedPrintoutNonGray"],
    CellMargins->{{18, 30}, {Inherited, 4}},
    FontFamily->"WRICourier",
    FontSize->9.5]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Contents and Index", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ContentsTitle"],
    ShowGroupOpenCloseIcon->False,
    CellMargins->{{10, 4}, {0, 18}},
    CellGroupingRules->{"SectionGrouping", 60},
    LineSpacing->{1, 11},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->26,
    FontWeight->"Bold"],
  
  Cell[StyleData["ContentsTitle", "Printout"],
    CellMargins->{{2, 0}, {0, 18}},
    PageBreakBelow->False,
    FontSize->18],
  
  Cell[StyleData["ContentsTitle", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 18}},
    PageBreakBelow->False,
    FontFamily->"Futura",
    FontSize->18],
  
  Cell[StyleData["ContentsTitle", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 18}},
    PageBreakBelow->False,
    FontFamily->"Futura",
    FontSize->18]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ContentsSection"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{35, 4}, {3, 18}},
    CellGroupingRules->{"SectionGrouping", 70},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["ContentsSection", "Printout"],
    CellMargins->{{20, 0}, {3, 18}},
    PageBreakBelow->False,
    FontSize->11],
  
  Cell[StyleData["ContentsSection", "EnhancedPrintout"],
    CellMargins->{{20, 0}, {3, 18}},
    PageBreakBelow->False,
    FontFamily->"Futura",
    FontSize->11],
  
  Cell[StyleData["ContentsSection", "EnhancedPrintoutNonGray"],
    CellMargins->{{20, 0}, {3, 18}},
    PageBreakBelow->False,
    FontFamily->"Futura",
    FontSize->11]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["IndexSection"],
    CellDingbat->"\[FilledSquare]",
    CellMargins->{{20, 4}, {5, 20}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["IndexSection", "Printout"],
    CellMargins->{{12, 0}, {5, 20}},
    PageBreakBelow->False,
    FontSize->12]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Contents"],
    ShowGroupOpenCloseIcon->False,
    CellMargins->{{50, 4}, {0, 5}},
    CellGroupingRules->{"SectionGrouping", 90},
    StyleMenuListing->None],
  
  Cell[StyleData["Contents", "Printout"],
    CellMargins->{{40, 4}, {0, 5}},
    FontSize->11],
  
  Cell[StyleData["Contents", "EnhancedPrintout"],
    CellMargins->{{40, 5}, {0, 5}},
    FontFamily->"Palatino",
    FontSize->11],
  
  Cell[StyleData["Contents", "EnhancedPrintoutNonGray"],
    CellMargins->{{40, 5}, {0, 5}},
    FontFamily->"Palatino",
    FontSize->11]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Index"],
    CellMargins->{{21, 4}, {0, 0}},
    ParagraphIndent->-48,
    StyleMenuListing->None],
  
  Cell[StyleData["Index", "Printout"],
    CellMargins->{{13, 0}, {0, 0}},
    FontSize->10],
  
  Cell[StyleData["Index", "EnhancedPrintout"],
    CellMargins->{{13, 0}, {0, 0}},
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["Index", "EnhancedPrintoutNonGray"],
    CellMargins->{{13, 0}, {0, 0}},
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["IndexSubentry"],
    CellMargins->{{36, 4}, {0, 0}},
    ParagraphIndent->-48,
    StyleMenuListing->None],
  
  Cell[StyleData["IndexSubentry", "Printout"],
    CellMargins->{{24, 0}, {0, 0}},
    FontSize->10],
  
  Cell[StyleData["IndexSubentry", "EnhancedPrintout"],
    CellMargins->{{24, 0}, {0, 0}},
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["IndexSubentry", "EnhancedPrintoutNonGray"],
    CellMargins->{{24, 0}, {0, 0}},
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Function List", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FunctionName"],
    CellDingbat->"\[FilledSquare]",
    CellMargins->{{24, 10}, {10, 12}},
    CellGroupingRules->{"SectionGrouping", 40},
    PageBreakBelow->False,
    FontFamily->"Courier",
    FontSize->14,
    FontWeight->"Bold",
    CellTags->"FunctionName"],
  
  Cell[StyleData["FunctionName", "Printout"],
    CellMargins->{{9, 0}, {10, 10}},
    FontSize->12],
  
  Cell[StyleData["FunctionName", "EnhancedPrintout"],
    CellMargins->{{9, 0}, {10, 10}},
    FontFamily->"Courier",
    FontSize->12],
  
  Cell[StyleData["FunctionName", "EnhancedPrintoutNonGray"],
    CellMargins->{{9, 0}, {10, 10}},
    FontFamily->"Courier",
    FontSize->12]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SubsectionIcon"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{24, 10}, {0, 30}},
    CellGroupingRules->{"SectionGrouping", 50},
    PageBreakBelow->False,
    FontSize->14,
    FontWeight->"Bold",
    CellTags->"FunctionSection"],
  
  Cell[StyleData["SubsectionIcon", "Printout"],
    CellMargins->{{20, 0}, {0, 20}},
    FontSize->13],
  
  Cell[StyleData["SubsectionIcon", "EnhancedPrintout"],
    CellMargins->{{20, 0}, {0, 20}},
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["SubsectionIcon", "EnhancedPrintoutNonGray"],
    CellMargins->{{20, 0}, {0, 20}},
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FunctionSubsection"],
    CellDingbat->"\[FilledSquare]",
    CellMargins->{{36, 10}, {0, 6}},
    CellGroupingRules->{"SectionGrouping", 60},
    PageBreakBelow->False,
    FontWeight->"Bold",
    CellTags->"FunctionSubsection"],
  
  Cell[StyleData["FunctionSubsection", "Printout"],
    CellMargins->{{30, 0}, {0, 6}}],
  
  Cell[StyleData["FunctionSubsection", "EnhancedPrintout"],
    CellMargins->{{30, 0}, {0, 6}},
    FontFamily->"Palatino",
    FontSize->11],
  
  Cell[StyleData["FunctionSubsection", "EnhancedPrintoutNonGray"],
    CellMargins->{{30, 0}, {0, 6}},
    FontFamily->"Palatino",
    FontSize->11]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SubsubsectionIcon"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{36, 10}, {0, 6}},
    CellGroupingRules->{"SectionGrouping", 60},
    PageBreakBelow->False,
    FontWeight->"Bold",
    CellTags->"SubsubsectionIcon"],
  
  Cell[StyleData["SubsubsectionIcon", "Printout"],
    CellMargins->{{30, 0}, {0, 6}},
    FontSize->11],
  
  Cell[StyleData["SubsubsectionIcon", "EnhancedPrintout"],
    CellMargins->{{30, 0}, {0, 6}},
    FontFamily->"Palatino",
    FontSize->9],
  
  Cell[StyleData["SubsubsectionIcon", "EnhancedPrintoutNonGray"],
    CellMargins->{{30, 0}, {0, 6}},
    FontFamily->"Palatino",
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FunctionDescription"],
    CellMargins->{{36, 10}, {4, 0}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0.7, 0},
    CounterIncrements->"Text",
    FontWeight->"Plain"],
  
  Cell[StyleData["FunctionDescription", "Printout"],
    CellMargins->{{30, 0}, {4, 0}},
    FontSize->11],
  
  Cell[StyleData["FunctionDescription", "EnhancedPrintout"],
    CellMargins->{{30, 0}, {4, 0}},
    TextJustification->0,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["FunctionDescription", "EnhancedPrintoutNonGray"],
    CellMargins->{{30, 0}, {4, 0}},
    TextJustification->0,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FunctionDescriptionRuled"],
    CellFrame->{{0, 0}, {0.25, 0.25}},
    CellMargins->{{36, 10}, {4, 0}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0.7, 0},
    CounterIncrements->"Text"],
  
  Cell[StyleData["FunctionDescriptionRuled", "Printout"],
    CellMargins->{{30, 0}, {4, 0}},
    FontSize->11],
  
  Cell[StyleData["FunctionDescriptionRuled", "EnhancedPrintout"],
    CellMargins->{{30, 0}, {4, 0}},
    TextJustification->0,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["FunctionDescriptionRuled", "EnhancedPrintoutNonGray"],
    CellMargins->{{30, 0}, {4, 0}},
    TextJustification->0,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FunctionDescriptionRuleTop"],
    CellFrame->{{0, 0}, {0, 0.25}},
    CellMargins->{{36, 10}, {4, 0}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0.7, 0},
    CounterIncrements->"Text"],
  
  Cell[StyleData["FunctionDescriptionRuleTop", "Printout"],
    CellMargins->{{30, 0}, {4, 0}},
    FontSize->11],
  
  Cell[StyleData["FunctionDescriptionRuleTop", "EnhancedPrintout"],
    CellMargins->{{30, 0}, {4, 0}},
    TextJustification->0,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["FunctionDescriptionRuleTop", "EnhancedPrintoutNonGray"],
    CellMargins->{{30, 0}, {4, 0}},
    TextJustification->0,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FunctionDescriptionRuleBottom"],
    CellFrame->{{0, 0}, {0.25, 0}},
    CellMargins->{{36, 10}, {4, 0}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0.7, 0},
    CounterIncrements->"Text"],
  
  Cell[StyleData["FunctionDescriptionRuleBottom", "Printout"],
    CellMargins->{{30, 0}, {4, 0}},
    FontSize->11],
  
  Cell[StyleData["FunctionDescriptionRuleBottom", "EnhancedPrintout"],
    CellMargins->{{30, 0}, {4, 0}},
    TextJustification->0,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["FunctionDescriptionRuleBottom", "EnhancedPrintoutNonGray"],
    CellMargins->{{30, 0}, {4, 0}},
    TextJustification->0,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FunctionExample"],
    CellMargins->{{36, 10}, {4, 0}},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["FunctionExample", "Printout"],
    CellMargins->{{30, 0}, {4, 0}},
    FontSize->9],
  
  Cell[StyleData["FunctionExample", "EnhancedPrintout"],
    CellMargins->{{30, 0}, {4, 0}},
    FontFamily->"Palatino",
    FontSize->9],
  
  Cell[StyleData["FunctionExample", "EnhancedPrintoutNonGray"],
    CellMargins->{{30, 0}, {4, 0}},
    FontFamily->"Palatino",
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FunctionTextNote"],
    CellMargins->{{36, 4}, {0, 4}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0, 4},
    LineIndent->0],
  
  Cell[StyleData["FunctionTextNote", "Printout"],
    CellMargins->{{36, 4}, {0, 4}},
    FontSize->9],
  
  Cell[StyleData["FunctionTextNote", "EnhancedPrintout"],
    CellMargins->{{36, 4}, {0, 4}},
    FontFamily->"Palatino",
    FontSize->8],
  
  Cell[StyleData["FunctionTextNote", "EnhancedPrintoutNonGray"],
    CellMargins->{{36, 4}, {0, 4}},
    FontFamily->"Palatino",
    FontSize->8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["3ColumnFunctionTable"],
    CellMargins->{{36, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->2,
    ColumnWidths->{0.28, 0.28, 0.43},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["3ColumnFunctionTable", "Printout"],
    CellMargins->{{30, 0}, {0, 8}},
    FontSize->10],
  
  Cell[StyleData["3ColumnFunctionTable", "EnhancedPrintout"],
    CellMargins->{{30, 0}, {0, 8}},
    FontSize->10],
  
  Cell[StyleData["3ColumnFunctionTable", "EnhancedPrintoutNonGray"],
    CellMargins->{{30, 0}, {0, 8}},
    FontSize->10]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Browser Emulation", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TextNormal"],
    CellMargins->{{12, 10}, {7, 7}},
    LineSpacing->{1, 3},
    CounterIncrements->"Text",
    FontFamily->"Times",
    FontSize->12],
  
  Cell[StyleData["TextNormal", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["BrowserEmulation"],
    CellMargins->{{12, 1}, {7, 24}},
    CellGroupingRules->{"SectionGrouping", 70},
    LineSpacing->{1, 3},
    FontFamily->"Helvetica",
    GridBoxOptions->{ColumnWidths->0.25,
    ColumnAlignments->{Left},
    GridFrame->True,
    GridFrameMargins->0.5,
    ColumnLines->True}],
  
  Cell[StyleData["Text", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["CategoryDefs"],
    CellMargins->{{300, 10}, {7, 7}},
    LineSpacing->{1, 3},
    FontFamily->"Helvetica",
    Background->RGBColor[1, 0.8, 0.6],
    GridBoxOptions->{ColumnAlignments->{Left},
    GridFrame->False,
    RowLines->True,
    ColumnLines->True}],
  
  Cell[StyleData["Text", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Category1"],
    ShowCellBracket->False,
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{12, 10}, {7, 7}},
    CellGroupingRules->{"SectionGrouping", 50},
    FontSize->16,
    FontWeight->"Bold"],
  
  Cell[StyleData["Category1", "Printout"],
    CellMargins->{{2, 2}, {6, 6}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Category2"],
    ShowCellBracket->False,
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{85, 10}, {7, 7}},
    CellGroupingRules->{"SectionGrouping", 60},
    FontSize->14,
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0, 0.500008]],
  
  Cell[StyleData["Category2", "Printout"],
    CellMargins->{{2, 2}, {6, 6}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Category3"],
    ShowCellBracket->False,
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{157, 10}, {7, 7}},
    CellGroupingRules->{"SectionGrouping", 70},
    FontSize->12,
    FontWeight->"Bold",
    FontColor->RGBColor[0.2, 0, 0.4]],
  
  Cell[StyleData["Category3", "Printout"],
    CellMargins->{{2, 2}, {6, 6}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Category4"],
    ShowCellBracket->False,
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{230, 10}, {7, 7}},
    CellGroupingRules->{"SectionGrouping", 80},
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0.300008, 0.4]],
  
  Cell[StyleData["Category4", "Printout"],
    CellMargins->{{2, 2}, {6, 6}}]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Styles for Headers and Footers", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Header"],
    CellMargins->{{0, 0}, {4, 1}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->8,
    FontWeight->"Bold"],
  
  Cell[StyleData["Header", "Printout"]],
  
  Cell[StyleData["Header", "EnhancedPrintout"],
    FontFamily->"Futura"],
  
  Cell[StyleData["Header", "EnhancedPrintoutNonGray"],
    FontFamily->"Futura"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Footer"],
    CellMargins->{{0, 0}, {0, 4}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->7,
    FontSlant->"Plain"],
  
  Cell[StyleData["Footer", "Printout"]],
  
  Cell[StyleData["Footer", "EnhancedPrintout"],
    FontFamily->"Futura"],
  
  Cell[StyleData["Footer", "EnhancedPrintoutNonGray"],
    FontFamily->"Futura"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PageNumber"],
    CellMargins->{{0, 0}, {4, 1}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->8,
    FontWeight->"Bold"],
  
  Cell[StyleData["PageNumber", "Printout"]],
  
  Cell[StyleData["PageNumber", "EnhancedPrintout"],
    FontFamily->"Futura"],
  
  Cell[StyleData["PageNumber", "EnhancedPrintoutNonGray"],
    FontFamily->"Futura"]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Hyperlink Styles", "Section"],
  
  Cell["\<\
The cells below define styles useful for making hypertext \
ButtonBoxes.  The \"Hyperlink\" style is for links within the same Notebook, \
or between Notebooks.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Hyperlink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0, 0, 1],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #2]}]&),
    Active->True,
    ButtonNote->ButtonData}],
  
  Cell[StyleData["Hyperlink", "Printout"],
    FontSize->11,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["Hyperlink", "EnhancedPrintout"],
    FontFamily->"Palatino",
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["Hyperlink", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino",
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell["\<\
The following styles are for linking automatically to the on-line \
help system.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MainBookLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0, 0, 1],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "MainBook", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["MainBookLink", "Printout"],
    FontSize->11,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["MainBookLink", "EnhancedPrintout"],
    FontFamily->"Palatino",
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["MainBookLink", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino",
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["AddOnsLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontFamily->"Courier",
    FontColor->RGBColor[0, 0, 1],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "AddOns", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["AddOnsLink", "Printout"],
    FontSize->11,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["AddOnsLink", "EnhancedPrintout"],
    FontSize->11,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["AddOnsLink", "EnhancedPrintoutNonGray"],
    FontSize->11,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["AddOnsLinkText"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontFamily->"Times",
    FontColor->RGBColor[0, 0, 1],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "AddOns", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["AddOnsLinkText", "Printout"],
    FontSize->11,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["AddOnsLinkText", "EnhancedPrintout"],
    FontSize->11,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["AddOnsLinkText", "EnhancedPrintoutNonGray"],
    FontSize->11,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["RefGuideLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontFamily->"Courier",
    FontColor->RGBColor[0, 0, 1],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "RefGuide", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["RefGuideLink", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["RefGuideLink", "EnhancedPrintout"],
    FontFamily->"WRICourier",
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["RefGuideLink", "EnhancedPrintoutNonGray"],
    FontFamily->"WRICourier",
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["GettingStartedLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0, 0, 1],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "GettingStarted", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["GettingStartedLink", "Printout"],
    FontSize->11,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["GettingStartedLink", "EnhancedPrintout"],
    FontFamily->"Palatino",
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["GettingStartedLink", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino",
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["OtherInformationLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0, 0, 1],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "OtherInformation", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["OtherInformationLink", "Printout"],
    FontSize->11,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["OtherInformationLink", "EnhancedPrintout"],
    FontFamily->"Palatino",
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["OtherInformationLink", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino",
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Outline Styles", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Outline1"],
    CellMargins->{{12, 10}, {7, 7}},
    CellGroupingRules->{"SectionGrouping", 50},
    ParagraphIndent->-38,
    CounterIncrements->"Outline1",
    FontSize->18,
    FontWeight->"Bold",
    CounterBoxOptions->{CounterFunction:>CapitalRomanNumeral}],
  
  Cell[StyleData["Outline1", "Printout"],
    CounterBoxOptions->{CounterFunction:>CapitalRomanNumeral}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Outline2"],
    CellMargins->{{59, 10}, {7, 7}},
    CellGroupingRules->{"SectionGrouping", 60},
    ParagraphIndent->-27,
    CounterIncrements->"Outline2",
    FontSize->15,
    FontWeight->"Bold",
    CounterBoxOptions->{CounterFunction:>(Part[ 
        CharacterRange[ "A", "Z"], #]&)}],
  
  Cell[StyleData["Outline2", "Printout"],
    CounterBoxOptions->{CounterFunction:>(Part[ 
        CharacterRange[ "A", "Z"], #]&)}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Outline3"],
    CellMargins->{{108, 10}, {7, 7}},
    CellGroupingRules->{"SectionGrouping", 70},
    ParagraphIndent->-21,
    CounterIncrements->"Outline3",
    FontSize->12,
    CounterBoxOptions->{CounterFunction:>Identity}],
  
  Cell[StyleData["Outline3", "Printout"],
    CounterBoxOptions->{CounterFunction:>Identity}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Outline4"],
    CellMargins->{{158, 10}, {7, 7}},
    CellGroupingRules->{"SectionGrouping", 80},
    ParagraphIndent->-18,
    CounterIncrements->"Outline4",
    FontSize->10,
    CounterBoxOptions->{CounterFunction:>(Part[ 
        CharacterRange[ "a", "z"], #]&)}],
  
  Cell[StyleData["Outline4", "Printout"]]
  }, Closed]]
  }, Closed]]
  }, Open  ]]
  }]
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1705, 50, 42, 0, 69, "ContentsTitle"],
Cell[1750, 52, 302, 11, 49, "Text",
  CellGroupingRules->{"TitleGrouping", 0}],

Cell[CellGroupData[{
Cell[2077, 67, 440, 14, 68, "Text",
  CellGroupingRules->{"TitleGrouping", 0}],

Cell[CellGroupData[{
Cell[2542, 85, 398, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],

Cell[CellGroupData[{
Cell[2965, 103, 354, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[3322, 117, 409, 13, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[3734, 132, 374, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[4111, 146, 372, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[4486, 160, 383, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[4884, 175, 359, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],

Cell[CellGroupData[{
Cell[5280, 192, 430, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],
Cell[5713, 208, 399, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],

Cell[CellGroupData[{
Cell[6137, 224, 407, 13, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[6547, 239, 354, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[6904, 253, 376, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[7283, 267, 363, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[7661, 282, 361, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],

Cell[CellGroupData[{
Cell[8059, 299, 689, 22, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],
Cell[8751, 323, 579, 19, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[9333, 344, 361, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],

Cell[CellGroupData[{
Cell[9731, 361, 432, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],
Cell[10166, 377, 580, 19, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],

Cell[CellGroupData[{
Cell[10771, 400, 369, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[11143, 414, 381, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[11527, 428, 365, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[11907, 443, 359, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[12269, 457, 386, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[12658, 471, 379, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[13040, 485, 781, 23, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[13824, 510, 359, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],

Cell[CellGroupData[{
Cell[14220, 527, 433, 15, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],
Cell[14656, 544, 355, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[15014, 558, 411, 13, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[15428, 573, 359, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],

Cell[CellGroupData[{
Cell[15824, 590, 397, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],

Cell[CellGroupData[{
Cell[16246, 608, 373, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[16622, 622, 877, 28, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[17502, 652, 371, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[17876, 666, 369, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],

Cell[CellGroupData[{
Cell[18282, 683, 391, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[18676, 697, 354, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[19033, 711, 393, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[19441, 726, 391, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],

Cell[CellGroupData[{
Cell[19857, 742, 368, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[20228, 756, 378, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[20609, 770, 377, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[20989, 784, 372, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[21364, 798, 351, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[21730, 813, 359, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],
Cell[22104, 828, 392, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}]
}, Closed]],

Cell[CellGroupData[{
Cell[22533, 847, 410, 13, 31, "Text",
  CellGroupingRules->{"TitleGrouping", 0}],

Cell[CellGroupData[{
Cell[22968, 864, 429, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],
Cell[23400, 880, 354, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[23757, 894, 390, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[24150, 908, 355, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[24508, 922, 353, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[24864, 936, 376, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[25243, 950, 378, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[25624, 964, 382, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[26009, 978, 395, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[26407, 992, 380, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[26790, 1006, 360, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],

Cell[CellGroupData[{
Cell[27187, 1023, 453, 15, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],
Cell[27643, 1040, 376, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[28022, 1054, 367, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[28392, 1068, 366, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[28761, 1082, 400, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[29164, 1096, 360, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],

Cell[CellGroupData[{
Cell[29561, 1113, 405, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],
Cell[29969, 1129, 396, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[30368, 1143, 378, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],

Cell[CellGroupData[{
Cell[30771, 1159, 381, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[31155, 1173, 390, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[31548, 1187, 390, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[31941, 1201, 362, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[32306, 1215, 388, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],

Cell[CellGroupData[{
Cell[32731, 1232, 371, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[33105, 1246, 355, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[33463, 1260, 374, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[33840, 1274, 391, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[34234, 1288, 372, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[34609, 1302, 377, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[34989, 1316, 366, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[35358, 1330, 393, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],

Cell[CellGroupData[{
Cell[35788, 1347, 367, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[36158, 1361, 370, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[36531, 1375, 366, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[36912, 1390, 434, 13, 48, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[37349, 1405, 360, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],

Cell[CellGroupData[{
Cell[37746, 1422, 404, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],
Cell[38153, 1438, 356, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],

Cell[CellGroupData[{
Cell[38534, 1454, 406, 13, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[38943, 1469, 360, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[39306, 1483, 350, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[39659, 1497, 559, 18, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[40233, 1518, 422, 13, 48, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[40658, 1533, 388, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],

Cell[CellGroupData[{
Cell[41071, 1549, 423, 13, 48, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[41497, 1564, 371, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[41871, 1578, 350, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[42236, 1593, 360, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],
Cell[42611, 1608, 393, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}]
}, Closed]],

Cell[CellGroupData[{
Cell[43041, 1627, 437, 14, 50, "Text",
  CellGroupingRules->{"TitleGrouping", 0}],

Cell[CellGroupData[{
Cell[43503, 1645, 482, 15, 64, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],

Cell[CellGroupData[{
Cell[44010, 1664, 374, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[44387, 1678, 354, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[44744, 1692, 360, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[45107, 1706, 376, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],

Cell[CellGroupData[{
Cell[45520, 1723, 404, 13, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[45927, 1738, 409, 13, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[46339, 1753, 351, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[46693, 1767, 395, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[47091, 1781, 350, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],

Cell[CellGroupData[{
Cell[47478, 1798, 375, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[47856, 1812, 352, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[48211, 1826, 362, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[48576, 1840, 432, 13, 38, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],

Cell[CellGroupData[{
Cell[49045, 1858, 405, 13, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[49453, 1873, 355, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[49811, 1887, 389, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[50203, 1901, 386, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[50592, 1915, 380, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[50975, 1929, 350, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[51340, 1944, 360, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],

Cell[CellGroupData[{
Cell[51737, 1961, 434, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],
Cell[52174, 1977, 384, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],

Cell[CellGroupData[{
Cell[52583, 1993, 364, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[52950, 2007, 359, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[53312, 2021, 383, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[53698, 2035, 429, 13, 38, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],

Cell[CellGroupData[{
Cell[54164, 2053, 367, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[54534, 2067, 366, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[54903, 2081, 350, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],

Cell[CellGroupData[{
Cell[55290, 2098, 362, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[55655, 2112, 366, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[56024, 2126, 317, 10, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[56344, 2138, 362, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[56709, 2152, 350, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],

Cell[CellGroupData[{
Cell[57096, 2169, 367, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[57466, 2183, 355, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[57824, 2197, 398, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[58225, 2211, 411, 13, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[58651, 2227, 360, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],
Cell[59026, 2242, 393, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}]
}, Closed]],

Cell[CellGroupData[{
Cell[59456, 2261, 400, 13, 31, "Text",
  CellGroupingRules->{"TitleGrouping", 0}],

Cell[CellGroupData[{
Cell[59881, 2278, 412, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],

Cell[CellGroupData[{
Cell[60318, 2296, 382, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[60703, 2310, 372, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[61078, 2324, 397, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[61490, 2339, 373, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],

Cell[CellGroupData[{
Cell[61888, 2355, 376, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[62267, 2369, 391, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[62661, 2383, 353, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[63017, 2397, 355, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[63387, 2412, 381, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[63771, 2426, 360, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],

Cell[CellGroupData[{
Cell[64168, 2443, 475, 15, 64, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],
Cell[64646, 2460, 369, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],

Cell[CellGroupData[{
Cell[65040, 2476, 397, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[65440, 2490, 381, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[65824, 2504, 354, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[66181, 2518, 378, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[66562, 2532, 371, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[66948, 2547, 360, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],

Cell[CellGroupData[{
Cell[67345, 2564, 433, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],
Cell[67781, 2580, 386, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[68170, 2594, 360, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[68533, 2608, 778, 23, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[69314, 2633, 1430, 43, 30, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[70747, 2678, 355, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[71105, 2692, 363, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[71471, 2706, 363, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[71837, 2720, 361, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[72201, 2734, 360, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],

Cell[CellGroupData[{
Cell[72598, 2751, 444, 15, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],

Cell[CellGroupData[{
Cell[73067, 2770, 379, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[73449, 2784, 359, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[73811, 2798, 362, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[74176, 2812, 371, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[74550, 2826, 388, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[74953, 2841, 367, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[75323, 2855, 376, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[75702, 2869, 360, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],
Cell[76077, 2884, 393, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}]
}, Closed]],

Cell[CellGroupData[{
Cell[76507, 2903, 434, 14, 50, "Text",
  CellGroupingRules->{"TitleGrouping", 0}],

Cell[CellGroupData[{
Cell[76966, 2921, 411, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],

Cell[CellGroupData[{
Cell[77402, 2939, 377, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[77782, 2953, 358, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[78143, 2967, 358, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],

Cell[CellGroupData[{
Cell[78538, 2984, 381, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[78922, 2998, 423, 13, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[79348, 3013, 356, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[79707, 3027, 353, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],

Cell[CellGroupData[{
Cell[80097, 3044, 377, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[80477, 3058, 396, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[80876, 3072, 380, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[81259, 3086, 381, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[81643, 3100, 363, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[82009, 3114, 384, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[82396, 3128, 356, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[82767, 3143, 360, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],

Cell[CellGroupData[{
Cell[83164, 3160, 401, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],

Cell[CellGroupData[{
Cell[83590, 3178, 375, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[83968, 3192, 354, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[84325, 3206, 397, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[84725, 3220, 415, 13, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[85143, 3235, 358, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[85504, 3249, 398, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[85905, 3263, 359, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],

Cell[CellGroupData[{
Cell[86301, 3280, 383, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[86687, 3294, 365, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[87055, 3308, 402, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[87460, 3322, 357, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[87820, 3336, 364, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[88199, 3351, 360, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],

Cell[CellGroupData[{
Cell[88596, 3368, 489, 16, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],
Cell[89088, 3386, 376, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[89467, 3400, 383, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[89853, 3414, 372, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],
Cell[90240, 3429, 393, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}]
}, Closed]],

Cell[CellGroupData[{
Cell[90670, 3448, 443, 14, 50, "Text",
  CellGroupingRules->{"TitleGrouping", 0}],

Cell[CellGroupData[{
Cell[91138, 3466, 405, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],
Cell[91546, 3482, 355, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],

Cell[CellGroupData[{
Cell[91926, 3498, 366, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[92295, 3512, 348, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[92646, 3526, 351, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[93000, 3540, 351, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[93354, 3554, 351, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],

Cell[CellGroupData[{
Cell[93742, 3571, 366, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[94111, 3585, 360, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[94474, 3599, 390, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[94879, 3614, 360, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],

Cell[CellGroupData[{
Cell[95276, 3631, 399, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],

Cell[CellGroupData[{
Cell[95700, 3649, 367, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[96070, 3663, 376, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[96449, 3677, 373, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[96825, 3691, 354, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[97182, 3705, 353, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[97538, 3719, 390, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[97931, 3733, 384, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[98318, 3747, 370, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],

Cell[CellGroupData[{
Cell[98725, 3764, 367, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[99095, 3778, 358, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[99456, 3792, 368, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[99827, 3806, 361, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[100191, 3820, 353, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[100559, 3835, 360, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],

Cell[CellGroupData[{
Cell[100956, 3852, 524, 17, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],
Cell[101483, 3871, 368, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],

Cell[CellGroupData[{
Cell[101876, 3887, 378, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[102257, 3901, 369, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[102629, 3915, 413, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[103045, 3929, 388, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],

Cell[CellGroupData[{
Cell[103470, 3946, 382, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[103855, 3960, 369, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[104227, 3974, 407, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[104637, 3988, 388, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],

Cell[CellGroupData[{
Cell[105062, 4005, 370, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[105435, 4019, 372, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[105810, 4033, 401, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[106214, 4047, 400, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[106617, 4061, 403, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[107023, 4075, 403, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[107441, 4090, 372, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],
Cell[107828, 4105, 393, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}]
}, Closed]],

Cell[CellGroupData[{
Cell[108258, 4124, 422, 13, 31, "Text",
  CellGroupingRules->{"TitleGrouping", 0}],

Cell[CellGroupData[{
Cell[108705, 4141, 441, 15, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],
Cell[109149, 4158, 358, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],

Cell[CellGroupData[{
Cell[109532, 4174, 355, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[109890, 4188, 942, 28, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[110835, 4218, 945, 28, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[111783, 4248, 363, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[112149, 4262, 389, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],

Cell[CellGroupData[{
Cell[112575, 4279, 359, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[112937, 4293, 380, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[113320, 4307, 351, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[113674, 4321, 360, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[114049, 4336, 360, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],

Cell[CellGroupData[{
Cell[114446, 4353, 404, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],
Cell[114853, 4369, 379, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[115235, 4383, 388, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],

Cell[CellGroupData[{
Cell[115648, 4399, 389, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[116040, 4413, 355, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[116398, 4427, 366, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[116767, 4441, 374, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[117144, 4455, 381, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],

Cell[CellGroupData[{
Cell[117562, 4472, 374, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[117939, 4486, 359, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[118301, 4500, 371, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[118687, 4515, 360, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],

Cell[CellGroupData[{
Cell[119084, 4532, 524, 17, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],
Cell[119611, 4551, 373, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[119987, 4565, 382, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[120372, 4579, 371, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],

Cell[CellGroupData[{
Cell[120768, 4595, 361, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[121132, 4609, 382, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[121517, 4623, 379, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[121899, 4637, 422, 13, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],

Cell[CellGroupData[{
Cell[122358, 4655, 364, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[122725, 4669, 365, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[123093, 4683, 391, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[123487, 4697, 403, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[123893, 4711, 363, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[124271, 4726, 372, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],
Cell[124658, 4741, 374, 13, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 30}]
}, Closed]],

Cell[CellGroupData[{
Cell[125069, 4759, 414, 13, 31, "Text",
  CellGroupingRules->{"TitleGrouping", 0}],

Cell[CellGroupData[{
Cell[125508, 4776, 398, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],
Cell[125909, 4792, 355, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],

Cell[CellGroupData[{
Cell[126289, 4808, 373, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[126665, 4822, 363, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[127031, 4836, 353, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[127387, 4850, 367, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[127757, 4864, 350, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[128110, 4878, 410, 13, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[128535, 4894, 360, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],

Cell[CellGroupData[{
Cell[128932, 4911, 406, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],

Cell[CellGroupData[{
Cell[129363, 4929, 377, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[129743, 4943, 351, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[130097, 4957, 390, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[130490, 4971, 364, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[130857, 4985, 369, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],

Cell[CellGroupData[{
Cell[131263, 5002, 355, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[131621, 5016, 364, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[131988, 5030, 359, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[132350, 5044, 385, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],

Cell[CellGroupData[{
Cell[132772, 5061, 363, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[133138, 5075, 369, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[133510, 5089, 361, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[133874, 5103, 378, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[134255, 5117, 370, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[134640, 5132, 360, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],

Cell[CellGroupData[{
Cell[135037, 5149, 549, 18, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],
Cell[135589, 5169, 362, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],

Cell[CellGroupData[{
Cell[135976, 5185, 367, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[136346, 5199, 386, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[136735, 5213, 388, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[137138, 5228, 372, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],
Cell[137525, 5243, 393, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}]
}, Closed]],

Cell[CellGroupData[{
Cell[137955, 5262, 796, 25, 31, "Text",
  CellGroupingRules->{"TitleGrouping", 0}],
Cell[138754, 5289, 661, 22, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],

Cell[CellGroupData[{
Cell[139440, 5315, 883, 29, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],
Cell[140326, 5346, 365, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[140694, 5360, 384, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[141081, 5374, 379, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[141463, 5388, 370, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[141836, 5402, 373, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[142212, 5416, 818, 25, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[143033, 5443, 372, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],
Cell[143420, 5458, 898, 29, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],

Cell[CellGroupData[{
Cell[144343, 5491, 421, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],
Cell[144767, 5507, 368, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[145138, 5521, 365, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[145506, 5535, 389, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],

Cell[CellGroupData[{
Cell[145932, 5552, 427, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],
Cell[146362, 5568, 393, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],

Cell[CellGroupData[{
Cell[146780, 5584, 384, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[147167, 5598, 370, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[147540, 5612, 366, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[147909, 5626, 376, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[148288, 5640, 378, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[148681, 5655, 418, 13, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[149102, 5670, 375, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[149480, 5684, 372, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],

Cell[CellGroupData[{
Cell[149889, 5701, 415, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],
Cell[150307, 5717, 791, 25, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[151101, 5744, 791, 25, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[151895, 5771, 397, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[152295, 5785, 796, 25, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[153094, 5812, 372, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[153469, 5826, 364, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[153836, 5840, 366, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[154205, 5854, 371, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[154579, 5868, 372, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],
Cell[154966, 5883, 425, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],

Cell[CellGroupData[{
Cell[155416, 5901, 415, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],
Cell[155834, 5917, 380, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[156217, 5931, 367, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],

Cell[CellGroupData[{
Cell[156609, 5947, 374, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[156986, 5961, 380, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[157369, 5975, 392, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[157764, 5989, 385, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[158164, 6004, 374, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[158541, 6018, 387, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[158931, 6032, 398, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[159332, 6046, 372, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],

Cell[CellGroupData[{
Cell[159741, 6063, 407, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],
Cell[160151, 6079, 367, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[160521, 6093, 368, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[160892, 6107, 367, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[161262, 6121, 372, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],

Cell[CellGroupData[{
Cell[161671, 6138, 440, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],

Cell[CellGroupData[{
Cell[162136, 6156, 1044, 33, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[163183, 6191, 388, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[163574, 6205, 393, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[163970, 6219, 400, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[164373, 6233, 374, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[164762, 6248, 373, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],

Cell[CellGroupData[{
Cell[165172, 6265, 418, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],
Cell[165593, 6281, 398, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[165994, 6295, 378, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[166375, 6309, 370, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],

Cell[CellGroupData[{
Cell[166770, 6325, 364, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[167137, 6339, 387, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],
Cell[167539, 6354, 373, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}]
}, Closed]],

Cell[CellGroupData[{
Cell[167949, 6371, 900, 29, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}],
Cell[168852, 6402, 377, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[169232, 6416, 418, 13, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[169653, 6431, 392, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],

Cell[CellGroupData[{
Cell[170070, 6447, 365, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[170438, 6461, 369, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[170810, 6475, 380, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[171193, 6489, 386, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[171582, 6503, 377, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[171962, 6517, 371, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[172336, 6531, 371, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]],

Cell[CellGroupData[{
Cell[172744, 6548, 377, 12, 29, "Text",
  CellGroupingRules->{"SectionGrouping", 40}],
Cell[173124, 6562, 374, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}],
Cell[173501, 6576, 377, 12, 19, "Text",
  CellGroupingRules->{"SectionGrouping", 50}]
}, Closed]]
}, Closed]],
Cell[173905, 6592, 405, 14, 45, "Text",
  CellGroupingRules->{"SectionGrouping", 30}]
}, Closed]],
Cell[174325, 6609, 331, 11, 31, "Text",
  CellGroupingRules->{"TitleGrouping", 0}],
Cell[174659, 6622, 296, 11, 49, "Text",
  CellGroupingRules->{"TitleGrouping", 0}]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

